#include <CommunicationModel/VirtualCommandSet/VirtualCommandSet_Manager.h>
#include "CommunicationModel.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CCommunicationModel::CCommunicationModel()
{
}

CCommunicationModel::~CCommunicationModel()
{
    DeleteVirtualCommandSetDialogManager();
    DeleteVirtualCommandSetManager();
}

BOOL CCommunicationModel::CreateVirtualCommandSetManager()
{
    BOOL oResult = FALSE;
    
    DeleteVirtualCommandSetManager();
    
	m_pVirtualCommandSetManager = new CVirtualCommandSet_Manager((int)(long)this);
    
	if(m_pVirtualCommandSetManager != 0)
    {
        //Init Epos4 device
        if(m_pVirtualCommandSetManager->VCS_InitVirtualDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS4, PROTOCOL_MAXON_SERIAL_V2, INTERFACE_USB, DRIVER_HID + CStdString(_T(" ")) + USB_VENDOR_PRODUCT_ID_EPOS4)) oResult = TRUE;
        if(m_pVirtualCommandSetManager->VCS_InitVirtualDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS4, PROTOCOL_MAXON_SERIAL_V2, INTERFACE_RS232)) oResult = TRUE;
        if(m_pVirtualCommandSetManager->VCS_InitVirtualDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS4, PROTOCOL_CAN_OPEN, INTERFACE_CAN)) oResult = TRUE;

        //Init Epos2 Device
        if(m_pVirtualCommandSetManager->VCS_InitVirtualDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS2, PROTOCOL_MAXON_SERIAL_V2, INTERFACE_USB, DRIVER_FTD2XX + CStdString(_T(" ")) + USB_VENDOR_PRODUCT_ID_EPOS2)) oResult = TRUE;
        if(m_pVirtualCommandSetManager->VCS_InitVirtualDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS2, PROTOCOL_MAXON_SERIAL_V1, INTERFACE_RS232)) oResult = TRUE;
        if(m_pVirtualCommandSetManager->VCS_InitVirtualDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS2, PROTOCOL_CAN_OPEN, INTERFACE_CAN)) oResult = TRUE;
        
        //Init Epos Device
        if(m_pVirtualCommandSetManager->VCS_InitVirtualDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS, PROTOCOL_MAXON_SERIAL_V1, INTERFACE_RS232)) oResult = TRUE;
        if(m_pVirtualCommandSetManager->VCS_InitVirtualDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS, PROTOCOL_CAN_OPEN, INTERFACE_CAN)) oResult = TRUE;

        //Subdevices
		if(m_pVirtualCommandSetManager->VCS_InitVirtualGatewayDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS4, PROTOCOL_CAN_OPEN, DEVICE_EPOS4, PROTOCOL_MAXON_SERIAL_V2)) oResult = TRUE;
		if(m_pVirtualCommandSetManager->VCS_InitVirtualGatewayDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS4, PROTOCOL_CAN_OPEN, DEVICE_EPOS2, PROTOCOL_MAXON_SERIAL_V2)) oResult = TRUE;
		if(m_pVirtualCommandSetManager->VCS_InitVirtualGatewayDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS4, PROTOCOL_CAN_OPEN, DEVICE_EPOS, PROTOCOL_MAXON_SERIAL_V1)) oResult = TRUE;

		if(m_pVirtualCommandSetManager->VCS_InitVirtualGatewayDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS2, PROTOCOL_CAN_OPEN, DEVICE_EPOS4, PROTOCOL_MAXON_SERIAL_V2)) oResult = TRUE;
		if(m_pVirtualCommandSetManager->VCS_InitVirtualGatewayDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS2, PROTOCOL_CAN_OPEN, DEVICE_EPOS2, PROTOCOL_MAXON_SERIAL_V2)) oResult = TRUE;
		if(m_pVirtualCommandSetManager->VCS_InitVirtualGatewayDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS2, PROTOCOL_CAN_OPEN, DEVICE_EPOS, PROTOCOL_MAXON_SERIAL_V1)) oResult = TRUE;

		if(m_pVirtualCommandSetManager->VCS_InitVirtualGatewayDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS, PROTOCOL_CAN_OPEN, DEVICE_EPOS4, PROTOCOL_MAXON_SERIAL_V2)) oResult = TRUE;
		if(m_pVirtualCommandSetManager->VCS_InitVirtualGatewayDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS, PROTOCOL_CAN_OPEN, DEVICE_EPOS2, PROTOCOL_MAXON_SERIAL_V2)) oResult = TRUE;
		if(m_pVirtualCommandSetManager->VCS_InitVirtualGatewayDevice(VIRTUAL_DEVICE_DRIVE2, DEVICE_EPOS, PROTOCOL_CAN_OPEN, DEVICE_EPOS, PROTOCOL_MAXON_SERIAL_V1)) oResult = TRUE;
    }

    //Init Device Dialog Manager
    if(oResult)
    {
        DeleteVirtualCommandSetDialogManager();
    }

    return oResult;
}
