// EPOS_WinDLL.cpp : Legt die Initialisierungsroutinen fuer die DLL fest.
//
#include "CommunicationModel/CommunicationModel.h"
#include <CommunicationModel/Common/Journal/Time/JournalTime.h>
#include <CommunicationModel/CommonLayer/Classes/Commands/Command/CommandRoot.h>
#include <RecorderCmdManager/RecorderCmdManager.h>

#include "Definitions.h"
#include "EposCmd.h"

CEPOSLinuxSharedLibApp *m_pDllInstance = 0;

//////////////////////////////////////////////////////////////////////
// CEPOS_WinDLLApp Konstruktion

CEPOSLinuxSharedLibApp::CEPOSLinuxSharedLibApp()
{
    m_pRecorderCmdManager = NULL;
    m_pCommunicationModel = NULL;
}

//////////////////////////////////////////////////////////////////////
// Das einzige CEPOS_WinDLLApp-Objekt

CEPOSLinuxSharedLibApp::~CEPOSLinuxSharedLibApp()
{
    DeleteRecorderCmdManager();
    CloseAllDevices();
    DeleteCommunicationModel();
}

CCommunicationModel *CEPOSLinuxSharedLibApp::CreateCommunicationModel()
{
    if(!m_pCommunicationModel)
    {
        m_pCommunicationModel = new CCommunicationModel();
    }

    return m_pCommunicationModel;
}

BOOL CEPOSLinuxSharedLibApp::CloseAllDevices()
{
    CErrorInfo errorInfo;

    if(m_pCommunicationModel)
    {
        m_pCommunicationModel->VCS_CloseAllVirtualDevices(&errorInfo);
    }

    return TRUE;
}

BOOL CEPOSLinuxSharedLibApp::DeleteCommunicationModel()
{
    if(m_pCommunicationModel)
    {
        delete m_pCommunicationModel;
        m_pCommunicationModel = NULL;
    }

    return TRUE;
}

CRecorderCmdManager *CEPOSLinuxSharedLibApp::CreateRecorderCmdManager(HANDLE p_hKeyHandle)
{
    CStdString deviceName;

    if (!m_pRecorderCmdManager)
    {
        m_pRecorderCmdManager = new CRecorderCmdManager();

        m_pRecorderCmdManager->InitCommunicationModel(m_pCommunicationModel);
    }

    return m_pRecorderCmdManager;
}

BOOL CEPOSLinuxSharedLibApp::DeleteRecorderCmdManager()
{
    if (m_pRecorderCmdManager)
    {
        delete m_pRecorderCmdManager;
        m_pRecorderCmdManager = NULL;
    }

    return TRUE;
}

HANDLE StartTransaction(HANDLE KeyHandle,HANDLE JournalHandle)
{
    HANDLE hTransactionHandle = NULL;

    return hTransactionHandle;
}

void StopTransaction(HANDLE hTransactionHandle)
{
}

void SetNodeId(CCommandRoot* pCommand,WORD wNodeId)
{
    CStdString name;
    int iNbOfParameter;

    if(pCommand)
    {
        iNbOfParameter = pCommand->GetNbOfParameter();
        for(int i=0;i<iNbOfParameter;i++)
        {
            name = pCommand->GetParameterName(i);
            if(name.CompareNoCase("NodeId") == 0)
            {
                pCommand->SetParameterData(i,&wNodeId,sizeof(wNodeId));
                break;
            }
        }
    }
}
