# EPOS Command Library

EPOS Command Library is delivered as source code package ready to build and tested for following platforms:

- Ubuntu 12.04 - 16.04 x86/x64
- Raspbian Stretch for Raspberry PI, versions 1, 2 and 3 (ARM v6,v7 and v8 32-bit)
- Ubuntu 16.04 for Nvidia TX2 (ARMv8 64-bit)


## Getting Started

EPOS Command Library is written in C/C++ and is using standard C++ libraries. 


### Prerequisites

The easiest way to build EPOS Command Library on Ubuntu system is to install the 'build-essential' package.

```
sudo apt-get install build-essential
```

Additionally, the CMake toolkit is required for initial project files generation process.

```
sudo apt-get install cmake
```

### Build process

EPOS Command Library source code package is using the CMake framework system to generate the target specific project files.
Those project files can be used finally to build the binary using standard make build automation tool.

In the root directory, run the following commands:

```
mkdir build
cd build
cmake ../Epos/EposCmdLinux
make 
```
after successful execution, in the build directory you will find the library build for your system:

- libEposCmd.so

### Installing

Library can be manually installed on the system by copying following files:

- libEposCmd.so
- libftd2xx.so (search in Epos/EposCmdLinux/Lib/Ftdi sub-directory)


to /usr/lib directory or using standard _make install_ routine:

```
sudo make install
```

### HelloEposCmd example

In Epos/EposCmdLinux/Examples directory you can find the HelloEposCmd example application.

Sample build process out of root package directory:

**Please note, that the library _has to be installed_ first.**

```
mkdir build_example
cd build_example
cmake ../Epos/EposCmdLinux/Examples/HelloEposCmd
make
```

To check the basic functionality you can run the application in demo mode

```
./HelloEposCmd
```

**Other options are available and you can list them by passing -h switch**


## Built With

* [CMake 2.8.12](http://www.cmake.org) - Cross-platform framework for managing the build process
* [FTDI D2XX Library](https://www.ftdichip.com/) - USB Communication Library


## Authors

maxonmotor ag, all rights reserved 
