#pragma once

#include <MmcTypeDefinition.h>

class CObjectFilter;
class CObjectEntryBase;
class CObjectEntry;
class XML_PARSER;

typedef std::list<CObjectEntryBase*> tObjectEntryBaseList;
typedef std::list<CObjectEntry*> tObjectEntryList;

class CObjectEntryBase
{
public:
    //Class initialisation
    virtual void Init() = 0;
    bool IsKindOf(CStdString p_classType);
    CStdString GetClassType();

    //User levels
    BOOL SetUserLevels(CStdString p_UserLevels);
    BOOL GetUserLevels(CStdString& p_rUserLevels);
    virtual BOOL IsUserLevelAvailable(CStdString p_UserLevel);

    //ObjectFilter
    virtual BOOL InitObjectFilter(CObjectFilter* p_pObjectFilter);

    //Set Object Information
    BOOL SetIndex(WORD p_usIndex);
    BOOL SetIndex(CStdString sp_index);
    BOOL SetParameterName(CStdString p_name);
    BOOL SetObjectType(BYTE p_ubObjectType);
    BOOL SetObjectType(CStdString p_objectType);

    //Get Object Information
    virtual WORD GetIndex();
    virtual BOOL GetIndex(CStdString& p_rIndex);
    BOOL GetParameterName(CStdString& p_rName);
    BYTE GetObjectType();
    BOOL GetObjectType(CStdString& p_rObjectType);

    //Information
    virtual CObjectEntryBase* SearchObject(WORD p_usIndex, WORD p_usSubIndex);
    virtual int GetNumberOfSubObjects();
    virtual BOOL IsVisible();

    //Common
    virtual CObjectEntryBase* Clone();
    virtual CObjectEntryBase& operator=(CObjectEntryBase& other);
    virtual BOOL Reset();
    virtual BOOL ResetValue();

    //Xml
    virtual BOOL StoreObjectDictionarySchema(XML_PARSER* p_pXmlParser);

    CObjectEntryBase();
    virtual ~CObjectEntryBase();
    virtual void Serialize(CArchive &ar);

protected:

    CObjectFilter* m_pObjectFilter;
    WORD m_wIndex;
    BYTE m_uObjectType;
    CStdString m_strParameterName;
    CStdString m_UserLevels;
    CStdString m_strClassType;
};
