#pragma once

#include <ObjectDictionary/ObjectEntryBase.h>

class CObjectEntryIterator;
class XML_PARSER;

class CStructuredObjectEntry : public CObjectEntryBase
{
public:
    CStructuredObjectEntry();
    virtual ~CStructuredObjectEntry();

    void Init() { m_strClassType = _T("CStructuredObjectEntry"); }

    //ObjectFilter
    virtual BOOL InitObjectFilter(CObjectFilter* p_pObjectFilter);
    CObjectFilter* GetFilter();

    //Common
    virtual CObjectEntryBase* Clone();
    virtual CStructuredObjectEntry& operator=(CStructuredObjectEntry& p_rStructuredObjectEntry);
    virtual BOOL Reset();
    virtual BOOL ResetValue();

    //Object
    BOOL AddObject(CObjectEntry* p_pObject);
    BOOL SetFirstSubObjectEntryValues(CObjectEntryBase* p_pObjectEntry);

    //Information
    CObjectEntryBase* SearchObject(WORD p_usIndex, WORD p_usSubIndex);
    int GetNumberOfSubObjects();
    CStdString GetParameterNameStr();

    //Xml
    virtual void Serialize(CArchive &p_rArchive);

    BOOL StoreObjectDictionarySchema(XML_PARSER* p_pXmlParser);
    void Parse_XML_Document(XML_PARSER* p_pXmlParser);

    //Iteration
    CObjectEntryIterator* CreateObjectEntryIterator();

private:
    BOOL DeleteObjectEntryList();

private:
    tObjectEntryList m_ObjectEntryList;
};
