#pragma once

#include <list>
#include <MmcTypeDefinition.h>

class CParameterSetEntry;
class CXmlReader;
class CXmlWriter;

typedef std::list<CParameterSetEntry*> tParameterList;

class CParameterSet
{
public:
    CParameterSet();
    virtual ~CParameterSet();
    virtual CParameterSet& operator=(CParameterSet& p_rOther);
    virtual BOOL operator==(CParameterSet& p_rOther);
    virtual CParameterSet* Clone();

    //Common
    BOOL Reset();
    BOOL ResetValues();

    //Add parameter
    BOOL AddParameter(CStdString p_Name, BYTE* p_pDefaultValue, DWORD p_ulSize, BOOL p_oPersistent = FALSE);
    BOOL AddParameter(CStdString p_Name, CStdString p_DefaultValue, BOOL p_oPersistent = FALSE);
    BOOL DeleteParameter(CStdString p_Name);

    //Init parameter
    BOOL InitParameter(CStdString p_Name, BYTE* p_pValue, DWORD p_ulSize, BOOL p_oPersistent = FALSE);
    BOOL InitParameter(CStdString p_Name, CStdString p_Value, BOOL p_oPersistent = FALSE);

    //Get parameter
    BOOL GetParameter(CStdString p_Name, BYTE* p_pValue, DWORD p_ulSize);
    BOOL GetParameter(CStdString p_Name, CStdString& p_rValue);

    //Set parameter
    BOOL SetParameter(CStdString p_Name, BYTE* p_pValue, DWORD p_ulSize);
    BOOL SetParameter(CStdString p_Name, CStdString p_Value);

    //Persistence
    BOOL WriteTo(CXmlWriter* p_pXmlWriter);
    BOOL ReadFrom(CXmlReader* p_pXmlReader);

private:
    //Common
    CParameterSetEntry* FindParameter(CStdString p_Name);

private:
    tParameterList m_ParameterEntryList;
};
