#pragma once

#include <MmcTypeDefinition.h>

class CTrapezePositionTrajectory;

class CPositionPathPlanner
{
public:
    CPositionPathPlanner();
    virtual ~CPositionPathPlanner();

    BOOL GetRunTotalTime(double p_dStartPosition, double p_dStopPosition, long& p_rlTotalTime);

    void SetMainSensorResolution(DWORD p_ulIncrementsPerTurn);
    DWORD GetMainSensorResolution();
    
    void SetProfileVelocity(double p_ffProfileVelocity);
    void SetInitialVelocity(double p_ffInitialVelocity);
    void SetProfileAcceleration(double p_ffProfileAcceleration);
    void SetProfileDeceleration(double p_ffProfileDeceleration);
        
private:
    bool InitTrajectory(CTrapezePositionTrajectory* p_pTrajectory);    
    void ConvertRevolutionProMinuteToIncrementProMilisecond(double p_dRevolutionProMinute, double& p_rdIncrementProMilisecond);
    void ConvertRevolutionProMinuteProSecondToIncrementProMilisecondQuadrat(double p_dRevolutionProMinuteproSecond, double& p_rdIncrementProMilisecondQuadrat);
    
private:
    DWORD m_ulIncrementsPerTurn;
    double m_dProfileVelocity;
    double m_dProfileAcceleration;
    double m_dProfileDeceleration;
    double m_dInitialVelocity;
};