#include <stdafx.h>
#include <math.h>
#include <Math/MmcMath.h>

double CMmcMath::Round(double p_dValue, unsigned short p_usDecimalPlaces)
{
    double dResult(0.0f);
    double dResolution(1.0f);

    //Calculate Resolution
    for(unsigned short i = 0; i < p_usDecimalPlaces; i++)
    {
        dResolution /= 10;
    }

    //Init
    dResult = p_dValue / dResolution;

    //Round to zero decimal places
    dResult = floor(dResult + 0.5);

    //Result
    dResult *= dResolution;

    return dResult;
}

__int64 CMmcMath::Round(__int64 p_llValue, unsigned short p_usDecimalPlaces)
{
    return p_llValue;
}

__uint64 CMmcMath::Round(__uint64 p_ullValue, unsigned short p_usDecimalPlaces)
{
    return p_ullValue;
}

double CMmcMath::Round(double p_dValue, double p_dRoundingIncrement, unsigned short p_ulDecimalPlaces)
{
    double dResult(p_dValue);

    if(p_dRoundingIncrement > 0)
    {
        int lNbOfIncrements = (int)(p_dValue / p_dRoundingIncrement) + 1;

        dResult = (p_dRoundingIncrement * lNbOfIncrements);
        dResult = Round(dResult, p_ulDecimalPlaces);
    }

    return dResult;
}
