#pragma once

#include <CommunicationModel/Common/CommunicationModelDefinitions.h>
#include <MmcTypeDefinition.h>

class CCommandRoot;
class CJournalTime;
struct IJournalEvents;

class CJournalManagerBase
{
public:
    //Journal run time
    virtual BOOL StopJournalRunTime();
    virtual BOOL StartJournalRunTime();
    virtual BOOL StartCommandTime(CJournalTime* pThisTime);
    virtual BOOL StopCommandTime(CJournalTime* pThisTime);
    virtual BOOL IsActiveJournalListEmpty();

    //IJournal
    virtual BOOL StopJournal(HANDLE p_hJournalHandle) = 0;
    virtual HANDLE StartJournal(HANDLE p_hKeyHandle, T_JournalCallback p_journalCallback) = 0;
    virtual HANDLE StartJournal(HANDLE p_hKeyHandle, CStdString p_fileName) = 0;
    virtual HANDLE StartJournal(HANDLE p_hKeyHandle, IJournalEvents* p_pIJournalEvents) = 0;

    //IJournalTransaction
    virtual HANDLE StartTransaction(HANDLE p_hKeyHandle, HANDLE p_hJournalHandle);
    virtual BOOL StopTransaction(HANDLE p_hTransactionHandle);

    //TransactionEvents
    BOOL TransactionEvent(ELayer eLayer, HANDLE p_hTransactionHandle, CStdString p_eventData);
    virtual BOOL TransactionEvent_VCSLayer(HANDLE p_hTransactionHandle, CStdString p_eventData);
    virtual BOOL TransactionEvent_DCSLayer(HANDLE p_hTransactionHandle, CStdString p_eventData);
    virtual BOOL TransactionEvent_ProtocolStackLayer(HANDLE p_hTransactionHandle, CStdString p_eventData);
    virtual BOOL TransactionEvent_InterfaceLayer(HANDLE p_hTransactionHandle, CStdString p_eventData);

    BOOL TransactionEvent(ELayer eLayer, HANDLE p_hTransactionHandle, CCommandRoot* p_pCommand);
    virtual BOOL TransactionEvent_VCSLayer(HANDLE p_hTransactionHandle, CCommandRoot* p_pCommand);
    virtual BOOL TransactionEvent_DCSLayer(HANDLE p_hTransactionHandle, CCommandRoot* p_pCommand);
    virtual BOOL TransactionEvent_ProtocolStackLayer(HANDLE p_hTransactionHandle, CCommandRoot* p_pCommand);
    virtual BOOL TransactionEvent_InterfaceLayer(HANDLE p_hTransactionHandle, CCommandRoot* p_pCommand);

    CJournalManagerBase();
    virtual ~CJournalManagerBase();
};
