#pragma once

#include <MmcTypeDefinition.h>
#include <Classes/XXMLFile.h>
#include <list>

class CCommandRoot;

class CTransactionEventData
{
public:
    BOOL LoadFromXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElement* p_pCommandElement);
    CXXMLFile::CElement* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElement* p_pParentElement);

    void MoveChildList(std::list<CTransactionEventData*>* p_pList);

    CTransactionEventData* Clone();
    CTransactionEventData& operator=(CTransactionEventData& p_rOther);

    void StoreToASCIIFile(std::ofstream* p_pFile);

    CTransactionEventData();
    virtual ~CTransactionEventData();

    virtual void SetString(CStdString* p_pData);
    virtual void SetCommand(CCommandRoot* p_pCommand);
    virtual CCommandRoot* GetCommand();

private:
    virtual CXXMLFile::CElement* StoreEventDataToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElement* p_pElement);

    void StoreString(std::ofstream* p_pFile, CStdString* p_pData);
    void DeleteChildTransactionEventDataList();

private:
    CCommandRoot* m_pCommand;
    CStdString m_Data;
    std::list<CTransactionEventData*> m_ChildTransactionEventDataList;
};
