// LayerParameterStack.h: Schnittstelle für die Klasse CLayerParameterStack.
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include <CommunicationModel/Common/CommunicationModelDefinitions.h>
#include <ParameterSet/ParameterStack.h>

class CLayerParameterSet;

class CLayerParameterStack: public CParameterStack
{
public:
    CLayerParameterStack();
    virtual ~CLayerParameterStack();
    virtual CLayerParameterStack& operator=(CLayerParameterStack& other);
    virtual BOOL operator==(CLayerParameterStack& other);

    BOOL PushLayer(CLayerParameterSet& p_rParameterSet);
    BOOL PopLayer(ELayer p_eLayer, CLayerParameterSet& p_rParameterSet);
    BOOL PeekLayer(ELayer p_eLayer, CLayerParameterSet& p_rParameterSet);

    BOOL GetLayerParameter(ELayer p_eLayer, CStdString p_Name, BYTE* p_pValue, DWORD p_ulSize);
    BOOL GetLayerParameter(ELayer p_eLayer, CStdString p_Name, CStdString& p_rValue);

    BOOL DeleteLayerParameter(ELayer p_eLayer, CStdString p_Name);
};
