#pragma once

#include <CommunicationModel/Common/CommunicationModelDefinitions.h>

#include "BaseClasses/Command_DCS.h"

class CCommand_DCS_Epos4 : public CCommand_DCS
{
public:
    CCommand_DCS_Epos4();
    CCommand_DCS_Epos4(DWORD p_ulCommandId);
    virtual ~CCommand_DCS_Epos4();

    BOOL InitCommand(DWORD p_ulCommandId);

    CCommand_DCS_Epos4& operator=(CCommand_DCS_Epos4& p_rOther);
    CCommandRoot* CloneCommand();

private:
    BOOL InitCommand_ObjectDictionary(DWORD p_ulCommandId);
    BOOL InitCommand_NetworkManagement(DWORD p_ulCommandId);
    BOOL InitCommand_GeneralGateway(DWORD p_ulCommandId);
    BOOL InitCommand_LayerSettingServices(DWORD p_ulCommandId);
    BOOL InitCommand_Register(DWORD p_ulCommandId);
    BOOL InitCommand_EtherCatStateMachine(DWORD p_ulCommandId);
    BOOL InitCommand_FoE(DWORD p_ulCommandId);

    //Object dictionary
    void SetDefaultParameter_WriteObject();
    void SetDefaultParameter_InitiateSegmentedWrite();
    void SetDefaultParameter_SegmentedWrite();
    void SetDefaultParameter_ReadObject();
    void SetDefaultParameter_InitiateSegmentedRead();
    void SetDefaultParameter_SegmentedRead();
    void SetDefaultParameter_AbortTransfer();

    //Network management
    void SetDefaultParameter_SendNMTService();

    //General gateway
    void SetDefaultParameter_SendCANFrame();
    void SetDefaultParameter_ReadCANFrame();
    void SetDefaultParameter_RequestCANFrame();

    //Layer setting services
    void SetDefaultParameter_SendLSSFrame();
    void SetDefaultParameter_ReadLSSFrame();

    //ESC register
    BOOL SetDefaultParameter_ReadEscRegister();
    BOOL SetDefaultParameter_WriteEscRegister();

    //ESM
    BOOL SetDefaultParameter_InitEsm();
    BOOL SetDefaultParameter_ChangeEsmState();
    BOOL SetDefaultParameter_GetEsmState();

    //FoE
    BOOL SetDefaultParameter_ReadFile();
    BOOL SetDefaultParameter_WriteFile();
    BOOL SetDefaultParameter_InitiateSegmentedReadFile();
    BOOL SetDefaultParameter_InitiateSegmentedWriteFile();
    BOOL SetDefaultParameter_SegmentReadFile();
    BOOL SetDefaultParameter_SegmentWriteFile();
};
