/***************************************************************************

    HEADER FILE:    Command_I_MCP_Definitions.h

***************************************************************************

    COPYRIGHT (C)   2013 maxon motor control

    Written by:     Ineichen Adrian
    System:         Visual C++
    File:           Command_I_MCP_Definitions.h
    Date:           25.02.2013

****************************************************************************

    Task:

***************************************************************************/

#if !defined(COMMAND_I_MCP_DEFINITIONS_25032013)
#define COMMAND_I_MCP_DEFINITIONS_25032013

//Commands
const DWORD     MCP_SEND_ACCESS_PASSWORD                = 0x00023001;
const DWORD     MCP_SET_CHIP_SETTINGS                   = 0x00023002;
const DWORD     MCP_GET_CHIP_SETTINGS                   = 0x00023003;

const DWORD     MCP_SET_CURRENT_SPI_TRANSFER_SETTINGS   = 0x00023004;
const DWORD     MCP_GET_CURRENT_SPI_TRANSFER_SETTINGS   = 0x00023005;

const DWORD     MCP_SET_CURRENT_CHIP_SETTINGS           = 0x00023006;
const DWORD     MCP_GET_CURRENT_CHIP_SETTINGS           = 0x00023007;

const DWORD     MCP_SET_CURRENT_PIN_DIRECTIONS          = 0x00023008;
const DWORD     MCP_GET_CURRENT_PIN_DIRECTIONS          = 0x00023009;

const DWORD     MCP_SET_CURRENT_PIN_VALUES              = 0x0002300A;
const DWORD     MCP_GET_CURRENT_PIN_VALUES              = 0x0002300B;

const DWORD     MCP_WRITE_READ_DATA                     = 0x0002300C;


//USB constants
const int MCP_STRUCTURE_MIN_DATA_SIZE = 0;
const int MCP_STRUCTURE_MAX_DATA_SIZE = 60;
const int MCP_STRUCTURE_MAX_SIZE = 64;
const int MCP_MAX_NAME_LENGTH = 28;
const int MAX_PWD_LENGTH = 8;

const int MCP_COMMAND_CMD_CODE = 0;
const int MCP_COMMAND_SUBCMD_CODE = 1;

const int MCP_RESPONSE_CMD_CODE = 0;
const int MCP_RESPONSE_RETURN_CODE = 1;
const int MCP_RESPONSE_SUBCMD_CODE = 2;

//SPI Transfer
const int MCP_RESPONSE_NB_OF_RECEIVED_DATA_BYTES = 2;
const int MCP_RESPONSE_TRANSER_ENGINE_STATUS = 3;
const int MCP_RESPONSE_RECEIVED_DATA_BYTES = 4;

//MCP command code
const BYTE MCP_CMD_CODE_GET_MCP2210_STATUS          = 0x10;
const BYTE MCP_CMD_CODE_CANCEL_SPI_TRANSFER         = 0x11;
const BYTE MCP_CMD_CODE_GET_NB_EVENTS_INTERRUP_PIN  = 0x12;
const BYTE MCP_CMD_CODE_GET_CHIP_SETTINGS           = 0x20;
const BYTE MCP_CMD_CODE_SET_CHIP_SETTINGS           = 0x21;
const BYTE MCP_CMD_CODE_SET_PIN_VALUES              = 0x30;
const BYTE MCP_CMD_CODE_GET_PIN_VALUES              = 0x31;
const BYTE MCP_CMD_CODE_SET_PIN_DIRECTIONS          = 0x32;
const BYTE MCP_CMD_CODE_GET_PIN_DIRECTIONS          = 0x33;
const BYTE MCP_CMD_CODE_SET_SPI_TRANSFER_SETTINGS   = 0x40;
const BYTE MCP_CMD_CODE_GET_SPI_TRANSFER_SETTINGS   = 0x41;
const BYTE MCP_CMD_CODE_TRANSFER_SPI_DATA           = 0x42;
const BYTE MCP_CMD_CODE_READ_EEPROM_MEMORY          = 0x50;
const BYTE MCP_CMD_CODE_WRITE_EEPROM_MEMORY         = 0x51;
const BYTE MCP_CMD_CODE_SET_PARAMETER               = 0x60;
const BYTE MCP_CMD_CODE_GET_PARAMETER               = 0x61;
const BYTE MCP_CMD_CODE_SEND_ACCESS_PWD             = 0x70;
const BYTE MCP_CMD_CODE_REQUEST_SPI_BUS_RELEASE     = 0x80;

//MCP subCommand code
const BYTE MCP_SUBCMD_CODE_SPI_POWER_UP_TRANSFER_SETTINGS   = 0x10;
const BYTE MCP_SUBCMD_CODE_CHIP_SETTINGS_POWER_UP_DEFAULT   = 0x20;
const BYTE MCP_SUBCMD_CODE_POWER_UP_KEY_PARAMETERS          = 0x30;
const BYTE MCP_SUBCMD_CODE_PRODUCT_NAME                     = 0x40;
const BYTE MCP_SUBCMD_CODE_MANUFACTURER_NAME                = 0x50;

//MCP return code definitions
const BYTE  MCP_NO_ERROR                            = 0x00;
const BYTE  MCP_ERROR_SPI_BUS_NOT_AVAILABLE         = 0xF7;
const BYTE  MCP_ERROR_SPI_TRANSFER_IN_PROGRESS      = 0xF8;
const BYTE  MCP_ERROR_UNSUPPORTED_COMMAND           = 0xF9;
const BYTE  MCP_ERROR_EEPROM_WRITE_FAILURE          = 0xFA;
const BYTE  MCP_ERROR_BLOCKED_ACCESS                = 0xFB;
const BYTE  MCP_ERROR_ACCESS_NOT_ALLOWED_FC         = 0xFC;
const BYTE  MCP_ERROR_ACCESS_NOT_ALLOWED_FD         = 0xFD;

//Spi Transfer Engine Status
enum EMcpSpiTransferEngineStatus
{
    MSTES_UNKNOWN                                    = 0x00,
    MSTES_TRANSFER_FINISHED_NO_MORE_DATA             = 0x10,
    MSTES_TRANSFER_STARTED_NO_DATA_TO_RECEIVE        = 0x20,
    MSTES_TRANSFER_NOT_FINISHED_DATA_RECEIVED        = 0x30,
};

//Spi Transfer Settings
struct SMcpIdleChipSelect
{
    BYTE ubChipSelect0  :1;
    BYTE ubChipSelect1  :1;
    BYTE ubChipSelect2  :1;
    BYTE ubChipSelect3  :1;
    BYTE ubChipSelect4  :1;
    BYTE ubChipSelect5  :1;
    BYTE ubChipSelect6  :1;
    BYTE ubChipSelect7  :1;
    BYTE ubChipSelect8  :1;
    BYTE ubNotUsed0     :1;
    BYTE ubNotUsed1     :1;
    BYTE ubNotUsed2     :1;
    BYTE ubNotUsed3     :1;
    BYTE ubNotUsed4     :1;
    BYTE ubNotUsed5     :1;
    BYTE ubNotUsed6     :1;
};

struct SMcpActiveChipSelect
{
    BYTE ubChipSelect0  :1;
    BYTE ubChipSelect1  :1;
    BYTE ubChipSelect2  :1;
    BYTE ubChipSelect3  :1;
    BYTE ubChipSelect4  :1;
    BYTE ubChipSelect5  :1;
    BYTE ubChipSelect6  :1;
    BYTE ubChipSelect7  :1;
    BYTE ubChipSelect8  :1;
    BYTE ubNotUsed0     :1;
    BYTE ubNotUsed1     :1;
    BYTE ubNotUsed2     :1;
    BYTE ubNotUsed3     :1;
    BYTE ubNotUsed4     :1;
    BYTE ubNotUsed5     :1;
    BYTE ubNotUsed6     :1;
};

struct SMcpSpiTransferSettings
{
    DWORD                   ulBitRate;
    SMcpIdleChipSelect      idleChipSelect;
    SMcpActiveChipSelect    activeChipSelect;
    WORD                    usChipSelectToDataDelay;
    WORD                    usLastDataByteToChipSelect;
    WORD                    usDelayBetweenSubsequentDataBytes;
    WORD                    usBytesToTransferPerSpiTransfer;
    BYTE                    ubSpiMode; 
};


#endif  //COMMAND_I_MCP_DEFINITIONS_25032013

