
#pragma once

#include <CommunicationModel/CommonLayer/Classes/Commands/ProtocolStack/BaseClasses/Command_PS.h>
#include <CommunicationModel/CommonLayer/Classes/Commands/ProtocolStack/Command_PS_CANopen_Definitions.h>

class CCommand_PS_CANopen : public CCommand_PS
{
public:
    CCommand_PS_CANopen();
    CCommand_PS_CANopen(DWORD p_ulCommandId);
    virtual ~CCommand_PS_CANopen();

    BOOL InitCommand(DWORD p_ulCommandId);

    CCommand_PS_CANopen& operator=(CCommand_PS_CANopen& p_rOther);
    CCommandRoot* CloneCommand();

private:
    void SetDefaultParameter_InitiateSDODownload();
    void SetDefaultParameter_DownloadSDOSegment();
    void SetDefaultParameter_InitiateSDOUpload();
    void SetDefaultParameter_UploadSDOSegment();
    void SetDefaultParameter_AbortSDOTransfer();
    void SetDefaultParameter_NetworkIndication();
    void SetDefaultParameter_SendNMTService();
    void SetDefaultParameter_SendCANFrame();
    void SetDefaultParameter_ReadCANFrame();
    void SetDefaultParameter_RequestCANFrame();
    void SetDefaultParameter_SendLSSFrame();
    void SetDefaultParameter_ReadLSSFrame();
    void SetDefaultParameter_CleanupCommunication();
};
