#pragma once

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/BaseClasses/Command_VCS.h>
#include "Command_VCS_DataRecorder_Definitions.h"

class CCommand_VCS_DataRecorder : public CCommand_VCS
{
public:
    CCommand_VCS_DataRecorder();
    CCommand_VCS_DataRecorder(DWORD p_ulCommandId);
    virtual ~CCommand_VCS_DataRecorder();

    BOOL InitCommand(DWORD p_ulCommandId);

    CCommand_VCS_DataRecorder& operator=(CCommand_VCS_DataRecorder& other);
    CCommandRoot*CloneCommand();

private:
    BOOL InitCommand_DataRecording(DWORD p_ulCommandId);

    //Data Recorder
    void SetDefaultParameter_SetRecorderParameter();
    void SetDefaultParameter_GetRecorderParameter();
    void SetDefaultParameter_EnableTrigger();
    void SetDefaultParameter_DisableAllTriggers();
    void SetDefaultParameter_ActivateChannel();
    void SetDefaultParameter_DeactivateAllChannels();
    void SetDefaultParameter_ActiveChannel();
    void SetDefaultParameter_GetVariable();
    void SetDefaultParameter_GetMaxNbOfSamples();
    void SetDefaultParameter_GetNbOfRecordedSamples();
    void SetDefaultParameter_SetNbOfPrecedingSamples();
    void SetDefaultParameter_GetNbOfPrecedingSamples();
    void SetDefaultParameter_GetNbOfSamplingVariables();
    void SetDefaultParameter_GetSamplingPeriod();
    void SetDefaultParameter_StartRecorder();
    void SetDefaultParameter_StopRecorder();
    void SetDefaultParameter_ForceTrigger();
    void SetDefaultParameter_IsRecorderRunning();
    void SetDefaultParameter_IsRecorderTriggered();
    void SetDefaultParameter_GetRecorderStatus();
    void SetDefaultParameter_SetRecorderConfiguration();
    void SetDefaultParameter_GetRecorderConfiguration();
    void SetDefaultParameter_ReadChannelVectorSize();
    void SetDefaultParameter_ReadChannelDataVector();
    void SetDefaultParameter_GetVectorStartOffset();
    void SetDefaultParameter_ReadDataBuffer();
    void SetDefaultParameter_ExtractChannelDataVector();
};
