#pragma once

#include "BaseClasses/Command_VCS.h"
#include "Command_VCS_ErrorHandling_Definitions.h"

class CCommand_VCS_ErrorHandling: public CCommand_VCS
{
public:
    CCommand_VCS_ErrorHandling();
    CCommand_VCS_ErrorHandling(DWORD p_ulCommandId);
    virtual ~CCommand_VCS_ErrorHandling();

    BOOL InitCommand(DWORD p_ulCommandId);

    CCommand_VCS_ErrorHandling& operator=(CCommand_VCS_ErrorHandling& p_rOther);
    CCommandRoot*CloneCommand();

private:
    BOOL InitCommand_Reset(DWORD p_ulCommandId);
    BOOL InitCommand_ErrorHistory(DWORD p_ulCommandId);
    BOOL InitCommand_Safety(DWORD p_ulCommandId);

    //Reset
    void SetDefaultParameter_ResetDevice();
    void SetDefaultParameter_WaitForReboot();

    //Error history
    void SetDefaultParameter_ClearDeviceErrors();
    void SetDefaultParameter_GetNbOfDeviceErrors();
    void SetDefaultParameter_GetDeviceErrorCode();

    //Safety
    void SetDefaultParameter_GotoSafeState();
};
