
#pragma once

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/BaseClasses/Command_VCS.h>
#include "Command_VCS_InputsOutputs_Definitions.h"

class CCommand_VCS_InputsOutputs : public CCommand_VCS
{
public:
    CCommand_VCS_InputsOutputs();
    CCommand_VCS_InputsOutputs(DWORD p_ulCommandId);
    virtual ~CCommand_VCS_InputsOutputs();

    BOOL InitCommand(DWORD p_ulCommandId);

    CCommand_VCS_InputsOutputs& operator=(CCommand_VCS_InputsOutputs& p_rOther);
    CCommandRoot* CloneCommand();

private:
    BOOL InitCommand_DigitalInputs(DWORD p_ulCommandId);
    BOOL InitCommand_DigitalOutputs(DWORD p_ulCommandId);
    BOOL InitCommand_AnalogInputs(DWORD p_ulCommandId);
    BOOL InitCommand_AnalogOutputs(DWORD p_ulCommandId);

    BOOL InitCommand_PositionCompare(DWORD p_ulCommandId);
    BOOL InitCommand_PositionMarker(DWORD p_ulCommandId);

    //Digital inputs
    void SetDefaultParameter_DigitalInputConfiguration();
    void SetDefaultParameter_GetAllDigitalInputs();
    //Digital outputs
    void SetDefaultParameter_DigitalOutputConfiguration();
    void SetDefaultParameter_GetAllDigitalOutputs();
    void SetDefaultParameter_SetAllDigitalOutputs();
    //Analog inputs
    void SetDefaultParameter_AnalogInputConfiguration();
    void SetDefaultParameter_GetAnalogInput();
    void SetDefaultParameter_GetAnalogInputVoltage();
    void SetDefaultParameter_GetAnalogInputState();
    //Analog outputs
    void SetDefaultParameter_AnalogOutputConfiguration();
    void SetDefaultParameter_SetAnalogOutput();
    void SetDefaultParameter_SetAnalogOutputVoltage();
    void SetDefaultParameter_SetAnalogOutputState();
    //Position compare
    void SetDefaultParameter_SetPositionCompareParameter();
    void SetDefaultParameter_GetPositionCompareParameter();
    void SetDefaultParameter_ActivatePositionCompare();
    void SetDefaultParameter_DeactivatePositionCompare();
    void SetDefaultParameter_EnablePositionCompare();
    void SetDefaultParameter_DisablePositionCompare();
    void SetDefaultParameter_SetPositionCompareReferencePosition();
    //Position marker
    void SetDefaultParameter_SetPositionMarkerParameter();
    void SetDefaultParameter_GetPositionMarkerParameter();
    void SetDefaultParameter_ActivatePositionMarker();
    void SetDefaultParameter_DeactivatePositionMarker();
    void SetDefaultParameter_ReadPositionMarkerCounter();
    void SetDefaultParameter_ReadPositionMarkerCapturedPosition();
    void SetDefaultParameter_ResetPositionMarkerCounter();
};
