///////////////////////////////////////////////////////////
//Command_VCS_OperationMode_Definitions.h
//
//Project:CommonWinLib
//Author:Software team
//DateofCreation:14.08.2015
//
//Copyright2015,maxonmotorag.
//Allrightsreserved.
///////////////////////////////////////////////////////////

#pragma once

//Command IDs
    //Initialisation
    const DWORD    MODE_SET_OPERATION_MODE                             = 0x000A0001;
    const DWORD    MODE_GET_OPERATION_MODE                             = 0x000A0002;

    //Current Mode
    const DWORD    MODE_CUM_GET_CURRENT_MUST                           = 0x000A0011;
    const DWORD    MODE_CUM_SET_CURRENT_MUST                           = 0x000A0012;
    const DWORD    MODE_CUM_ACTIVATE_ANALOG_CURRENT_SETPOINT           = 0x000A0013;
    const DWORD    MODE_CUM_DEACTIVATE_ANALOG_CURRENT_SETPOINT         = 0x000A0014;
    const DWORD    MODE_CUM_ENABLE_ANALOG_CURRENT_SETPOINT             = 0x000A0015;
    const DWORD    MODE_CUM_DISABLE_ANALOG_CURRENT_SETPOINT            = 0x000A0016;

    //Current Pulse Mode
    const DWORD    MODE_CPM_DO_CURRENT_PULSE                           = 0x000A0021;

    //Velocity Mode
    const DWORD    MODE_VEM_GET_VELOCITY_MUST                          = 0x000A0031;
    const DWORD    MODE_VEM_SET_VELOCITY_MUST                          = 0x000A0032;

    //Velocity Mode Analog
    const DWORD    MODE_VEM_ACTIVATE_ANALOG_VELOCITY_SETPOINT          = 0x000A0041;
    const DWORD    MODE_VEM_DEACTIVATE_ANALOG_VELOCITY_SETPOINT        = 0x000A0042;
    const DWORD    MODE_VEM_ENABLE_ANALOG_VELOCITY_SETPOINT            = 0x000A0043;
    const DWORD    MODE_VEM_DISABLE_ANALOG_VELOCITY_SETPOINT           = 0x000A0044;

    //Position Mode
    const DWORD    MODE_POM_GET_POSITION_MUST                          = 0x000A0051;
    const DWORD    MODE_POM_SET_POSITION_MUST                          = 0x000A0052;

    //Position Mode Analog
    const DWORD    MODE_POM_ACTIVATE_ANALOG_POSITION_SETPOINT          = 0x000A0061;
    const DWORD    MODE_POM_DEACTIVATE_ANALOG_POSITION_SETPOINT        = 0x000A0062;
    const DWORD    MODE_POM_ENABLE_ANALOG_POSITION_SETPOINT            = 0x000A0063;
    const DWORD    MODE_POM_DISABLE_ANALOG_POSITION_SETPOINT           = 0x000A0064;

    //Cyclic sync torque mode
    const DWORD    MODE_CST_INIT_CYCLIC_SYNC_TORQUE_MODE               = 0x000A0071;
    const DWORD    MODE_CST_SET_TARGET_TORQUE                          = 0x000A0072;
    const DWORD    MODE_CST_GET_TARGET_TORQUE                          = 0x000A0073;
    const DWORD    MODE_CST_GET_TORQUE_IS                              = 0x000A0074;

    //Homing mode
    const DWORD    MODE_HM_FIND_HOME                                   = 0x000A0081;
    const DWORD    MODE_HM_GET_HOMING_PARAMETER                        = 0x000A0082;
    const DWORD    MODE_HM_SET_HOMING_PARAMETER                        = 0x000A0083;
    const DWORD    MODE_HM_STOP_HOMING                                 = 0x000A0084;
    const DWORD    MODE_HM_DEFINE_POSITION                             = 0x000A0085;
    const DWORD    MODE_HM_GET_HOMING_STATE                            = 0x000A0086;

    //Profile Position Mode
    const DWORD    MODE_PPM_GET_POSITION_PROFILE                       = 0x000A0091;
    const DWORD    MODE_PPM_GET_TARGET_POSITION                        = 0x000A0092;
    const DWORD    MODE_PPM_HALT_POSITION_MOVEMENT                     = 0x000A0093;
    const DWORD    MODE_PPM_MOVE_TO_POSITION                           = 0x000A0094;
    const DWORD    MODE_PPM_SET_POSITION_PROFILE                       = 0x000A0095;
    const DWORD    MODE_PPM_ENABLE_POSITION_WINDOW                     = 0x000A0096;
    const DWORD    MODE_PPM_DISABLE_POSITION_WINDOW                    = 0x000A0097;

    //ProfileVelocityMode
    const DWORD    MODE_PVM_GET_TARGET_VELOCITY                        = 0x000A00A1;
    const DWORD    MODE_PVM_GET_VELOCITY_PROFILE                       = 0x000A00A2;
    const DWORD    MODE_PVM_HALT_VELOCITY_MOVEMENT                     = 0x000A00A3;
    const DWORD    MODE_PVM_MOVE_WITH_VELOCITY                         = 0x000A00A4;
    const DWORD    MODE_PVM_SET_VELOCITY_PROFILE                       = 0x000A00A5;
    const DWORD    MODE_PVM_ENABLE_VELOCITY_WINDOW                     = 0x000A00A6;
    const DWORD    MODE_PVM_DISABLE_VELOCITY_WINDOW                    = 0x000A00A7;

    //Interpolated position mode
    const DWORD    MODE_IPM_SET_IPM_BUFFER_PARAMETER                   = 0x000A00B1;
    const DWORD    MODE_IPM_GET_IPM_BUFFER_PARAMETER                   = 0x000A00B2;
    const DWORD    MODE_IPM_CLEAR_IPM_BUFFER                           = 0x000A00B3;
    const DWORD    MODE_IPM_GET_FREE_IPM_BUFFER_SIZE                   = 0x000A00B4;
    const DWORD    MODE_IPM_ADD_PVT_VALUE_TO_IPM_BUFFER                = 0x000A00B5;
    const DWORD    MODE_IPM_START_IPM_TRAJECTORY                       = 0x000A00B6;
    const DWORD    MODE_IPM_STOP_IPM_TRAJECTORY                        = 0x000A00B7;
    const DWORD    MODE_IPM_GET_IPM_STATUS                             = 0x000A00B8;

    //Master Encoder Mode
    const DWORD    MODE_MEM_SET_MASTER_ENCODER_PARAMETER               = 0x000A00C1;
    const DWORD    MODE_MEM_GET_MASTER_ENCODER_PARAMETER               = 0x000A00C2;

    //Step Direction Mode
    const DWORD    MODE_STM_SET_STEP_DIRECTION_PARAMETER               = 0x000A00D1;
    const DWORD    MODE_STM_GET_STEP_DIRECTION_PARAMETER               = 0x000A00D2;

    //Tuning Mode
    const DWORD    MODE_TUNING_DO_TUNING                               = 0x000A00E1;
