#pragma once

#include <CommunicationModel/Common/CommunicationModelDefinitions.h>
#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/BaseClasses/Command_VCS.h>
#include "Command_VCS_Scada_Definitions.h"

class CCommand_VCS_Scada : public CCommand_VCS
{
public:
    CCommand_VCS_Scada();
    CCommand_VCS_Scada(DWORD p_ulCommandId);
    virtual ~CCommand_VCS_Scada();

    BOOL InitCommand(DWORD p_ulCommandId);

    CCommand_VCS_Scada& operator=(CCommand_VCS_Scada& p_rOther);
    CCommandRoot*CloneCommand();

private:
    BOOL InitCommand_Initialisation(DWORD p_ulCommandId);
    BOOL InitCommand_ProgramStatus(DWORD p_ulCommandId);
    BOOL InitCommand_ProgramVariableAccess(DWORD p_ulCommandId);
    BOOL InitCommand_ProcessInputOutputAccess(DWORD p_ulCommandId);
    BOOL InitCommand_ProcessImageAccess(DWORD p_ulCommandId);

    //Initialisation
    void SetDefaultParameter_SetBootupBehavior();
    void SetDefaultParameter_GetBootupBehavior();
    //Program Status
    void SetDefaultParameter_ColdstartPlc();
    void SetDefaultParameter_WarmstartPlc();
    void SetDefaultParameter_HotstartPlc();
    void SetDefaultParameter_StopPlc();
    void SetDefaultParameter_ErasePlc();
    void SetDefaultParameter_GetPlcStatus();
    //Program Variable Access
    void SetDefaultParameter_InitVariableTable();
    void SetDefaultParameter_SetVariable();
    void SetDefaultParameter_GetVariable();
    //Process Input/Output Access
    void SetDefaultParameter_SetProcessInput();
    void SetDefaultParameter_GetProcessOutput();
    void SetDefaultParameter_SetProcessInputBit();
    void SetDefaultParameter_GetProcessOutputBit();
    //Process Image Access
    void SetDefaultParameter_SetProcessInputImage();
    void SetDefaultParameter_GetProcessOutputImage();
};
