#pragma once

#include <CommunicationModel/Common/CommunicationModelDefinitions.h>
#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/BaseClasses/Command_VCS.h>
#include "Command_VCS_StateMachine_Definitions.h"

class CCommand_VCS_StateMachine : public CCommand_VCS
{
public:
    CCommand_VCS_StateMachine();
    CCommand_VCS_StateMachine(DWORD p_ulCommandId);
    virtual ~CCommand_VCS_StateMachine();

    BOOL InitCommand(DWORD p_ulCommandId);

    CCommand_VCS_StateMachine& operator=(CCommand_VCS_StateMachine& p_rOther);
    CCommandRoot*CloneCommand();

private:
    BOOL InitCommand_StateMachineCia402(DWORD p_ulCommandId);
    BOOL InitCommand_StateMachineMaxon(DWORD p_ulCommandId);

    //State machine Cia402
    void SetDefaultParameter_ClearFault();
    void SetDefaultParameter_GetDisableState();
    void SetDefaultParameter_GetEnableState();
    void SetDefaultParameter_GetFaultState();
    void SetDefaultParameter_GetQuickStopState();
    void SetDefaultParameter_SetDisableState();
    void SetDefaultParameter_SetEnableState();
    void SetDefaultParameter_SetQuickStopState();
    //State machine maxon
    void SetDefaultParameter_GetStoppingState();
    void SetDefaultParameter_SetStoppingState();
};
