#pragma once

#include "ErrorInfo.h"
#include "Error.h"
#include "ErrorProducer.h"
#include "ErrorCode_Definitions.h"

class CErrorHandling
{
public:
    CErrorHandling();
    virtual ~CErrorHandling();

    //Initialisation
    BOOL InitErrorProducer(CErrorProducer* p_pErrorProducer);

    //Infos
    BOOL GetErrorProducerInfos(ELayer& p_rLayer, CStdString& p_rClassName, CStdString& p_rCommandName);
    BOOL GetError(DWORD p_ulErrorCode, CErrorInfo* p_pErrorInfo);

    //Static Infos
    static BOOL GetErrorDescription(DWORD p_ulErrorCode, CStdString* p_pDescription);
    static BOOL IsDeviceErrorCode(DWORD* p_pulErrorCode);
    static BOOL IsDeviceErrorCode(CErrorInfo& p_rErrorInfo);

protected:
    void DeleteErrorProducer();

protected:
    CErrorProducer* m_pErrorProducer;
};
