#pragma once

#include <MmcTypeDefinition.h>
#include "Error.h"
#include "ErrorProducer.h"

class CErrorInfo
{
public:
    void Reset();
    void SetCommandName(CStdString p_commandName);
    BOOL IsCommandNameSet();
    DWORD GetErrorCode();

    CErrorInfo();
    virtual ~CErrorInfo();

    CErrorInfo& operator=(CErrorInfo& p_rOther);
    CErrorInfo* Clone();

#ifdef _WIN32
    virtual void Serialize(CArchive &ar);
#endif //_WIN32

    void Init(CError* p_pError, CErrorProducer* p_pErrorProducer);
    void Init(DWORD p_ulErrorCode, CErrorProducer* p_pErrorProducer);
    void Init(DWORD p_ulErrorCode);

private:
    void DeleteError();
    void DeleteErrorProducer();

protected:
    CError* m_pError;
    CErrorProducer* m_pErrorProducer;
};

