///////////////////////////////////////////////////////////
//Device_Epos4.h
//
//Project:CommunicationXLib
//Author:MMAGINA
//DateofCreation:28.05.2015
//
//Description:
//
//Copyright2015,maxonmotorag.
//Allrightsreserved.
///////////////////////////////////////////////////////////

#pragma once

#include <CommunicationModel/Common/CommunicationModelDefinitions.h>
#include <MmcTypeDefinition.h>
#include "BaseClasses/DeviceBase.h"

class CCommandGroupStandard_DCS_Epos4;
class CProtocolStackManagerBase;

class CDevice_Epos4 : public CDeviceBase
{
public:
    //Command invoke
    BOOL GetCommands(CStdString* p_pCommandInfo);

    BOOL InitDevice(CErrorInfo* p_pErrorInfo = NULL);
    BOOL InitGateway(CStdString p_protocolStackName);

    CDevice_Epos4();
    CDevice_Epos4(const CDevice_Epos4& p_rObject);
    virtual ~CDevice_Epos4();
    virtual CDeviceBase* Clone();

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

private:
    BOOL VerifyGateway(CStdString p_protocolStackName);
    BOOL InitErrorHandling();

    void DeleteGroupList();
    void FillGroupList();
    BOOL InitGroupList(CGatewayDCStoPS* p_pGateway);

    //Parameter set
    BOOL InitParameterSet();

    //Default settings
    BOOL InitDefaultProtocolStackSettings(CProtocolStackManagerBase* p_pProtocolStackManager, CStdString p_protocolStackName);
    BOOL InitDefaultProtocolStackSettings(CProtocolStackManagerBase* p_pProtocolStackManager, CStdString p_protocolStackName, CStdString p_interfaceName);

    CCommandGroupStandard_DCS_Epos4* m_pCommandGroupStandard;
};
