#pragma once

#include <CommunicationModel/CommonLayer/Classes/Commands/DeviceCommandSet/DcsEtherCatDefinitions.h>
#include <list>

class CEtherCatStateMachine
{
public:
    CEtherCatStateMachine();
    virtual ~CEtherCatStateMachine();

    BOOL GetSmMBox(__uint64 &p_rullSmMBoxOut, __uint64 &p_rullSmMBoxIn);
    BOOL GetSmMBoxBootstrap(__uint64 &p_rullSmMBoxOut, __uint64 &p_rullSmMBoxIn);
    BOOL GetTransition(WORD p_usStateActual, WORD p_usStateAfter, std::list<WORD>& p_rTransitions);

    virtual BOOL Init(WORD p_usPositionAddr, WORD p_usStationId, __uint32 p_ulVendorId, __uint32 p_ulProductCode, __uint32 p_ulRevisionNo, __uint64 p_ullSmMBoxOut, __uint64 p_ullSmMBoxIn, __uint64 p_ullSmOutputs, __uint64 p_ullSmInputs, BYTE* p_pubFmmu0, BYTE* p_pubFmmu1, __uint64 p_ullBootStrap);
    BOOL GetInitCmds(std::list<SInitCmd>& p_rInitCmds);
    BOOL GetTransitionInitCmds(std::list<SInitCmd>& p_rInitCmds, WORD p_usTransition);

protected:
    void InitSmMBoxes(__uint64 p_ullSmMBoxOut, __uint64 p_ullSmMBoxIn);
    void InitSmMBoxesBootstrap(__uint64 p_ullSmMBoxOut, __uint64 p_ullSmMBoxIn, __uint64 p_ullBootStrap);

    BOOL ClearList();
    BOOL AddCommand(WORD p_usTransition, BYTE p_ubCommand, WORD p_usAddress, WORD p_usOffset, WORD p_usTimeout, WORD p_usRetries, WORD p_usLength, BYTE* p_pbData, BOOL p_oValidate = FALSE, BYTE* p_pbDataValidate = 0, BYTE* p_pbDataValidateMask = 0);

private:
    BOOL GetMBoxBootStrap(__uint64 p_ullBootstrap, WORD& p_rusMBoxOutAddress, WORD& p_rusMBoxOutSize, WORD& p_rusMBoxInAddress, WORD& p_rusMBoxInSize);
    __uint64 BuildSmMbBox(__uint64 p_ullSmMBox, WORD p_usMbBoxAddress, WORD p_usMbBoxSize);
    WORD SwapWord(WORD p_rusValue);

private:
    std::list<SInitCmd> m_ListInitCmds;
    __uint64 m_ullSmMBoxOut;
    __uint64 m_ullSmMBoxIn;
    __uint64 m_ullSmMBoxOutBootstrap;
    __uint64 m_ullSmMBoxInBootstrap;
};
