#pragma once

class CDeviceBase;
class CMmcCriticalSectionEx;
class CProtocolStackManagerBase;

class CHandleRegistration_DCS
{
public:
    CHandleRegistration_DCS();
    virtual ~CHandleRegistration_DCS();

    BOOL IsEqual(CDeviceBase* p_pDevice, CProtocolStackManagerBase* p_pManager, HANDLE p_hProtocolStackHandle);
    BOOL IsEmpty();

    void SetKeyHandle(HANDLE p_hDeviceCommandSetHandle);
    void Init(CDeviceBase* p_pDevice, CProtocolStackManagerBase* p_pManager, HANDLE p_phProtocolStackHandle);
    void DeleteRegistration();

    BOOL GetRegistrationValues(CDeviceBase** p_ppDevice, CProtocolStackManagerBase** p_ppManager, HANDLE* p_phProtocolStackHandle);
    HANDLE GetKeyHandle();
    HANDLE GetProtocolStackHandle();

    //Critical section
    BOOL DoLock(DWORD p_ulTimeout = -1);
    BOOL DoUnlock();
    BOOL IsLocked();
    bool AbortLock(bool p_oActive);

private:
    BOOL CreateCriticalSection();
    BOOL DeleteCriticalSection();

    BOOL GetTraceString(CStdString& p_rTraceString);

private:
    CDeviceBase* m_pDevice;
    CMmcCriticalSectionEx* m_pCriticalSection;
    CProtocolStackManagerBase* m_pManager;
    HANDLE m_Handle_DCS;
    HANDLE m_Handle_PS;
};
