#pragma once

#include <Thread/MmcCriticalSection.h>
#include <Drv/SocketCAN/SocketCANDeviceInfo.h>

#include "../../BaseClasses/DeviceInfoHandlingBase.h"

class CCANDeviceInfoHandling : public CDeviceInfoHandlingBase
{
public:
    CCANDeviceInfoHandling(void);
    CCANDeviceInfoHandling(int p_lInstanceValue);
    ~CCANDeviceInfoHandling(void);

    //Singleton
    static CMmcCriticalSection* GetSyncInstance();

    //Info
    BOOL GetInterfaceNames(CStdStringArray& p_rNames);
    BOOL GetPortNames(CStdString p_InterfaceName, CStdStringArray& p_rNames);
    CSocketCANDeviceInfo* FindDeviceInfo(CStdString p_rInterfaceName);

    //Device infos
    BOOL InitDeviceInfos(tSocketCANDeviceInfoList& p_rDeviceInfoList);

private:
    BOOL DeleteDeviceInfoList(tSocketCANDeviceInfoList& p_rDeviceInfoList);

private:
    static CMmcCriticalSection m_CriticalSection;
    int m_lInstanceValue;

    //Device info
    tSocketCANDeviceInfoList m_DeviceInfoList;
};
