#pragma once

#include <Thread/MmcCriticalSection.h>
#include <Drv/Rs232/Rs232DeviceInfo.h>
#include "../../BaseClasses/DeviceInfoHandlingBase.h"

class CRs232DeviceInfoHandling : public CDeviceInfoHandlingBase
{
public:
    CRs232DeviceInfoHandling(void);
    CRs232DeviceInfoHandling(int p_lInstanceValue);
    ~CRs232DeviceInfoHandling(void);

    //Singleton
    static CMmcCriticalSection* GetSyncInstance();

    //Info
    BOOL GetPortNames(CStdStringArray& p_rNames);
    CRs232DeviceInfo* FindDeviceInfo(CStdString p_rPortName);

    //DeviceInfos
    BOOL InitDeviceInfos(tRs232DeviceInfoList& p_rDeviceInfoList);

private:
    BOOL DeleteDeviceInfoList(tRs232DeviceInfoList& p_rDeviceInfoList);

private:
    static CMmcCriticalSection m_CriticalSection;
    int m_lInstanceValue;

    //DeviceInfo
    tRs232DeviceInfoList m_DeviceInfoList;
};

