#pragma once

#include "BaseClasses/InterfaceBase.h"

class CCANDeviceInfoHandling;

class CInterface_CAN : public CInterfaceBase
{
public:
    void Init() { m_strClassType="CInterface_CAN"; }

    //Initialisation
    BOOL InitInterface(CErrorInfo* p_pErrorInfo = NULL);
    BOOL InitInterface(CStdString p_DriverName, CErrorInfo* p_pErrorInfo = NULL);

    BOOL I_OpenInterface(CErrorInfo* p_pErrorInfo = NULL);
    BOOL I_OpenInterfacePort(CPortBase* p_pPort, CStdString p_portName, CErrorInfo* p_pErrorInfo = NULL);

    BOOL I_CloseInterface(CErrorInfo* p_pErrorInfo = NULL);
    BOOL I_CloseInterfacePort(CPortBase* p_pPort, CErrorInfo* p_pErrorInfo = NULL);

    BOOL I_GetInterfaceSettings(CPortBase* p_pPort, DWORD* p_pulBaudrate, DWORD* p_pulTimeout, CErrorInfo* p_pErrorInfo = NULL);
    BOOL I_SetInterfaceSettings(CPortBase* p_pPort, DWORD p_ulBaudrate, DWORD p_ulTimeout, BOOL p_oChangeOnly, CErrorInfo* p_pErrorInfo = NULL);

    BOOL I_GetInterfaceMode(WORD* p_pusModeIndex, CErrorInfo* p_pErrorInfo = NULL);
    BOOL I_SetInterfaceMode(WORD p_usModeIndex, CErrorInfo* p_pErrorInfo = NULL);

    BOOL I_ResetInterface(CPortBase* pPort, CErrorInfo* p_pErrorInfo = NULL);

    //Hardware infos
    BOOL GetInterfaceHardwareNames(CStdStringArray& p_rNames);
    BOOL GetInterfaceHardwareNames(CStdString p_DriverName, CStdStringArray& p_rNames);

    //Info handling
    BOOL InitInfoHandling(CDeviceInfoHandlingBase* p_pInfoHandling);

    CInterface_CAN();
    CInterface_CAN(const CInterface_CAN& rObject);
    virtual ~CInterface_CAN();
    CInterfaceBase* Clone();

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

private:
    BOOL InitErrorHandling();
    BOOL InitGateway(CStdString p_DriverName);
    BOOL InitPort(CStdString p_DriverName, CErrorInfo* p_pErrorInfo);

    //Parameter set
    BOOL InitParameterSet();

private:
    //Info handling
    CCANDeviceInfoHandling* m_pInfoHandling;
};
