#pragma once

#include <CommunicationModel/Interface/Classes/Ports/BaseClasses/PortBase.h>

class CCommand_I_CAN;
class JournalManagerBase;
class CCANDeviceInfoHandling;

class CPort_CAN : public CPortBase
{
public:
    CPort_CAN();
    CPort_CAN(CPort_CAN& p_rObject);
    virtual ~CPort_CAN();
    CPortBase* Clone();

    //Initialisation
    BOOL InitPort(CStdString p_DriverName, CGatewayIToDrv* p_pGateway, CErrorInfo* p_pErrorInfo = 0);
    BOOL InitInfoHandling(CDeviceInfoHandlingBase* p_pInfoHandling);
    BOOL InitGateway(CGatewayIToDrv* p_pGateway);

    //Functionality
    BOOL GetCommands(CStdString* pCommandInfo);

    BOOL I_TransmitCanFrame(HANDLE p_hTransactionHandle, DWORD p_ulCobId, BOOL p_oRtr, BYTE p_ubDlc, void* p_pDataBuffer, DWORD p_ulDataBufferLength, CErrorInfo* p_pErrorInfo = NULL);
    BOOL I_ReceiveCanFrame(HANDLE p_hTransactionHandle, DWORD* p_pulCobId, BOOL* p_poRtr, BYTE* p_pubDlc, void* p_pDataBuffer, DWORD p_ulDataBufferLength, CErrorInfo* p_pErrorInfo = NULL);
    BOOL I_ReceiveFilteredCanFrame(HANDLE p_hTransactionHandle, DWORD p_ulCobIdFilter, BOOL p_oRtrFilter, DWORD* p_pulCobId, BOOL* p_poRtr, BYTE* p_pubDlc, void* p_pDataBuffer, DWORD p_ulDataBufferLength, CErrorInfo* p_pErrorInfo = NULL);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

private:
    BOOL InitErrorHandling();
    BOOL InitGateway(CStdString p_DriverName, CGatewayIToDrv* p_pGateway);
    void SetDefault();
    void ResetPortMembers();

    void DeleteCommands();
    void InitCommands();
    void InitCommands(CGatewayIToDrv* pGateway);

    //Parameter set
    BOOL InitParameterSet();

private:
    CCommand_I_CAN* m_pCommand_TransmitCanFrame;
    CCommand_I_CAN* m_pCommand_ReceiveCanFrame;
    CCommand_I_CAN* m_pCommand_ReceiveFilteredCanFrame;

    //Info handling
    CCANDeviceInfoHandling* m_pInfoHandling;
};
