
#pragma once

#include <CommunicationModel/Interface/Classes/Ports/BaseClasses/PortBase.h>

class CCommand_I_RS232;
class CJournalManagerBase;
class CRs232DeviceInfoHandling;

class CPort_RS232 : public CPortBase
{
public:
    BOOL operator==(const CPort_RS232& rPort);
    CPort_RS232& operator=(CPort_RS232& rSetting);

    CPort_RS232();
    CPort_RS232(CPort_RS232& rObject);
    virtual ~CPort_RS232();
    CPortBase* Clone();

    //Initialisation
    BOOL InitPort(CStdString p_DriverName, CGatewayIToDrv* p_pGateway, CErrorInfo* p_pErrorInfo = 0);
    BOOL InitInfoHandling(CDeviceInfoHandlingBase* p_pInfoHandling);

    //Functionality
    BOOL GetCommands(CStdString* p_pCommandInfo);
    BOOL I_ReadData(HANDLE hTransactionHandle, void* pData, DWORD dNumberOfBytesToRead, DWORD* pdNumberOfBytesRead, CErrorInfo* pErrorInfo=NULL);
    BOOL I_WriteData(HANDLE hTransactionHandle, void* pData, DWORD dNumberOfBytesToWrite, DWORD* pdNumberOfBytesWritten, CErrorInfo* pErrorInfo=NULL);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

private:
    BOOL InitErrorHandling();
    BOOL InitGateway(CStdString p_DriverName, CGatewayIToDrv* p_pGateway);
    void DeleteCommands();
    void InitCommands();
    void InitCommands(CGatewayIToDrv* p_pGateway);
    void ResetPortMembers();
    void SetDefault();

    //ParameterSet
    BOOL InitParameterSet();

private:
    CCommand_I_RS232* m_pCommand_ReadData;
    CCommand_I_RS232* m_pCommand_WriteData;

    //Info handling
    CRs232DeviceInfoHandling* m_pInfoHandling;
};
