
#pragma once

#include <CommunicationModel/Interface/Classes/Ports/BaseClasses/PortBase.h>

class CCommand_I_USB;
class CJournalManagerBase;
class CUsbDeviceInfoHandling;

class CPort_USB : public CPortBase
{
public:
    BOOL operator==(const CPort_USB& rPort);
    CPort_USB& operator=(CPort_USB& rSetting);

    CPort_USB();
    CPort_USB(CPort_USB& rObject);
    virtual ~CPort_USB();
    CPortBase* Clone();

    //Initialisation
    BOOL InitPort(CStdString p_DriverName, CGatewayIToDrv* p_pGateway, CErrorInfo* p_pErrorInfo = 0);
    BOOL InitInfoHandling(CDeviceInfoHandlingBase* p_pInfoHandling);

    //Functionality
    BOOL GetCommands(CStdString* p_pCommandInfo);
    BOOL I_ReadData(HANDLE hTransactionHandle, void* pData, DWORD dNumberOfBytesToRead, DWORD* pdNumberOfBytesRead, CErrorInfo* p_pErrorInfo = NULL);
    BOOL I_WriteData(HANDLE hTransactionHandle, void* pData, DWORD dNumberOfBytesToWrite, DWORD* pdNumberOfBytesWritten, CErrorInfo* p_pErrorInfo = NULL);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase *pJournalManager);
    virtual void ResetJournalManager();

    //Selection update
    BOOL ResetPortEnumeration(CErrorInfo* p_pErrorInfo = NULL);

private:
    BOOL InitErrorHandling();
    BOOL InitGateway(CStdString p_DriverName, CGatewayIToDrv* p_pGateway);
    void DeleteCommands();
    void InitCommands();
    void InitCommands(CGatewayIToDrv* pGateway);
    void ResetPortMembers();
    void SetDefault();

    //Driver infos
    BOOL ExtractDriverInfos(CStdString p_DriverName, CStdString& p_rDriverName, CStdString& p_rDriverParameters);

    //ParameterSet
    BOOL InitParameterSet();

private:
    CCommand_I_USB* m_pCommand_ReadData;
    CCommand_I_USB* m_pCommand_WriteData;

    //UsbDeviceInfoHandling
    CUsbDeviceInfoHandling* m_pInfoHandling;
};
