
#pragma once

#include "../BaseClasses/CommandGroupBase_VCS.h"
#include <Classes/XXMLFile.h>
#include <CommunicationModel/Common/CommunicationModelDefinitions.h>

class CCommandSetGeneralGateway_VCS_CanOpen;
class CCommandSetLayerSettingServices_VCS_CanOpen;
class CCommandSetObjectDictionary_VCS_CanOpen;
class CCommandSetRegulation_VCS_Configuration;
class CCommandSetMotor_VCS_Configuration;
class CCommandSetSafety_VCS_Configuration;
class CCommandSetSensors_VCS_Configuration;
class CCommandSetInfos_VCS_Device;
class CCommandSetErrorHistory_VCS_ErrorHandling;
class CCommandSetReset_VCS_ErrorHandling;
class CCommandSetSafety_VCS_ErrorHandling;
class CCommandSetAnalogInputs_VCS_InputsOutputs;
class CCommandSetAnalogOutputs_VCS_InputsOutputs;
class CCommandSetDigitalInputs_VCS_InputsOutputs;
class CCommandSetDigitalOutputs_VCS_InputsOutputs;
class CCommandSetPositionMarker_VCS_InputsOutputs;
class CCommandSetInfo_VCS_Motion;
class CCommandSetCurrentMode_VCS_OperationMode;
class CCommandSetHomingMode_VCS_OperationMode;
class CCommandSetInitialisation_VCS_OperationMode;
class CCommandSetPositionMode_VCS_OperationMode;
class CCommandSetProfilePositionMode_VCS_OperationMode;
class CCommandSetProfileVelocityMode_VCS_OperationMode;
class CCommandSetVelocityMode_VCS_OperationMode;
class CCommandSetCia402_VCS_StateMachine;
class CCommandSetConfiguration_VCS_Scanning;
class CCommandSetIdentification_VCS_Scanning;
class CGateway;

class CCommandGroupStandard_VCS_Drive : public CCommandGroupBase_VCS
{
public:
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    CCommandGroupStandard_VCS_Drive();
    virtual ~CCommandGroupStandard_VCS_Drive();

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

protected:
    //CANopen
    CCommandSetGeneralGateway_VCS_CanOpen* m_pCommandSetCanOpenGeneralGateway;
    CCommandSetLayerSettingServices_VCS_CanOpen* m_pCommandSetCanOpenLayerSettingServices;
    CCommandSetObjectDictionary_VCS_CanOpen* m_pCommandSetCanOpenObjectDictionary;
    //Configuration
    CCommandSetRegulation_VCS_Configuration* m_pCommandSetConfigurationRegulation;
    CCommandSetMotor_VCS_Configuration* m_pCommandSetConfigurationMotor;
    CCommandSetSafety_VCS_Configuration* m_pCommandSetConfigurationSafety;
    CCommandSetSensors_VCS_Configuration* m_pCommandSetConfigurationSensors;
    //Device
    CCommandSetInfos_VCS_Device* m_pCommandSetDeviceInfos;
    //Error handling
    CCommandSetErrorHistory_VCS_ErrorHandling* m_pCommandSetErrorHandlingErrorHistory;
    CCommandSetReset_VCS_ErrorHandling* m_pCommandSetErrorHandlingReset;
    CCommandSetSafety_VCS_ErrorHandling* m_pCommandSetErrorHandlingSafety;
    //Inputs/Outputs
    CCommandSetAnalogInputs_VCS_InputsOutputs* m_pCommandSetInputsOutputsAnalogInputs;
    CCommandSetAnalogOutputs_VCS_InputsOutputs* m_pCommandSetInputsOutputsAnalogOutputs;
    CCommandSetDigitalInputs_VCS_InputsOutputs* m_pCommandSetInputsOutputsDigitalInputs;
    CCommandSetDigitalOutputs_VCS_InputsOutputs* m_pCommandSetInputsOutputsDigitalOutputs;
    CCommandSetPositionMarker_VCS_InputsOutputs* m_pCommandSetInputsOutputsPositionMarker;
    //Motion
    CCommandSetInfo_VCS_Motion* m_pCommandSetMotionInfo;
    //Operation mode
    CCommandSetCurrentMode_VCS_OperationMode* m_pCommandSetOperationModeCurrentMode;
    CCommandSetHomingMode_VCS_OperationMode* m_pCommandSetOperationModeHomingMode;
    CCommandSetInitialisation_VCS_OperationMode* m_pCommandSetOperationModeInitialisation;
    CCommandSetPositionMode_VCS_OperationMode* m_pCommandSetOperationModePositionMode;
    CCommandSetProfilePositionMode_VCS_OperationMode* m_pCommandSetOperationModeProfilePositionMode;
    CCommandSetProfileVelocityMode_VCS_OperationMode* m_pCommandSetOperationModeProfileVelocityMode;
    CCommandSetVelocityMode_VCS_OperationMode* m_pCommandSetOperationModeVelocityMode;
    //State machine
    CCommandSetCia402_VCS_StateMachine* m_pCommandSetStateMachineCia402;
    //Scanning
    CCommandSetConfiguration_VCS_Scanning* m_pCommandSetScanningConfiguration;
    CCommandSetIdentification_VCS_Scanning* m_pCommandSetScanningIdentification;

private:
    void DeleteSetList();
    void FillSetList();
};
