
#pragma once

#include "../Drive/CommandGroupStandard_VCS_Drive.h"
#include <Classes/XXMLFile.h>
#include <CommunicationModel/Common/CommunicationModelDefinitions.h>

class CCommandSetUnits_VCS_Configuration;
class CCommandSetDataRecording_VCS_DataRecorder;
class CCommandSetPositionCompare_VCS_InputsOutputs;
class CCommandSetCurrentModeAnalog_VCS_OperationMode;
class CCommandSetInterpolatedPositionMode_VCS_OperationMode;
class CCommandSetMasterEncoderMode_VCS_OperationMode;
class CCommandSetPositionModeAnalog_VCS_OperationMode;
class CCommandSetStepDirectionMode_VCS_OperationMode;
class CCommandSetVelocityModeAnalog_VCS_OperationMode;
class CCommandSetPersistence_VCS_Parameter;

class CGateway;

class CCommandGroupStandard_VCS_Drive2 : public CCommandGroupStandard_VCS_Drive
{
public:
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    CCommandGroupStandard_VCS_Drive2();
    virtual ~CCommandGroupStandard_VCS_Drive2();

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

protected:
    //Configuration
    CCommandSetUnits_VCS_Configuration* m_pCommandSetConfigurationUnits;
    //Data recording
    CCommandSetDataRecording_VCS_DataRecorder* m_pCommandSetDataRecorderDataRecording;
    //Inputs/Outputs
    CCommandSetPositionCompare_VCS_InputsOutputs* m_pCommandSetInputsOutputsPositionCompare;
    //Operation mode
    CCommandSetCurrentModeAnalog_VCS_OperationMode* m_pCommandSetOperationModeCurrentModeAnalog;
    CCommandSetInterpolatedPositionMode_VCS_OperationMode* m_pCommandSetOperationModeInterpolatedPositionMode;
    CCommandSetMasterEncoderMode_VCS_OperationMode* m_pCommandSetOperationModeMasterEncoderMode;
    CCommandSetPositionModeAnalog_VCS_OperationMode* m_pCommandSetOperationModePositionModeAnalog;
    CCommandSetStepDirectionMode_VCS_OperationMode* m_pCommandSetOperationModeStepDirectionMode;
    CCommandSetVelocityModeAnalog_VCS_OperationMode* m_pCommandSetOperationModeVelocityModeAnalog;
    //Parameter
    CCommandSetPersistence_VCS_Parameter* m_pCommandSetParameterPersistence;

private:
    void DeleteSetList();
    void FillSetList();
};
