
#pragma once

#include "../BaseClasses/CommandGroupBase_VCS.h"
#include <Classes/XXMLFile.h>
#include <CommunicationModel/Common/CommunicationModelDefinitions.h>

class CCommandSetGeneralGateway_VCS_CanOpen;
class CCommandSetLayerSettingServices_VCS_CanOpen;
class CCommandSetObjectDictionary_VCS_CanOpen;
class CCommandSetInfos_VCS_Device;
class CCommandSetErrorHistory_VCS_ErrorHandling;
class CCommandSetReset_VCS_ErrorHandling;
class CCommandSetSafety_VCS_ErrorHandling;
class CCommandSetConfiguration_VCS_Scanning;
class CCommandSetIdentification_VCS_Scanning;
class CGateway;

class CCommandGroupStandard_VCS_Plc : public CCommandGroupBase_VCS
{
public:
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* pFile, CXXMLFile::CElementPart* pParentElement);

    CCommandGroupStandard_VCS_Plc();
    virtual ~CCommandGroupStandard_VCS_Plc();

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

protected:
    //CANopen
    CCommandSetGeneralGateway_VCS_CanOpen* m_pCommandSetCanOpenGeneralGateway;
    CCommandSetLayerSettingServices_VCS_CanOpen* m_pCommandSetCanOpenLayerSettingServices;
    CCommandSetObjectDictionary_VCS_CanOpen* m_pCommandSetCanOpenObjectDictionary;
    //Device
    CCommandSetInfos_VCS_Device* m_pCommandSetDeviceInfos;
    //Error handling
    CCommandSetErrorHistory_VCS_ErrorHandling* m_pCommandSetErrorHandlingErrorHistory;
    CCommandSetReset_VCS_ErrorHandling* m_pCommandSetErrorHandlingReset;
    CCommandSetSafety_VCS_ErrorHandling* m_pCommandSetErrorHandlingSafety;
    //Scanning
    CCommandSetConfiguration_VCS_Scanning* m_pCommandSetScanningConfiguration;
    CCommandSetIdentification_VCS_Scanning* m_pCommandSetScanningIdentification;

private:
    void DeleteSetList();
    void FillSetList();
};
