#pragma once

#include "../Plc/CommandGroupStandard_VCS_Plc.h"
#include <Classes/XXMLFile.h>
#include <CommunicationModel/Common/CommunicationModelDefinitions.h>

class CCommandSetDownload_VCS_Firmware;
class CCommandSetAnalogInputs_VCS_InputsOutputs;
class CCommandSetAnalogOutputs_VCS_InputsOutputs;
class CCommandSetDigitalInputs_VCS_InputsOutputs;
class CCommandSetDigitalOutputs_VCS_InputsOutputs;
class CCommandSetPersistence_VCS_Parameter;
class CCommandSetInitialisation_VCS_Scada;
class CCommandSetProcessImage_VCS_Scada;
class CCommandSetProcessInputOutput_VCS_Scada;
class CCommandSetProgramStatus_VCS_Scada;
class CCommandSetProgramVariable_VCS_Scada;
class CGateway;

class CCommandGroupStandard_VCS_Plc2 : public CCommandGroupStandard_VCS_Plc
{
public:
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* pParentElement);

    CCommandGroupStandard_VCS_Plc2();
    virtual ~CCommandGroupStandard_VCS_Plc2();

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

private:
    void DeleteSetList();
    void FillSetList();

    //Firmware
    CCommandSetDownload_VCS_Firmware* m_pCommandSetFirmwareDownload;
    //Inputs/Outputs
    CCommandSetAnalogInputs_VCS_InputsOutputs* m_pCommandSetInputsOutputsAnalogInputs;
    CCommandSetAnalogOutputs_VCS_InputsOutputs* m_pCommandSetInputsOutputsAnalogOutputs;
    CCommandSetDigitalInputs_VCS_InputsOutputs* m_pCommandSetInputsOutputsDigitalInputs;
    CCommandSetDigitalOutputs_VCS_InputsOutputs* m_pCommandSetInputsOutputsDigitalOutputs;
    //Parameter
    CCommandSetPersistence_VCS_Parameter* m_pCommandSetParameterPersistence;
    //Scada
    CCommandSetInitialisation_VCS_Scada* m_pCommandSetScadaInitialisation;
    CCommandSetProcessImage_VCS_Scada* m_pCommandSetScadaProcessImage;
    CCommandSetProcessInputOutput_VCS_Scada* m_pCommandSetScadaProcessInputOutput;
    CCommandSetProgramStatus_VCS_Scada* m_pCommandSetScadaProgramStatus;
    CCommandSetProgramVariable_VCS_Scada* m_pCommandSetScadaProgramVariable;
};
