#pragma once

#include <CommunicationModel/CommonLayer/ErrorHandling/ErrorInfo.h>
#include "../BaseClasses/CommandSetBase_VCS.h"
#include <Classes/XXMLFile.h>

class CGateway;
class CCommand_VCS_CanOpen;
class CLayerManagerBase;

class CCommandSetCompleteAccess_VCS_CanOpen : public CCommandSetBase_VCS
{
public:
    CCommandSetCompleteAccess_VCS_CanOpen();
    virtual ~CCommandSetCompleteAccess_VCS_CanOpen();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_GetCompleteObject(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usObjectIndex, void* p_pData, DWORD p_ulNbOfBytesToRead, DWORD* p_pulNbOfBytesRead, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_CanOpen* m_pCommand_GetCompleteObject;
};

