#pragma once

#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CCommand_VCS_CanOpen;
class CLayerManagerBase;

class CCommandSetLayerSettingServices_VCS_CanOpen : public CCommandSetBase_VCS
{
public:
    CCommandSetLayerSettingServices_VCS_CanOpen();
    virtual ~CCommandSetLayerSettingServices_VCS_CanOpen();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase *p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway *p_pGateway);

    //API
    BOOL VCS_SendLSSFrame(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, void* p_pDataBuffer, DWORD p_ulDataBufferLength, CErrorInfo* p_pErrorInfo);
    BOOL VCS_ReadLSSFrame(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usTimeout, void* p_pDataBuffer, DWORD p_ulDataBufferLength, CErrorInfo* p_pErrorInfo);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_CanOpen* m_pCommand_ReadLSSFrame;
    CCommand_VCS_CanOpen* m_pCommand_SendLSSFrame;
};
