#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_Configuration;

class CCommandSetControllerGain_VCS_Configuration: public CCommandSetBase_VCS
{
public:
    CCommandSetControllerGain_VCS_Configuration();
    virtual ~CCommandSetControllerGain_VCS_Configuration();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_SetControllerGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usController, WORD p_usGain, __uint64 p_ullValue, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetControllerGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usController, WORD p_usGain, __uint64* p_pullValue, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Configuration* m_pCommand_GetControllerGain;
    CCommand_VCS_Configuration* m_pCommand_SetControllerGain;
};
