#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_Configuration;

class CCommandSetMotor_VCS_Configuration: public CCommandSetBase_VCS
{
public:
    CCommandSetMotor_VCS_Configuration();
    virtual ~CCommandSetMotor_VCS_Configuration();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_SetMotorParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usMotorType, WORD p_usNominalCurrent, WORD p_usMaxOutputCurrent, BYTE p_ubNbOfPolePairs, WORD p_usThermalTimeConstant, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetMotorParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD *p_pusMotorType, WORD *p_pusNominalCurrent, WORD *p_pusMaxOutputCurrent, BYTE *p_pubNbOfPolePairs, WORD *p_pusThermalTimeConstant, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_SetMotorType(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usMotorType, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetMotorType(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD *p_pusMotorType, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_SetDcMotorParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usNominalCurrent, WORD p_usMaxOutputCurrent, WORD p_usThermalTimeConstant, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetDcMotorParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD *p_pusNominalCurrent, WORD *p_pusMaxOutputCurrent, WORD *p_pusThermalTimeConstant, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_SetEcMotorParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usNominalCurrent, WORD p_usMaxOutputCurrent, WORD p_usThermalTimeConstant, BYTE p_ubNbOfPolePair, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetEcMotorParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD *p_pusNominalCurrent, WORD *p_pusMaxOutputCurrent, WORD *p_pusThermalTimeConstant, BYTE *p_pubNbOfPolePair, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Configuration* m_pCommand_SetMotorParameter;
    CCommand_VCS_Configuration* m_pCommand_GetMotorParameter;
    CCommand_VCS_Configuration* m_pCommand_SetMotorType;
    CCommand_VCS_Configuration* m_pCommand_GetMotorType;
    CCommand_VCS_Configuration* m_pCommand_SetDcMotorParameter;
    CCommand_VCS_Configuration* m_pCommand_GetDcMotorParameter;
    CCommand_VCS_Configuration* m_pCommand_SetEcMotorParameter;
    CCommand_VCS_Configuration* m_pCommand_GetEcMotorParameter;
};

