#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_Configuration;
class CGateway;
class CLayerManagerBase;

class CCommandSetRegulation_VCS_Configuration: public CCommandSetBase_VCS
{
public:
    CCommandSetRegulation_VCS_Configuration();
    virtual ~CCommandSetRegulation_VCS_Configuration();

    BOOL VCS_SetCurrentRegulatorGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usP, WORD p_usI, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetCurrentRegulatorGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusP, WORD* p_pusI, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_SetPositionRegulatorGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usP, WORD p_usI, WORD p_usD, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetPositionRegulatorGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusP, WORD* p_pusI, WORD* p_pusD, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_SetPositionRegulatorFeedForward(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usVelocityFeedForward, WORD p_usAccelerationFeedForward, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetPositionRegulatorFeedForward(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD *p_pusVelocityFeedForward, WORD *p_pusAccelerationFeedForward, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_SetVelocityRegulatorGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usP, WORD p_usI, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetVelocityRegulatorGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusP, WORD* p_pusI, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_SetVelocityRegulatorFeedForward(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usVelocityFeedForward, WORD p_usAccelerationFeedForward, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetVelocityRegulatorFeedForward(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD *p_pusVelocityFeedForward, WORD *p_pusAccelerationFeedForward, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_SetControllerGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usController, WORD p_usGain, __uint64 p_ullValue, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetControllerGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usController, WORD p_usGain, __uint64* p_pullValue, CErrorInfo* p_pErrorInfo = 0);

    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Configuration* m_pCommand_GetControllerGain;
    CCommand_VCS_Configuration* m_pCommand_GetCurrentRegulatorGain;
    CCommand_VCS_Configuration* m_pCommand_GetPositionRegulatorFeedForward;
    CCommand_VCS_Configuration* m_pCommand_GetPositionRegulatorGain;
    CCommand_VCS_Configuration* m_pCommand_GetVelocityRegulatorGain;
    CCommand_VCS_Configuration* m_pCommand_GetVelocityRegulatorFeedForward;
    CCommand_VCS_Configuration* m_pCommand_SetControllerGain;
    CCommand_VCS_Configuration* m_pCommand_SetCurrentRegulatorGain;
    CCommand_VCS_Configuration* m_pCommand_SetPositionRegulatorFeedForward;
    CCommand_VCS_Configuration* m_pCommand_SetPositionRegulatorGain;
    CCommand_VCS_Configuration* m_pCommand_SetVelocityRegulatorGain;
    CCommand_VCS_Configuration* m_pCommand_SetVelocityRegulatorFeedForward;
};
