#pragma once

#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_Configuration;

class CCommandSetSafety_VCS_Configuration: public CCommandSetBase_VCS
{
public:
    CCommandSetSafety_VCS_Configuration();
    virtual ~CCommandSetSafety_VCS_Configuration();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_SetMaxFollowingError(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulMaxFollowingError, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetMaxFollowingError(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulMaxFollowingError, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_SetMaxProfileVelocity(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulMaxProfileVelocity, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetMaxProfileVelocity(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulMaxProfileVelocity, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_SetMaxAcceleration(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulMaxAcceleration, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetMaxAcceleration(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulMaxAcceleration, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Configuration* m_pCommand_GetMaxFollowingError;
    CCommand_VCS_Configuration* m_pCommand_SetMaxFollowingError;

    CCommand_VCS_Configuration* m_pCommand_GetMaxProfileVelocity;
    CCommand_VCS_Configuration* m_pCommand_SetMaxProfileVelocity;

    CCommand_VCS_Configuration* m_pCommand_GetMaxAcceleration;
    CCommand_VCS_Configuration* m_pCommand_SetMaxAcceleration;
};

