#pragma once

#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_Configuration;
class CGateway;
class CLayerManagerBase;

class CCommandSetUnits_VCS_Configuration: public CCommandSetBase_VCS
{
public:
    CCommandSetUnits_VCS_Configuration();
    virtual ~CCommandSetUnits_VCS_Configuration();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_SetVelocityUnits(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BYTE p_ubVelocityDimension, char p_bVelocityNotation, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetVelocityUnits(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BYTE* p_pubVelocityDimension, char* p_pbVelocityNotation, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Configuration* m_pCommand_GetVelocityUnits;
    CCommand_VCS_Configuration* m_pCommand_SetVelocityUnits;
};

