#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_Device;

class CCommandSetInfos_VCS_Device: public CCommandSetBase_VCS
{
public:
    CCommandSetInfos_VCS_Device();
    virtual ~CCommandSetInfos_VCS_Device();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_GetVersion(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pulHardwareVersion, WORD* p_pulSoftwareVersion, WORD* p_pulApplicationNumber, WORD* p_pulApplicationVersion, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetDeviceType(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulDeviceType, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Device* m_pCommand_GetVersion;
    CCommand_VCS_Device* m_pCommand_GetDeviceType;
};

