#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_ErrorHandling;

class CCommandSetErrorHistory_VCS_ErrorHandling: public CCommandSetBase_VCS
{
public:
    CCommandSetErrorHistory_VCS_ErrorHandling();
    virtual ~CCommandSetErrorHistory_VCS_ErrorHandling();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_ClearDeviceErrors(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetNbOfDeviceErrors(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BYTE* p_pubNbOfDeviceErrors, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetDeviceErrorCode(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BYTE p_ubErrorNumber, DWORD* p_pulDeviceErrorCode, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_ErrorHandling* m_pCommand_ClearDeviceErrors;
    CCommand_VCS_ErrorHandling* m_pCommand_GetNbOfDeviceErrors;
    CCommand_VCS_ErrorHandling* m_pCommand_GetDeviceErrorCode;
};

