#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_ErrorHandling;

class CCommandSetReset_VCS_ErrorHandling: public CCommandSetBase_VCS
{
public:
    CCommandSetReset_VCS_ErrorHandling();
    virtual ~CCommandSetReset_VCS_ErrorHandling();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_ResetDevice(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL p_oWaitForReboot, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ResetDevice(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL p_oWaitForReboot, DWORD p_ulRebootTimeout, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_WaitForReboot(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_WaitForReboot(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulRebootTimeout, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_ErrorHandling* m_pCommand_ResetDevice;
    CCommand_VCS_ErrorHandling* m_pCommand_WaitForReboot;
};
