#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_EtherCat;
class CGateway;
class CLayerManagerBase;

class CCommandSetApplication_VCS_EtherCat: public CCommandSetBase_VCS
{
public:
    CCommandSetApplication_VCS_EtherCat();
    virtual ~CCommandSetApplication_VCS_EtherCat();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_InitEsm(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulVendorId, DWORD p_ulProductCode, DWORD p_ulRevisionNo, unsigned __int64 p_ullSmMBoxOut, unsigned __int64 p_ullSmMBoxIn, unsigned __int64 p_ullSmOutputs, unsigned __int64 p_ullSmInputs, BYTE* p_pFmmu0, DWORD p_ulFmmu0Size, BYTE* p_pFmmu1, DWORD p_ulFmmu1Size, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ChangeEsmState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usState, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadAlStatus(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusStatus, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadAlStatusCode(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusStatusCode, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_EtherCat* m_pCommand_InitEsm;
    CCommand_VCS_EtherCat* m_pCommand_ChangeEsmState;
    CCommand_VCS_EtherCat* m_pCommand_ReadAlStatus;
    CCommand_VCS_EtherCat* m_pCommand_ReadAlStatusCode;
};

