#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_EtherCat;

class CCommandSetEeprom_VCS_EtherCat: public CCommandSetBase_VCS
{
public:
    CCommandSetEeprom_VCS_EtherCat();
    virtual ~CCommandSetEeprom_VCS_EtherCat();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_ReadVendorId(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulVendorId, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadSoftwareVersion(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusSoftwareVersion, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadHardwareVersion(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusHardwareVersion, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadApplicationNumber(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusApplicationNumber, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadApplicationVersion(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusApplicationVersion, CErrorInfo* p_pErrorInfo = 0);    
    
private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_EtherCat* m_pCommand_ReadSoftwareVersion;
    CCommand_VCS_EtherCat* m_pCommand_ReadHardwareVersion;
    CCommand_VCS_EtherCat* m_pCommand_ReadApplicationNumber;
    CCommand_VCS_EtherCat* m_pCommand_ReadApplicationVersion;
    CCommand_VCS_EtherCat* m_pCommand_ReadVendorId;
};

