#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_EtherCat;

class CCommandSetRegister_VCS_EtherCat: public CCommandSetBase_VCS
{
public:
    CCommandSetRegister_VCS_EtherCat();
    virtual ~CCommandSetRegister_VCS_EtherCat();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_ReadEscRegister(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usAdo, BYTE* p_pDataBuffer, WORD p_usLength, WORD* p_usLengthRead, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_WriteEscRegister(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usAdo, BYTE* p_pDataBuffer, WORD p_usLength, WORD* p_usLengthWritten, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_EtherCat* m_pCommand_ReadEscRegister;
    CCommand_VCS_EtherCat* m_pCommand_WriteEscRegister;
};

