#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_Firmware;

class CCommandSetDownload_VCS_Firmware: public CCommandSetBase_VCS
{
public:
    CCommandSetDownload_VCS_Firmware();
    virtual ~CCommandSetDownload_VCS_Firmware();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_GetBaseSectorVersion(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusBaseSectorVersion, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetSerialNumber(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, __uint64* p_pullSerialNumber, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ProgramHardwareInfos(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usHardwareVersion, __uint64 p_ullSerialNumber, DWORD p_ulControlWord, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Firmware* m_pCommand_GetBaseSectorVersion;
    CCommand_VCS_Firmware* m_pCommand_GetSerialNumber;
    CCommand_VCS_Firmware* m_pCommand_ProgramHardwareInfos;
};
