#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_InputsOutputs;

class CCommandSetAnalogInputs_VCS_InputsOutputs: public CCommandSetBase_VCS
{
public:
    CCommandSetAnalogInputs_VCS_InputsOutputs();
    virtual ~CCommandSetAnalogInputs_VCS_InputsOutputs();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_AnalogInputConfiguration(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usInputNumber, WORD p_usConfiguration, BOOL p_oExecutionMask, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetAnalogInput(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usInputNumber, WORD* p_pusAnalogValue, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetAnalogInputVoltage(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usInputNumber, long* p_plAnalogValue, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_InputsOutputs* m_pCommand_AnalogInputConfiguration;
    CCommand_VCS_InputsOutputs* m_pCommand_GetAnalogInput;
    CCommand_VCS_InputsOutputs* m_pCommand_GetAnalogInputVoltage;
};

