#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_InputsOutputs;

class CCommandSetAnalogOutputs_VCS_InputsOutputs: public CCommandSetBase_VCS
{
public:
    CCommandSetAnalogOutputs_VCS_InputsOutputs();
    virtual ~CCommandSetAnalogOutputs_VCS_InputsOutputs();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_AnalogOutputConfiguration(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usOutputNumber, WORD p_usConfiguration, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_SetAnalogOutput(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usOutputNumber, WORD* p_pusAnalogValue, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_SetAnalogOutputVoltage(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usOutputNumber, long* p_plAnalogValue, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_SetAnalogOutputState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usConfiguration, long* p_plStateValue, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_InputsOutputs* m_pCommand_AnalogOutputConfiguration;
    CCommand_VCS_InputsOutputs* m_pCommand_SetAnalogOutput;
    CCommand_VCS_InputsOutputs* m_pCommand_SetAnalogOutputVoltage;
    CCommand_VCS_InputsOutputs* m_pCommand_SetAnalogOutputState;
};

