#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_InputsOutputs;

class CCommandSetDigitalInputs_VCS_InputsOutputs: public CCommandSetBase_VCS
{
public:
    CCommandSetDigitalInputs_VCS_InputsOutputs();
    virtual ~CCommandSetDigitalInputs_VCS_InputsOutputs();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_DigitalInputConfiguration(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usDigitalInputNb, WORD p_usConfiguration, BOOL p_oMask, BOOL p_oPolarity, BOOL p_oExecutionMask, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetAllDigitalInputs(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD *p_pusInputs, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_InputsOutputs* m_pCommand_DigitalInputConfiguration;
    CCommand_VCS_InputsOutputs* m_pCommand_GetAllDigitalInputs;
};

