#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_InputsOutputs;

class CCommandSetDigitalOutputs_VCS_InputsOutputs: public CCommandSetBase_VCS
{
public:
    CCommandSetDigitalOutputs_VCS_InputsOutputs();
    virtual ~CCommandSetDigitalOutputs_VCS_InputsOutputs();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_DigitalOutputConfiguration(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usDigitalOutputNb, WORD p_usConfiguration, BOOL p_oState, BOOL p_oMask, BOOL p_oPolarity, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetAllDigitalOutputs(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD *p_pusOutputs, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_SetAllDigitalOutputs(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usOutputs, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_InputsOutputs* m_pCommand_DigitalOutputConfiguration;
    CCommand_VCS_InputsOutputs* m_pCommand_GetAllDigitalOutputs;
    CCommand_VCS_InputsOutputs* m_pCommand_SetAllDigitalOutputs;
};

