#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_InputsOutputs;

class CCommandSetPositionCompare_VCS_InputsOutputs: public CCommandSetBase_VCS
{
public:
    CCommandSetPositionCompare_VCS_InputsOutputs();
    virtual ~CCommandSetPositionCompare_VCS_InputsOutputs();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_SetPositionCompareParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BYTE p_ubOperationalMode, BYTE p_ubIntervalMode, BYTE p_ubDirectionDependency, WORD p_usIntervalWidth, WORD p_usIntervalRepetitions, WORD p_usPulseWidth, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetPositionCompareParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BYTE* p_pubOperationalMode, BYTE* p_pubIntervalMode, BYTE* p_pubDirectionDependency, WORD* p_pusIntervalWidth, WORD* p_pusIntervalRepetitions, WORD* p_pusPulseWidth, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ActivatePositionCompare(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usDigitalOutputNumber, BOOL p_oPolarity, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_DeactivatePositionCompare(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usDigitalOutputNumber, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_EnablePositionCompare(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_DisablePositionCompare(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_SetPositionCompareReferencePosition(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int p_lReferencePosition, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_InputsOutputs* m_pCommand_SetPositionCompareParameter;
    CCommand_VCS_InputsOutputs* m_pCommand_GetPositionCompareParameter;
    CCommand_VCS_InputsOutputs* m_pCommand_ActivatePositionCompare;
    CCommand_VCS_InputsOutputs* m_pCommand_DeactivatePositionCompare;
    CCommand_VCS_InputsOutputs* m_pCommand_EnablePositionCompare;
    CCommand_VCS_InputsOutputs* m_pCommand_DisablePositionCompare;
    CCommand_VCS_InputsOutputs* m_pCommand_SetPositionCompareReferencePosition;
};

