#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_InputsOutputs;

class CCommandSetPositionMarker_VCS_InputsOutputs: public CCommandSetBase_VCS
{
public:
    CCommandSetPositionMarker_VCS_InputsOutputs();
    virtual ~CCommandSetPositionMarker_VCS_InputsOutputs();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_SetPositionMarkerParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BYTE p_ubPositionMarkerEdgeType, BYTE p_ubPositionMarkerMode, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetPositionMarkerParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BYTE* p_pubPositionMarkerEdgeType, BYTE* p_pubPositionMarkerMode, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ActivatePositionMarker(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usDigitalInputNumber, BOOL p_oPolarity, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_DeactivatePositionMarker(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usDigitalInputNumber, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadPositionMarkerCounter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pCount, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadPositionMarkerCapturedPosition(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usCountIndex, int* p_plCapturedPosition, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ResetPositionMarkerCounter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_InputsOutputs* m_pCommand_SetPositionMarkerParameter;
    CCommand_VCS_InputsOutputs* m_pCommand_GetPositionMarkerParameter;
    CCommand_VCS_InputsOutputs* m_pCommand_ActivatePositionMarker;
    CCommand_VCS_InputsOutputs* m_pCommand_DeactivatePositionMarker;
    CCommand_VCS_InputsOutputs* m_pCommand_ReadPositionMarkerCounter;
    CCommand_VCS_InputsOutputs* m_pCommand_ReadPositionMarkerCapturedPosition;
    CCommand_VCS_InputsOutputs* m_pCommand_ResetPositionMarkerCounter;
};

