#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_Motion;
class CGateway;
class CLayerManagerBase;

class CCommandSetInfo_VCS_Motion: public CCommandSetBase_VCS
{
public:
    CCommandSetInfo_VCS_Motion();
    virtual ~CCommandSetInfo_VCS_Motion();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_GetMovementState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL* p_poTargetReached, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_GetPositionIs(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int* p_plPositionIs, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetVelocityIs(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int* p_plVelocityIs, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetCurrentIs(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, short* p_psCurrentIs, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_GetVelocityIsAveraged(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int* p_plVelocityIsAveraged, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetCurrentIsAveraged(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, short* p_psCurrentIsAveraged, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Motion* m_pCommand_GetMovementState;

    CCommand_VCS_Motion* m_pCommand_GetPositionIs;
    CCommand_VCS_Motion* m_pCommand_GetVelocityIs;
    CCommand_VCS_Motion* m_pCommand_GetCurrentIs;

    CCommand_VCS_Motion* m_pCommand_GetVelocityIsAveraged;
    CCommand_VCS_Motion* m_pCommand_GetCurrentIsAveraged;
};

