#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CGateway;
class CLayerManagerBase;
class CCommand_VCS_OperationMode;

class CCommandSetCurrentModeAnalog_VCS_OperationMode: public CCommandSetBase_VCS
{
public:
    CCommandSetCurrentModeAnalog_VCS_OperationMode();
    virtual ~CCommandSetCurrentModeAnalog_VCS_OperationMode();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_ActivateAnalogCurrentSetpoint(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usAnalogInputNumber, float p_fScaling, short p_sOffset, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_DeactivateAnalogCurrentSetpoint(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usAnalogInputNumber, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_EnableAnalogCurrentSetpoint(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_DisableAnalogCurrentSetpoint(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_OperationMode* m_pCommand_ActivateAnalogCurrentSetpoint;
    CCommand_VCS_OperationMode* m_pCommand_DeactivateAnalogCurrentSetpoint;
    CCommand_VCS_OperationMode* m_pCommand_EnableAnalogCurrentSetpoint;
    CCommand_VCS_OperationMode* m_pCommand_DisableAnalogCurrentSetpoint;
};

