#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_OperationMode;
class CGateway;
class CLayerManagerBase;

class CCommandSetCyclicSyncTorqueMode_VCS_OperationMode: public CCommandSetBase_VCS
{
public:
    CCommandSetCyclicSyncTorqueMode_VCS_OperationMode();
    virtual ~CCommandSetCyclicSyncTorqueMode_VCS_OperationMode();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_InitCyclicSyncTorqueMode(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usNominalCurrent, DWORD p_ulTorqueConstant, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_SetTargetTorque(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usTargetCurrent, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetTargetTorque(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusTargetCurrent, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetTorqueIs(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusCurrentIs, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_OperationMode* m_pCommand_InitCyclicSyncTorqueMode;
    CCommand_VCS_OperationMode* m_pCommand_SetTargetTorque;
    CCommand_VCS_OperationMode* m_pCommand_GetTargetTorque;
    CCommand_VCS_OperationMode* m_pCommand_GetTorqueIs;
};

