#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_OperationMode;
class CGateway;
class CLayerManagerBase;

class CCommandSetHomingMode_VCS_OperationMode: public CCommandSetBase_VCS
{
public:
    CCommandSetHomingMode_VCS_OperationMode();
    virtual ~CCommandSetHomingMode_VCS_OperationMode();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_SetHomingParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulHomingAcceleration, DWORD p_ulSpeedSwitch, DWORD p_ulSpeedIndex, int p_lHomeOffset, WORD p_usCurrentThreshold, int p_lHomePosition = 0, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetHomingParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD *p_pulHomingAcceleration, DWORD *p_pulSpeedSwitch, DWORD *p_pulSpeedIndex, int *p_plHomeOffset, WORD* p_pusCurrentThreshold, int *p_plHomePosition = NULL, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_FindHome(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, __int8 p_bHomingMethod, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_StopHoming(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_DefinePosition(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int p_lHomePosition, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetHomingState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL* p_poHomingAttained, BOOL* p_poHomingError, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_OperationMode* m_pCommand_SetHomingParameter;
    CCommand_VCS_OperationMode* m_pCommand_GetHomingParameter;
    CCommand_VCS_OperationMode* m_pCommand_FindHome;
    CCommand_VCS_OperationMode* m_pCommand_StopHoming;
    CCommand_VCS_OperationMode* m_pCommand_DefinePosition;
    CCommand_VCS_OperationMode* m_pCommand_GetHomingState;
};

