#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_OperationMode;
class CGateway;
class CLayerManagerBase;

class CCommandSetInterpolatedPositionMode_VCS_OperationMode: public CCommandSetBase_VCS
{
public:
    CCommandSetInterpolatedPositionMode_VCS_OperationMode();
    virtual ~CCommandSetInterpolatedPositionMode_VCS_OperationMode();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_SetIpmBufferParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usUnderflowWarningLimit, WORD p_usOverflowWarningLimit, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetIpmBufferParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD *p_pusUnderflowWarningLimit, WORD *p_pusOverflowWarningLimit, DWORD *p_pulMaxBufferSize, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ClearIpmBuffer(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetFreeIpmBufferSize(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD *p_pulBufferSize, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_AddPvtValueToIpmBuffer(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int p_lPosition, int p_lVelocity, BYTE p_ubTime, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_StartIpmTrajectory(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_StopIpmTrajectory(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetIpmStatus(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL* p_poTrajectoryRunning, BOOL* p_poIsUnderflowWarning, BOOL* p_poIsOverflowWarning, BOOL* p_poIsVelocityWarning, BOOL* p_poIsAccelerationWarning, BOOL *p_poIsUnderflowError, BOOL* p_poIsOverflowError, BOOL* p_poIsVelocityError, BOOL* p_poIsAccelerationError, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_OperationMode* m_pCommand_SetIpmBufferParameter;
    CCommand_VCS_OperationMode* m_pCommand_GetIpmBufferParameter;
    CCommand_VCS_OperationMode* m_pCommand_ClearIpmBuffer;
    CCommand_VCS_OperationMode* m_pCommand_GetFreeIpmBufferSize;
    CCommand_VCS_OperationMode* m_pCommand_AddPvtValueToIpmBuffer;
    CCommand_VCS_OperationMode* m_pCommand_StartIpmTrajectory;
    CCommand_VCS_OperationMode* m_pCommand_StopIpmTrajectory;
    CCommand_VCS_OperationMode* m_pCommand_GetIpmStatus;
};

