#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_OperationMode;
class CGateway;
class CLayerManagerBase;

class CCommandSetPositionModeAnalog_VCS_OperationMode: public CCommandSetBase_VCS
{
public:
    CCommandSetPositionModeAnalog_VCS_OperationMode();
    virtual ~CCommandSetPositionModeAnalog_VCS_OperationMode();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_ActivateAnalogPositionSetpoint(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usAnalogInputNumber, float p_fScaling, short p_sOffset, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_DeactivateAnalogPositionSetpoint(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usAnalogInputNumber, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_EnableAnalogPositionSetpoint(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_DisableAnalogPositionSetpoint(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_OperationMode* m_pCommand_ActivateAnalogPositionSetpoint;
    CCommand_VCS_OperationMode* m_pCommand_DeactivateAnalogPositionSetpoint;
    CCommand_VCS_OperationMode* m_pCommand_EnableAnalogPositionSetpoint;
    CCommand_VCS_OperationMode* m_pCommand_DisableAnalogPositionSetpoint;
};

