#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_OperationMode;
class CGateway;
class CLayerManagerBase;

class CCommandSetProfileVelocityMode_VCS_OperationMode: public CCommandSetBase_VCS
{
public:
    CCommandSetProfileVelocityMode_VCS_OperationMode();
    virtual ~CCommandSetProfileVelocityMode_VCS_OperationMode();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_SetVelocityProfile(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulProfileAcceleration, DWORD p_ulProfileDeceleration, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetVelocityProfile(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pdProfileAcceleration, DWORD* p_pdProfileDeceleration, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_MoveWithVelocity(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int p_lTargetVelocity, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetTargetVelocity(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int *p_plTargetVelocity, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_HaltVelocityMovement(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_EnableVelocityWindow(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulVelocityWindow, WORD p_usVelocityWindowTime, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_DisableVelocityWindow(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_OperationMode* m_pCommand_SetVelocityProfile;
    CCommand_VCS_OperationMode* m_pCommand_GetVelocityProfile;

    CCommand_VCS_OperationMode* m_pCommand_MoveWithVelocity;
    CCommand_VCS_OperationMode* m_pCommand_GetTargetVelocity;
    CCommand_VCS_OperationMode* m_pCommand_HaltVelocityMovement;

    CCommand_VCS_OperationMode* m_pCommand_EnableVelocityWindow;
    CCommand_VCS_OperationMode* m_pCommand_DisableVelocityWindow;
};

