#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_OperationMode;
class CGateway;
class CLayerManagerBase;

class CCommandSetVelocityModeAnalog_VCS_OperationMode: public CCommandSetBase_VCS
{
public:
    CCommandSetVelocityModeAnalog_VCS_OperationMode();
    virtual ~CCommandSetVelocityModeAnalog_VCS_OperationMode();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_ActivateAnalogVelocitySetpoint(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usAnalogInputNumber, float fScaling, short sOffset, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_DeactivateAnalogVelocitySetpoint(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usAnalogInputNumber, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_EnableAnalogVelocitySetpoint(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_DisableAnalogVelocitySetpoint(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_OperationMode* m_pCommand_ActivateAnalogVelocitySetpoint;
    CCommand_VCS_OperationMode* m_pCommand_DeactivateAnalogVelocitySetpoint;
    CCommand_VCS_OperationMode* m_pCommand_EnableAnalogVelocitySetpoint;
    CCommand_VCS_OperationMode* m_pCommand_DisableAnalogVelocitySetpoint;
};

