#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_OperationMode;
class CGateway;
class CLayerManagerBase;

class CCommandSetVelocityMode_VCS_OperationMode: public CCommandSetBase_VCS
{
public:
    CCommandSetVelocityMode_VCS_OperationMode();
    virtual ~CCommandSetVelocityMode_VCS_OperationMode();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_GetVelocityMust(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int *p_plVelocityMust, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_SetVelocityMust(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int p_lVelocityMust, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_OperationMode* m_pCommand_GetVelocityMust;
    CCommand_VCS_OperationMode* m_pCommand_SetVelocityMust;
};

