#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_Parameter;
class CGateway;
class CLayerManagerBase;

class CCommandSetPersistence_VCS_Parameter: public CCommandSetBase_VCS
{
public:
    CCommandSetPersistence_VCS_Parameter();
    virtual ~CCommandSetPersistence_VCS_Parameter();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_Store(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_Restore(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_RestoreFactory(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_StoreAll(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_RestoreAll(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Parameter* m_pCommand_Store;
    CCommand_VCS_Parameter* m_pCommand_Restore;
    CCommand_VCS_Parameter* m_pCommand_RestoreFactory;

    CCommand_VCS_Parameter* m_pCommand_Store_All;
    CCommand_VCS_Parameter* m_pCommand_Restore_All;
};

