#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_Scada;
class CGateway;
class CLayerManagerBase;

class CCommandSetInitialisation_VCS_Scada: public CCommandSetBase_VCS
{
public:
    CCommandSetInitialisation_VCS_Scada();
    virtual ~CCommandSetInitialisation_VCS_Scada();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_SetBootupBehavior(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usProgramControl, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetBootupBehavior(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusProgramControl, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Scada* m_pCommand_GetBootupBehavior;
    CCommand_VCS_Scada* m_pCommand_SetBootupBehavior;
};