#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_Scada;
class CGateway;
class CLayerManagerBase;

class CCommandSetProcessImage_VCS_Scada: public CCommandSetBase_VCS
{
public:
    CCommandSetProcessImage_VCS_Scada();
    virtual ~CCommandSetProcessImage_VCS_Scada();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_SetProcessInputImage(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulSelectionStart, DWORD p_ulSelectionLength, void* p_pDataBuffer, DWORD p_ulDataBufferLength, CErrorInfo* p_pErrorInfo  = 0);
    BOOL VCS_GetProcessOutputImage(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulSelectionStart, DWORD p_ulSelectionLength, void* p_pDataBuffer, DWORD p_ulDataBufferLength, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Scada* m_pCommand_GetProcessOutputImage;
    CCommand_VCS_Scada* m_pCommand_SetProcessInputImage;
};
