#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_Scada;
class CGateway;
class CLayerManagerBase;

class CCommandSetProcessInputOutput_VCS_Scada: public CCommandSetBase_VCS
{
public:
    CCommandSetProcessInputOutput_VCS_Scada();
    virtual ~CCommandSetProcessInputOutput_VCS_Scada();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_SetProcessInput(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usProcessInputType, BYTE p_ubElementNumber, void* p_pDataBuffer, DWORD p_ulNbOfBytesToWrite, DWORD* p_pulNbOfBytesWritten, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetProcessOutput(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usProcessOutputType, BYTE p_ubElementNumber, void* p_pDataBuffer, DWORD p_ulNbOfBytesToRead, DWORD* p_pulNbOfBytesRead, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_SetProcessInputBit(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usProcessInputType, BYTE p_ubElementNumber, BYTE p_ubBitNumber, BYTE p_ubBitState, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetProcessOutputBit(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usProcessOutputType, BYTE p_ubElementNumber, BYTE p_ubBitNumber, BYTE* p_pubBitState, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Scada* m_pCommand_GetProcessOutput;
    CCommand_VCS_Scada* m_pCommand_SetProcessInput;
    CCommand_VCS_Scada* m_pCommand_GetProcessOutputBit;
    CCommand_VCS_Scada* m_pCommand_SetProcessInputBit;
};

