#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_Scada;
class CGateway;
class CLayerManagerBase;

class CCommandSetProgramVariable_VCS_Scada: public CCommandSetBase_VCS
{
public:
    CCommandSetProgramVariable_VCS_Scada();
    virtual ~CCommandSetProgramVariable_VCS_Scada();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_InitVariableTable(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, char* p_pProjectPathName, WORD p_usLength, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_SetVariable(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CStdString p_VariableName, void* p_pDataBuffer, DWORD p_ulNbOfBytesToWrite, DWORD* p_pulNbOfBytesWritten, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetVariable(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CStdString p_VariableName, void* p_pDataBuffer, DWORD p_ulNbOfBytesToRead, DWORD* p_pulNbOfBytesRead, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Scada* m_pCommand_InitVariableTable;
    CCommand_VCS_Scada* m_pCommand_GetVariable;
    CCommand_VCS_Scada* m_pCommand_SetVariable;
};

