#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_Scanning;
class CGateway;
class CLayerManagerBase;

class CCommandSetConfiguration_VCS_Scanning: public CCommandSetBase_VCS
{
public:
    CCommandSetConfiguration_VCS_Scanning();
    virtual ~CCommandSetConfiguration_VCS_Scanning();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_ReadNodeId(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulNodeId, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_WriteNodeId(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulNodeId, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadStationId(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusStationId, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_WriteStationId(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usStationId, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadTransferRate(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulTransferRate, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_WriteTransferRate(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulTransferRate, CErrorInfo* p_pErrorInfo = 0);

    BOOL VCS_Store(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ResetDevice(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL p_oBroadcast, BOOL p_oWaitForReboot, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_WaitForReboot(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Scanning* m_pCommand_ReadNodeId;
    CCommand_VCS_Scanning* m_pCommand_WriteNodeId;
    CCommand_VCS_Scanning* m_pCommand_ReadStationId;
    CCommand_VCS_Scanning* m_pCommand_WriteStationId;
    CCommand_VCS_Scanning* m_pCommand_ReadTransferRate;
    CCommand_VCS_Scanning* m_pCommand_WriteTransferRate;
    CCommand_VCS_Scanning* m_pCommand_Store;
    CCommand_VCS_Scanning* m_pCommand_Reset;
    CCommand_VCS_Scanning* m_pCommand_WaitForReboot;
};

