#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_Scanning;
class CGateway;
class CLayerManagerBase;

class CCommandSetIdentification_VCS_Scanning: public CCommandSetBase_VCS
{
public:
    CCommandSetIdentification_VCS_Scanning();
    virtual ~CCommandSetIdentification_VCS_Scanning();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_ReadVendorId(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulVendorId, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadDeviceType(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulDeviceType, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadDeviceName(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CStdString& p_rulDeviceName, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadProductCode(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulProductCode, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadRevisionNumber(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulRevisionNumber, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ReadSerialNumber(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulSerialNumber, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_IsIdentifySupported(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulRevisionNumber, BYTE* p_rubIdentifySupported, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_StartIdentify(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulVendorId, DWORD* p_pulProductCode, DWORD* p_pulRevisionNumber, DWORD* p_pulSerialNumber, WORD* p_pusTimeout, BYTE* p_pubNodeId, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_StopIdentify(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BYTE* p_pubMode, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_Scanning* m_pCommand_ReadVendorId;
    CCommand_VCS_Scanning* m_pCommand_ReadDeviceType;
    CCommand_VCS_Scanning* m_pCommand_ReadDeviceName;
    CCommand_VCS_Scanning* m_pCommand_ReadProductCode;
    CCommand_VCS_Scanning* m_pCommand_ReadRevisionNumber;
    CCommand_VCS_Scanning* m_pCommand_ReadSerialNumber;
    CCommand_VCS_Scanning* m_pCommand_IsIdentifySupported;
    CCommand_VCS_Scanning* m_pCommand_StartIdentify;
    CCommand_VCS_Scanning* m_pCommand_StopIdentify;
};

