#pragma once

#include <Classes/XXMLFile.h>
#include "../BaseClasses/CommandSetBase_VCS.h"

class CCommand_VCS_StateMachine;
class CGateway;
class CLayerManagerBase;

class CCommandSetCia402_VCS_StateMachine: public CCommandSetBase_VCS
{
public:
    CCommandSetCia402_VCS_StateMachine();
    virtual ~CCommandSetCia402_VCS_StateMachine();
    CXXMLFile::CElementPart* StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement);

    //Journal manager
    virtual void InitJournalManager(CJournalManagerBase* p_pJournalManager);
    virtual void ResetJournalManager();

    //Gateway
    virtual BOOL InitGateway(CGateway* p_pGateway);

    //API
    BOOL VCS_GetFaultState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL* p_poIsInFault, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_ClearFault(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetQuickStopState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL* p_poQuickStopActive, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_SetQuickStopState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetEnableState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL* p_poIsEnabled, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_SetEnableState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_GetDisableState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL* p_poIsDisabled, CErrorInfo* p_pErrorInfo = 0);
    BOOL VCS_SetDisableState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo = 0);

private:
    void InitCommands();
    void DeleteCommands();

private:
    CCommand_VCS_StateMachine* m_pCommand_ClearFault;
    CCommand_VCS_StateMachine* m_pCommand_GetFaultState;

    CCommand_VCS_StateMachine* m_pCommand_SetDisableState;
    CCommand_VCS_StateMachine* m_pCommand_GetDisableState;

    CCommand_VCS_StateMachine* m_pCommand_SetEnableState;
    CCommand_VCS_StateMachine* m_pCommand_GetEnableState;

    CCommand_VCS_StateMachine* m_pCommand_SetQuickStopState;
    CCommand_VCS_StateMachine* m_pCommand_GetQuickStopState;
};

