#pragma once

#include <CommunicationModel/CommonLayer/Classes/Commands/DeviceCommandSet/DcsCanOpenDriveDef.h>

class CCia402StateMachine
{
public:
    CCia402StateMachine();
    ~CCia402StateMachine();

public:
    BOOL  IsDecelerationRelevantForTransition(WORD p_usTransition);
    BOOL  IsStandstillWindowRelevantForTransition(WORD p_usTransition);
    BOOL  IsBrakeRiseTimeRelevantForTransition(WORD p_usTransition);
    BOOL  IsBrakeFallTimeRelevantForTransition(WORD p_usTransition);

    void FindTransition(EDeviceState p_ActualState, EDeviceState p_TargetState, WORD* p_pusTransition);
    void FindTransitionFromOperationEnabledTo(EDeviceState p_TargetState, WORD* p_pusTransition);
    void FindTransitionFromQuickStopTo(EDeviceState p_TargetState, WORD* p_pusTransition);
    void FindTransitionFromSwitchedOnTo(EDeviceState p_TargetState, WORD* p_pusTransition);
    void FindTransitionFromReadyToSwitchOnTo(EDeviceState p_TargetState, WORD* p_pusTransition);

    void FindRelevantOptionCode(WORD p_usTransition, WORD* p_pusOptionCodeIndex, WORD* p_pusOptionCodeSubIndex);
    void FindRelevantDecelerationProfile(WORD p_usOptionCode, WORD* p_pusDecelerationIndex, WORD* p_pusDecelerationSubIndex);

};

