
#pragma once

#include <CommunicationModel/CommonLayer/Classes/Gateway/Gateway.h>
#include <MmcTypeDefinition.h>

class CCommandRoot;
class CDeviceCommandSetManagerBase;
class CLayerManagerBase;
class CRecorderChannelObjects;

class CGatewayVCStoDCS: public CGateway
{
public:
    CGatewayVCStoDCS();
    virtual ~CGatewayVCStoDCS();
    virtual CGateway* Clone();
    CGatewayVCStoDCS& operator=(CGatewayVCStoDCS& p_rOther);

    BOOL InitGateway();
    virtual BOOL ProcessCommand(CCommandRoot* p_pCommand, CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle);

    WORD GetNewBitMask(WORD p_usConfiguration, WORD p_usOldMask, BOOL p_oState);

    BOOL CopyBuffer(char* p_pBuffer, DWORD p_ulSize, CStdString* p_pValue);

    virtual BOOL SetGatewayDeviceTimeout(CDeviceCommandSetManagerBase* p_pManager, HANDLE p_hDCS_Handle, HANDLE p_hTransactionHandle, DWORD p_ulGatewayTimeout);

    void CreateRecorderChannelObjects(WORD p_usMaxNumberOfRecorderVariables);
    CRecorderChannelObjects* GetRecorderChannelObjects();

protected:
    //Logging
    BOOL LogCmdMessageIn(CCommandRoot* p_pCommand, BOOL p_oLogMessageActive, CStdString p_label);
    BOOL LogCmdMessageOut(CCommandRoot* p_pCommand, BOOL p_oLogMessageActive, CStdString p_label);

private:
    void DeleteRecorderChannelObjects();

private:
    CRecorderChannelObjects* m_pRecorderChannelObjects;
};
