#pragma once

#include <MmcTypeDefinition.h>

class CRecorderChannelObject;

class CRecorderChannelObjects
{
public:
    CRecorderChannelObjects(WORD p_usMaxNumberOfRecorderVariables);
    virtual ~CRecorderChannelObjects();

    CRecorderChannelObject* GetChannel(int p_lChannelIndex);

    BOOL SetChannel(int p_lChannelIndex, WORD p_usIndex, BYTE p_ubSubIndex, BYTE p_ubSize);
    BOOL GetChannel(int p_lChannelIndex, WORD& p_rusIndex, BYTE& p_rubSubIndex, BYTE& p_rubSize);

    BOOL IsEqual(int p_lChannelIndex, WORD p_usIndex, BYTE p_ubSubIndex);

    BOOL IsSizeAvailable(int p_lChannelIndex);
    WORD GetSizeInWord(int p_lChannelIndex);
    WORD GetTotalSizeInWord();

    int GetNbOfConfiguredChannels();

    void ResetTrigger();
    void SetTrigger(BYTE p_ubTriggerType);
    BYTE GetTrigger();

private:
    void CreateChannels();
    void CreateChannel();

    void DeleteChannels();

private:
    BYTE m_ubTriggerType;
    std::vector<CRecorderChannelObject*> m_RecorderChannelObjects;
    WORD m_usMaxNumberOfRecorderVariables;
};
