#pragma once

#include <CommunicationModel/CommonLayer/Classes/Commands/DeviceCommandSet/DcsCanOpenCommunicationDef.h>

class CDiagnosisHistory
{
public:
    CDiagnosisHistory(void);
    virtual ~CDiagnosisHistory(void);
    void Reset();

    //Initialisation
    BOOL InitDiagnosisHistory(BYTE p_ubMaximumMessages, BYTE p_ubNewestMessage, BYTE p_ubNewestAckMessage);
    BOOL AddDiagnoseMessage(SDiagnosisMessage p_diagnosisMessage);
    BOOL AddDiagnoseMessage(SDiagnosisLongMessage p_diagnosisMessage);

    //Messages
    BYTE GetNbOfDiagnoseMessages();
    BOOL GetDiagnoseMessage(BYTE p_ubMessageNumber, SDiagnosisMessage& p_rsMessage);

    //Filtered messages
    BYTE GetNbOfDiagnoseMessages(EDiagSource p_eSource, WORD p_usId);
    BOOL GetDiagnoseMessage(BYTE p_ubMessageNumber, EDiagSource p_eSource, WORD p_usId, SDiagnosisMessage& p_rsMessage);

private:
    //Helpers
    BOOL GetMaxNbOfMessages(int& p_rlMaxNb);
    BOOL GetNewestMessageIndex(int& p_rlIndex);
    BOOL GetRingBufferIndex(int p_lMsgIndex, int& p_rlRingBufferIndex);

private:
    //Maximum messages
    BYTE m_ubMaximumMessages;

    //Newest message
    BYTE m_ubNewestMessage;

    //Newest acknowledged message
    BYTE m_ubNewestAckMessage;

    //Message buffer parameters
    std::list<SDiagnosisMessage> m_MessageList;
};
