#pragma once

#include <MmcTypeDefinition.h>
#include <Thread/MmcCriticalSection.h>
#include <Thread/MmcCriticalSectionEx.h>

class CDeviceCommandSetManagerBase;
class CVirtualDeviceBase;

class CHandleRegistration_VCS
{
public:
    CHandleRegistration_VCS();
    virtual ~CHandleRegistration_VCS();
    BOOL IsEqual(CVirtualDeviceBase* p_pVirtualDevice, CDeviceCommandSetManagerBase* p_pManager, HANDLE p_hDeviceCommandSetHandle);
    BOOL IsEmpty();

    void SetKeyHandle(HANDLE p_hVCS_Handle);
    void Init(CVirtualDeviceBase* p_pVirtualDevice, CDeviceCommandSetManagerBase* p_pManager, HANDLE p_hDeviceCommandSetHandle);
    void DeleteRegistration();

    BOOL GetRegistrationValues(CVirtualDeviceBase** p_ppVirtualDevice, CDeviceCommandSetManagerBase** p_ppManager, HANDLE* p_phDeviceCommandSetHandle);
    HANDLE GetKeyHandle();

    //Critical section
    BOOL DoLock(DWORD p_ulTimeout = -1);
    BOOL DoUnlock();
    BOOL IsLocked();
    BOOL AbortLock(BOOL oActive);

private:
    BOOL CreateCriticalSection();
    BOOL DeleteCriticalSection();

    BOOL GetTraceString(CStdString& p_rTraceString);

private:
    CDeviceCommandSetManagerBase* m_pManager;
    CVirtualDeviceBase* m_pVirtualDevice;
    HANDLE m_Handle_DCS;
    HANDLE m_Handle_VCS;

    CMmcCriticalSectionEx* m_pCriticalSection;
};
