#pragma once

class CProtocolStackSettings;

#include <list>
#include <MmcTypeDefinition.h>

typedef std::list<CProtocolStackSettings*> tProtocolStackSettingsList;

class CDeviceSettings
{
public:
    CDeviceSettings();
    virtual ~CDeviceSettings();

    void Init(CStdString p_virtualDeviceName, CStdString p_deviceName, CStdString p_protocolStackName, CStdString p_interfaceName, CStdString p_portName);
    CStdString GetVirtualDeviceName();
    CStdString GetDeviceName();
    CStdString GetProtocolStackName();
    CStdString GetInterfaceName();
    CStdString GetPortName();

    BOOL operator==(const CDeviceSettings& data) const;
    CDeviceSettings& operator=(CDeviceSettings& other);
    CDeviceSettings(const CDeviceSettings& other);
    void Reset();

    void AddProtocolStackSettings(CProtocolStackSettings* p_pProtocolStackSettings);
    BOOL GetProtocolStackSettingsList(tProtocolStackSettingsList** p_ppList);

    BOOL SetDefaultProtocolStackSettings(CProtocolStackSettings* p_pProtocolStackSettings);
    BOOL GetDefaultProtocolStackSettings(CProtocolStackSettings* p_pProtocolStackSettings);

private:
    void CreateDefaultProtocolStackSettings();
    void DeleteDefaultProtocolStackSettings();

    void DeleteProtocolStackSettingsList();
    void CopyProtocolStackSettingsList(tProtocolStackSettingsList* p_pSourceList);

private:
    CStdString m_strVirtualDeviceName;
    CStdString m_strDeviceName;
    CStdString m_strProtocolStackName;
    CStdString m_strInterfaceName;
    CStdString m_strPortName;

    CProtocolStackSettings* m_pDefaultProtocolStackSettings;
    tProtocolStackSettingsList m_ProtocolStackSettingsList;
};

typedef std::list<CDeviceSettings*> tDeviceSettingsList;
