#pragma once

class CDeviceSettings;
class CProtocolStackSettings;

#include <list>
#ifdef WINVER

#include <CommunicationModel/VirtualCommandSet/Common/DeviceSettings.h>

class COpenDeviceDlg : public CDialog
{
public:
    void GetParameter(CStdString *p_pStrVirtualDeviceName, CStdString *p_pStrDeviceName, CStdString *p_pStrProtocolStackName, CStdString *p_pStrInterfaceName, CStdString *p_pStrPortName, DWORD_PTR* p_pulBaudrate, DWORD_PTR* p_pulTimeout);
    void SetParameter(tDeviceSettingsList* p_pDeviceSettingsList, CStdStringArray *p_pstrVirtualDeviceNameArray, CStdString p_strDeviceName, CStdString p_strProtocolStackName, CStdString p_strInterfaceName, CStdString p_strPortName, DWORD_PTR p_ulBaudrate, DWORD_PTR p_ulTimeout);

    COpenDeviceDlg(CWnd* p_pParent = NULL);

    CComboBox m_ComboBaudrate;
    CComboBox m_ComboInterfaceName;
    CComboBox m_ComboProtocolStackName;
    CComboBox m_ComboPortName;
    CComboBox m_ComboDeviceName;
    DWORD_PTR m_EditTimeout;

public:
    virtual BOOL DestroyWindow();

protected:
    virtual void DoDataExchange(CDataExchange* pDX);

protected:
    virtual BOOL OnInitDialog();
    afx_msg void OnSelendokComboDeviceName();
    afx_msg void OnSelendokComboPortName();
    afx_msg void OnSelendokComboProtocolStackName();
    afx_msg void OnSelendokComboInterfaceName();
    virtual void OnCancel();
    afx_msg void OnSelendokComboBaudrate();
    afx_msg void OnKillfocusTimeout();

    DECLARE_MESSAGE_MAP()

private:
    BOOL InitControl();
    BOOL InitControl_DeviceName(CStdString p_strVirtualDeviceName, CStdString* p_pStrDeviceNameSel);
    BOOL InitControl_ProtocolStackName(CStdString p_strVirtualDeviceName, CStdString p_strDeviceName, CStdString* p_pStrProtocolStackNameSel);
    BOOL InitControl_InterfaceName(CStdString p_strVirtualDeviceName, CStdString p_strDeviceName, CStdString p_strProtocolStackName, CStdString* p_pStrInterfaceNameSel);
    BOOL InitControl_PortName(CStdString p_strVirtualDeviceName, CStdString p_strDeviceName, CStdString p_strProtocolStackName, CStdString strInterfaceName, CStdString* p_pStrPortNameSel);
    BOOL InitControl_BaudrateTimeout(CStdString p_strVirtualDeviceName, CStdString p_strDeviceName, CStdString p_strProtocolStackName, CStdString p_strInterfaceName, CStdString p_strPortName, DWORD_PTR* p_pulBaudrateSel, DWORD_PTR* p_pulTimeout);

    BOOL UpdateControl_DeviceName();
    BOOL UpdateControl_ProtocolStackName();
    BOOL UpdateControl_InterfaceName();
    BOOL UpdateControl_PortName();
    BOOL UpdateControl_Baudrate();
    BOOL UpdateControl_Timeout();

    CStdString GetNoDeviceString();
    CStdString GetNoProtocolStackString();
    CStdString GetNoInterfaceString();
    CStdString GetNoPortString();
    CStdString GetNoBaudrateString();

    BOOL FindDeviceSettings(CStdString p_strVirtualDeviceName, CStdString p_strDeviceName, CStdString p_strProtocolStackName, CStdString p_strInterfaceName, CStdString p_strPortName, CDeviceSettings** p_ppDeviceSettings);

    void DeleteDeviceSettingsList();
    void CopyDeviceSettingsList(tDeviceSettingsList* p_pSourceList);

    void GetVirtualDeviceNameAddictedToDeviceName();

    tDeviceSettingsList m_DeviceSettingsList;
    CStdStringArray m_strVirtualDeviceNameArray;
    CStdString m_strVirtualDeviceName;
    CStdString m_strDeviceName;
    CStdString m_strInterfaceName;
    CStdString m_strPortName;
    CStdString m_strProtocolStackName;
    DWORD_PTR m_ulBaudrate;
    DWORD_PTR m_ulTimeout;
};
#endif
