#pragma once

#ifdef WINVER

#include "afxwin.h"

class CProtocolStackSettings;

class COpenSubDeviceDlg : public CDialog
{
    DECLARE_DYNAMIC(COpenSubDeviceDlg)

public:
    CComboBox m_ComboProtocolStackName;
    CComboBox m_ComboSubDeviceName;
    CComboBox m_ComboBitRateName;

public:
    COpenSubDeviceDlg(CWnd* pParent = NULL);
    virtual ~COpenSubDeviceDlg();

protected:
    virtual void DoDataExchange(CDataExchange* pDX);

    DECLARE_MESSAGE_MAP()

    virtual BOOL OnInitDialog();
    virtual BOOL DestroyWindow();
    virtual void OnCancel();
    afx_msg void OnCbnSelendokComboSubDeviceName();
    afx_msg void OnCbnSelendokComboProtocolStackName();
    afx_msg void OnCbnSelendokComboBitRateName();

public:
    void GetParameter(CStdString& p_rSubDeviceName, CStdString& p_rProtocolStackName, CStdString& p_rBitRateName);
    void SetParameter(CStdStringArray* p_paSubDeviceNames, CStdStringArray* p_paProtocolStackNames, CStdStringArray* p_paBitRateNames);

private:
    void InitComboBoxProtocolStackNames();
    void InitComboBoxSubDeviceNames();
    void InitComboBoxBitRateNames();

    void UpdateComboBoxProtocolStackNameSelection();
    void UpdateComboBoxSubDeviceNameSelection();
    void UpdateComboBoxBitRateNameSelection();

    CStdString GetNoProtocolStackName();
    CStdString GetNoSubDeviceName();
    CStdString GetNoBitRateName();

private:
    CStdString m_protocolStackName;
    CStdString m_subDeviceName;
    CStdString m_bitRateName;
    CStdStringArray m_aProtocolStackNames;
    CStdStringArray m_aSubDeviceNames;
    CStdStringArray m_aBitRateNames;
};

#endif
