#pragma once

#include <Thread/MmcThread.h>
#include "../../../Common/Classes/CommunicationSetting.h"
#include "../../../CommonLayer/Classes/Commands/Command/CommandRoot.h"

#define WM_NextCommunicationSetting WM_USER + 1
#define WM_EndCommunicationSearch WM_USER + 2

class CSearchCommunicationDlg;
class CVirtualCommandSet_ManagerBase;

class CSearchCommunicationThread : public CMmcThread
{
public:
    CSearchCommunicationThread();
    virtual ~CSearchCommunicationThread();

    void SetStartHandle(HANDLE hHandle);
    void Init(CVirtualCommandSet_ManagerBase* p_pManager, CCommandRoot* p_pCommand);
    void InitSearchCommunicationDlg(CSearchCommunicationDlg* p_pSearchCommunicationDlg);
    void InitCommunicationSettingList(std::list<CCommunicationSetting*>* p_pList);

    DWORD WINAPI ThreadFunc();

private:
    void DeleteTestCommand();
    void DeleteStartCommunicationSetting();

    BOOL StoreCommunicationSetting(HANDLE p_hHandle);
    BOOL OpenCommunicationSetting(CCommunicationSetting* p_pSetting, CCommunicationSetting* p_pLastSetting, HANDLE* p_phHandle);
    BOOL IsDeviceChangeNecessary(CCommunicationSetting* p_pSetting, CCommunicationSetting* p_pLastSetting);
    BOOL RestoreCommunicationSetting(HANDLE* p_phHandle);

private:
    CCommandRoot* m_pTestCommand;
    CCommunicationSetting* m_pStartCommunicationSetting;
    CSearchCommunicationDlg* m_pSearchCommunicationDlg;
    CVirtualCommandSet_ManagerBase* m_pVirtualCommandSetManager;
    HANDLE m_hHandle;
    std::list<CCommunicationSetting*>* m_pCommunicationSettingList;
};
