#pragma once

#include <Thread/MmcThread.h>

#define WM_NEXT_COMMUNICATION_SETTING WM_USER + 1
#define WM_NEXT_NODE_SETTING + 2
#define WM_END_COMMUNICATION_SEARCH WM_USER + 3

class CSearchSubCommunicationDlg;
class CVirtualCommandSet_ManagerBase;

class CSearchSubCommunicationThread : public CMmcThread
{
public:
    CSearchSubCommunicationThread();
    virtual ~CSearchSubCommunicationThread();

    void Init(CSearchSubCommunicationDlg* p_pSearchCommunicationDlg);
    void Init(CVirtualCommandSet_ManagerBase* p_pManager);
    void Init(HANDLE p_hDevice);
    void InitCommunicationSettings(std::list<DWORD> p_aBaudrate, std::list<BYTE> p_aNodeId);

    DWORD WINAPI ThreadFunc();

private:
    BOOL TestCommunication(BYTE p_ubNodeId);

private:
    CSearchSubCommunicationDlg* m_pSearchCommunicationDlg;
    CVirtualCommandSet_ManagerBase* m_pVirtualCommandSetManager;
    HANDLE m_hDevice;
    std::list<DWORD> m_aBaudrate;
    std::list<BYTE> m_aNodeId;
};
