#pragma once

#include <CommunicationModel/CommonLayer/ErrorHandling/ErrorInfo.h>
#include <CommunicationModel/VirtualCommandSet/Common/DeviceSettings.h>
#include <CommunicationModel/VirtualCommandSet/Dialogs/OpenDeviceDlg.h>
#include <CommunicationModel/VirtualCommandSet/Dialogs/SearchCommunicationDefinitions.h>
#include <MmcTypeDefinition.h>

class CCommandRoot;
class CVirtualCommandSet_Manager;

class CVirtualCommandSet_DialogManager
{
public:
    BOOL SearchCommunicationDlg(CVirtualCommandSet_Manager* p_pVirtualCommandSet_Manager, HANDLE* p_pKeyHandle, CStdString p_strVirtualDeviceName, CCommandRoot* p_pSearchCommand, CStdString p_strSearchingInfo, CStdString p_strRootDeviceName, CStdString p_strRootProtocolStackName, CStdString p_strRootInterfaceName, CStdString p_strRootPortName, EDialogMode p_eDialogMode);
    HANDLE OpenDriveDlg(CVirtualCommandSet_Manager* p_pVirtualCommandSet_Manager, CStdString p_strVirtualDeviceName, CStdStringArray* p_pstrDriveNameArray, HANDLE p_hPS_BaseLayerHandle, CErrorInfo* p_pErrorInfo = NULL);
    HANDLE OpenPlcDlg(CVirtualCommandSet_Manager* p_pVirtualCommandSet_Manager, CStdString p_strVirtualDeviceName, CStdStringArray* p_pstrPlcNameArray, HANDLE p_hPS_BaseLayerHandle, CErrorInfo* p_pErrorInfo = NULL);
    HANDLE OpenVirtualDeviceDlg(CVirtualCommandSet_Manager* p_pVirtualCommandSet_Manager, CStdStringArray* p_pstrVirtualDeviceNameArray, CErrorInfo* p_pErrorInfo = NULL);
    HANDLE OpenSubDeviceDlg(CVirtualCommandSet_Manager* p_pVirtualCommandSet_Manager, CStdString p_virtualDeviceName, HANDLE p_hVirtualDevice, CErrorInfo* p_pErrorInfo = NULL);

    CVirtualCommandSet_DialogManager();
    virtual ~CVirtualCommandSet_DialogManager();

private:
    BOOL InitDeviceSettingsSelection(CVirtualCommandSet_Manager* p_pVirtualCommandSet_Manager, CStdString p_strVirtualDeviceName, tDeviceSettingsList* p_pList);
    BOOL InitDeviceSettingsSelection(CVirtualCommandSet_Manager* p_pVirtualCommandSet_Manager, CStdString p_strVirtualDeviceName, CStdString p_strDeviceName, tDeviceSettingsList* p_pList);
    BOOL InitDeviceSettingsSelection(CVirtualCommandSet_Manager* p_pVirtualCommandSet_Manager, CStdString p_strVirtualDeviceName, CStdString p_strDeviceName, CStdString p_strProtocolStackName, tDeviceSettingsList* p_pList);
    BOOL InitDeviceSettingsSelection(CVirtualCommandSet_Manager* p_pVirtualCommandSet_Manager, CStdString p_strVirtualDeviceName, CStdString p_strDeviceName, CStdString p_strProtocolStackName, CStdString p_strInterfaceName, tDeviceSettingsList* p_pList);
    BOOL InitDeviceSettingsSelection(CVirtualCommandSet_Manager* p_pVirtualCommandSet_Manager, CStdString p_strVirtualDeviceName, CStdString p_strDeviceName, CStdString p_strProtocolStackName, CStdString p_strInterfaceName, CStdString p_strPortName, tDeviceSettingsList* p_pList);
    BOOL DeleteDeviceSettingsSelection(tDeviceSettingsList* p_pList);
    BOOL SetGatewaySettings(CVirtualCommandSet_Manager* p_pVirtualCommandSet_Manager, HANDLE p_hVirtualDevice, CStdString p_strBitRate, CErrorInfo* p_pErrorInfo = NULL);
    BOOL IsGatewaySupported(CVirtualCommandSet_Manager* p_pVirtualCommandSet_Manager, HANDLE p_hVirtualDevice, CErrorInfo* p_pErrorInfo);

private:
    CStdStringArray m_strVirtualDeviceNameArray;
    DWORD_PTR m_ulTimeout;
};
