#pragma once

#include <RecorderCmdManager/Classes/RecorderCmdDefinitions.h>

class CObjectEntry;

class CRecorderCmdChannel
{
public:
    CRecorderCmdChannel();
    virtual ~CRecorderCmdChannel();

    void Serialize(CArchive& ar);
    CRecorderCmdChannel& operator=(CRecorderCmdChannel& p_other);
    CRecorderCmdChannel* Clone();

    // Channel activation
    BOOL IsActive();
    void SetActive(BOOL p_oActive);

    // Scale
    BOOL IsLeftScale();
    BOOL IsRightScale();
    void SetLeftScale();
    void SetRightScale();

    // Object functions
    BOOL SetSelObject(WORD p_usIndex, BYTE p_ubSubIndex, CStdString p_type);
    BOOL SetSelObject(WORD p_usIndex, BYTE p_ubSubIndex, WORD p_usType);
    void SetSelObjectDefault(int p_lChannelIndex);

    BOOL GetSelObject(WORD& p_rusIndex, BYTE& p_rubSubIndex, WORD& p_rusType);

    BYTE GetSelObjectSubIndex();
    WORD GetSelObjectIndex();
    CStdString GetSelObjectDataTypeLongStr();
    EDataType GetSelObjectDataType();

    WORD GetSelObjectSize();

    CStdString GetSelObjectName();
    void SetSelObjectName(CStdString p_objectName);

private:
    BOOL m_oActive;
    CObjectEntry* m_pSelObjectEntry;
    EScale m_Scale;
};
