#pragma once

class CLayerParameterStack;
class CRecorderCmdConfiguration;
class CRecorderCmdManager;
class CVirtualDeviceCommunicationModel;

class CRecorderConfigurationEntry
{
public:
    CRecorderConfigurationEntry();
    virtual ~CRecorderConfigurationEntry();

    BOOL Init(CRecorderCmdManager* p_pRecorderManager);
    BOOL InitCommunicationModel(CVirtualDeviceCommunicationModel* p_pCommunicationModel);
    BOOL Init(HANDLE p_KeyHandle, CLayerParameterStack& p_rParameterStack);
    BOOL IsEqual(HANDLE p_KeyHandle, CLayerParameterStack& p_rParameterStack);
    BOOL GetRecorderConfiguration(CRecorderCmdConfiguration*& p_rpRecorderConfiguration);

private:
    BOOL CreateLayerParameterStack(CLayerParameterStack& p_rParameterStack);
    BOOL CreateRecorderConfiguration();
    BOOL DeleteLayerParameterStack();
    BOOL DeleteRecorderConfiguration();

private:
    HANDLE m_KeyHandle;
    CLayerParameterStack* m_pLayerParameterStack;
    CRecorderCmdConfiguration* m_pRecorderConfiguration;
};