// Command_I_FTD2XX.cpp: Implementierung der Klasse CCommand_I_FTD2XX.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <CommunicationModel/CommonLayer/Classes/Commands/Interface/Command_I_FTD2XX.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
/////////////////////////0/////////////////////////////////////////////
CCommand_I_FTD2XX::CCommand_I_FTD2XX()
{
}

CCommand_I_FTD2XX::CCommand_I_FTD2XX(DWORD dCommandId)
{
    InitCommand(dCommandId);
}

CCommand_I_FTD2XX::~CCommand_I_FTD2XX()
{
}

//******************************************************************
CCommandRoot* CCommand_I_FTD2XX::CloneCommand()
{
    CCommand_I_FTD2XX* pNewCommand;

    pNewCommand = new CCommand_I_FTD2XX();
    *pNewCommand = *this;

    return pNewCommand;
}

//******************************************************************
CCommand_I_FTD2XX& CCommand_I_FTD2XX::operator=(CCommand_I_FTD2XX& other)
{
    if(this != &other)
    {
        *((CCommandRoot*)this) = *((CCommandRoot*)&other);
    }

    return *this;
}
//******************************************************************
BOOL CCommand_I_FTD2XX::InitCommand(DWORD dCommandId)
{
    ResetCommand();
    switch(dCommandId)
    {
        case FTD2XX_EE_READ:
            {
                CCommand_I::InitCommand("FTD2XX_EE_Read", FTD2XX_EE_READ);
                AddReturnParameter(0,"vendorId",ODT_UINT16);
                AddReturnParameter(1,"productId",ODT_UINT16);
                AddReturnParameter(2,"manufacturer",ODT_MEMORY_BLOCK);
                AddReturnParameter(3,"description",ODT_MEMORY_BLOCK);
                AddReturnParameter(4,"serialNumber",ODT_MEMORY_BLOCK);
                AddReturnParameter(5,"useVcpDriver",ODT_BOOLEAN);
                SetDefaultParameter_EE_Read();
                return TRUE;
            };

        case FTD2XX_EE_PROGRAM:
            {
                CCommand_I::InitCommand("FTD2XX_EE_Program", FTD2XX_EE_PROGRAM);
                AddParameter(0,"vendorId",ODT_UINT16);
                AddParameter(1,"productId",ODT_UINT16);
                AddParameter(2,"manufacturer",ODT_MEMORY_BLOCK);
                AddParameter(3,"description",ODT_MEMORY_BLOCK);
                AddParameter(4,"serialNumber",ODT_MEMORY_BLOCK);
                AddParameter(5,"useVcpDriver",ODT_BOOLEAN);
                SetDefaultParameter_EE_Program();
                return TRUE;
            };

    }

    return FALSE;
}

void CCommand_I_FTD2XX::SetDefaultParameter_EE_Read()
{
    WORD usVendorId = 0;
    WORD usProductId = 0;
    void* pManufacturer = NULL;
    void* pDescription = NULL;
    void* pSerialNumber = NULL;
    BOOL oUseVcpDriver = FALSE;

    //ReturnParameter
    SetReturnParameterData(0,&usVendorId,sizeof(usVendorId));
    SetReturnParameterData(1,&usProductId,sizeof(usVendorId));
    SetReturnParameterData(2,&pManufacturer,0);
    SetReturnParameterData(3,&pDescription,0);
    SetReturnParameterData(4,&pSerialNumber,0);
    SetReturnParameterData(5,&oUseVcpDriver,0);
}

void CCommand_I_FTD2XX::SetDefaultParameter_EE_Program()
{
    WORD usVendorId = 0;
    WORD usProductId = 0;
    void* pManufacturer = NULL;
    void* pDescription = NULL;
    void* pSerialNumber = NULL;
    BOOL oUseVcpDriver = FALSE;

    //Parameter
    SetParameterData(0,&usVendorId,sizeof(usVendorId));
    SetParameterData(1,&usProductId,sizeof(usVendorId));
    SetParameterData(2,&pManufacturer,0);
    SetParameterData(3,&pDescription,0);
    SetParameterData(4,&pSerialNumber,0);
    SetParameterData(5,&oUseVcpDriver,0);
}

