// Command_I_MCP.cpp: Implementierung der Klasse CCommand_I_MCP.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <CommunicationModel/CommonLayer/Classes/Commands/Interface/Command_I_MCP.h>

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
/////////////////////////0/////////////////////////////////////////////
CCommand_I_MCP::CCommand_I_MCP()
{
}

CCommand_I_MCP::CCommand_I_MCP(DWORD p_ulCommandId)
{
    InitCommand(p_ulCommandId);
}

CCommand_I_MCP::~CCommand_I_MCP()
{
}

CCommandRoot* CCommand_I_MCP::CloneCommand()
{
    CCommand_I_MCP* pNewCommand;

    pNewCommand = new CCommand_I_MCP();
    *pNewCommand = *this;

    return pNewCommand;
}

CCommand_I_MCP& CCommand_I_MCP::operator=(CCommand_I_MCP& other)
{
    if(this != &other)
    {
        *((CCommandRoot*)this) = *((CCommandRoot*)&other);
    }

    return *this;
}

BOOL CCommand_I_MCP::InitCommand(DWORD p_ulCommandId)
{
    BOOL oResult = FALSE;

    ResetCommand();

    switch(p_ulCommandId)
    {
        case MCP_SEND_ACCESS_PASSWORD:
            {
                CCommand_I::InitCommand("MCP Send Access Password", MCP_SEND_ACCESS_PASSWORD);
                AddParameter(0, "password", ODT_MEMORY_BLOCK);
                oResult = TRUE; break;
            }
        case MCP_SET_CHIP_SETTINGS:
            {
                CCommand_I::InitCommand("MCP Set Chip Settings", MCP_SET_CHIP_SETTINGS);
                AddParameter(0, "chip settings power-up default", ODT_MEMORY_BLOCK);
                AddParameter(1, "power-up transfer settings", ODT_MEMORY_BLOCK);
                AddParameter(2, "usb power-up key parameters", ODT_MEMORY_BLOCK);
                AddParameter(3, "usb manufacturer name", ODT_MEMORY_BLOCK);
                AddParameter(4, "usb product name", ODT_MEMORY_BLOCK);
                oResult = TRUE; break;
            }
        case MCP_GET_CHIP_SETTINGS:
            {
                CCommand_I::InitCommand("MCP Get Chip Settings", MCP_GET_CHIP_SETTINGS);
                AddReturnParameter(0, "chip settings power-up default", ODT_MEMORY_BLOCK);
                AddReturnParameter(1, "power-up transfer settings", ODT_MEMORY_BLOCK);
                AddReturnParameter(2, "usb power-up key parameters", ODT_MEMORY_BLOCK);
                AddReturnParameter(3, "usb manufacturer name", ODT_MEMORY_BLOCK);
                AddReturnParameter(4, "usb product name", ODT_MEMORY_BLOCK);
                oResult = TRUE; break;
            }

        case MCP_SET_CURRENT_SPI_TRANSFER_SETTINGS:
            {
                CCommand_I::InitCommand("MCP Set Current Spi Transfer Settings", MCP_SET_CURRENT_SPI_TRANSFER_SETTINGS);
                AddParameter(0, "spi transfer settings", ODT_MEMORY_BLOCK);
                SetDefaultParameter_SetCurrentSpiTransferSettings();
                oResult = TRUE; break;
            }

        case MCP_GET_CURRENT_SPI_TRANSFER_SETTINGS:
            {
                CCommand_I::InitCommand("MCP Get Current Spi Transfer Settings", MCP_GET_CURRENT_SPI_TRANSFER_SETTINGS);
                AddReturnParameter(0, "spi transfer settings", ODT_MEMORY_BLOCK);
                SetDefaultParameter_GetCurrentSpiTransferSettings();
                oResult = TRUE; break;
            }

        case MCP_SET_CURRENT_CHIP_SETTINGS:
            {
                CCommand_I::InitCommand("MCP Set Current Chip Settings", MCP_SET_CURRENT_CHIP_SETTINGS);
                AddParameter(0, "chip settings", ODT_MEMORY_BLOCK);
                SetDefaultParameter_SetCurrentChipSettings();
                oResult = TRUE; break;
            }

        case MCP_GET_CURRENT_CHIP_SETTINGS:
            {
                CCommand_I::InitCommand("MCP Get Current Chip Settings", MCP_GET_CURRENT_CHIP_SETTINGS);
                AddReturnParameter(0, "chip settings", ODT_MEMORY_BLOCK);
                SetDefaultParameter_GetCurrentChipSettings();
                oResult = TRUE; break;
            }

        case MCP_SET_CURRENT_PIN_DIRECTIONS:
            {
                CCommand_I::InitCommand("MCP Set Current Pin Directions", MCP_SET_CURRENT_PIN_DIRECTIONS);
                AddParameter(0, "pin directions", ODT_MEMORY_BLOCK);
                SetDefaultParameter_SetCurrentPinDirections();
                oResult = TRUE; break;
            }

        case MCP_GET_CURRENT_PIN_DIRECTIONS:
            {
                CCommand_I::InitCommand("MCP Get Current Pin Directions", MCP_GET_CURRENT_PIN_DIRECTIONS);
                AddReturnParameter(0, "pin directions", ODT_MEMORY_BLOCK);
                SetDefaultParameter_GetCurrentPinDirections();
                oResult = TRUE; break;
            }

        case MCP_SET_CURRENT_PIN_VALUES:
            {
                CCommand_I::InitCommand("MCP Set Current Pin Values", MCP_SET_CURRENT_PIN_VALUES);
                AddParameter(0, "pin values", ODT_MEMORY_BLOCK);
                SetDefaultParameter_SetCurrentPinValues();
                oResult = TRUE; break;
            }

        case MCP_GET_CURRENT_PIN_VALUES:
            {
                CCommand_I::InitCommand("MCP Get Current Pin Values", MCP_GET_CURRENT_PIN_VALUES);
                AddReturnParameter(0, "pin values", ODT_MEMORY_BLOCK);
                SetDefaultParameter_GetCurrentPinValues();
                oResult = TRUE; break;
            }

        case MCP_WRITE_READ_DATA:
            {
                CCommand_I::InitCommand("Write and Read Data", MCP_WRITE_READ_DATA);
                AddParameter(0,"dataToWrite",ODT_MEMORY_BLOCK);
                AddParameter(1,"nbOfBytesToRead",ODT_UINT32);
                AddReturnParameter(0,"nbOfBytesWritten",ODT_UINT32);
                AddReturnParameter(1,"dataRead",ODT_MEMORY_BLOCK);
                SetDefaultParameter_WriteReadData();
                oResult = TRUE; break;
            }
    }

    return oResult;
}

void CCommand_I_MCP::SetDefaultParameter_SetCurrentSpiTransferSettings()
{
    void* pData = NULL;

    //Parameter
    SetParameterData(0, pData, 0);
}

void CCommand_I_MCP::SetDefaultParameter_GetCurrentSpiTransferSettings()
{
    void* pData = NULL;

    //ReturnParameter
    SetReturnParameterData(0, pData, 0);
}

void CCommand_I_MCP::SetDefaultParameter_SetCurrentChipSettings()
{
    void* pData = NULL;

    //Parameter
    SetParameterData(0, pData, 0);
}

void CCommand_I_MCP::SetDefaultParameter_GetCurrentChipSettings()
{
    void* pData = NULL;

    //ReturnParameter
    SetReturnParameterData(0, pData, 0);
}

void CCommand_I_MCP::SetDefaultParameter_SetCurrentPinDirections()
{
    void* pData = NULL;

    //Parameter
    SetParameterData(0, pData, 0);
}

void CCommand_I_MCP::SetDefaultParameter_GetCurrentPinDirections()
{
    void* pData = NULL;

    //ReturnParameter
    SetReturnParameterData(0, pData, 0);
}

void CCommand_I_MCP::SetDefaultParameter_SetCurrentPinValues()
{
    void* pData = NULL;

    //Parameter
    SetParameterData(0, pData, 0);
}

void CCommand_I_MCP::SetDefaultParameter_GetCurrentPinValues()
{
    void* pData = NULL;

    //ReturnParameter
    SetReturnParameterData(0, pData, 0);
}

void CCommand_I_MCP::SetDefaultParameter_WriteReadData()
{
    void* pData = NULL;
    DWORD dNbOfBytesWritten = 0;
    DWORD dNbOfBytesToRead = 0;

    //Parameter
    SetParameterData(0, pData,0);
    SetParameterData(1, &dNbOfBytesToRead, sizeof(dNbOfBytesToRead));

    //ReturnParameter
    SetReturnParameterData(0, &dNbOfBytesWritten, sizeof(dNbOfBytesWritten));
    SetReturnParameterData(1, pData, 0);
}
