#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/ProtocolStack/Command_PS_InfoteamSerial.h>

CCommand_PS_InfoteamSerial::CCommand_PS_InfoteamSerial()
{
}

CCommand_PS_InfoteamSerial::CCommand_PS_InfoteamSerial(DWORD p_ulCommandId)
{
    InitCommand(p_ulCommandId);
}

CCommand_PS_InfoteamSerial::~CCommand_PS_InfoteamSerial()
{
}

CCommandRoot*CCommand_PS_InfoteamSerial::CloneCommand()
{
    CCommand_PS_InfoteamSerial* pNewCommand;

    pNewCommand = new CCommand_PS_InfoteamSerial();
    *pNewCommand = *this;

    return pNewCommand;
}

CCommand_PS_InfoteamSerial& CCommand_PS_InfoteamSerial::operator=(CCommand_PS_InfoteamSerial& other)
{
    if(this != &other)
    {
        *((CCommandRoot*)this) = *((CCommandRoot*)&other);
    }

    return *this;
}

BOOL CCommand_PS_InfoteamSerial::InitCommand(DWORD p_ulCommandId)
{
    ResetCommand();

    switch(p_ulCommandId)
    {
        case INFOTEAM_SERIAL_PROCESS_PROTOCOL:
            {
                CCommand_PS::InitCommand("Infoteam Serial Protocol",INFOTEAM_SERIAL_PROCESS_PROTOCOL);
                AddParameter(0,"PackageSize",ODT_UINT32);
                AddParameter(1,"ChunkSize",ODT_UINT16);
                AddParameter(2,"LastChunkFlag",ODT_UINT8);
                AddParameter(3,"Checksum",ODT_UINT32);
                AddParameter(4,"Data",ODT_MEMORY_BLOCK);
                AddReturnParameter(0,"PackageSize",ODT_UINT32);
                AddReturnParameter(1,"Checksum",ODT_UINT32);
                AddReturnParameter(2,"Data",ODT_MEMORY_BLOCK);
                SetDefaultParameter_ProcessProtocol();
                return TRUE;
            };

        case INFOTEAM_SERIAL_PROCESS_PROTOCOL_MAXON:
            {
                CCommand_PS::InitCommand("Infoteam Serial Protocol",INFOTEAM_SERIAL_PROCESS_PROTOCOL_MAXON);
                AddParameter(0,"PackageSize",ODT_UINT32);
                AddParameter(1,"ChunkSize",ODT_UINT16);
                AddParameter(2,"LastChunkFlag",ODT_UINT8);
                AddParameter(3,"Checksum",ODT_UINT32);
                AddParameter(4,"PackageType",ODT_UINT8);
                AddParameter(5,"OpCode",ODT_UINT8);
                AddParameter(6,"Data",ODT_MEMORY_BLOCK);
                AddParameter(7,"KeepLock",ODT_UINT8, FALSE, FALSE);
                AddReturnParameter(0,"PackageSize",ODT_UINT32);
                AddReturnParameter(1,"Checksum",ODT_UINT32);
                AddReturnParameter(2,"PackageType",ODT_UINT8);
                AddReturnParameter(3,"Data",ODT_MEMORY_BLOCK);
                SetDefaultParameter_ProcessProtocolMaxon();
                return TRUE;
            };

        case INFOTEAM_SERIAL_ABORT_PROTOCOL_MAXON:
            {
                CCommand_PS::InitCommand("Infoteam Serial Abort Protocol",INFOTEAM_SERIAL_ABORT_PROTOCOL_MAXON);
                SetDefaultParameter_AbortProtocolMaxon();
                return TRUE;
            };

        case INFOTEAM_SERIAL_SEND_CHUNK:
            {
                CCommand_PS::InitCommand("Infoteam Serial Protocol SendChunk",INFOTEAM_SERIAL_SEND_CHUNK);
                AddParameter(0,"PackageSize",ODT_UINT32);
                AddParameter(1,"ChunkSize",ODT_UINT16);
                AddParameter(2,"LastChunkFlag",ODT_UINT8);
                AddParameter(3,"Checksum",ODT_UINT32);
                AddParameter(4,"Data",ODT_MEMORY_BLOCK);
                SetDefaultParameter_SendChunk();
                return TRUE;
            };

        case INFOTEAM_SERIAL_RECEIVE_DATA:
            {
                CCommand_PS::InitCommand("Infoteam Serial Protocol ReceiveData",INFOTEAM_SERIAL_RECEIVE_DATA);
                AddReturnParameter(0,"PackageSize",ODT_UINT32);
                AddReturnParameter(1,"Checksum",ODT_UINT32);
                AddReturnParameter(2,"Data",ODT_MEMORY_BLOCK);
                SetDefaultParameter_ReceiveData();
                return TRUE;
            };
    }

    return FALSE;
}

void CCommand_PS_InfoteamSerial::SetDefaultParameter_ProcessProtocol()
{
    DWORD ulPackageSize = 0;
    WORD usChunkSize = 0;
    BYTE ubLastChunkFlag = 0;
    DWORD ulCheckSum = 0;
    void* pData = NULL;

    //Parameter
    SetParameterData(0,&ulPackageSize, sizeof(ulPackageSize));
    SetParameterData(1,&usChunkSize, sizeof(usChunkSize));
    SetParameterData(2,&ubLastChunkFlag, sizeof(ubLastChunkFlag));
    SetParameterData(3,&ulCheckSum, sizeof(ulCheckSum));
    SetParameterData(4, pData, 0);

    //Return Parameter
    SetReturnParameterData(0,&ulPackageSize, sizeof(ulPackageSize));
    SetReturnParameterData(1,&ulCheckSum, sizeof(ulCheckSum));
    SetReturnParameterData(2, pData, 0);
}

void CCommand_PS_InfoteamSerial::SetDefaultParameter_ProcessProtocolMaxon()
{
    DWORD ulPackageSize = 0;
    WORD usChunkSize = 0;
    BYTE ubLastChunkFlag = 0;
    DWORD ulCheckSum = 0;
    BYTE ubPackageType = 0;
    BYTE uOpCode = 0;
    void* pData = NULL;
    BYTE ubKeepLock = 0;

    //Parameter
    SetParameterData(0,&ulPackageSize, sizeof(ulPackageSize));
    SetParameterData(1,&usChunkSize, sizeof(usChunkSize));
    SetParameterData(2,&ubLastChunkFlag, sizeof(ubLastChunkFlag));
    SetParameterData(3,&ulCheckSum, sizeof(ulCheckSum));
    SetParameterData(4,&ubPackageType, sizeof(ubPackageType));
    SetParameterData(5,&uOpCode, sizeof(uOpCode));
    SetParameterData(6, pData, 0);
    SetParameterData(7,&ubKeepLock, sizeof(ubKeepLock));

    //Return Parameter
    SetReturnParameterData(0,&ulPackageSize, sizeof(ulPackageSize));
    SetReturnParameterData(1,&ulCheckSum, sizeof(ulCheckSum));
    SetReturnParameterData(2,&ubPackageType, sizeof(ubPackageType));
    SetReturnParameterData(3, pData, 0);
}

void CCommand_PS_InfoteamSerial::SetDefaultParameter_AbortProtocolMaxon()
{
    //No Parameter

    //No Return Parameter
}

void CCommand_PS_InfoteamSerial::SetDefaultParameter_SendChunk()
{
    DWORD ulPackageSize = 0;
    WORD usChunkSize = 0;
    BYTE ubLastChunkFlag = 0;
    DWORD ulCheckSum = 0;
    void* pData = NULL;

    //Parameter
    SetParameterData(0,&ulPackageSize, sizeof(ulPackageSize));
    SetParameterData(1,&usChunkSize, sizeof(usChunkSize));
    SetParameterData(2,&ubLastChunkFlag, sizeof(ubLastChunkFlag));
    SetParameterData(3,&ulCheckSum, sizeof(ulCheckSum));
    SetParameterData(4, pData, 0);
}

void CCommand_PS_InfoteamSerial::SetDefaultParameter_ReceiveData()
{
    DWORD ulPackageSize = 0;
    DWORD ulCheckSum = 0;
    void* pData = NULL;

    //Return Parameter
    SetReturnParameterData(0,&ulPackageSize, sizeof(ulPackageSize));
    SetReturnParameterData(1,&ulCheckSum, sizeof(ulCheckSum));
    SetReturnParameterData(2, pData, 0);
}

