
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_Configuration.h>

CCommand_VCS_Configuration::CCommand_VCS_Configuration()
{
}

CCommand_VCS_Configuration::CCommand_VCS_Configuration(DWORD p_ulCommandId)
{
    InitCommand(p_ulCommandId);
}

CCommand_VCS_Configuration::~CCommand_VCS_Configuration()
{
}

BOOL CCommand_VCS_Configuration::InitCommand(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    ResetCommand();

    if(!oResult && InitCommand_ControllerGains(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_PositionRegulator(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_VelocityRegulator(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_CurrentRegulator(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_Safety(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_Units(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_Motor(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_Sensors(p_ulCommandId))
    {
        oResult = TRUE;
    }

    return oResult;
}

CCommand_VCS_Configuration& CCommand_VCS_Configuration::operator=(CCommand_VCS_Configuration& p_Other)
{
    if(this != &p_Other)
    {
        *((CCommandRoot*)this) = *((CCommandRoot*)&p_Other);
    }

    return *this;
}

CCommandRoot* CCommand_VCS_Configuration::CloneCommand()
{
    CCommand_VCS_Configuration* pNewCommand;

    pNewCommand = new CCommand_VCS_Configuration();
    *pNewCommand = *this;

    return pNewCommand;
}

BOOL CCommand_VCS_Configuration::InitCommand_ControllerGains(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch (p_ulCommandId)
    {
        case CONF_SET_CONTROLLER_GAIN:
        {
            CCommand_VCS::InitCommand("SetControllerGain", CONF_SET_CONTROLLER_GAIN);
            AddParameter(0, "EController", ODT_UINT16);
            AddParameter(1, "EGain", ODT_UINT16);
            AddParameter(2, "Value", ODT_UINT64);
            SetDefaultParameter_SetControllerGain();
            oResult = TRUE;
            break;
        };
        case CONF_GET_CONTROLLER_GAIN:
        {
            CCommand_VCS::InitCommand("GetControllerGain", CONF_GET_CONTROLLER_GAIN);
            AddParameter(0, "EController", ODT_UINT16);
            AddParameter(1, "EGain", ODT_UINT16);
            AddReturnParameter(0, "Value", ODT_UINT64);
            SetDefaultParameter_GetControllerGain();
            oResult = TRUE;
            break;
        };
    }

    return oResult;
}

BOOL CCommand_VCS_Configuration::InitCommand_PositionRegulator(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case CONF_SET_POSITION_REGULATOR_GAIN:
            {
                CCommand_VCS::InitCommand("SetPositionRegulatorGain", CONF_SET_POSITION_REGULATOR_GAIN);
                AddParameter(0, "P", ODT_UINT16);
                AddParameter(1, "I", ODT_UINT16);
                AddParameter(2, "D", ODT_UINT16);
                SetDefaultParameter_SetPositionRegulatorGain();
                oResult = TRUE; break;
            };
        case CONF_GET_POSITION_REGULATOR_GAIN:
            {
                CCommand_VCS::InitCommand("GetPositionRegulatorGain", CONF_GET_POSITION_REGULATOR_GAIN);
                AddReturnParameter(0, "P", ODT_UINT16);
                AddReturnParameter(1, "I", ODT_UINT16);
                AddReturnParameter(2, "D", ODT_UINT16);
                SetDefaultParameter_GetPositionRegulatorGain();
                oResult = TRUE; break;
            };
        case CONF_SET_POSITION_REGULATOR_FEED_FORWARD:
            {
                CCommand_VCS::InitCommand("SetPositionRegulatorFeedForward", CONF_SET_POSITION_REGULATOR_FEED_FORWARD);
                AddParameter(0, "velocityFeedForward", ODT_UINT16);
                AddParameter(1, "accelerationFeedForward", ODT_UINT16);
                SetDefaultParameter_SetPositionRegulatorFeedForward();
                oResult = TRUE; break;
            };
        case CONF_GET_POSITION_REGULATOR_FEED_FORWARD:
            {
                CCommand_VCS::InitCommand("GetPositionRegulatorFeedForward", CONF_GET_POSITION_REGULATOR_FEED_FORWARD);
                AddReturnParameter(0, "velocityFeedForward", ODT_UINT16);
                AddReturnParameter(1, "accelerationFeedForward", ODT_UINT16);
                SetDefaultParameter_GetPositionRegulatorFeedForward();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_Configuration::InitCommand_VelocityRegulator(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case CONF_SET_VELOCITY_REGULATOR_GAIN:
            {
                CCommand_VCS::InitCommand("SetVelocityRegulatorGain", CONF_SET_VELOCITY_REGULATOR_GAIN);
                AddParameter(0, "P", ODT_UINT16);
                AddParameter(1, "I", ODT_UINT16);
                SetDefaultParameter_SetVelocityRegulatorGain();
                oResult = TRUE; break;
            };
        case CONF_GET_VELOCITY_REGULATOR_GAIN:
            {
                CCommand_VCS::InitCommand("GetVelocityRegulatorGain", CONF_GET_VELOCITY_REGULATOR_GAIN);
                AddReturnParameter(0, "P", ODT_UINT16);
                AddReturnParameter(1, "I", ODT_UINT16);
                SetDefaultParameter_GetVelocityRegulatorGain();
                oResult = TRUE; break;
            };
        case CONF_SET_VELOCITY_REGULATOR_FEED_FORWARD:
            {
                CCommand_VCS::InitCommand("SetVelocityRegulatorFeedForward", CONF_SET_VELOCITY_REGULATOR_FEED_FORWARD);
                AddParameter(0, "velocityFeedForward", ODT_UINT16);
                AddParameter(1, "accelerationFeedForward", ODT_UINT16);
                SetDefaultParameter_SetVelocityRegulatorFeedForward();
                oResult = TRUE; break;
            };
        case CONF_GET_VELOCITY_REGULATOR_FEED_FORWARD:
            {
                CCommand_VCS::InitCommand("GetVelocityRegulatorFeedForward", CONF_GET_VELOCITY_REGULATOR_FEED_FORWARD);
                AddReturnParameter(0, "velocityFeedForward", ODT_UINT16);
                AddReturnParameter(1, "accelerationFeedForward", ODT_UINT16);
                SetDefaultParameter_GetVelocityRegulatorFeedForward();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_Configuration::InitCommand_CurrentRegulator(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case CONF_SET_CURRENT_REGULATOR_GAIN:
            {
                CCommand_VCS::InitCommand("SetCurrentRegulatorGain", CONF_SET_CURRENT_REGULATOR_GAIN);
                AddParameter(0, "P", ODT_UINT16);
                AddParameter(1, "I", ODT_UINT16);
                SetDefaultParameter_SetCurrentRegulatorGain();
                oResult = TRUE; break;
            };
        case CONF_GET_CURRENT_REGULATOR_GAIN:
            {
                CCommand_VCS::InitCommand("GetCurrentRegulatorGain", CONF_GET_CURRENT_REGULATOR_GAIN);
                AddReturnParameter(0, "P", ODT_UINT16);
                AddReturnParameter(1, "I", ODT_UINT16);
                SetDefaultParameter_GetCurrentRegulatorGain();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_Configuration::InitCommand_Safety(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case CONF_SET_MAX_FOLLOWING_ERROR:
            {
                CCommand_VCS::InitCommand("SetMaxFollowingError", CONF_SET_MAX_FOLLOWING_ERROR);
                AddParameter(0, "MaxFollowingError", ODT_UINT32);
                SetDefaultParameter_SetMaxFollowingError();
                oResult = TRUE; break;
            };
        case CONF_GET_MAX_FOLLOWING_ERROR:
            {
                CCommand_VCS::InitCommand("GetMaxFollowingError", CONF_GET_MAX_FOLLOWING_ERROR);
                AddReturnParameter(0, "MaxFollowingError", ODT_UINT32);
                SetDefaultParameter_GetMaxFollowingError();
                oResult = TRUE; break;
            };
        case CONF_SET_MAX_PROFILE_VELOCITY:
            {
                CCommand_VCS::InitCommand("SetMaxProfileVelocity", CONF_SET_MAX_PROFILE_VELOCITY);
                AddParameter(0, "MaxProfileVelocity", ODT_UINT32);
                SetDefaultParameter_SetMaxProfileVelocity();
                oResult = TRUE; break;
            };
        case CONF_GET_MAX_PROFILE_VELOCITY:
            {
                CCommand_VCS::InitCommand("GetMaxProfileVelocity", CONF_GET_MAX_PROFILE_VELOCITY);
                AddReturnParameter(0, "MaxProfileVelocity", ODT_UINT32);
                SetDefaultParameter_GetMaxProfileVelocity();
                oResult = TRUE; break;
            };
        case CONF_SET_MAX_ACCELERATION:
            {
                CCommand_VCS::InitCommand("SetMaxAcceleration", CONF_SET_MAX_ACCELERATION);
                AddParameter(0, "MaxAcceleration", ODT_UINT32);
                SetDefaultParameter_SetMaxAcceleration();
                oResult = TRUE; break;
            };
        case CONF_GET_MAX_ACCELERATION:
            {
                CCommand_VCS::InitCommand("GetMaxAcceleration", CONF_GET_MAX_ACCELERATION);
                AddReturnParameter(0, "MaxAcceleration", ODT_UINT32);
                SetDefaultParameter_GetMaxAcceleration();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_Configuration::InitCommand_Units(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case CONF_SET_VELOCITY_UNITS:
            {
                CCommand_VCS::InitCommand("SetVelocityUnits", CONF_SET_VELOCITY_UNITS);
                AddParameter(0, "velocityDimensionIndex", ODT_UINT8);
                AddParameter(1, "velocityNotationIndex", ODT_INT8);
                SetDefaultParameter_SetVelocityUnits();
                oResult = TRUE; break;
            };
        case CONF_GET_VELOCITY_UNITS:
            {
                CCommand_VCS::InitCommand("GetVelocityUnits", CONF_GET_VELOCITY_UNITS);
                AddReturnParameter(0, "velocityDimension", ODT_UINT8);
                AddReturnParameter(1, "velocityNotation", ODT_UINT8);
                SetDefaultParameter_GetVelocityUnits();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_Configuration::InitCommand_Motor(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case CONF_SET_MOTOR_PARAMETER:
            {
                CCommand_VCS::InitCommand("SetMotorParameter", CONF_SET_MOTOR_PARAMETER);
                AddParameter(0, "motorType", ODT_UINT16);
                AddParameter(1, "continuousCurrent", ODT_UINT16);
                AddParameter(2, "peakCurrent", ODT_UINT16);
                AddParameter(3, "polePair", ODT_UINT8);
                AddParameter(4, "thermalTimeConstant", ODT_UINT16);
                SetDefaultParameter_SetMotorParameter();
                oResult = TRUE; break;
            };
        case CONF_GET_MOTOR_PARAMETER:
            {
                CCommand_VCS::InitCommand("GetMotorParameter", CONF_GET_MOTOR_PARAMETER);
                AddReturnParameter(0, "motorType", ODT_UINT16);
                AddReturnParameter(1, "continuousCurrent", ODT_UINT16);
                AddReturnParameter(2, "peakCurrent", ODT_UINT16);
                AddReturnParameter(3, "polePair", ODT_UINT8);
                AddReturnParameter(4, "thermalTimeConstant", ODT_UINT16);
                SetDefaultParameter_GetMotorParameter();
                oResult = TRUE; break;
            };
        case CONF_SET_MOTOR_TYPE:
            {
                CCommand_VCS::InitCommand("SetMotorType", CONF_SET_MOTOR_TYPE);
                AddParameter(0, "motorType", ODT_UINT16);
                SetDefaultParameter_SetMotorType();
                oResult = TRUE; break;
            };
        case CONF_GET_MOTOR_TYPE:
            {
                CCommand_VCS::InitCommand("GetMotorType", CONF_GET_MOTOR_TYPE);
                AddReturnParameter(0, "motorType", ODT_UINT16);
                SetDefaultParameter_GetMotorType();
                oResult = TRUE; break;
            };
        case CONF_SET_DC_MOTOR_PARAMETER:
            {
                CCommand_VCS::InitCommand("SetDcMotorParameter", CONF_SET_DC_MOTOR_PARAMETER);
                AddParameter(0, "nominalCurrent", ODT_UINT16);
                AddParameter(1, "maxOutputCurrent", ODT_UINT16);
                AddParameter(2, "thermalTimeConstant", ODT_UINT16);
                SetDefaultParameter_SetDcMotorParameter();
                oResult = TRUE; break;
            };
        case CONF_GET_DC_MOTOR_PARAMETER:
            {
                CCommand_VCS::InitCommand("GetDcMotorParameter", CONF_GET_DC_MOTOR_PARAMETER);
                AddReturnParameter(0, "nominalCurrent", ODT_UINT16);
                AddReturnParameter(1, "maxOutputCurrent", ODT_UINT16);
                AddReturnParameter(2, "thermalTimeConstant", ODT_UINT16);
                SetDefaultParameter_GetDcMotorParameter();
                oResult = TRUE; break;
            };
        case CONF_SET_EC_MOTOR_PARAMETER:
            {
                CCommand_VCS::InitCommand("SetEcMotorParameter", CONF_SET_EC_MOTOR_PARAMETER);
                AddParameter(0, "nominalCurrent", ODT_UINT16);
                AddParameter(1, "maxOutputCurrent", ODT_UINT16);
                AddParameter(2, "thermalTimeConstant", ODT_UINT16);
                AddParameter(3, "nbOfPolePairs", ODT_UINT8);
                SetDefaultParameter_SetEcMotorParameter();
                oResult = TRUE; break;
            };
        case CONF_GET_EC_MOTOR_PARAMETER:
            {
                CCommand_VCS::InitCommand("GetEcMotorParameter", CONF_GET_EC_MOTOR_PARAMETER);
                AddReturnParameter(0, "nominalCurrent", ODT_UINT16);
                AddReturnParameter(1, "maxOutputCurrent", ODT_UINT16);
                AddReturnParameter(2, "thermalTimeConstant", ODT_UINT16);
                AddReturnParameter(3, "nbOfPolePairs", ODT_UINT8);
                SetDefaultParameter_GetEcMotorParameter();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_Configuration::InitCommand_Sensors(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case CONF_SET_ENCODER_PARAMETER:
            {
                CCommand_VCS::InitCommand("SetEncoderParameter", CONF_SET_ENCODER_PARAMETER);
                AddParameter(0, "counts", ODT_UINT16);
                AddParameter(1, "positionSensorType", ODT_UINT16);
                SetDefaultParameter_SetEncoderParameter();
                oResult = TRUE; break;
            };
        case CONF_GET_ENCODER_PARAMETER:
            {
                CCommand_VCS::InitCommand("GetEncoderParameter", CONF_GET_ENCODER_PARAMETER);
                AddReturnParameter(0, "counts", ODT_UINT16);
                AddReturnParameter(1, "positionSensorType", ODT_UINT16);
                SetDefaultParameter_GetEncoderParameter();
                oResult = TRUE; break;
            };
        case CONF_SET_SENSOR_TYPE:
            {
                CCommand_VCS::InitCommand("SetSensorType", CONF_SET_SENSOR_TYPE);
                AddParameter(0, "sensorType", ODT_UINT16);
                SetDefaultParameter_SetSensorType();
                oResult = TRUE; break;
            };
        case CONF_GET_SENSOR_TYPE:
            {
                CCommand_VCS::InitCommand("GetSensorType", CONF_GET_SENSOR_TYPE);
                AddReturnParameter(0, "sensorType", ODT_UINT16);
                SetDefaultParameter_GetSensorType();
                oResult = TRUE; break;
            };
        case CONF_SET_INC_ENCODER_PARAMETER:
            {
                CCommand_VCS::InitCommand("SetIncEncoderParameter", CONF_SET_INC_ENCODER_PARAMETER);
                AddParameter(0, "encoderResolution", ODT_UINT32);
                AddParameter(1, "invertedPolarity", ODT_BOOLEAN);
                SetDefaultParameter_SetIncEncoderParameter();
                oResult = TRUE; break;
            };
        case CONF_GET_INC_ENCODER_PARAMETER:
            {
                CCommand_VCS::InitCommand("GetIncEncoderParameter", CONF_GET_INC_ENCODER_PARAMETER);
                AddReturnParameter(0, "encoderResolution", ODT_UINT32);
                AddReturnParameter(1, "invertedPolarity", ODT_BOOLEAN);
                SetDefaultParameter_GetIncEncoderParameter();
                oResult = TRUE; break;
            };
        case CONF_SET_HALL_SENSOR_PARAMETER:
            {
                CCommand_VCS::InitCommand("SetHallSensorParameter", CONF_SET_HALL_SENSOR_PARAMETER);
                AddParameter(0, "invertedPolarity", ODT_BOOLEAN);
                SetDefaultParameter_SetHallSensorParameter();
                oResult = TRUE; break;
            };
        case CONF_GET_HALL_SENSOR_PARAMETER:
            {
                CCommand_VCS::InitCommand("GetHallSensorParameter", CONF_GET_HALL_SENSOR_PARAMETER);
                AddReturnParameter(0, "invertedPolarity", ODT_BOOLEAN);
                SetDefaultParameter_GetHallSensorParameter();
                oResult = TRUE; break;
            };
        case CONF_SET_SSI_ABS_ENCODER_PARAMETER:
            {
                CCommand_VCS::InitCommand("SetSsiAbsEncoderParameter", CONF_SET_SSI_ABS_ENCODER_PARAMETER);
                AddParameter(0, "dataRate", ODT_UINT16);
                AddParameter(1, "nbOfMultiTurnDataBits", ODT_UINT16);
                AddParameter(2, "nbOfSingleTurnDataBits", ODT_UINT16);
                AddParameter(3, "invertedPolarity", ODT_BOOLEAN);
                SetDefaultParameter_SetSsiAbsEncoderParameter();
                oResult = TRUE; break;
            };
        case CONF_SET_SSI_ABS_ENCODER_PARAMETER_EX:
            {
                CCommand_VCS::InitCommand("SetSsiAbsEncoderParameterEx", CONF_SET_SSI_ABS_ENCODER_PARAMETER_EX);
                AddParameter(0, "dataRate", ODT_UINT16);
                AddParameter(1, "nbOfMultiTurnDataBits", ODT_UINT16);
                AddParameter(2, "nbOfSingleTurnDataBits", ODT_UINT16);
                AddParameter(3, "nbOfSpecialDataBits", ODT_UINT16);
                AddParameter(4, "invertedPolarity", ODT_BOOLEAN);
                AddParameter(5, "timeout", ODT_UINT16);
                AddParameter(6, "powerupTime", ODT_UINT16);
                SetDefaultParameter_SetSsiAbsEncoderParameterEx();
                oResult = TRUE; break;
            };
        case CONF_GET_SSI_ABS_ENCODER_PARAMETER:
            {
                CCommand_VCS::InitCommand("GetSsiAbsEncoderParameter", CONF_GET_SSI_ABS_ENCODER_PARAMETER);
                AddReturnParameter(0, "dataRate", ODT_UINT16);
                AddReturnParameter(1, "nbOfMultiTurnDataBits", ODT_UINT16);
                AddReturnParameter(2, "nbOfSingleTurnDataBits", ODT_UINT16);
                AddReturnParameter(3, "invertedPolarity", ODT_BOOLEAN);
                SetDefaultParameter_GetSsiAbsEncoderParameter();
                oResult = TRUE; break;
            };
        case CONF_GET_SSI_ABS_ENCODER_PARAMETER_EX:
            {
                CCommand_VCS::InitCommand("GetSsiAbsEncoderParameterEx", CONF_GET_SSI_ABS_ENCODER_PARAMETER_EX);
                AddReturnParameter(0, "dataRate", ODT_UINT16);
                AddReturnParameter(1, "nbOfMultiTurnDataBits", ODT_UINT16);
                AddReturnParameter(2, "nbOfSingleTurnDataBits", ODT_UINT16);
                AddReturnParameter(3, "nbOfSpecialDataBits", ODT_UINT16);
                AddReturnParameter(4, "invertedPolarity", ODT_BOOLEAN);
                AddReturnParameter(5, "timeout", ODT_UINT16);
                AddReturnParameter(6, "powerupTime", ODT_UINT16);
                SetDefaultParameter_GetSsiAbsEncoderParameterEx();
                oResult = TRUE; break;
            };
        case CONF_GET_MAIN_SENSOR_RESOLUTION:
            {
                CCommand_VCS::InitCommand("GetMainSensorResolution", CONF_GET_MAIN_SENSOR_RESOLUTION);
                AddReturnParameter(0, "incrementsPerTurn", ODT_UINT32);
                SetDefaultParameter_GetMainSensorResolution();
                oResult = TRUE; break;
            };
        case CONF_GET_AUXILIARY_SENSOR_RESOLUTION:
            {
                CCommand_VCS::InitCommand("GetAuxiliarySensorResolution", CONF_GET_AUXILIARY_SENSOR_RESOLUTION);
                AddReturnParameter(0, "incrementsPerTurn", ODT_UINT32);
                SetDefaultParameter_GetAuxiliarySensorResolution();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetPositionRegulatorGain()
{
    WORD usP = 100;
    WORD usI = 100;
    WORD usD = 100;

    //Parameter
    SetParameterData(0, &usP, sizeof(usP));
    SetParameterData(1, &usI, sizeof(usI));
    SetParameterData(2, &usD, sizeof(usD));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetPositionRegulatorGain()
{
    WORD usP = 100;
    WORD usI = 100;
    WORD usD = 100;

    //ReturnParameter
    SetReturnParameterData(0, &usP, sizeof(usP));
    SetReturnParameterData(1, &usI, sizeof(usI));
    SetReturnParameterData(2, &usD, sizeof(usD));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetPositionRegulatorFeedForward()
{
    WORD usAccelerationFeedForward = 0;
    WORD usVelocityFeedForward = 0;

    //Parameter
    SetParameterData(0, &usVelocityFeedForward, sizeof(usVelocityFeedForward));
    SetParameterData(1, &usAccelerationFeedForward, sizeof(usAccelerationFeedForward));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetPositionRegulatorFeedForward()
{
    WORD usAccelerationFeedForward = 0;
    WORD usVelocityFeedForward = 0;

    //ReturnParameter
    SetReturnParameterData(0, &usVelocityFeedForward, sizeof(usVelocityFeedForward));
    SetReturnParameterData(1, &usAccelerationFeedForward, sizeof(usAccelerationFeedForward));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetControllerGain()
{
    WORD usController(1);
    WORD usGain(1);
    __uint64 ullValue(0);

    //Parameter
    SetParameterData(0, &usController, sizeof(usController));
    SetParameterData(1, &usGain, sizeof(usGain));
    SetParameterData(2, &ullValue, sizeof(ullValue));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetControllerGain()
{
    WORD usController(1);
    WORD usGain(2);
    __uint64 ullValue(0);

    //Parameter
    SetParameterData(0, &usController, sizeof(usController));
    SetParameterData(1, &usGain, sizeof(usGain));

    //ReturnParameter
    SetReturnParameterData(0, &ullValue, sizeof(ullValue));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetVelocityRegulatorGain()
{
    WORD usP = 100;
    WORD usI = 100;

    //Parameter
    SetParameterData(0, &usP, sizeof(usP));
    SetParameterData(1, &usI, sizeof(usI));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetVelocityRegulatorGain()
{
    BYTE uPortNumber = 0;
    WORD wNodeId = 1;
    WORD usP = 100;
    WORD usI = 100;

    //Parameter
    SetParameterData(0, &uPortNumber, sizeof(uPortNumber));
    SetParameterData(1, &wNodeId, sizeof(wNodeId));

    //ReturnParameter
    SetReturnParameterData(0, &usP, sizeof(usP));
    SetReturnParameterData(1, &usI, sizeof(usI));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetVelocityRegulatorFeedForward()
{
    WORD usAccelerationFeedForward = 0;
    WORD usVelocityFeedForward = 0;

    //Parameter
    SetParameterData(0, &usVelocityFeedForward, sizeof(usVelocityFeedForward));
    SetParameterData(1, &usAccelerationFeedForward, sizeof(usAccelerationFeedForward));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetVelocityRegulatorFeedForward()
{
    WORD usAccelerationFeedForward = 0;
    WORD usVelocityFeedForward = 0;

    //ReturnParameter
    SetReturnParameterData(0, &usVelocityFeedForward, sizeof(usVelocityFeedForward));
    SetReturnParameterData(1, &usAccelerationFeedForward, sizeof(usAccelerationFeedForward));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetCurrentRegulatorGain()
{
    WORD usP = 100;
    WORD usI = 100;

    //Parameter
    SetParameterData(0, &usP, sizeof(usP));
    SetParameterData(1, &usI, sizeof(usI));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetCurrentRegulatorGain()
{
    WORD usP = 100;
    WORD usI = 100;

    //ReturnParameter
    SetReturnParameterData(0, &usP, sizeof(usP));
    SetReturnParameterData(1, &usI, sizeof(usI));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetMaxFollowingError()
{
    DWORD ulMaxFollowingError = 2000;

    //Parameter
    SetParameterData(0, &ulMaxFollowingError, sizeof(ulMaxFollowingError));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetMaxFollowingError()
{
    BYTE uPortNumber = 0;
    WORD wNodeId = 1;
    DWORD ulMaxFollowingError = 2000;

    //Parameter
    SetParameterData(0, &uPortNumber, sizeof(uPortNumber));
    SetParameterData(1, &wNodeId, sizeof(wNodeId));

    //ReturnParameter
    SetReturnParameterData(0, &ulMaxFollowingError, sizeof(ulMaxFollowingError));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetMaxProfileVelocity()
{
    DWORD ulMaxProfileVelocity = 25000;

    //Parameter
    SetParameterData(0, &ulMaxProfileVelocity, sizeof(ulMaxProfileVelocity));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetMaxProfileVelocity()
{
    BYTE uPortNumber = 0;
    WORD wNodeId = 1;
    DWORD ulMaxProfileVelocity = 25000;

    //Parameter
    SetParameterData(0, &uPortNumber, sizeof(uPortNumber));
    SetParameterData(1, &wNodeId, sizeof(wNodeId));

    //ReturnParameter
    SetReturnParameterData(0, &ulMaxProfileVelocity, sizeof(ulMaxProfileVelocity));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetMaxAcceleration()
{
    DWORD ulMaxAcceleration = UINT_MAX;

    //Parameter
    SetParameterData(0, &ulMaxAcceleration, sizeof(ulMaxAcceleration));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetMaxAcceleration()
{
    BYTE uPortNumber = 0;
    WORD wNodeId = 1;
    DWORD ulMaxAcceleration = UINT_MAX;

    //Parameter
    SetParameterData(0, &uPortNumber, sizeof(uPortNumber));
    SetParameterData(1, &wNodeId, sizeof(wNodeId));

    //ReturnParameter
    SetReturnParameterData(0, &ulMaxAcceleration, sizeof(ulMaxAcceleration));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetVelocityUnits()
{
    BYTE ubVelocityDimension = 0xA4;
    char bVelocityNotation = 0;

    //Parameter
    SetParameterData(0, &ubVelocityDimension, sizeof(ubVelocityDimension));
    SetParameterData(1, &bVelocityNotation, sizeof(bVelocityNotation));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetVelocityUnits()
{
    BYTE ubVelocityDimension = 0xA4;
    char bVelocityNotation = 0;

    //ReturnParameter
    SetReturnParameterData(0, &ubVelocityDimension, sizeof(ubVelocityDimension));
    SetReturnParameterData(1, &bVelocityNotation, sizeof(bVelocityNotation));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetMotorParameter()
{
    WORD usMotorType = 10;
    WORD usContinuousCurrent = 1;
    WORD usMaxOutputCurrent = 1;
    BYTE ubNbOfPolePairs = 1;
    WORD usThermalTimeConstant = 40;

    //Parameter
    SetParameterData(0, &usMotorType, sizeof(usMotorType));
    SetParameterData(1, &usContinuousCurrent, sizeof(usContinuousCurrent));
    SetParameterData(2, &usMaxOutputCurrent, sizeof(usMaxOutputCurrent));
    SetParameterData(3, &ubNbOfPolePairs, sizeof(ubNbOfPolePairs));
    SetParameterData(4, &usThermalTimeConstant, sizeof(usThermalTimeConstant));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetMotorParameter()
{
    WORD usMotorType = 10;
    WORD usContinuousCurrent = 1;
    WORD usMaxOutputCurrent = 1;
    BYTE ubNbOfPolePairs = 1;
    WORD usThermalTimeConstant = 40;

    //ReturnParameter
    SetReturnParameterData(0, &usMotorType, sizeof(usMotorType));
    SetReturnParameterData(1, &usContinuousCurrent, sizeof(usContinuousCurrent));
    SetReturnParameterData(2, &usMaxOutputCurrent, sizeof(usMaxOutputCurrent));
    SetReturnParameterData(3, &ubNbOfPolePairs, sizeof(ubNbOfPolePairs));
    SetReturnParameterData(4, &usThermalTimeConstant, sizeof(usThermalTimeConstant));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetMotorType()
{
    WORD usMotorType = 10;

    //Parameter
    SetParameterData(0, &usMotorType, sizeof(usMotorType));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetMotorType()
{
    WORD usMotorType = 10;

    //ReturnParameter
    SetReturnParameterData(0, &usMotorType, sizeof(usMotorType));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetDcMotorParameter()
{
    WORD usContinuousCurrent = 1;
    WORD usMaxOutputCurrent = 1;
    WORD usThermalTimeConstant = 40;

    //Parameter
    SetParameterData(0, &usContinuousCurrent, sizeof(usContinuousCurrent));
    SetParameterData(1, &usMaxOutputCurrent, sizeof(usMaxOutputCurrent));
    SetParameterData(2, &usThermalTimeConstant, sizeof(usThermalTimeConstant));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetDcMotorParameter()
{
    WORD usContinuousCurrent = 1;
    WORD usMaxOutputCurrent = 1;
    WORD usThermalTimeConstant = 40;

    //ReturnParameter
    SetReturnParameterData(0, &usContinuousCurrent, sizeof(usContinuousCurrent));
    SetReturnParameterData(1, &usMaxOutputCurrent, sizeof(usMaxOutputCurrent));
    SetReturnParameterData(2, &usThermalTimeConstant, sizeof(usThermalTimeConstant));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetEcMotorParameter()
{
    WORD usContinuousCurrent = 1;
    WORD usMaxOutputCurrent = 1;
    BYTE ubNbOfPolePairs = 1;
    WORD usThermalTimeConstant = 40;

    //Parameter
    SetParameterData(0, &usContinuousCurrent, sizeof(usContinuousCurrent));
    SetParameterData(1, &usMaxOutputCurrent, sizeof(usMaxOutputCurrent));
    SetParameterData(2, &usThermalTimeConstant, sizeof(usThermalTimeConstant));
    SetParameterData(3, &ubNbOfPolePairs, sizeof(ubNbOfPolePairs));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetEcMotorParameter()
{
    WORD usContinuousCurrent = 1;
    WORD usMaxOutputCurrent = 1;
    BYTE ubNbOfPolePairs = 1;
    WORD usThermalTimeConstant = 40;

    //ReturnParameter
    SetReturnParameterData(0, &usContinuousCurrent, sizeof(usContinuousCurrent));
    SetReturnParameterData(1, &usMaxOutputCurrent, sizeof(usMaxOutputCurrent));
    SetReturnParameterData(2, &usThermalTimeConstant, sizeof(usThermalTimeConstant));
    SetReturnParameterData(3, &ubNbOfPolePairs, sizeof(ubNbOfPolePairs));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetEncoderParameter()
{
    WORD usCounts = 500;
    WORD usPositionSensorType = 1;

    //Parameter
    SetParameterData(0, &usCounts, sizeof(usCounts));
    SetParameterData(1, &usPositionSensorType, sizeof(usPositionSensorType));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetEncoderParameter()
{
    WORD usCounts = 500;
    WORD usPositionSensorType = 1;

    //ReturnParameter
    SetReturnParameterData(0, &usCounts, sizeof(usCounts));
    SetReturnParameterData(1, &usPositionSensorType, sizeof(usPositionSensorType));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetSensorType()
{
    WORD usSensorType = 1;

    //Parameter
    SetParameterData(0, &usSensorType, sizeof(usSensorType));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetSensorType()
{
    WORD usSensorType = 1;

    //ReturnParameter
    SetReturnParameterData(0, &usSensorType, sizeof(usSensorType));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetIncEncoderParameter()
{
    WORD usEncoderResolution = 500;
    BOOL oInvertedPolarity = FALSE;

    //Parameter
    SetParameterData(0, &usEncoderResolution, sizeof(usEncoderResolution));
    SetParameterData(1, &oInvertedPolarity, sizeof(oInvertedPolarity));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetIncEncoderParameter()
{
    WORD usEncoderResolution = 500;
    BOOL oInvertedPolarity = FALSE;

    //ReturnParameter
    SetReturnParameterData(0, &usEncoderResolution, sizeof(usEncoderResolution));
    SetReturnParameterData(1, &oInvertedPolarity, sizeof(oInvertedPolarity));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetHallSensorParameter()
{
    BOOL oInvertedPolarity = FALSE;

    //ReturnParameter
    SetReturnParameterData(0, &oInvertedPolarity, sizeof(oInvertedPolarity));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetHallSensorParameter()
{
    BOOL oInvertedPolarity = FALSE;

    //Parameter
    SetParameterData(0, &oInvertedPolarity, sizeof(oInvertedPolarity));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetSsiAbsEncoderParameter()
{
    WORD usDataRate = 500;
    WORD usNbOfMultiTurnDataBits = 12;
    WORD usNbOfSingleTurnDataBits = 13;
    BOOL oInvertedPolarity = FALSE;

    //Parameter
    SetParameterData(0, &usDataRate, sizeof(usDataRate));
    SetParameterData(1, &usNbOfMultiTurnDataBits, sizeof(usNbOfMultiTurnDataBits));
    SetParameterData(2, &usNbOfSingleTurnDataBits, sizeof(usNbOfSingleTurnDataBits));
    SetParameterData(3, &oInvertedPolarity, sizeof(oInvertedPolarity));
}

void CCommand_VCS_Configuration::SetDefaultParameter_SetSsiAbsEncoderParameterEx()
{
    WORD usDataRate = 500;
    WORD usNbOfMultiTurnDataBits = 12;
    WORD usNbOfSingleTurnDataBits = 13;
    WORD usNbSpecialDataBits = 0;
    BOOL oInvertedPolarity = FALSE;
    WORD usTimeout = 30;
    WORD usPowerupTime = 200;

    //Parameter
    SetParameterData(0, &usDataRate, sizeof(usDataRate));
    SetParameterData(1, &usNbOfMultiTurnDataBits, sizeof(usNbOfMultiTurnDataBits));
    SetParameterData(2, &usNbOfSingleTurnDataBits, sizeof(usNbOfSingleTurnDataBits));
    SetParameterData(3, &usNbSpecialDataBits, sizeof(usNbSpecialDataBits));
    SetParameterData(4, &oInvertedPolarity, sizeof(oInvertedPolarity));
    SetParameterData(5, &usTimeout, sizeof(usTimeout));
    SetParameterData(6, &usPowerupTime, sizeof(usPowerupTime));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetSsiAbsEncoderParameter()
{
    WORD usDataRate = 500;
    WORD usNbOfMultiTurnDataBits = 12;
    WORD usNbOfSingleTurnDataBits = 13;
    BOOL oInvertedPolarity = FALSE;

    //ReturnParameter
    SetReturnParameterData(0, &usDataRate, sizeof(usDataRate));
    SetReturnParameterData(1, &usNbOfMultiTurnDataBits, sizeof(usNbOfMultiTurnDataBits));
    SetReturnParameterData(2, &usNbOfSingleTurnDataBits, sizeof(usNbOfSingleTurnDataBits));
    SetReturnParameterData(3, &oInvertedPolarity, sizeof(oInvertedPolarity));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetSsiAbsEncoderParameterEx()
{
    WORD usDataRate = 500;
    WORD usNbOfMultiTurnDataBits = 12;
    WORD usNbOfSingleTurnDataBits = 13;
    WORD usNbSpecialDataBits = 0;
    BOOL oInvertedPolarity = FALSE;
    WORD usTimeout = 30;
    WORD usPowerupTime = 200;

    //ReturnParameter
    SetReturnParameterData(0, &usDataRate, sizeof(usDataRate));
    SetReturnParameterData(1, &usNbOfMultiTurnDataBits, sizeof(usNbOfMultiTurnDataBits));
    SetReturnParameterData(2, &usNbOfSingleTurnDataBits, sizeof(usNbOfSingleTurnDataBits));
    SetReturnParameterData(3, &usNbSpecialDataBits, sizeof(usNbSpecialDataBits));
    SetReturnParameterData(3, &oInvertedPolarity, sizeof(oInvertedPolarity));
    SetReturnParameterData(5, &usTimeout, sizeof(usTimeout));
    SetReturnParameterData(6, &usPowerupTime, sizeof(usPowerupTime));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetMainSensorResolution()
{
    DWORD ulIncrementsPerTurn = 0;

    //ReturnParameter
    SetReturnParameterData(0, &ulIncrementsPerTurn, sizeof(ulIncrementsPerTurn));
}

void CCommand_VCS_Configuration::SetDefaultParameter_GetAuxiliarySensorResolution()
{
    DWORD ulIncrementsPerTurn = 0;

    //ReturnParameter
    SetReturnParameterData(0, &ulIncrementsPerTurn, sizeof(ulIncrementsPerTurn));
}
