
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_Device.h>

CCommand_VCS_Device::CCommand_VCS_Device()
{
}

CCommand_VCS_Device::CCommand_VCS_Device(DWORD p_ulCommandId)
{
    InitCommand(p_ulCommandId);
}

CCommand_VCS_Device::~CCommand_VCS_Device()
{
}

BOOL CCommand_VCS_Device::InitCommand(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    ResetCommand();

    if(!oResult && InitCommand_Infos(p_ulCommandId))
    {
        oResult = TRUE;
    }

    return oResult;
}

CCommand_VCS_Device& CCommand_VCS_Device::operator=(CCommand_VCS_Device& p_Other)
{
    if(this != &p_Other)
    {
        *((CCommandRoot*)this) = *((CCommandRoot*)&p_Other);
    }

    return *this;
}

CCommandRoot* CCommand_VCS_Device::CloneCommand()
{
    CCommand_VCS_Device* pNewCommand;

    pNewCommand = new CCommand_VCS_Device();
    *pNewCommand = *this;

    return pNewCommand;
}

BOOL CCommand_VCS_Device::InitCommand_Infos(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case DEVICE_GET_VERSION:
            {
                CCommand_VCS::InitCommand("GetVersion", DEVICE_GET_VERSION);
                AddReturnParameter(0, "hardwareVersion", ODT_UINT16);
                AddReturnParameter(1, "softwareVersion", ODT_UINT16);
                AddReturnParameter(2, "applicationNumber", ODT_UINT16);
                AddReturnParameter(3, "applicationVersion", ODT_UINT16);
                SetDefaultParameter_GetVersion();
                oResult = TRUE; break;
            };

        case DEVICE_GET_TYPE:
            {
                CCommand_VCS::InitCommand("GetDeviceType", DEVICE_GET_TYPE);
                AddReturnParameter(0, "deviceType", ODT_UINT32);
                SetDefaultParameter_GetDeviceType();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

void CCommand_VCS_Device::SetDefaultParameter_GetVersion()
{
    WORD usHWVersion = 0x0000;
    WORD usSWVersion = 0x0000;
    WORD usAppNumber = 0x0000;
    WORD usAppVersion = 0x0000;

    //ReturnParameter
    SetReturnParameterData(0, &usHWVersion, sizeof(usHWVersion));
    SetReturnParameterData(1, &usSWVersion, sizeof(usSWVersion));
    SetReturnParameterData(2, &usAppNumber, sizeof(usAppNumber));
    SetReturnParameterData(3, &usAppVersion, sizeof(usAppVersion));
}

void CCommand_VCS_Device::SetDefaultParameter_GetDeviceType()
{
    DWORD ulDeviceType = 0;

    //ReturnParameter
    SetReturnParameterData(0, &ulDeviceType, sizeof(ulDeviceType));
}
