
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_Firmware.h>

CCommand_VCS_Firmware::CCommand_VCS_Firmware()
{
}

CCommand_VCS_Firmware::CCommand_VCS_Firmware(DWORD p_ulCommandId)
{
    InitCommand(p_ulCommandId);
}

CCommand_VCS_Firmware::~CCommand_VCS_Firmware()
{
}

BOOL CCommand_VCS_Firmware::InitCommand(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    ResetCommand();

    if(!oResult && InitCommand_FirmwareUpdate(p_ulCommandId))
    {
        oResult = TRUE;
    }

    return oResult;
}

CCommand_VCS_Firmware& CCommand_VCS_Firmware::operator=(CCommand_VCS_Firmware& p_Other)
{
    if(this != &p_Other)
    {
        *((CCommandRoot*)this) = *((CCommandRoot*)&p_Other);
    }

    return *this;
}

CCommandRoot* CCommand_VCS_Firmware::CloneCommand()
{
    CCommand_VCS_Firmware* pNewCommand;

    pNewCommand = new CCommand_VCS_Firmware();
    *pNewCommand = *this;

    return pNewCommand;
}

BOOL CCommand_VCS_Firmware::InitCommand_FirmwareUpdate(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case FIRMWARE_GET_BASE_SECTOR_VERSION:
            {
                CCommand_VCS::InitCommand("GetBaseSectorVersion", FIRMWARE_GET_BASE_SECTOR_VERSION);
                AddReturnParameter(0, "baseSectorVersion", ODT_UINT16);
                SetDefaultParameter_GetBaseSectorVersion();
                oResult = TRUE;
                break;
            };
        case FIRMWARE_GET_SERIAL_NUMBER:
            {
                CCommand_VCS::InitCommand("GetSerialNumber", FIRMWARE_GET_SERIAL_NUMBER);
                AddReturnParameter(0, "serialNumber", ODT_UINT64);
                SetDefaultParameter_GetSerialNumber();
                oResult = TRUE;
                break;
            };
        case FIRMWARE_PROGRAM_HARDWARE_INFOS:
            {
                CCommand_VCS::InitCommand("ProgramHardwareInfos", FIRMWARE_PROGRAM_HARDWARE_INFOS);
                AddParameter(0, "hardwareVersion", ODT_UINT16);
                AddParameter(1, "serialNumber", ODT_UINT64);
                AddParameter(2, "controlWord", ODT_UINT32);
                SetDefaultParameter_ProgramHardwareInfos();
                oResult = TRUE;
                break;
            };
        case FIRMWARE_CLEANUP_CANOPEN_COMMUNICATION:
            {
                CCommand_VCS::InitCommand("Cleanup Communication", FIRMWARE_CLEANUP_CANOPEN_COMMUNICATION);
                AddParameter(0, "cleanupCanPassive", ODT_BOOLEAN);
                SetDefaultParameter_CleanupCommunication();
                oResult = TRUE;
                break;
            };
    }

    return oResult;
}

void CCommand_VCS_Firmware::SetDefaultParameter_GetBaseSectorVersion()
{
    WORD usBaseSectorVersion(0);

    //ReturnParameter
    SetReturnParameterData(0, &usBaseSectorVersion, sizeof(usBaseSectorVersion));
}

void CCommand_VCS_Firmware::SetDefaultParameter_GetSerialNumber()
{
    __uint64 ullSerialNb(0);

    //ReturnParameter
    SetReturnParameterData(0, &ullSerialNb, sizeof(ullSerialNb));
}

void CCommand_VCS_Firmware::SetDefaultParameter_ProgramHardwareInfos()
{
    WORD usHardwareVersion(0);
    __uint64 ullSerialNb(0);
    DWORD ulControlWord(0);

    //Parameter
    SetParameterData(0, &usHardwareVersion, sizeof(usHardwareVersion));
    SetParameterData(1, &ullSerialNb, sizeof(ullSerialNb));
    SetParameterData(2, &ulControlWord, sizeof(ulControlWord));
}

void CCommand_VCS_Firmware::SetDefaultParameter_CleanupCommunication()
{
    BOOL oCleanupAfterCanPassive = FALSE;

    //Parameter
    SetParameterData(0, &oCleanupAfterCanPassive, sizeof(oCleanupAfterCanPassive));
}
