#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_Gateway.h>

CCommand_VCS_Gateway::CCommand_VCS_Gateway()
{
}

CCommand_VCS_Gateway::CCommand_VCS_Gateway(DWORD p_ulCommandId)
{
    InitCommand(p_ulCommandId);
}

CCommand_VCS_Gateway::~CCommand_VCS_Gateway()
{
}

BOOL CCommand_VCS_Gateway::InitCommand(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    ResetCommand();

    if(!oResult && InitCommand_Infos(p_ulCommandId))
    {
        oResult = TRUE;
    }

    return oResult;
}

CCommand_VCS_Gateway& CCommand_VCS_Gateway::operator=(CCommand_VCS_Gateway& p_Other)
{
    if(this != &p_Other)
    {
        *((CCommandRoot*)this) = *((CCommandRoot*)&p_Other);
    }

    return *this;
}

CCommandRoot* CCommand_VCS_Gateway::CloneCommand()
{
    CCommand_VCS_Gateway* pNewCommand;

    pNewCommand = new CCommand_VCS_Gateway();
    *pNewCommand = *this;

    return pNewCommand;
}

BOOL CCommand_VCS_Gateway::InitCommand_Infos(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case GET_GATEWAY_SETTINGS:
            {
                CCommand_VCS::InitCommand("GetGatewaySetting", GET_GATEWAY_SETTINGS);
                AddReturnParameter(0, "CANBitRate", ODT_UINT32);
                SetDefaultParameter_GetGatewaySettings();
                oResult = TRUE; break;
            };
        case SET_GATEWAY_SETTINGS:
            {
                CCommand_VCS::InitCommand("SetGatewaySetting", SET_GATEWAY_SETTINGS);
                AddParameter(0, "CANBitRate", ODT_UINT32);
                SetDefaultParameter_SetGatewaySettings();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

void CCommand_VCS_Gateway::SetDefaultParameter_GetGatewaySettings()
{
    DWORD ulCANBitRate = 1000000;

    SetReturnParameterData(0, &ulCANBitRate, sizeof(ulCANBitRate));
}

void CCommand_VCS_Gateway::SetDefaultParameter_SetGatewaySettings()
{
    DWORD ulCANBitRate = 1000000;

    SetParameterData(0, &ulCANBitRate, sizeof(ulCANBitRate));
}
