
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_Motion.h>

CCommand_VCS_Motion::CCommand_VCS_Motion()
{
}

CCommand_VCS_Motion::CCommand_VCS_Motion(DWORD p_ulCommandId)
{
    InitCommand(p_ulCommandId);
}

CCommand_VCS_Motion::~CCommand_VCS_Motion()
{
}

BOOL CCommand_VCS_Motion::InitCommand(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    ResetCommand();

    if(!oResult && InitCommand_Info(p_ulCommandId))
    {
        oResult = TRUE;
    }

    return oResult;
}

CCommand_VCS_Motion& CCommand_VCS_Motion::operator=(CCommand_VCS_Motion& p_Other)
{
    if(this != &p_Other)
    {
        *((CCommandRoot*)this) = *((CCommandRoot*)&p_Other);
    }

    return *this;
}

CCommandRoot* CCommand_VCS_Motion::CloneCommand()
{
    CCommand_VCS_Motion* pNewCommand;

    pNewCommand = new CCommand_VCS_Motion();
    *pNewCommand = *this;

    return pNewCommand;
}

BOOL CCommand_VCS_Motion::InitCommand_Info(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MOTION_GET_MOVEMENT_STATE:
            {
                CCommand_VCS::InitCommand("GetMovementState", MOTION_GET_MOVEMENT_STATE);
                AddReturnParameter(0, "targetReached", ODT_BOOLEAN);
                SetDefaultParameter_GetMovementState();
                oResult = TRUE; break;
            };
        case MOTION_GET_CURRENT_IS:
            {
                CCommand_VCS::InitCommand("GetCurrentIs", MOTION_GET_CURRENT_IS);
                AddReturnParameter(0, "currentIs", ODT_INT16);
                SetDefaultParameter_GetCurrentIs();
                oResult = TRUE; break;
            };
        case MOTION_GET_CURRENT_IS_AVERAGED:
            {
                CCommand_VCS::InitCommand("GetCurrentIsAveraged", MOTION_GET_CURRENT_IS_AVERAGED);
                AddReturnParameter(0, "CurrentIsAveraged", ODT_INT16);
                SetDefaultParameter_GetCurrentIsAveraged();
                oResult = TRUE; break;
            };
        case MOTION_GET_POSITION_IS:
            {
                CCommand_VCS::InitCommand("GetPositionIs", MOTION_GET_POSITION_IS);
                AddReturnParameter(0, "positionIs", ODT_INT32);
                SetDefaultParameter_GetPositionIs();
                oResult = TRUE; break;
            };
        case MOTION_GET_VELOCITY_IS:
            {
                CCommand_VCS::InitCommand("GetVelocityIs", MOTION_GET_VELOCITY_IS);
                AddReturnParameter(0, "velocityIs", ODT_INT32);
                SetDefaultParameter_GetVelocityIs();
                oResult = TRUE; break;
            };
        case MOTION_GET_VELOCITY_IS_AVERAGED:
            {
                CCommand_VCS::InitCommand("GetVelocityIsAveraged", MOTION_GET_VELOCITY_IS_AVERAGED);
                AddReturnParameter(0, "VelocityIsAveraged", ODT_INT32);
                SetDefaultParameter_GetVelocityIsAveraged();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

void CCommand_VCS_Motion::SetDefaultParameter_GetMovementState()
{
    BOOL oTargetReached = FALSE;

    //ReturnParameter
    SetReturnParameterData(0, &oTargetReached, sizeof(oTargetReached));
}

void CCommand_VCS_Motion::SetDefaultParameter_GetCurrentIs()
{
    short sCurrentIs = 0;

    //ReturnParameter
    SetReturnParameterData(0, &sCurrentIs, sizeof(sCurrentIs));
}

void CCommand_VCS_Motion::SetDefaultParameter_GetCurrentIsAveraged()
{
    short sCurrentIsAveraged = 0;

    //ReturnParameter
    SetReturnParameterData(0, &sCurrentIsAveraged, sizeof(sCurrentIsAveraged));
}

void CCommand_VCS_Motion::SetDefaultParameter_GetPositionIs()
{
    int lPositionIs = 0;

    //ReturnParameter
    SetReturnParameterData(0, &lPositionIs, sizeof(lPositionIs));
}

void CCommand_VCS_Motion::SetDefaultParameter_GetVelocityIs()
{
    int lVelocityIs = 0;

    //ReturnParameter
    SetReturnParameterData(0, &lVelocityIs, sizeof(lVelocityIs));
}

void CCommand_VCS_Motion::SetDefaultParameter_GetVelocityIsAveraged()
{
    int lVelocityIsAveraged = 0;

    //ReturnParameter
    SetReturnParameterData(0, &lVelocityIsAveraged, sizeof(lVelocityIsAveraged));
}
