#include "stdafx.h"
#include "stdint.h"
#include "MmcTypeDefinition.h"
#include <limits>
#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_OperationMode.h>

using namespace std;

CCommand_VCS_OperationMode::CCommand_VCS_OperationMode()
{
}

CCommand_VCS_OperationMode::CCommand_VCS_OperationMode(DWORD p_ulCommandId)
{
    InitCommand(p_ulCommandId);
}

CCommand_VCS_OperationMode::~CCommand_VCS_OperationMode()
{
}

BOOL CCommand_VCS_OperationMode::InitCommand(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    ResetCommand();

    if(!oResult && InitCommand_Initialisation(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_CurrentMode(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_CurrentPulseMode(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_VelocityMode(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_VelocityModeAnalog(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_PositionMode(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_PositionModeAnalog(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_CyclicSyncTorqueMode(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_HomingMode(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_ProfilePositionMode(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_ProfileVelocityMode(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_InterpolatedPositionMode(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_MasterEncoderMode(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_StepDirectionMode(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_TuningMode(p_ulCommandId))
    {
        oResult = TRUE;
    }

    return oResult;
}

CCommand_VCS_OperationMode& CCommand_VCS_OperationMode::operator=(CCommand_VCS_OperationMode& p_Other)
{
    if(this != &p_Other)
    {
        *((CCommandRoot*)this) = *((CCommandRoot*)&p_Other);
    }

    return *this;
}

CCommandRoot* CCommand_VCS_OperationMode::CloneCommand()
{
    CCommand_VCS_OperationMode* pNewCommand;

    pNewCommand = new CCommand_VCS_OperationMode();
    *pNewCommand = *this;

    return pNewCommand;
}

BOOL CCommand_VCS_OperationMode::InitCommand_Initialisation(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_GET_OPERATION_MODE:
            {
                CCommand_VCS::InitCommand("GetOperationMode", MODE_GET_OPERATION_MODE);
                AddReturnParameter(0, "mode", ODT_INT8);
                SetDefaultParameter_GetOperationMode();
                oResult = TRUE; break;
            };
        case MODE_SET_OPERATION_MODE:
            {
                CCommand_VCS::InitCommand("SetOperationMode", MODE_SET_OPERATION_MODE);
                AddParameter(0, "mode", ODT_INT8);
                SetDefaultParameter_SetOperationMode();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_CurrentMode(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_CUM_GET_CURRENT_MUST:
            {
                CCommand_VCS::InitCommand("GetCurrentMust", MODE_CUM_GET_CURRENT_MUST);
                AddReturnParameter(0, "currentMust", ODT_INT16);
                SetDefaultParameter_GetCurrentMust();
                oResult = TRUE; break;
            };
        case MODE_CUM_SET_CURRENT_MUST:
            {
                CCommand_VCS::InitCommand("SetCurrentMust", MODE_CUM_SET_CURRENT_MUST);
                AddParameter(0, "currentMust", ODT_INT16);
                SetDefaultParameter_SetCurrentMust();
                oResult = TRUE; break;
            };
        case MODE_CUM_ACTIVATE_ANALOG_CURRENT_SETPOINT:
            {
                CCommand_VCS::InitCommand("ActivateAnalogCurrentSetpoint", MODE_CUM_ACTIVATE_ANALOG_CURRENT_SETPOINT);
                AddParameter(0, "analogInputNumber", ODT_UINT16);
                AddParameter(1, "scaling", ODT_FLOAT);
                AddParameter(2, "offset", ODT_INT16);
                SetDefaultParameter_ActivateAnalogCurrentSetpoint();
                oResult = TRUE; break;
            };
        case MODE_CUM_DEACTIVATE_ANALOG_CURRENT_SETPOINT:
            {
                CCommand_VCS::InitCommand("DeactivateAnalogCurrentSetpoint", MODE_CUM_DEACTIVATE_ANALOG_CURRENT_SETPOINT);
                AddParameter(0, "analogInputNumber", ODT_UINT16);
                SetDefaultParameter_DeactivateAnalogCurrentSetpoint();
                oResult = TRUE; break;
            };
        case MODE_CUM_ENABLE_ANALOG_CURRENT_SETPOINT:
            {
                CCommand_VCS::InitCommand("EnableAnalogCurrentSetpoint", MODE_CUM_ENABLE_ANALOG_CURRENT_SETPOINT);
                SetDefaultParameter_EnableAnalogCurrentSetpoint();
                oResult = TRUE; break;
            };
        case MODE_CUM_DISABLE_ANALOG_CURRENT_SETPOINT:
            {
                CCommand_VCS::InitCommand("DisableAnalogCurrentSetpoint", MODE_CUM_DISABLE_ANALOG_CURRENT_SETPOINT);
                SetDefaultParameter_DisableAnalogCurrentSetpoint();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_CurrentPulseMode(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_CPM_DO_CURRENT_PULSE:
            {
                CCommand_VCS::InitCommand("DoCurrentPulse", MODE_CPM_DO_CURRENT_PULSE);
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_VelocityMode(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_VEM_GET_VELOCITY_MUST:
            {
                CCommand_VCS::InitCommand("GetVelocityMust", MODE_VEM_GET_VELOCITY_MUST);
                AddReturnParameter(0, "velocityMust", ODT_INT32);
                SetDefaultParameter_GetVelocityMust();
                oResult = TRUE; break;
            };
        case MODE_VEM_SET_VELOCITY_MUST:
            {
                CCommand_VCS::InitCommand("SetVelocityMust", MODE_VEM_SET_VELOCITY_MUST);
                AddParameter(0, "velocityMust", ODT_INT32);
                SetDefaultParameter_SetVelocityMust();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_VelocityModeAnalog(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_VEM_ACTIVATE_ANALOG_VELOCITY_SETPOINT:
            {
                CCommand_VCS::InitCommand("ActivateAnalogVelocitySetpoint", MODE_VEM_ACTIVATE_ANALOG_VELOCITY_SETPOINT);
                AddParameter(0, "analogInputNumber", ODT_UINT16);
                AddParameter(1, "scaling", ODT_FLOAT);
                AddParameter(2, "offset", ODT_INT32);
                SetDefaultParameter_ActivateAnalogVelocitySetpoint();
                oResult = TRUE; break;
            };
        case MODE_VEM_DEACTIVATE_ANALOG_VELOCITY_SETPOINT:
            {
                CCommand_VCS::InitCommand("DeactivateAnalogVelocitySetpoint", MODE_VEM_DEACTIVATE_ANALOG_VELOCITY_SETPOINT);
                AddParameter(0, "analogInputNumber", ODT_UINT16);
                SetDefaultParameter_DeactivateAnalogVelocitySetpoint();
                oResult = TRUE; break;
            };
        case MODE_VEM_ENABLE_ANALOG_VELOCITY_SETPOINT:
            {
                CCommand_VCS::InitCommand("EnableAnalogVelocitySetpoint", MODE_VEM_ENABLE_ANALOG_VELOCITY_SETPOINT);
                SetDefaultParameter_EnableAnalogVelocitySetpoint();
                oResult = TRUE; break;
            };
        case MODE_VEM_DISABLE_ANALOG_VELOCITY_SETPOINT:
            {
                CCommand_VCS::InitCommand("DisableAnalogVelocitySetpoint", MODE_VEM_DISABLE_ANALOG_VELOCITY_SETPOINT);
                SetDefaultParameter_DisableAnalogVelocitySetpoint();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_PositionMode(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_POM_GET_POSITION_MUST:
            {
                CCommand_VCS::InitCommand("GetPositionMust", MODE_POM_GET_POSITION_MUST);
                AddReturnParameter(0, "positionMust", ODT_INT32);
                SetDefaultParameter_GetPositionMust();
                oResult = TRUE; break;
            };
        case MODE_POM_SET_POSITION_MUST:
            {
                CCommand_VCS::InitCommand("SetPositionMust", MODE_POM_SET_POSITION_MUST);
                AddParameter(0, "positionMust", ODT_INT32);
                SetDefaultParameter_SetPositionMust();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_PositionModeAnalog(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_POM_ACTIVATE_ANALOG_POSITION_SETPOINT:
            {
                CCommand_VCS::InitCommand("ActivateAnalogPositionSetpoint", MODE_POM_ACTIVATE_ANALOG_POSITION_SETPOINT);
                AddParameter(0, "analogInputNumber", ODT_UINT16);
                AddParameter(1, "scaling", ODT_FLOAT);
                AddParameter(2, "offset", ODT_INT32);
                SetDefaultParameter_ActivateAnalogPositionSetpoint();
                oResult = TRUE; break;
            };
        case MODE_POM_DEACTIVATE_ANALOG_POSITION_SETPOINT:
            {
                CCommand_VCS::InitCommand("DeactivateAnalogPositionSetpoint", MODE_POM_DEACTIVATE_ANALOG_POSITION_SETPOINT);
                AddParameter(0, "analogInputNumber", ODT_UINT16);
                SetDefaultParameter_DeactivateAnalogPositionSetpoint();
                oResult = TRUE; break;
            };
        case MODE_POM_ENABLE_ANALOG_POSITION_SETPOINT:
            {
                CCommand_VCS::InitCommand("EnableAnalogPositionSetpoint", MODE_POM_ENABLE_ANALOG_POSITION_SETPOINT);
                SetDefaultParameter_EnableAnalogPositionSetpoint();
                oResult = TRUE; break;
            };
        case MODE_POM_DISABLE_ANALOG_POSITION_SETPOINT:
            {
                CCommand_VCS::InitCommand("DisableAnalogPositionSetpoint", MODE_POM_DISABLE_ANALOG_POSITION_SETPOINT);
                SetDefaultParameter_DisableAnalogPositionSetpoint();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_CyclicSyncTorqueMode(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_CST_INIT_CYCLIC_SYNC_TORQUE_MODE:
            {
                CCommand_VCS::InitCommand("InitCyclicSyncTorqueMode", MODE_CST_INIT_CYCLIC_SYNC_TORQUE_MODE);
                AddParameter(0, "nominalCurrent", ODT_UINT16);
                AddParameter(1, "torqueConstant", ODT_UINT32);
                SetDefaultParameter_InitCyclicSyncTorqueMode();
                oResult = TRUE; break;
            };
        case MODE_CST_SET_TARGET_TORQUE:
            {
                CCommand_VCS::InitCommand("SetTargetTorque", MODE_CST_SET_TARGET_TORQUE);
                AddParameter(0, "targetCurrent", ODT_UINT16);
                SetDefaultParameter_SetTargetTorque();
                oResult = TRUE; break;
            };
        case MODE_CST_GET_TARGET_TORQUE:
            {
                CCommand_VCS::InitCommand("GetTargetTorque", MODE_CST_GET_TARGET_TORQUE);
                AddReturnParameter(0, "targetCurrent", ODT_UINT16);
                SetDefaultParameter_GetTargetTorque();
                oResult = TRUE; break;
            };
        case MODE_CST_GET_TORQUE_IS:
            {
                CCommand_VCS::InitCommand("GetTorqueIs", MODE_CST_GET_TORQUE_IS);
                AddReturnParameter(0, "currentIs", ODT_UINT16);
                SetDefaultParameter_GetTorqueIs();
                oResult = TRUE; break;
            };
    }
    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_HomingMode(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_HM_FIND_HOME:
            {
                CCommand_VCS::InitCommand("FindHome", MODE_HM_FIND_HOME);
                AddParameter(0, "homingMethod", ODT_INT8);
                SetDefaultParameter_FindHome();
                oResult = TRUE; break;
            };
        case MODE_HM_GET_HOMING_PARAMETER:
            {
                CCommand_VCS::InitCommand("GetHomingParameter", MODE_HM_GET_HOMING_PARAMETER);
                AddReturnParameter(0, "homingAcceleration", ODT_UINT32);
                AddReturnParameter(1, "speedSwitch", ODT_UINT32);
                AddReturnParameter(2, "speedIndex", ODT_UINT32);
                AddReturnParameter(3, "homeOffset", ODT_INT32);
                AddReturnParameter(4, "currentThreshold", ODT_UINT16);
                AddReturnParameter(5, "homePosition", ODT_INT32);
                SetDefaultParameter_GetHomingParameter();
                oResult = TRUE; break;
            };
        case MODE_HM_SET_HOMING_PARAMETER:
            {
                CCommand_VCS::InitCommand("SetHomingParameter", MODE_HM_SET_HOMING_PARAMETER);
                AddParameter(0, "homingAcceleration", ODT_UINT32);
                AddParameter(1, "speedSwitch", ODT_UINT32);
                AddParameter(2, "speedIndex", ODT_UINT32);
                AddParameter(3, "homeOffset", ODT_INT32);
                AddParameter(4, "currentThreshold", ODT_UINT16);
                AddParameter(5, "homePosition", ODT_INT32);
                SetDefaultParameter_SetHomingParameter();
                oResult = TRUE; break;
            };
        case MODE_HM_STOP_HOMING:
            {
                CCommand_VCS::InitCommand("StopHoming", MODE_HM_STOP_HOMING);
                SetDefaultParameter_StopHoming();
                oResult = TRUE; break;
            };
        case MODE_HM_DEFINE_POSITION:
            {
                CCommand_VCS::InitCommand("DefinePosition", MODE_HM_DEFINE_POSITION);
                AddParameter(0, "homePosition", ODT_INT32);
                SetDefaultParameter_DefinePosition();
                oResult = TRUE; break;
            }
       case MODE_HM_GET_HOMING_STATE:
            {
                CCommand_VCS::InitCommand("GetHomingState", MODE_HM_GET_HOMING_STATE);
                AddReturnParameter(0, "homingAttained", ODT_BOOLEAN);
                AddReturnParameter(1, "homingError", ODT_BOOLEAN);
                SetDefaultParameter_GetHomingState();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_ProfilePositionMode(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_PPM_GET_POSITION_PROFILE:
            {
                CCommand_VCS::InitCommand("GetPositionProfile", MODE_PPM_GET_POSITION_PROFILE);
                AddReturnParameter(0, "profileVelocity", ODT_UINT32);
                AddReturnParameter(1, "profileAcceleration", ODT_UINT32);
                AddReturnParameter(2, "profileDeceleration", ODT_UINT32);
                SetDefaultParameter_GetPositionProfile();
                oResult = TRUE; break;
            };
        case MODE_PPM_GET_TARGET_POSITION:
            {
                CCommand_VCS::InitCommand("GetTargetPosition", MODE_PPM_GET_TARGET_POSITION);
                AddReturnParameter(0, "targetPosition", ODT_INT32);
                SetDefaultParameter_GetTargetPosition();
                oResult = TRUE; break;
            };
        case MODE_PPM_HALT_POSITION_MOVEMENT:
            {
                CCommand_VCS::InitCommand("HaltPositionMovement", MODE_PPM_HALT_POSITION_MOVEMENT);
                AddParameter(0, "nodeID", ODT_UINT16, FALSE, FALSE);
                SetDefaultParameter_HaltPositionMovement();
                oResult = TRUE; break;
            };
        case MODE_PPM_MOVE_TO_POSITION:
            {
                CCommand_VCS::InitCommand("MoveToPosition", MODE_PPM_MOVE_TO_POSITION);
                AddParameter(0, "targetPosition", ODT_INT32);
                AddParameter(1, "absolute", ODT_BOOLEAN);
                AddParameter(2, "immediately", ODT_BOOLEAN);
                SetDefaultParameter_MoveToPosition();
                oResult = TRUE; break;
            };
        case MODE_PPM_SET_POSITION_PROFILE:
            {
                CCommand_VCS::InitCommand("SetPositionProfile", MODE_PPM_SET_POSITION_PROFILE);
                AddParameter(0, "profileVelocity", ODT_UINT32);
                AddParameter(1, "profileAcceleration", ODT_UINT32);
                AddParameter(2, "profileDeceleration", ODT_UINT32);
                SetDefaultParameter_SetPositionProfile();
                oResult = TRUE; break;
            };
        case MODE_PPM_ENABLE_POSITION_WINDOW:
            {
                CCommand_VCS::InitCommand("EnablePositionWindow", MODE_PPM_ENABLE_POSITION_WINDOW);
                AddParameter(0, "positionWindow", ODT_UINT32);
                AddParameter(1, "positionWindowTime", ODT_UINT16);
                SetDefaultParameter_EnablePositionWindow();
                oResult = TRUE; break;
            };
        case MODE_PPM_DISABLE_POSITION_WINDOW:
            {
                CCommand_VCS::InitCommand("DisablePositionWindow", MODE_PPM_DISABLE_POSITION_WINDOW);
                SetDefaultParameter_DisablePositionWindow();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_ProfileVelocityMode(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_PVM_GET_TARGET_VELOCITY:
            {
                CCommand_VCS::InitCommand("GetTargetVelocity", MODE_PVM_GET_TARGET_VELOCITY);
                AddReturnParameter(0, "targetVelocity", ODT_INT32);
                SetDefaultParameter_GetTargetVelocity();
                oResult = TRUE; break;
            };
        case MODE_PVM_GET_VELOCITY_PROFILE:
            {
                CCommand_VCS::InitCommand("GetVelocityProfile", MODE_PVM_GET_VELOCITY_PROFILE);
                AddReturnParameter(0, "profileAcceleration", ODT_UINT32);
                AddReturnParameter(1, "profileDeceleration", ODT_UINT32);
                SetDefaultParameter_GetVelocityProfile();
                oResult = TRUE; break;
            };
        case MODE_PVM_HALT_VELOCITY_MOVEMENT:
            {
                CCommand_VCS::InitCommand("HaltVelocityMovement", MODE_PVM_HALT_VELOCITY_MOVEMENT);
                SetDefaultParameter_HaltVelocityMovement();
                oResult = TRUE; break;
            };
        case MODE_PVM_MOVE_WITH_VELOCITY:
            {
                CCommand_VCS::InitCommand("MoveWithVelocity", MODE_PVM_MOVE_WITH_VELOCITY);
                AddParameter(0, "targetVelocity", ODT_INT32);
                SetDefaultParameter_MoveWithVelocity();
                oResult = TRUE; break;
            };
        case MODE_PVM_SET_VELOCITY_PROFILE:
            {
                CCommand_VCS::InitCommand("SetVelocityProfile", MODE_PVM_SET_VELOCITY_PROFILE);
                AddParameter(0, "profileAcceleration", ODT_UINT32);
                AddParameter(1, "profileDeceleration", ODT_UINT32);
                SetDefaultParameter_SetVelocityProfile();
                oResult = TRUE; break;
            };
        case MODE_PVM_ENABLE_VELOCITY_WINDOW:
            {
                CCommand_VCS::InitCommand("EnableVelocityWindow", MODE_PVM_ENABLE_VELOCITY_WINDOW);
                AddParameter(0, "velocityWindow", ODT_UINT32);
                AddParameter(1, "velocityWindowTime", ODT_UINT16);
                SetDefaultParameter_EnableVelocityWindow();
                oResult = TRUE; break;
            };
        case MODE_PVM_DISABLE_VELOCITY_WINDOW:
            {
                CCommand_VCS::InitCommand("DisableVelocityWindow", MODE_PVM_DISABLE_VELOCITY_WINDOW);
                SetDefaultParameter_DisableVelocityWindow();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_InterpolatedPositionMode(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_IPM_SET_IPM_BUFFER_PARAMETER:
            {
                CCommand_VCS::InitCommand("SetIpmBufferParameter", MODE_IPM_SET_IPM_BUFFER_PARAMETER);
                AddParameter(0, "underflowWarningLimit", ODT_UINT16);
                AddParameter(1, "overflowWarningLimit", ODT_UINT16);
                SetDefaultParameter_SetIpmBufferParameter();
                oResult = TRUE; break;
            };
        case MODE_IPM_GET_IPM_BUFFER_PARAMETER:
            {
                CCommand_VCS::InitCommand("GetIpmBufferParameter", MODE_IPM_GET_IPM_BUFFER_PARAMETER);
                AddReturnParameter(0, "underflowWarningLimit", ODT_UINT16);
                AddReturnParameter(1, "overflowWarningLimit", ODT_UINT16);
                AddReturnParameter(2, "maxBufferSize", ODT_UINT32);
                SetDefaultParameter_GetIpmBufferParameter();
                oResult = TRUE; break;
            };
        case MODE_IPM_CLEAR_IPM_BUFFER:
            {
                CCommand_VCS::InitCommand("ClearIpmBuffer", MODE_IPM_CLEAR_IPM_BUFFER);
                SetDefaultParameter_ClearIpmBuffer();
                oResult = TRUE; break;
            };
        case MODE_IPM_GET_FREE_IPM_BUFFER_SIZE:
            {
                CCommand_VCS::InitCommand("GetFreeIpmBufferSize", MODE_IPM_GET_FREE_IPM_BUFFER_SIZE);
                AddReturnParameter(0, "bufferSize", ODT_UINT32);
                SetDefaultParameter_GetFreeIpmBufferSize();
                oResult = TRUE; break;
            };
        case MODE_IPM_ADD_PVT_VALUE_TO_IPM_BUFFER:
            {
                CCommand_VCS::InitCommand("AddPvtValueToIpmBuffer", MODE_IPM_ADD_PVT_VALUE_TO_IPM_BUFFER);
                AddParameter(0, "position", ODT_UINT32);
                AddParameter(1, "velocity", ODT_UINT32);
                AddParameter(2, "time", ODT_UINT8);
                SetDefaultParameter_AddPvtValueToIpmBuffer();
                oResult = TRUE; break;
            };
        case MODE_IPM_START_IPM_TRAJECTORY:
            {
                CCommand_VCS::InitCommand("StartIpmTrajectory", MODE_IPM_START_IPM_TRAJECTORY);
                SetDefaultParameter_StartIpmTrajectory();
                oResult = TRUE; break;
            };
        case MODE_IPM_STOP_IPM_TRAJECTORY:
            {
                CCommand_VCS::InitCommand("StopIpmTrajectory", MODE_IPM_STOP_IPM_TRAJECTORY);
                SetDefaultParameter_StopIpmTrajectory();
                oResult = TRUE; break;
            };
        case MODE_IPM_GET_IPM_STATUS:
            {
                CCommand_VCS::InitCommand("GetIpmStatus", MODE_IPM_GET_IPM_STATUS);
                AddReturnParameter(0, "trajectoryRunning", ODT_BOOLEAN);
                AddReturnParameter(1, "isUnderflowWarning", ODT_BOOLEAN);
                AddReturnParameter(2, "isOverflowWarning", ODT_BOOLEAN);
                AddReturnParameter(3, "isVelocityWarning", ODT_BOOLEAN);
                AddReturnParameter(4, "isAccelerationWarning", ODT_BOOLEAN);
                AddReturnParameter(5, "isUnderflowError", ODT_BOOLEAN);
                AddReturnParameter(6, "isOverflowError", ODT_BOOLEAN);
                AddReturnParameter(7, "isVelocityError", ODT_BOOLEAN);
                AddReturnParameter(8, "isAccelerationError", ODT_BOOLEAN);
                SetDefaultParameter_GetIpmStatus();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_MasterEncoderMode(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_MEM_SET_MASTER_ENCODER_PARAMETER:
            {
                CCommand_VCS::InitCommand("SetMasterEncoderParameter", MODE_MEM_SET_MASTER_ENCODER_PARAMETER);
                AddParameter(0, "scalingNumerator", ODT_UINT16);
                AddParameter(1, "scalingDenominator", ODT_UINT16);
                AddParameter(2, "polarity", ODT_UINT8);
                AddParameter(3, "maxVelocity", ODT_UINT32);
                AddParameter(4, "maxAcceleration", ODT_UINT32);
                SetDefaultParameter_SetMasterEncoderParameter();
                oResult = TRUE; break;
            };
        case MODE_MEM_GET_MASTER_ENCODER_PARAMETER:
            {
                CCommand_VCS::InitCommand("GetMasterEncoderParameter", MODE_MEM_GET_MASTER_ENCODER_PARAMETER);
                AddReturnParameter(0, "scalingNumerator", ODT_UINT16);
                AddReturnParameter(1, "scalingDenominator", ODT_UINT16);
                AddReturnParameter(2, "polarity", ODT_UINT8);
                AddReturnParameter(3, "maxVelocity", ODT_UINT32);
                AddReturnParameter(4, "maxAcceleration", ODT_UINT32);
                SetDefaultParameter_GetMasterEncoderParameter();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_StepDirectionMode(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_STM_SET_STEP_DIRECTION_PARAMETER:
            {
                CCommand_VCS::InitCommand("SetStepDirectionParameter", MODE_STM_SET_STEP_DIRECTION_PARAMETER);
                AddParameter(0, "scalingNumerator", ODT_UINT16);
                AddParameter(1, "scalingDenominator", ODT_UINT16);
                AddParameter(2, "polarity", ODT_UINT8);
                AddParameter(3, "maxVelocity", ODT_UINT32);
                AddParameter(4, "maxAcceleration", ODT_UINT32);
                SetDefaultParameter_SetStepDirectionParameter();
                oResult = TRUE; break;
            };

        case MODE_STM_GET_STEP_DIRECTION_PARAMETER:
            {
                CCommand_VCS::InitCommand("GetStepDirectionParameter", MODE_STM_GET_STEP_DIRECTION_PARAMETER);
                AddReturnParameter(0, "scalingNumerator", ODT_UINT16);
                AddReturnParameter(1, "scalingDenominator", ODT_UINT16);
                AddReturnParameter(2, "polarity", ODT_UINT8);
                AddReturnParameter(3, "maxVelocity", ODT_UINT32);
                AddReturnParameter(4, "maxAcceleration", ODT_UINT32);
                SetDefaultParameter_GetStepDirectionParameter();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_OperationMode::InitCommand_TuningMode(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case MODE_TUNING_DO_TUNING:
            {
                CCommand_VCS::InitCommand("DoTuning", MODE_TUNING_DO_TUNING);
                oResult = TRUE; break;
            };
    }

    return oResult;
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetOperationMode()
{
    __int8 bMode = 0;

    //ReturnParameter
    SetReturnParameterData(0, &bMode, sizeof(bMode));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_SetOperationMode()
{
    __int8 bMode = 0;

    //Parameter
    SetParameterData(0, &bMode, sizeof(bMode));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetCurrentMust()
{
    short sCurrentMust = 0;

    //ReturnParameter
    SetReturnParameterData(0, &sCurrentMust, sizeof(sCurrentMust));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_SetCurrentMust()
{
    short sCurrentMust = 0;

    //Parameter
    SetParameterData(0, &sCurrentMust, sizeof(sCurrentMust));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_ActivateAnalogCurrentSetpoint()
{
    WORD usAnalogInputNumber = 0;
    float fScaling = 0;
    short sOffset = 0;

    //Parameter
    SetParameterData(0, &usAnalogInputNumber, sizeof(usAnalogInputNumber));
    SetParameterData(1, &fScaling, sizeof(fScaling));
    SetParameterData(2, &sOffset, sizeof(sOffset));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_DeactivateAnalogCurrentSetpoint()
{
    WORD usAnalogInputNumber = 0;

    //Parameter
    SetParameterData(0, &usAnalogInputNumber, sizeof(usAnalogInputNumber));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_EnableAnalogCurrentSetpoint()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_DisableAnalogCurrentSetpoint()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetVelocityMust()
{
    int lVelocityMust = 0;

    //ReturnParameter
    SetReturnParameterData(0, &lVelocityMust, sizeof(lVelocityMust));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_SetVelocityMust()
{
    int lVelocityMust = 0;

    //Parameter
    SetParameterData(0, &lVelocityMust, sizeof(lVelocityMust));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_ActivateAnalogVelocitySetpoint()
{
    WORD usAnalogInputNumber = 0;
    float fScaling = 0;
    int lOffset = 0;

    //Parameter
    SetParameterData(0, &usAnalogInputNumber, sizeof(usAnalogInputNumber));
    SetParameterData(1, &fScaling, sizeof(fScaling));
    SetParameterData(2, &lOffset, sizeof(lOffset));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_DeactivateAnalogVelocitySetpoint()
{
    WORD usAnalogInputNumber = 0;

    //Parameter
    SetParameterData(0, &usAnalogInputNumber, sizeof(usAnalogInputNumber));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_EnableAnalogVelocitySetpoint()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_DisableAnalogVelocitySetpoint()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetPositionMust()
{
    int lPositionMust = 0;

    //ReturnParameter
    SetReturnParameterData(0, &lPositionMust, sizeof(lPositionMust));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_SetPositionMust()
{
    int lPositionMust = 0;

    //Parameter
    SetParameterData(0, &lPositionMust, sizeof(lPositionMust));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_ActivateAnalogPositionSetpoint()
{
    WORD usAnalogInputNumber = 0;
    float fScaling = 0;
    int lOffset = 0;

    //Parameter
    SetParameterData(0, &usAnalogInputNumber, sizeof(usAnalogInputNumber));
    SetParameterData(1, &fScaling, sizeof(fScaling));
    SetParameterData(2, &lOffset, sizeof(lOffset));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_DeactivateAnalogPositionSetpoint()
{
    WORD usAnalogInputNumber = 0;

    //Parameter
    SetParameterData(0, &usAnalogInputNumber, sizeof(usAnalogInputNumber));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_EnableAnalogPositionSetpoint()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_DisableAnalogPositionSetpoint()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_InitCyclicSyncTorqueMode()
{
    WORD usNominalCurrent(0);
    DWORD ulTorqueConstant(0);

    //Parameter
    SetParameterData(0, &usNominalCurrent, sizeof(usNominalCurrent));
    SetParameterData(1, &ulTorqueConstant, sizeof(ulTorqueConstant));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_SetTargetTorque()
{
    short sTargetCurrent(0);

    //Parameter
    SetParameterData(0, &sTargetCurrent, sizeof(sTargetCurrent));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetTargetTorque()
{
    short sTargetCurrent(0);

    //Parameter
    SetReturnParameterData(0, &sTargetCurrent, sizeof(sTargetCurrent));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetTorqueIs()
{
    short sCurrentIs(0);

    //Parameter
    SetReturnParameterData(0, &sCurrentIs, sizeof(sCurrentIs));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_FindHome()
{
    __int8 bHomingMethod = 0;

    //Parameter
    SetParameterData(0, &bHomingMethod, sizeof(bHomingMethod));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetHomingParameter()
{
    DWORD ulHomingAcceleration = 0;
    DWORD ulSpeedSwitch = 0;
    DWORD ulSpeedIndex = 0;
    int lHomeOffset = 0;
    WORD usCurrentThreshold = 0;
    int lHomePosition = 0;

    //ReturnParameter
    SetReturnParameterData(0, &ulHomingAcceleration, sizeof(ulHomingAcceleration));
    SetReturnParameterData(1, &ulSpeedSwitch, sizeof(ulSpeedSwitch));
    SetReturnParameterData(2, &ulSpeedIndex, sizeof(ulSpeedIndex));
    SetReturnParameterData(3, &lHomeOffset, sizeof(lHomeOffset));
    SetReturnParameterData(4, &usCurrentThreshold, sizeof(usCurrentThreshold));
    SetReturnParameterData(5, &lHomePosition, sizeof(lHomePosition));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_SetHomingParameter()
{
    DWORD ulHomingAcceleration = 0;
    DWORD ulSpeedSwitch = 0;
    DWORD ulSpeedIndex = 0;
    int lHomeOffset = 0;
    WORD usCurrentThreshold = 0;
    int lHomePosition = 0;

    //Parameter
    SetParameterData(0, &ulHomingAcceleration, sizeof(ulHomingAcceleration));
    SetParameterData(1, &ulSpeedSwitch, sizeof(ulSpeedSwitch));
    SetParameterData(2, &ulSpeedIndex, sizeof(ulSpeedIndex));
    SetParameterData(3, &lHomeOffset, sizeof(lHomeOffset));
    SetParameterData(4, &usCurrentThreshold, sizeof(usCurrentThreshold));
    SetParameterData(5, &lHomePosition, sizeof(lHomePosition));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_StopHoming()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_DefinePosition()
{
    int lHomePosition = 0;

    //Parameter
    SetParameterData(0, &lHomePosition, sizeof(lHomePosition));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetHomingState()
{
    BOOL oHomingAttained = FALSE;
    BOOL oHomingError = FALSE;

    //ReturnParameter
    SetReturnParameterData(0, &oHomingAttained, sizeof(oHomingAttained));
    SetReturnParameterData(1, &oHomingError, sizeof(oHomingError));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetPositionProfile()
{
    DWORD ulProfileVelocity = 1000;
    DWORD ulProfileAcceleration = 10000;
    DWORD ulProfileDeceleration = 10000;

    //ReturnParameter
    SetReturnParameterData(0, &ulProfileVelocity, sizeof(ulProfileVelocity));
    SetReturnParameterData(1, &ulProfileAcceleration, sizeof(ulProfileAcceleration));
    SetReturnParameterData(2, &ulProfileDeceleration, sizeof(ulProfileDeceleration));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetTargetPosition()
{
    int lTargetPosition = 0;

    //ReturnParameter
    SetReturnParameterData(0, &lTargetPosition, sizeof(lTargetPosition));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_HaltPositionMovement()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_MoveToPosition()
{
    int lTargetPosition = 1000;
    BOOL oAbsolute = FALSE;
    BOOL oImmediately = TRUE;

    //Parameter
    SetParameterData(0, &lTargetPosition, sizeof(lTargetPosition));
    SetParameterData(1, &oAbsolute, sizeof(oAbsolute));
    SetParameterData(2, &oImmediately, sizeof(oImmediately));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_SetPositionProfile()
{
    DWORD ulProfileVelocity = 1000;
    DWORD ulProfileAcceleration = 10000;
    DWORD ulProfileDeceleration = 10000;

    //Parameter
    SetParameterData(0, &ulProfileVelocity, sizeof(ulProfileVelocity));
    SetParameterData(1, &ulProfileAcceleration, sizeof(ulProfileAcceleration));
    SetParameterData(2, &ulProfileDeceleration, sizeof(ulProfileDeceleration));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_EnablePositionWindow()
{
    DWORD ulPositionWindow = (DWORD)(numeric_limits<unsigned int>::max)();
    WORD usPositionWindowTime = 0;

    //Parameter
    SetParameterData(0, &ulPositionWindow, sizeof(ulPositionWindow));
    SetParameterData(1, &usPositionWindowTime, sizeof(usPositionWindowTime));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_DisablePositionWindow()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetTargetVelocity()
{
    int lTargetVelocity = 0;

    //ReturnParameter
    SetReturnParameterData(0, &lTargetVelocity, sizeof(lTargetVelocity));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetVelocityProfile()
{
    DWORD ulProfileAcceleration = 0;
    DWORD ulProfileDeceleration = 0;

    //ReturnParameter
    SetReturnParameterData(0, &ulProfileAcceleration, sizeof(ulProfileAcceleration));
    SetReturnParameterData(1, &ulProfileDeceleration, sizeof(ulProfileDeceleration));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_HaltVelocityMovement()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_MoveWithVelocity()
{
    int lTargetVelocity = 0;

    //Parameter
    SetParameterData(0, &lTargetVelocity, sizeof(lTargetVelocity));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_SetVelocityProfile()
{
    DWORD ulProfileAcceleration = 0;
    DWORD ulProfileDeceleration = 0;

    //Parameter
    SetParameterData(0, &ulProfileAcceleration, sizeof(ulProfileAcceleration));
    SetParameterData(1, &ulProfileDeceleration, sizeof(ulProfileDeceleration));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_EnableVelocityWindow()
{    
    DWORD ulVelocityWindow = (DWORD)(numeric_limits<unsigned int>::max)();
    WORD usVelocityWindowTime = 0;

    //Parameter
    SetParameterData(0, &ulVelocityWindow, sizeof(ulVelocityWindow));
    SetParameterData(1, &usVelocityWindowTime, sizeof(usVelocityWindowTime));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_DisableVelocityWindow()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_SetIpmBufferParameter()
{
    WORD usUnderflowWarningLimit = 4;
    WORD usOverflowWarningLimit = 60;

    //Parameter
    SetParameterData(0, &usUnderflowWarningLimit, sizeof(usUnderflowWarningLimit));
    SetParameterData(1, &usOverflowWarningLimit, sizeof(usOverflowWarningLimit));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetIpmBufferParameter()
{
    WORD usUnderflowWarningLimit = 4;
    WORD usOverflowWarningLimit = 60;
    DWORD ulMaxBufferSize = 0;

    //ReturnParameter
    SetReturnParameterData(0, &usUnderflowWarningLimit, sizeof(usUnderflowWarningLimit));
    SetReturnParameterData(1, &usOverflowWarningLimit, sizeof(usOverflowWarningLimit));
    SetReturnParameterData(2, &ulMaxBufferSize, sizeof(ulMaxBufferSize));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_ClearIpmBuffer()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetFreeIpmBufferSize()
{
    DWORD ulBufferSize = 0;

    //ReturnParameter
    SetReturnParameterData(0, &ulBufferSize, sizeof(ulBufferSize));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_AddPvtValueToIpmBuffer()
{
    int lPosition = 0;
    int lVelocity = 0;
    BYTE ubTime = 0;

    //Parameter
    SetParameterData(0, &lPosition, sizeof(lPosition));
    SetParameterData(1, &lVelocity, sizeof(lVelocity));
    SetParameterData(2, &ubTime, sizeof(ubTime));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_StartIpmTrajectory()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_StopIpmTrajectory()
{
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetIpmStatus()
{
    BOOL oTrajectoryRunning = FALSE;
    BOOL oIsUnderflowWarning = FALSE;
    BOOL oIsOverflowWarning = FALSE;
    BOOL oIsVelocityWarning = FALSE;
    BOOL oIsAccelerationWarning = FALSE;
    BOOL oIsUnderflowError = FALSE;
    BOOL oIsOverflowError = FALSE;
    BOOL oIsVelocityError = FALSE;
    BOOL oIsAccelerationError = FALSE;

    //ReturnParameter
    SetReturnParameterData(0, &oTrajectoryRunning, sizeof(oTrajectoryRunning));
    SetReturnParameterData(1, &oIsUnderflowWarning, sizeof(oIsUnderflowWarning));
    SetReturnParameterData(2, &oIsOverflowWarning, sizeof(oIsOverflowWarning));
    SetReturnParameterData(3, &oIsVelocityWarning, sizeof(oIsVelocityWarning));
    SetReturnParameterData(4, &oIsAccelerationWarning, sizeof(oIsAccelerationWarning));
    SetReturnParameterData(5, &oIsUnderflowError, sizeof(oIsUnderflowError));
    SetReturnParameterData(6, &oIsOverflowError, sizeof(oIsOverflowError));
    SetReturnParameterData(7, &oIsVelocityError, sizeof(oIsVelocityError));
    SetReturnParameterData(8, &oIsAccelerationError, sizeof(oIsAccelerationError));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_SetMasterEncoderParameter()
{
    BYTE ubPolarity = 0;
    DWORD ulMaxAcceleration = (DWORD)(numeric_limits<unsigned int>::max)();
    DWORD ulMaxVelocity = 25000;
    WORD usScalingDenominator = 1;
    WORD usScalingNumerator = 1;

    //Parameter
    SetParameterData(0, &usScalingNumerator, sizeof(usScalingNumerator));
    SetParameterData(1, &usScalingDenominator, sizeof(usScalingDenominator));
    SetParameterData(2, &ubPolarity, sizeof(ubPolarity));
    SetParameterData(3, &ulMaxVelocity, sizeof(ulMaxVelocity));
    SetParameterData(4, &ulMaxAcceleration, sizeof(ulMaxAcceleration));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetMasterEncoderParameter()
{
    BYTE ubPolarity = 0;
    DWORD ulMaxAcceleration = (DWORD)(numeric_limits<unsigned int>::max)();
    DWORD ulMaxVelocity = 25000;
    WORD usScalingDenominator = 1;
    WORD usScalingNumerator = 1;

    //ReturnParameter
    SetReturnParameterData(0, &usScalingNumerator, sizeof(usScalingNumerator));
    SetReturnParameterData(1, &usScalingDenominator, sizeof(usScalingDenominator));
    SetReturnParameterData(2, &ubPolarity, sizeof(ubPolarity));
    SetReturnParameterData(3, &ulMaxVelocity, sizeof(ulMaxVelocity));
    SetReturnParameterData(4, &ulMaxAcceleration, sizeof(ulMaxAcceleration));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_SetStepDirectionParameter()
{
    BYTE ubPolarity = 0;
    DWORD ulMaxAcceleration = (DWORD)(numeric_limits<unsigned int>::max)();
    DWORD ulMaxVelocity = 25000;
    WORD usScalingDenominator = 1;
    WORD usScalingNumerator = 1;

    //Parameter
    SetParameterData(0, &usScalingNumerator, sizeof(usScalingNumerator));
    SetParameterData(1, &usScalingDenominator, sizeof(usScalingDenominator));
    SetParameterData(2, &ubPolarity, sizeof(ubPolarity));
    SetParameterData(3, &ulMaxVelocity, sizeof(ulMaxVelocity));
    SetParameterData(4, &ulMaxAcceleration, sizeof(ulMaxAcceleration));
}

void CCommand_VCS_OperationMode::SetDefaultParameter_GetStepDirectionParameter()
{
    BYTE ubPolarity = 0;
    DWORD ulMaxAcceleration = (DWORD)(numeric_limits<unsigned int>::max)();
    DWORD ulMaxVelocity = 25000;
    WORD usScalingDenominator = 1;
    WORD usScalingNumerator = 1;

    //ReturnParameter
    SetReturnParameterData(0, &usScalingNumerator, sizeof(usScalingNumerator));
    SetReturnParameterData(1, &usScalingDenominator, sizeof(usScalingDenominator));
    SetReturnParameterData(2, &ubPolarity, sizeof(ubPolarity));
    SetReturnParameterData(3, &ulMaxVelocity, sizeof(ulMaxVelocity));
    SetReturnParameterData(4, &ulMaxAcceleration, sizeof(ulMaxAcceleration));
}
