
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_Parameter.h>

CCommand_VCS_Parameter::CCommand_VCS_Parameter()
{
}

CCommand_VCS_Parameter::CCommand_VCS_Parameter(DWORD p_ulCommandId)
{
    InitCommand(p_ulCommandId);
}

CCommand_VCS_Parameter::~CCommand_VCS_Parameter()
{
}

BOOL CCommand_VCS_Parameter::InitCommand(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    ResetCommand();

    if(!oResult && InitCommand_Values(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_Persistence(p_ulCommandId))
    {
        oResult = TRUE;
    }

    return oResult;
}

CCommand_VCS_Parameter& CCommand_VCS_Parameter::operator=(CCommand_VCS_Parameter& p_Other)
{
    if(this != &p_Other)
    {
        *((CCommandRoot*)this) = *((CCommandRoot*)&p_Other);
    }

    return *this;
}

CCommandRoot* CCommand_VCS_Parameter::CloneCommand()
{
    CCommand_VCS_Parameter* pNewCommand;

    pNewCommand = new CCommand_VCS_Parameter();
    *pNewCommand = *this;

    return pNewCommand;
}

BOOL CCommand_VCS_Parameter::InitCommand_Values(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case PARAMETER_GET_VALUE:
            {
                CCommand_VCS::InitCommand("GetObject", PARAMETER_GET_VALUE);
                AddParameter(0, "objectIndex", ODT_UINT16);
                AddParameter(1, "objectSubIndex", ODT_UINT8);
                AddParameter(2, "nbOfBytesToRead", ODT_UINT32);
                AddReturnParameter(0, "data", ODT_MEMORY_BLOCK);
                AddReturnParameter(1, "nbOfBytesRead", ODT_UINT32);
                SetDefaultParameter_GetObject();
                oResult = TRUE;
                break;
            };
        case PARAMETER_SET_VALUE:
            {
                CCommand_VCS::InitCommand("SetObject", PARAMETER_SET_VALUE);
                AddParameter(0, "objectIndex", ODT_UINT16);
                AddParameter(1, "objectSubIndex", ODT_UINT8);
                AddParameter(2, "data", ODT_MEMORY_BLOCK);
                AddParameter(3, "nbOfBytesToWrite", ODT_UINT32);
                AddReturnParameter(0, "nbOfBytesWritten", ODT_UINT32);
                SetDefaultParameter_SetObject();
                oResult = TRUE;
                break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_Parameter::InitCommand_Persistence(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case PARAMETER_STORE:
            {
                CCommand_VCS::InitCommand("Store", PARAMETER_STORE);
                SetDefaultParameter_Store();
                oResult = TRUE;
                break;
            };
        case PARAMETER_RESTORE:
            {
                CCommand_VCS::InitCommand("Restore", PARAMETER_RESTORE);
                SetDefaultParameter_Restore();
                oResult = TRUE;
                break;
            };
        case PARAMETER_RESTORE_FACTORY:
            {
                CCommand_VCS::InitCommand("RestoreFactory", PARAMETER_RESTORE_FACTORY);
                SetDefaultParameter_RestoreFactory();
                oResult = TRUE;
                break;
            };
        case PARAMETER_RESTORE_ALL:
            {
                CCommand_VCS::InitCommand("Restore All", PARAMETER_RESTORE_ALL);
                SetDefaultParameter_RestoreAll();
                oResult = TRUE; break;
            };

        case PARAMETER_STORE_ALL:
            {
                CCommand_VCS::InitCommand("Store All", PARAMETER_STORE_ALL);
                SetDefaultParameter_StoreAll();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

void CCommand_VCS_Parameter::SetDefaultParameter_GetObject()
{
    WORD usObjectIndex = 0x0000;
    BYTE ubObjectSubIndex = 0x00;
    DWORD ulNbOfBytesToRead = 0;
    void* pData = 0;
    DWORD ulNbOfBytesRead = 0;

    //Parameter
    SetParameterData(0, &usObjectIndex, sizeof(usObjectIndex));
    SetParameterData(1, &ubObjectSubIndex, sizeof(ubObjectSubIndex));
    SetParameterData(2, &ulNbOfBytesToRead, sizeof(ulNbOfBytesToRead));

    //ReturnParameter
    SetReturnParameterData(0, pData, ulNbOfBytesToRead);
    SetReturnParameterData(1, &ulNbOfBytesRead, sizeof(ulNbOfBytesRead));
}

void CCommand_VCS_Parameter::SetDefaultParameter_SetObject()
{
    WORD usObjectIndex = 0x0000;
    BYTE ubObjectSubIndex = 0x00;
    void* pData = 0;
    DWORD ulNbOfBytesToWrite = 0;
    DWORD ulNbOfBytesWritten = 0;

    //Parameter
    SetParameterData(0, &usObjectIndex, sizeof(usObjectIndex));
    SetParameterData(1, &ubObjectSubIndex, sizeof(ubObjectSubIndex));
    SetParameterData(2, pData, ulNbOfBytesToWrite);
    SetParameterData(3, &ulNbOfBytesToWrite, sizeof(ulNbOfBytesToWrite));

    //ReturnParameter
    SetReturnParameterData(0, &ulNbOfBytesWritten, sizeof(ulNbOfBytesWritten));
}

void CCommand_VCS_Parameter::SetDefaultParameter_Store()
{
}

void CCommand_VCS_Parameter::SetDefaultParameter_Restore()
{
}

void CCommand_VCS_Parameter::SetDefaultParameter_RestoreFactory()
{
}

void CCommand_VCS_Parameter::SetDefaultParameter_RestoreAll()
{
}

void CCommand_VCS_Parameter::SetDefaultParameter_StoreAll()
{
}