
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_StateMachine.h>

CCommand_VCS_StateMachine::CCommand_VCS_StateMachine()
{
}

CCommand_VCS_StateMachine::CCommand_VCS_StateMachine(DWORD p_ulCommandId)
{
    InitCommand(p_ulCommandId);
}

CCommand_VCS_StateMachine::~CCommand_VCS_StateMachine()
{
}

BOOL CCommand_VCS_StateMachine::InitCommand(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    ResetCommand();

    if(!oResult && InitCommand_StateMachineCia402(p_ulCommandId))
    {
        oResult = TRUE;
    }
    if(!oResult && InitCommand_StateMachineMaxon(p_ulCommandId))
    {
        oResult = TRUE;
    }

    return oResult;
}

CCommand_VCS_StateMachine& CCommand_VCS_StateMachine::operator=(CCommand_VCS_StateMachine& p_Other)
{
    if(this != &p_Other)
    {
        *((CCommandRoot*)this) = *((CCommandRoot*)&p_Other);
    }

    return *this;
}

CCommandRoot* CCommand_VCS_StateMachine::CloneCommand()
{
    CCommand_VCS_StateMachine* pNewCommand;

    pNewCommand = new CCommand_VCS_StateMachine();
    *pNewCommand = *this;

    return pNewCommand;
}

BOOL CCommand_VCS_StateMachine::InitCommand_StateMachineCia402(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case STATE_CLEAR_FAULT:
            {
                CCommand_VCS::InitCommand("ClearFault", STATE_CLEAR_FAULT);
                SetDefaultParameter_ClearFault();
                oResult = TRUE; break;
            };
        case STATE_GET_DISABLE_STATE:
            {
                CCommand_VCS::InitCommand("GetDisableState", STATE_GET_DISABLE_STATE);
                AddReturnParameter(0, "disabled", ODT_BOOLEAN);
                SetDefaultParameter_GetDisableState();
                oResult = TRUE; break;
            };
        case STATE_GET_ENABLE_STATE:
            {
                CCommand_VCS::InitCommand("GetEnableState", STATE_GET_ENABLE_STATE);
                AddReturnParameter(0, "enabled", ODT_BOOLEAN);
                SetDefaultParameter_GetEnableState();
                oResult = TRUE; break;
            };
        case STATE_GET_FAULT_STATE:
            {
                CCommand_VCS::InitCommand("GetFaultState", STATE_GET_FAULT_STATE);
                AddReturnParameter(0, "isInFault", ODT_BOOLEAN);
                SetDefaultParameter_GetFaultState();
                oResult = TRUE; break;
            };
        case STATE_GET_QUICK_STOP_STATE:
            {
                CCommand_VCS::InitCommand("GetQuickStopState", STATE_GET_QUICK_STOP_STATE);
                AddReturnParameter(0, "isQuickStoped", ODT_BOOLEAN);
                SetDefaultParameter_GetQuickStopState();
                oResult = TRUE; break;
            };
        case STATE_SET_DISABLE_STATE:
            {
                CCommand_VCS::InitCommand("SetDisableState", STATE_SET_DISABLE_STATE);
                SetDefaultParameter_SetDisableState();
                oResult = TRUE; break;
            };
        case STATE_SET_ENABLE_STATE:
            {
                CCommand_VCS::InitCommand("SetEnableState", STATE_SET_ENABLE_STATE);
                SetDefaultParameter_SetEnableState();
                oResult = TRUE; break;
            };
        case STATE_SET_QUICK_STOP_STATE:
            {
                CCommand_VCS::InitCommand("SetQuickStopState", STATE_SET_QUICK_STOP_STATE);
                SetDefaultParameter_SetQuickStopState();
                oResult = TRUE; break;
            };
    }

    return oResult;
}

BOOL CCommand_VCS_StateMachine::InitCommand_StateMachineMaxon(DWORD p_ulCommandId)
{
    BOOL oResult(FALSE);

    switch(p_ulCommandId)
    {
        case STATE_GET_STOPPING_STATE:
            {
                CCommand_VCS::InitCommand("GetStoppingState", STATE_GET_STOPPING_STATE);
                AddReturnParameter(0, "isStoppingState", ODT_BOOLEAN);
                SetDefaultParameter_GetStoppingState();
                oResult = TRUE;
                break;
            };
        case STATE_SET_STOPPING_STATE:
            {
                CCommand_VCS::InitCommand("SetStoppingState", STATE_SET_STOPPING_STATE);
                SetDefaultParameter_SetStoppingState();
                oResult = TRUE;
                break;
            };
    }

    return oResult;
}

void CCommand_VCS_StateMachine::SetDefaultParameter_ClearFault()
{
}

void CCommand_VCS_StateMachine::SetDefaultParameter_GetDisableState()
{
    BOOL oIsDisabled = FALSE;

    //ReturnParameter
    SetReturnParameterData(0, &oIsDisabled, sizeof(oIsDisabled));
}

void CCommand_VCS_StateMachine::SetDefaultParameter_GetEnableState()
{
    BOOL oIsEnabled = FALSE;

    //ReturnParameter
    SetReturnParameterData(0, &oIsEnabled, sizeof(oIsEnabled));
}

void CCommand_VCS_StateMachine::SetDefaultParameter_GetFaultState()
{
    BOOL oIsInFault = FALSE;

    //ReturnParameter
    SetReturnParameterData(0, &oIsInFault, sizeof(oIsInFault));
}

void CCommand_VCS_StateMachine::SetDefaultParameter_GetQuickStopState()
{
    BOOL oQuickStopActive = FALSE;

    //ReturnParameter
    SetReturnParameterData(0, &oQuickStopActive, sizeof(oQuickStopActive));
}

void CCommand_VCS_StateMachine::SetDefaultParameter_SetDisableState()
{
}

void CCommand_VCS_StateMachine::SetDefaultParameter_SetEnableState()
{
}

void CCommand_VCS_StateMachine::SetDefaultParameter_SetQuickStopState()
{
}

void CCommand_VCS_StateMachine::SetDefaultParameter_GetStoppingState()
{
    BOOL oStopActive(FALSE);

    //ReturnParameter
    SetReturnParameterData(0, &oStopActive, sizeof(oStopActive));
}

void CCommand_VCS_StateMachine::SetDefaultParameter_SetStoppingState()
{
}
