#include "stdafx.h"

#include <CommunicationModel/CommonLayer/DeviceErrorHandling/Epos/DeviceErrorHandling_Epos.h>
#include <CommunicationModel/CommonLayer/DeviceErrorHandling/Epos2/DeviceErrorHandling_Epos2.h>
#include <CommunicationModel/CommonLayer/DeviceErrorHandling/Epos4/DeviceErrorHandling_Epos4.h>
#include <CommunicationModel/CommonLayer/DeviceErrorHandling/Esam/DeviceErrorHandling_Esam.h>
#include <CommunicationModel/CommonLayer/DeviceErrorHandling/Esam2/DeviceErrorHandling_Esam2.h>
#include <CommunicationModel/CommonLayer/DeviceErrorHandling/Maxpos/DeviceErrorHandling_Maxpos.h>

#include <CommunicationModel/CommonLayer/DeviceErrorHandling/DeviceErrorHandling.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CDeviceErrorHandling::CDeviceErrorHandling()
{

}

CDeviceErrorHandling::~CDeviceErrorHandling()
{

}

BOOL CDeviceErrorHandling::GetErrorDescription(DWORD p_ulErrorCode, CStdString* p_pDescription)
{
    BOOL oResult(FALSE);

    if(p_pDescription)
    {
        //Init
        p_ulErrorCode = (WORD)(p_ulErrorCode & ERROR_MASK);

        //Description
        if(!oResult && GetErrorDescriptionEposFamily(p_ulErrorCode, p_pDescription)) oResult = TRUE;

        if(!oResult && p_pDescription) *p_pDescription = _T("Unknown Error");
    }

    return oResult;
}

BOOL CDeviceErrorHandling::GetErrorDescription(EControllerType p_eControllerType, DWORD p_ulErrorCode, CStdString* p_pDescription)
{
    BOOL oResult(FALSE);

    if(p_pDescription)
    {
        //Init
        p_ulErrorCode = (WORD)(p_ulErrorCode & ERROR_MASK);

        //Description
        if (p_eControllerType == CONTROLLER_TYPE_MAXPOS)
        {
            // Maxpos first, because there are cases with same error code but different error meanings as EPOS
            if(!oResult && GetErrorDescriptionMaxposFamily(p_ulErrorCode, p_pDescription)) oResult = TRUE;
        }

        if(!oResult && GetErrorDescriptionEposFamily(p_ulErrorCode, p_pDescription)) oResult = TRUE;

        if(!oResult && p_pDescription) *p_pDescription = _T("Unknown Error");
    }

    return oResult;
}

BOOL CDeviceErrorHandling::GetErrorDescriptionEposFamily(DWORD p_ulErrorCode, CStdString* p_rpDescription)
{
    BOOL oResult(FALSE);

    if(!oResult && CDeviceErrorHandling_Epos4::GetErrorDescription(p_ulErrorCode, p_rpDescription)) oResult = TRUE;
    if(!oResult && CDeviceErrorHandling_Epos2::GetErrorDescription(p_ulErrorCode, p_rpDescription)) oResult = TRUE;
    if(!oResult && CDeviceErrorHandling_Esam2::GetErrorDescription(p_ulErrorCode, p_rpDescription)) oResult = TRUE;
    if(!oResult && CDeviceErrorHandling_Epos::GetErrorDescription(p_ulErrorCode, p_rpDescription)) oResult = TRUE;
    if(!oResult && CDeviceErrorHandling_Esam::GetErrorDescription(p_ulErrorCode, p_rpDescription)) oResult = TRUE;

    return oResult;
}

BOOL CDeviceErrorHandling::GetErrorDescriptionMaxposFamily(DWORD p_ulErrorCode, CStdString* p_rpDescription)
{
    BOOL oResult(FALSE);

    if(!oResult && CDeviceErrorHandling_Maxpos::GetErrorDescription(p_ulErrorCode, p_rpDescription)) oResult = TRUE;

    return oResult;
}
