#include "stdafx.h"

#include <MmcTypeDefinition.h>

#include <CommunicationModel/CommonLayer/DeviceErrorHandling/Epos2/DeviceErrorHandling_Epos2.h>

CDeviceErrorHandling_Epos2::CDeviceErrorHandling_Epos2()
{
}

CDeviceErrorHandling_Epos2::~CDeviceErrorHandling_Epos2()
{
}

BOOL CDeviceErrorHandling_Epos2::GetErrorDescription(DWORD p_ulErrorCode, CStdString* p_pDescription)
{
    BOOL oResult(FALSE);

    if(p_pDescription)
    {
        oResult = TRUE;

        switch(p_ulErrorCode)
        {
            case ERROR_EPOS2_GENERIC:                                *p_pDescription = _T("Generic Error"); break;
            case ERROR_EPOS2_OVER_CURRENT:                           *p_pDescription = _T("Over Current"); break;
            case ERROR_EPOS2_OVER_VOLTAGE:                           *p_pDescription = _T("Over Voltage"); break;
            case ERROR_EPOS2_UNDER_VOLTAGE:                          *p_pDescription = _T("Under Voltage"); break;
            case ERROR_EPOS2_OVER_TEMPERATURE:                       *p_pDescription = _T("Over Temperature"); break;
            case ERROR_EPOS2_SUPPLY_VOLTAGE_TOO_LOW:                 *p_pDescription = _T("Supply Voltage is too low"); break;
            case ERROR_EPOS2_SUPPLY_VOLTAGE_OUTPUT_STAGE_TOO_LOW:    *p_pDescription = _T("Supply Voltage Output Stage is too low"); break;
            case ERROR_EPOS2_INTERNAL_SOFTWARE:                      *p_pDescription = _T("Internal Software Error"); break;
            case ERROR_EPOS2_SOFTWARE_PARAMETER:                     *p_pDescription = _T("Software Parameter Error"); break;
            case ERROR_EPOS2_SENSOR_POSITION:                        *p_pDescription = _T("Sensor Position Error"); break;
            case ERROR_EPOS2_CAN_OVERRUN_OBJECT_LOST:                *p_pDescription = _T("CAN Overrun (Objects lost)"); break;
            case ERROR_EPOS2_CAN_OVERRUN:                            *p_pDescription = _T("CAN Overrun"); break;
            case ERROR_EPOS2_CAN_PASSIVE:                            *p_pDescription = _T("CAN Passive Mode"); break;
            case ERROR_EPOS2_CAN_LIFE_GUARD:                         *p_pDescription = _T("CAN Lifeguard Error"); break;
            case ERROR_EPOS2_CAN_TX_COB_ID_COLLISION:                *p_pDescription = _T("CAN Transmit COB-ID Collision"); break;
            case ERROR_EPOS2_CAN_BUS_OFF:                            *p_pDescription = _T("CAN Bus Off"); break;
            case ERROR_EPOS2_CAN_RX_QUEUE_OVERRUN:                   *p_pDescription = _T("CAN Rx Queue Overrun"); break;
            case ERROR_EPOS2_CAN_TX_QUEUE_OVERRUN:                   *p_pDescription = _T("CAN Tx Queue Overrun"); break;
            case ERROR_EPOS2_CAN_PDO_LENGTH:                         *p_pDescription = _T("CAN PDO Length Error"); break;
            case ERROR_EPOS2_FOLLOWING_ERROR:                        *p_pDescription = _T("Following Error"); break;
            case ERROR_EPOS2_HALL_SENSOR:                            *p_pDescription = _T("Hall Sensor Error"); break;
            case ERROR_EPOS2_INDEX_PROCESSING:                       *p_pDescription = _T("Index Processing Error"); break;
            case ERROR_EPOS2_ENCODER_RESOLUTION:                     *p_pDescription = _T("Encoder Resolution Error"); break;
            case ERROR_EPOS2_HALL_SENSOR_NOT_FOUND:                  *p_pDescription = _T("Hallsensor not found"); break;
            case ERROR_EPOS2_NEGATIVE_LIMIT:                         *p_pDescription = _T("Negative Limit Switch Error"); break;
            case ERROR_EPOS2_POSITIVE_LIMIT:                         *p_pDescription = _T("Positive Limit Switch Error"); break;
            case ERROR_EPOS2_HALL_ANGLE_DETECTION:                   *p_pDescription = _T("Hall Angle Detection Error"); break;
            case ERROR_EPOS2_SOFTWARE_POSITION_LIMIT:                *p_pDescription = _T("Software Position Limit Error"); break;
            case ERROR_EPOS2_POSITION_SENSOR_BREACH:                 *p_pDescription = _T("Position Sensor Breach"); break;
            case ERROR_EPOS2_SYSTEM_OVERLOADED:                      *p_pDescription = _T("System Overloaded"); break;
            case ERROR_EPOS2_IPM_MODE:                               *p_pDescription = _T("Interpolated Position Mode Error"); break;
            case ERROR_EPOS2_AUTOTUNING_IDENTIFICATION:              *p_pDescription = _T("Auto Tuning Identification Error"); break;
            default: oResult = FALSE;
        }
    }

    return oResult;
}
