#include "stdafx.h"

#include <MmcTypeDefinition.h>

#include <CommunicationModel/CommonLayer/DeviceErrorHandling/Epos4/DeviceErrorHandling_Epos4.h>

CDeviceErrorHandling_Epos4::CDeviceErrorHandling_Epos4()
{
}

CDeviceErrorHandling_Epos4::~CDeviceErrorHandling_Epos4()
{
}

BOOL CDeviceErrorHandling_Epos4::GetErrorDescription(DWORD p_ulErrorCode, CStdString* p_pDescription)
{
    BOOL oResult(FALSE);

    if(p_pDescription)
    {
        oResult = TRUE;

        switch(p_ulErrorCode)
        {
            case ERROR_EPOS4_POWER_STAGE_PROTECTION:        *p_pDescription = _T("Power Stage Protection Error"); break;
            case ERROR_EPOS4_HARDWARE_DEFECT:               *p_pDescription = _T("Hardware Defect Error"); break;
            case ERROR_EPOS4_HARDWARE_MEMORY:               *p_pDescription = _T("Hardware Memory Error"); break;
            case ERROR_EPOS4_CURRENT_OFFSET:                *p_pDescription = _T("Current Offset Error"); break;
            case ERROR_EPOS4_POSITION_SENSOR_BREACH:        *p_pDescription = _T("Position Sensor Breach Error"); break;
            case ERROR_EPOS4_POSITION_SENSOR_RESOLUTION:    *p_pDescription = _T("Position Sensor Resolution Error"); break;
            case ERROR_EPOS4_POSITION_SENSOR_INDEX:         *p_pDescription = _T("Position Sensor Index Error"); break;
            case ERROR_EPOS4_HALL_SENSOR:                   *p_pDescription = _T("Hall Sensor Error"); break;
            case ERROR_EPOS4_HALL_SENSOR_NOT_FOUND:         *p_pDescription = _T("Hall Sensor not found Error"); break;
            case ERROR_EPOS4_HALL_ANGLE_DETECTION:          *p_pDescription = _T("Hall Angle Detection Error"); break;
            case ERROR_EPOS4_BISS:                          *p_pDescription = _T("Biss Encoder Error"); break;
            case ERROR_EPOS4_MISSING_MAIN_SENSOR:           *p_pDescription = _T("Missing Main Sensor Error"); break;
            case ERROR_EPOS4_MISSING_COMMUTATION_SENSOR:    *p_pDescription = _T("Missing Commutation Sensor Error"); break;
            case ERROR_EPOS4_ETHERCAT_COMMUNICATION:        *p_pDescription = _T("EtherCAT State Machine Error"); break;
            case ERROR_EPOS4_TORQUE_FAULT:                  *p_pDescription = _T("Torque Fault Error"); break;
            case ERROR_EPOS4_NEGATIVE_LIMIT_SWITCH:         *p_pDescription = _T("Negative Limit Switch Error"); break;
            case ERROR_EPOS4_POSITIVE_LIMIT_SWITCH:         *p_pDescription = _T("Positive Limit Switch Error"); break;
            case ERROR_EPOS4_SOFTWARE_POSITION_LIMIT:       *p_pDescription = _T("Software Position Limit Error"); break;
            case ERROR_EPOS4_MAX_SPEED:                     *p_pDescription = _T("Max Speed Error"); break;
            case ERROR_EPOS4_STO:                           *p_pDescription = _T("Safe Torque Off (STO) Error"); break;
            case ERROR_EPOS4_SYSTEM_OVERLOADED:             *p_pDescription = _T("System Overloaded Error"); break;
            case ERROR_EPOS4_CONTROLLER_GAIN:               *p_pDescription = _T("Controller Gain Error"); break;
            case ERROR_EPOS4_AUTO_TUNING_IDENTIFICATION:    *p_pDescription = _T("Auto Tuning Identification Error"); break;
            default: oResult = FALSE;
        }
    }

    return oResult;
}
