#include "stdafx.h"

#include <MmcTypeDefinition.h>

#include <CommunicationModel/CommonLayer/DeviceErrorHandling/Esam/DeviceErrorHandling_Esam.h>

CDeviceErrorHandling_Esam::CDeviceErrorHandling_Esam()
{
}

CDeviceErrorHandling_Esam::~CDeviceErrorHandling_Esam()
{
}

BOOL CDeviceErrorHandling_Esam::GetErrorDescription(DWORD p_ulErrorCode, CStdString* p_pDescription)
{
    BOOL oResult(FALSE);

    if(p_pDescription)
    {
        oResult = TRUE;

        switch(p_ulErrorCode)
        {
            case ERROR_EPOS_P_EEPROM:                                *p_pDescription = _T("Hardware Error by accessing nonvolatile memory"); break;
            case ERROR_EPOS_P_INTERPRETER:                           *p_pDescription = _T("Error occurred at interpreting code"); break;
            case ERROR_EPOS_P_NATIVE_CODE:                           *p_pDescription = _T("Error occured at executing native code"); break;
            case ERROR_EPOS_P_TIMER_TASK:                            *p_pDescription = _T("Error occured at starting a timer task"); break;
            case ERROR_EPOS_P_INTERRUPT_TASK:                        *p_pDescription = _T("Error occured at starting interrupt/event task"); break;
            case ERROR_EPOS_P_DATA_ACCESS:                           *p_pDescription = _T("Data or program access exception detected"); break;
            case ERROR_EPOS_P_RETAIN_VARIABLE:                       *p_pDescription = _T("Error occured at saving or restoring retain variables"); break;
            case ERROR_EPOS_P_DEVICE_TYPE:                           *p_pDescription = _T("Failed network bootup! Bad device type detected"); break;
            case ERROR_EPOS_P_VENDOR_ID:                             *p_pDescription = _T("Failed network bootup! Bad vendor-Id detected"); break;
            case ERROR_EPOS_P_PRODUCT_CODE:                          *p_pDescription = _T("Failed network bootup! Bad product code detected"); break;
            case ERROR_EPOS_P_REVISION_NUMBER:                       *p_pDescription = _T("Failed network bootup! Bad revision number detected"); break;
            case ERROR_EPOS_P_SERIAL_NUMBER:                         *p_pDescription = _T("Failed network bootup! Bad serial number detected"); break;
            case ERROR_EPOS_P_CONFIGURATION_TIME_DATE:               *p_pDescription = _T("Failed network bootup! Bad configuration date or time detected"); break;
            case ERROR_EPOS_P_ERROR_CONTROL:                         *p_pDescription = _T("Failed network bootup! No heartbeat received"); break;
            case ERROR_EPOS_P_NODE_IS_NOT_SLAVE:                     *p_pDescription = _T("Failed network bootup! Mandatory Node is not defined as slave"); break;
            case ERROR_EPOS_P_CAN_OVERRUN:                           *p_pDescription = _T("CAN Overrun"); break;
            case ERROR_EPOS_P_CAN_PASSIVE:                           *p_pDescription = _T("CAN Passive Mode"); break;
            case ERROR_EPOS_P_CAN_LIFQGUARD:                         *p_pDescription = _T("CAN Lifeguard Error"); break;
            case ERROR_EPOS_P_CAN_CONTROLLER:                        *p_pDescription = _T("Error occured at configuring CAN controller"); break;
            case ERROR_EPOS_P_CAN_NO_ANSWER:                         *p_pDescription = _T("Configured Node does not answer or is not present"); break;
            case ERROR_EPOS_P_CAN_WARNING:                           *p_pDescription = _T("CAN Frame Error warning level detected"); break;
            case ERROR_EPOS_P_CAN_BUS_OFF:                           *p_pDescription = _T("CAN Bus Off Error"); break;
            case ERROR_EPOS_P_CAN_PDO_LENGTH:                        *p_pDescription = _T("CAN PDO Length Error"); break;
            default: oResult = FALSE;
        }
    }

    return oResult;
}
