#include "stdafx.h"

#include <MmcTypeDefinition.h>

#include <CommunicationModel/CommonLayer/DeviceErrorHandling/Maxpos/DeviceErrorHandling_Maxpos.h>

CDeviceErrorHandling_Maxpos::CDeviceErrorHandling_Maxpos()
{
}

CDeviceErrorHandling_Maxpos::~CDeviceErrorHandling_Maxpos()
{
}

BOOL CDeviceErrorHandling_Maxpos::GetErrorDescription(DWORD p_ulErrorCode, CStdString* p_pDescription)
{
    BOOL oResult(FALSE);

    if(p_pDescription)
    {
        oResult = TRUE;

        switch(p_ulErrorCode)
        {
            case ERROR_MAXPOS_HARDWARE_DEFECT:               *p_pDescription = _T("Hardware Defect Error"); break;
            case ERROR_MAXPOS_CURRENT_OFFSET:                *p_pDescription = _T("Current Offset Error"); break;
            case ERROR_MAXPOS_POSITION_SENSOR_BREACH:        *p_pDescription = _T("Position Sensor Breach Error"); break;
            case ERROR_MAXPOS_POSITION_SENSOR_RESOLUTION:    *p_pDescription = _T("Position Sensor Resolution Error"); break;
            case ERROR_MAXPOS_POSITION_SENSOR_INDEX:         *p_pDescription = _T("Position Sensor Index Error"); break;
            case ERROR_MAXPOS_HALL_SENSOR:                   *p_pDescription = _T("Hall Sensor Error"); break;
            case ERROR_MAXPOS_HALL_SENSOR_NOT_FOUND:         *p_pDescription = _T("Hall Sensor not found Error"); break;
            case ERROR_MAXPOS_HALL_ANGLE_DETECTION:          *p_pDescription = _T("Hall Angle Detection Error"); break;
            case ERROR_MAXPOS_MISSING_MAIN_SENSOR:           *p_pDescription = _T("Missing Main Sensor Error"); break;
            case ERROR_MAXPOS_MISSING_COMMUTATION_SENSOR:    *p_pDescription = _T("Missing Commutation Sensor Error"); break;
            case ERROR_MAXPOS_ETHERCAT_STATE_MACHINE:        *p_pDescription = _T("EtherCAT State Machine Error"); break;
            case ERROR_MAXPOS_TORQUE_FAULT:                  *p_pDescription = _T("Torque Fault Error"); break;
            case ERROR_MAXPOS_NEGATIVE_LIMIT_SWITCH:         *p_pDescription = _T("Negative Limit Switch Error"); break;
            case ERROR_MAXPOS_POSITIVE_LIMIT_SWITCH:         *p_pDescription = _T("Positive Limit Switch Error"); break;
            case ERROR_MAXPOS_SOFTWARE_POSITION_LIMIT:       *p_pDescription = _T("Software Position Limit Error"); break;
            case ERROR_MAXPOS_STO:                           *p_pDescription = _T("Safe Torque Off (STO) Error"); break;
            case ERROR_MAXPOS_SYSTEM_OVERLOADED:             *p_pDescription = _T("System Overloaded Error"); break;
            case ERROR_MAXPOS_CONTROLLER_GAIN:               *p_pDescription = _T("Controller Gain Error"); break;
            case ERROR_MAXPOS_AUTO_TUNING_IDENTIFICATION:    *p_pDescription = _T("Auto Tuning Identification Error"); break;
            default: oResult = FALSE;
        }
    }

    return oResult;
}
