#include "stdafx.h"

#include <MmcTypeDefinition.h>

#include <CommunicationModel/CommonLayer/ErrorHandling/ErrorCode_Definitions.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/DeviceCommandSet/ErrorHandlingDeviceCommandSet_General.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/DeviceCommandSet/ErrorHandlingDeviceCommandSet_CanOpen.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/DeviceCommandSet/ErrorHandlingDeviceCommandSet_Epos.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/DeviceCommandSet/ErrorHandlingDeviceCommandSet_Epos2.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/DeviceCommandSet/ErrorHandlingDeviceCommandSet_Epos3.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/DeviceCommandSet/ErrorHandlingDeviceCommandSet_Epos4.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/DeviceCommandSet/ErrorHandlingDeviceCommandSet_Esam.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/DeviceCommandSet/ErrorHandlingDeviceCommandSet_Esam2.h>

#include <CommunicationModel/CommonLayer/ErrorHandling/DeviceCommandSet/ErrorHandlingDeviceCommandSet.h>

CErrorHandlingDeviceCommandSet::CErrorHandlingDeviceCommandSet()
{
}

CErrorHandlingDeviceCommandSet::~CErrorHandlingDeviceCommandSet()
{
}

BOOL CErrorHandlingDeviceCommandSet::GetErrorDescription(DWORD p_ulErrorCode, CStdString *p_pDescription)
{
    BOOL oResult(FALSE);

    if(!oResult)
    {
        if(CErrorHandlingDeviceCommandSet_General::GetErrorDescription(p_ulErrorCode, p_pDescription)
            || CErrorHandlingDeviceCommandSet_CanOpen::GetErrorDescription(p_ulErrorCode, p_pDescription)
            || CErrorHandlingDeviceCommandSet_Epos::GetErrorDescription(p_ulErrorCode, p_pDescription)
            || CErrorHandlingDeviceCommandSet_Epos2::GetErrorDescription(p_ulErrorCode, p_pDescription)
            || CErrorHandlingDeviceCommandSet_Epos3::GetErrorDescription(p_ulErrorCode, p_pDescription)
            || CErrorHandlingDeviceCommandSet_Epos4::GetErrorDescription(p_ulErrorCode, p_pDescription)
            || CErrorHandlingDeviceCommandSet_Esam::GetErrorDescription(p_ulErrorCode, p_pDescription)
            || CErrorHandlingDeviceCommandSet_Esam2::GetErrorDescription(p_ulErrorCode, p_pDescription))
        {
            oResult = TRUE;
        }
    }

    return oResult;
}
