#include "stdafx.h"

#include <MmcTypeDefinition.h>

#include <CommunicationModel/CommonLayer/ErrorHandling/ErrorCode_Definitions.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/DeviceCommandSet/ErrorHandlingDeviceCommandSet_CanOpen.h>

CErrorHandlingDeviceCommandSet_CanOpen::CErrorHandlingDeviceCommandSet_CanOpen()
{
}

CErrorHandlingDeviceCommandSet_CanOpen::~CErrorHandlingDeviceCommandSet_CanOpen()
{
}

BOOL CErrorHandlingDeviceCommandSet_CanOpen::GetErrorDescription(DWORD p_ulErrorCode, CStdString *p_pDescription)
{
    BOOL oResult(TRUE);

    switch(p_ulErrorCode)
    {
        case ERROR_DEVICE_CAN_TOGGLE:                                       *p_pDescription = _T("Toggle error"); break;
        case ERROR_DEVICE_CAN_SDO_TIME_OUT:                                 *p_pDescription = _T("SDO timeout"); break;
        case ERROR_DEVICE_CAN_CLIENT_SERVER:                                *p_pDescription = _T("Client/server specifier error"); break;
        case ERROR_DEVICE_CAN_INVALID_BLOCK_SIZE:                           *p_pDescription = _T("Invalid block size"); break;
        case ERROR_DEVICE_CAN_INVALID_SEQUENCE:                             *p_pDescription = _T("Invalid sequence"); break;
        case ERROR_DEVICE_CAN_CRC_ERROR:                                    *p_pDescription = _T("CRC error"); break;
        case ERROR_DEVICE_CAN_OUT_OF_MEMORY:                                *p_pDescription = _T("Out of memory error"); break;
        case ERROR_DEVICE_CAN_ACCESS:                                       *p_pDescription = _T("Access error"); break;
        case ERROR_DEVICE_CAN_WRITE_ONLY:                                   *p_pDescription = _T("Write only"); break;
        case ERROR_DEVICE_CAN_READ_ONLY:                                    *p_pDescription = _T("Read only"); break;
        case ERROR_DEVICE_CAN_OBJECT_NOT_EXIST:                             *p_pDescription = _T("Object does not exist"); break;
        case ERROR_DEVICE_CAN_PDO_MAPPING:                                  *p_pDescription = _T("PDO mapping error"); break;
        case ERROR_DEVICE_CAN_PDO_LENGTH:                                   *p_pDescription = _T("PDO length error"); break;
        case ERROR_DEVICE_CAN_GENERAL_PARAMETER:                            *p_pDescription = _T("General parameter error"); break;
        case ERROR_DEVICE_CAN_GENERAL_INTERN_INCOMPATIBILITY:               *p_pDescription = _T("General internal Incompatibility error"); break;
        case ERROR_DEVICE_CAN_HARDWARE:                                     *p_pDescription = _T("Hardware error"); break;
        case ERROR_DEVICE_CAN_SERVICE_PARAMETER:                            *p_pDescription = _T("Service parameter error"); break;
        case ERROR_DEVICE_CAN_SERVICE_PARAMETER_TO_HIGH:                    *p_pDescription = _T("Service parameter too high"); break;
        case ERROR_DEVICE_CAN_SERVICE_PARAMETER_TO_LOW:                     *p_pDescription = _T("Service Parameter too low"); break;
        case ERROR_DEVICE_CAN_SUB_OBJECT:                                   *p_pDescription = _T("Object subindex error"); break;
        case ERROR_DEVICE_CAN_VALUE_RANGE:                                  *p_pDescription = _T("Value range error"); break;
        case ERROR_DEVICE_CAN_VALUE_TO_HIGH:                                *p_pDescription = _T("Value too high"); break;
        case ERROR_DEVICE_CAN_VALUE_TO_LOW:                                 *p_pDescription = _T("Value too low"); break;
        case ERROR_DEVICE_CAN_MAX_LESS_MIN:                                 *p_pDescription = _T("Maximum less minimum error"); break;
        case ERROR_DEVICE_CAN_GENERAL:                                      *p_pDescription = _T("General error"); break;
        case ERROR_DEVICE_CAN_TRANSFER_OR_STORE:                            *p_pDescription = _T("Transfer or store error"); break;
        case ERROR_DEVICE_CAN_LOCAL_CONTROL:                                *p_pDescription = _T("Local control error"); break;
        case ERROR_DEVICE_CAN_WRONG_DEVICE:                                 *p_pDescription = _T("Wrong device state"); break;
        default: oResult = FALSE;
    }

    return oResult;
}
