#include "stdafx.h"

#include <MmcTypeDefinition.h>

#include <CommunicationModel/CommonLayer/ErrorHandling/ErrorCode_Definitions.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/DeviceCommandSet/ErrorHandlingDeviceCommandSet_Epos.h>

CErrorHandlingDeviceCommandSet_Epos::CErrorHandlingDeviceCommandSet_Epos()
{
}

CErrorHandlingDeviceCommandSet_Epos::~CErrorHandlingDeviceCommandSet_Epos()
{
}

BOOL CErrorHandlingDeviceCommandSet_Epos::GetErrorDescription(DWORD p_ulErrorCode, CStdString *p_pDescription)
{
    BOOL oResult(FALSE);

    if(!oResult)
    {
        if(GetErrorDescription_Device(p_ulErrorCode, p_pDescription)
            || GetErrorDescription_OldDevice(p_ulErrorCode, p_pDescription))
        {
            oResult = TRUE;
        }
    }

    return oResult;
}

BOOL CErrorHandlingDeviceCommandSet_Epos::GetErrorDescription_Device(DWORD p_ulErrorCode, CStdString* p_pDescription)
{
    BOOL oResult(TRUE);

    switch(p_ulErrorCode)
    {
        case ERROR_DEVICE_EPOS_UNKNOWN_NETWORK_ID:                          *p_pDescription = _T("Network Id is unknown"); break;
        case ERROR_DEVICE_EPOS_UNKNOWN_NODE_ID:                             *p_pDescription = _T("Node Id is unknown"); break;
        case ERROR_DEVICE_EPOS_CAN_ID:                                      *p_pDescription = _T("CAN ID error"); break;
        case ERROR_DEVICE_EPOS_SERVICE_MODE:                                *p_pDescription = _T("Service mode error"); break;
        case ERROR_DEVICE_EPOS_PASSWORD:                                    *p_pDescription = _T("Password error"); break;
        case ERROR_DEVICE_EPOS_ILLEGAL_COMMAND:                             *p_pDescription = _T("Illegal command"); break;
        case ERROR_DEVICE_EPOS_WRONG_NMT_STATE:                             *p_pDescription = _T("Wrong NMT state"); break;
        case ERROR_DEVICE_EPOS_COMMUNICATION_ABORTED:                       *p_pDescription = _T("Communication Aborted"); break;
        case ERROR_DEVICE_EPOS_COMMUNICATION_OVERFLOW:                      *p_pDescription = _T("Communication Buffer Overflow"); break;
        case ERROR_DEVICE_EPOS_SEGMENTED_COMMUNICATION_ERROR:               *p_pDescription = _T("Segmented Transfer Error"); break;
        case ERROR_DEVICE_EPOS_WRONG_AXIS_NUMBER:                           *p_pDescription = _T("Wrong Axis Number"); break;
        case ERROR_DEVICE_EPOS_WRONG_CAN_DEVICE:                            *p_pDescription = _T("Wrong Node Id"); break;
        case ERROR_DEVICE_EPOS_WRONG_CAN_PORT:                              *p_pDescription = _T("Can Port is not valid"); break;
        case ERROR_DEVICE_EPOS_WRONG_CALLING_PARAMETER:                     *p_pDescription = _T("Calling Parameter Error"); break;
        case ERROR_DEVICE_EPOS_GENERAL_COMMUNICATION_ERROR:                 *p_pDescription = _T("General Communication Error"); break;
        case ERROR_DEVICE_EPOS_TIMEOUT:                                     *p_pDescription = _T("Communication Timeout"); break;
        default: oResult = FALSE;
    }

    return oResult;
}

BOOL CErrorHandlingDeviceCommandSet_Epos::GetErrorDescription_OldDevice(DWORD p_ulErrorCode, CStdString* p_pDescription)
{
    BOOL oResult(TRUE);

    switch(p_ulErrorCode)
    {
        case ERROR_OLD_DEVICE_EPOS_TOGGLE_ERR:                  *p_pDescription = _T("Toggle Error"); break;
        case ERROR_OLD_DEVICE_EPOS_SDO_TIME_OUT:                *p_pDescription = _T("Timeout Error"); break;
        case ERROR_OLD_DEVICE_EPOS_CCS_ERR:                     *p_pDescription = _T("Command Specifier Error"); break;
        case ERROR_OLD_DEVICE_EPOS_INVALID_BLOCK_SIZE:          *p_pDescription = _T("Invalid Block Size"); break;
        case ERROR_OLD_DEVICE_EPOS_INVALID_SEQUENCE_NO:         *p_pDescription = _T("Invalid Sequence Number"); break;
        case ERROR_OLD_DEVICE_EPOS_CRC_ERR:                     *p_pDescription = _T("Crc Error"); break;
        case ERROR_OLD_DEVICE_EPOS_OUT_OF_MEMORY:               *p_pDescription = _T("Out of Memory"); break;
        case ERROR_OLD_DEVICE_EPOS_ACCESS_ERR:                  *p_pDescription = _T("Access Error"); break;
        case ERROR_OLD_DEVICE_EPOS_WRITE_ONLY:                  *p_pDescription = _T("Object is WriteOnly"); break;
        case ERROR_OLD_DEVICE_EPOS_READ_ONLY:                   *p_pDescription = _T("Object is ReadOnly"); break;
        case ERROR_OLD_DEVICE_EPOS_OBJ_NOT_EXIST:               *p_pDescription = _T("Object does not exist"); break;
        case ERROR_OLD_DEVICE_EPOS_NO_PDO_OBJ:                  *p_pDescription = _T("PDO Number Error"); break;
        case ERROR_OLD_DEVICE_EPOS_PDO_LENGTH_ERR:              *p_pDescription = _T("PDO Length Error"); break;
        case ERROR_OLD_DEVICE_EPOS_GENERAL_PARAM_ERR:           *p_pDescription = _T("Parameter Error"); break;
        case ERROR_OLD_DEVICE_EPOS_GENERAL_INTERN_INCOMP:       *p_pDescription = _T("Internal Incomp Error"); break;
        case ERROR_OLD_DEVICE_EPOS_HW_ERR:                      *p_pDescription = _T("Hardware Error"); break;
        case ERROR_OLD_DEVICE_EPOS_SERVICE_PARAM_ERR:           *p_pDescription = _T("Service Parameter Error"); break;
        case ERROR_OLD_DEVICE_EPOS_SERVICE_PARAM_TOO_HIGH:      *p_pDescription = _T("Service Parameter too High"); break;
        case ERROR_OLD_DEVICE_EPOS_SERVICE_PARAM_TOO_LOW:       *p_pDescription = _T("Service Parameter too Low"); break;
        case ERROR_OLD_DEVICE_EPOS_SUB_INDX_ERR:                *p_pDescription = _T("SubIndex Error"); break;
        case ERROR_OLD_DEVICE_EPOS_VALUE_RANGE:                 *p_pDescription = _T("Value Range Error"); break;
        case ERROR_OLD_DEVICE_EPOS_VAL_TOO_HIGH:                *p_pDescription = _T("Value too High"); break;
        case ERROR_OLD_DEVICE_EPOS_VAL_TOO_LOW:                 *p_pDescription = _T("Value too Low"); break;
        case ERROR_OLD_DEVICE_EPOS_MAX_LESS_MIN:                *p_pDescription = _T("Max. less Min."); break;
        case ERROR_OLD_DEVICE_EPOS_GENERAL_ERR:                 *p_pDescription = _T("General Error"); break;
        case ERROR_OLD_DEVICE_EPOS_TRANSF_OR_STORE_ERR:         *p_pDescription = _T("Transfer or Store Error"); break;
        case ERROR_OLD_DEVICE_EPOS_LOCAL_CONTROL_ERR:           *p_pDescription = _T("Local Control Error"); break;
        case ERROR_OLD_DEVICE_EPOS_WRONG_DEVICE_STATE:          *p_pDescription = _T("Wrong Device Control State"); break;
        case ERROR_OLD_DEVICE_EPOS_WRONG_NMT_STATE:             *p_pDescription = _T("Wrong Nmt State"); break;
        case ERROR_OLD_DEVICE_EPOS_ILLEGAL_COMMAND:             *p_pDescription = _T("Illegal Command"); break;
        case ERROR_OLD_DEVICE_EPOS_ERROR_PASSWORD:              *p_pDescription = _T("Error Password"); break;
        case ERROR_OLD_DEVICE_EPOS_ERROR_LENGTH:                *p_pDescription = _T("Error Length"); break;
        case ERROR_OLD_DEVICE_EPOS_ERROR_SERVICE:               *p_pDescription = _T("Error Service"); break;
        case ERROR_OLD_DEVICE_EPOS_NO_MORE_SEGMENTS:            *p_pDescription = _T("No more segments"); break;
        case ERROR_OLD_DEVICE_EPOS_SDO_ABORT:                   *p_pDescription = _T("Sdo Abort"); break;
        case ERROR_OLD_DEVICE_EPOS_ERROR_CAN_ID:                *p_pDescription = _T("Wrong CAN ID"); break;
        case ERROR_OLD_DEVICE_EPOS_ERROR_ADRESS:                *p_pDescription = _T("Error Address"); break;
        case ERROR_OLD_DEVICE_EPOS_SUB_INDEX_DOES_NOT_EXIST:    *p_pDescription = _T("SubIndex does not exist"); break;
        default: oResult = FALSE;
    }

    return oResult;
}