#include "stdafx.h"

#include <MmcTypeDefinition.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/ErrorCode_Definitions.h>

#include <CommunicationModel/CommonLayer/ErrorHandling/General/ErrorHandlingGeneral.h>

CErrorHandlingGeneral::CErrorHandlingGeneral()
{
}

CErrorHandlingGeneral::~CErrorHandlingGeneral()
{
}

BOOL CErrorHandlingGeneral::GetErrorDescription(DWORD p_ulErrorCode, CStdString* p_pDescription)
{
    BOOL oResult(TRUE);

    switch(p_ulErrorCode)
    {
        case NO_ERROR_DETECTED:                                 *p_pDescription = _T("No error"); break;
        case ERROR_INTERNAL:                                    *p_pDescription = _T("Internal error"); break;
        case ERROR_NULL_POINTER:                                *p_pDescription = _T("Null pointer"); break;
        case ERROR_HANDLE_NOT_VALID:                            *p_pDescription = _T("Handle not valid"); break;
        case ERROR_BAD_VIRTUAL_DEVICE_NAME:                     *p_pDescription = _T("Bad virtual device name"); break;
        case ERROR_BAD_DEVICE_NAME:                             *p_pDescription = _T("Bad device name"); break;
        case ERROR_BAD_PROTOCOL_STACK_NAME:                     *p_pDescription = _T("Bad protocol stack name"); break;
        case ERROR_BAD_INTERFACE_NAME:                          *p_pDescription = _T("Bad interface name"); break;
        case ERROR_BAD_PORT_NAME:                               *p_pDescription = _T("Bad port name"); break;
        case ERROR_LIBRARY_NOT_LOADED:                          *p_pDescription = _T("Library not loaded"); break;
        case ERROR_EXECUTING_COMMAND:                           *p_pDescription = _T("Command failed"); break;
        case ERROR_TIMEOUT_ELAPSED:                             *p_pDescription = _T("Timeout"); break;
        case ERROR_BAD_PARAMETER:                               *p_pDescription = _T("Bad parameter"); break;
        case ERROR_COMMAND_ABORTED_BY_USER:                     *p_pDescription = _T("Command aborted by user"); break;
        case ERROR_BUFFER_TOO_SMALL:                            *p_pDescription = _T("Buffer too small"); break;
        case ERROR_NO_COMMUNICATION_FOUND:                      *p_pDescription = _T("No communication found"); break;
        case ERROR_FUNCTION_NOT_SUPPORTED:                      *p_pDescription = _T("Function not supported"); break;
        case ERROR_PARAMETER_ALREADY_USED:                      *p_pDescription = _T("Parameter already used"); break;
        case ERROR_BAD_VIRTUAL_DEVICE_HANDLE:                   *p_pDescription = _T("Bad virtual device handle"); break;
        case ERROR_BAD_DEVICE_HANDLE:                           *p_pDescription = _T("Bad device handle"); break;
        case ERROR_BAD_PROTOCOL_STACK_HANDLE:                   *p_pDescription = _T("Bad protocol stack handle"); break;
        case ERROR_BAD_INTERFACE_HANDLE:                        *p_pDescription = _T("Bad interface handle"); break;
        case ERROR_BAD_PORT_HANDLE:                             *p_pDescription = _T("Bad port handle"); break;
        case ERROR_BAD_ADDRESS_PARAMETER:                       *p_pDescription = _T("Address parameters are not correct"); break;
        case ERROR_BAD_VARIABLE_INFO_FILE:                      *p_pDescription = _T("Variable info file is not initialized"); break;
        case ERROR_VARIABLE_NAME_NOT_FOUND:                     *p_pDescription = _T("Variable name not found"); break;
        case ERROR_BAD_DEVICE_STATE:                            *p_pDescription = _T("Bad device state"); break;
        case ERROR_BAD_FILE_CONTENT:                            *p_pDescription = _T("Bad file content"); break;
        case ERROR_PATH_DOES_NOT_EXISTS:                        *p_pDescription = _T("Path does not exist"); break;
        case ERROR_NO_LOGIC_SUPPLY:                             *p_pDescription = _T("No logic supply voltage"); break;
        case ERROR_GATEWAY_NOT_SUPPORTED:                       *p_pDescription = _T("Gateway not supported"); break;
        case ERROR_UPDATING_SERIAL_NUMBER:                      *p_pDescription = _T("Serial number update failed"); break;
        case ERROR_COMMUNICATION_INTERFACE_NOT_SUPPORTED:       *p_pDescription = _T("Communication interface is not supported"); break;
        case ERROR_FIRMWARE_VERSION_NOT_SUPPORTED:              *p_pDescription = _T("Firmware version does not support functionality"); break;
        case ERROR_FIRMWARE_FILE_WRONG_FOR_CONNECTED_HARDWARE:  *p_pDescription = _T("Firmware file does not match hardware version"); break;
        case ERROR_FIRMWARE_FILE_WRONG_OR_BAD:                  *p_pDescription = _T("Firmware file does not match or is corrupt"); break;
        case ERROR_PARAMETER_ACCESS_DENIED:                     *p_pDescription = _T("Parameter access denied"); break;
        case ERROR_DATA_RECORDER_NOT_CONFIGURED:                *p_pDescription = _T("Data recorder not configured"); break;
        case ERROR_FILE_FORMAT_NOT_SUPPORTED:                   *p_pDescription = _T("File format not supported"); break;
        case ERROR_FAILED_SAVING_DATA:                          *p_pDescription = _T("Failed saving data"); break;
        default: oResult = FALSE;
    }

    return oResult;
}
