#include "stdafx.h"

#include <MmcTypeDefinition.h>

#include <CommunicationModel/CommonLayer/ErrorHandling/ErrorCode_Definitions.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/Interface/ErrorHandlingInterface_General.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/Interface/ErrorHandlingInterface_RS232.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/Interface/ErrorHandlingInterface_USB.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/Interface/ErrorHandlingInterface_HID.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/Interface/ErrorHandlingInterface_CAN.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/Interface/ErrorHandlingInterface_Socket.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/Interface/ErrorHandlingInterface_TwinCAT.h>

#include <CommunicationModel/CommonLayer/ErrorHandling/Interface/ErrorHandlingInterface.h>


CErrorHandlingInterface::CErrorHandlingInterface()
{
}

CErrorHandlingInterface::~CErrorHandlingInterface()
{
}

BOOL CErrorHandlingInterface::GetErrorDescription(DWORD p_ulErrorCode, CStdString* p_pDescription)
{
    BOOL oResult(FALSE);

    if(!oResult)
    {
        if(CErrorHandlingInterface_General::GetErrorDescription(p_ulErrorCode, p_pDescription)
            || CErrorHandlingInterface_RS232::GetErrorDescription(p_ulErrorCode, p_pDescription)
            || CErrorHandlingInterface_CAN::GetErrorDescription(p_ulErrorCode, p_pDescription)
            || CErrorHandlingInterface_USB::GetErrorDescription(p_ulErrorCode, p_pDescription)
            || CErrorHandlingInterface_HID::GetErrorDescription(p_ulErrorCode, p_pDescription)
            || CErrorHandlingInterface_Socket::GetErrorDescription(p_ulErrorCode, p_pDescription)
            || CErrorHandlingInterface_TwinCAT::GetErrorDescription(p_ulErrorCode, p_pDescription))
        {
            oResult = TRUE;
        }
    }

    return oResult;
}
