#include "stdafx.h"

#include <MmcTypeDefinition.h>

#include <CommunicationModel/CommonLayer/ErrorHandling/ErrorCode_Definitions.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/Interface/ErrorHandlingInterface_General.h>

CErrorHandlingInterface_General::CErrorHandlingInterface_General()
{
}

CErrorHandlingInterface_General::~CErrorHandlingInterface_General()
{
}

BOOL CErrorHandlingInterface_General::GetErrorDescription(DWORD p_ulErrorCode, CStdString *p_pDescription)
{
    BOOL oResult(TRUE);

    switch(p_ulErrorCode)
    {
        case ERROR_I_OPENING_INTERFACE:     *p_pDescription = _T("Opening interface error"); break;
        case ERROR_I_CLOSING_INTERFACE:     *p_pDescription = _T("Closing interface error"); break;
        case ERROR_I_INTERFACE_NOT_OPEN:    *p_pDescription = _T("Interface is not open"); break;
        case ERROR_I_OPENING_PORT:          *p_pDescription = _T("Opening port error"); break;
        case ERROR_I_CLOSING_PORT:          *p_pDescription = _T("Closing port error"); break;
        case ERROR_I_PORT_NOT_OPEN:         *p_pDescription = _T("Port is not open"); break;
        case ERROR_I_RESET_PORT:            *p_pDescription = _T("Resetting port error"); break;
        case ERROR_I_SET_PORT_SETTINGS:     *p_pDescription = _T("Configuring port settings error"); break;
        case ERROR_I_SET_PORT_MODE:         *p_pDescription = _T("Configuring port mode error"); break;
        case ERROR_I_GET_PORT_SETTINGS:     *p_pDescription = _T("Getting port mode configuration"); break;
        case ERROR_I_ACCESS_DENIED:         *p_pDescription = _T("Access denied"); break;
        default: oResult = FALSE;
    }

    return oResult;
}
