#include "stdafx.h"

#include <MmcTypeDefinition.h>

#include <CommunicationModel/CommonLayer/ErrorHandling/ErrorCode_Definitions.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/ProtocolStack/ErrorHandlingProtocolStack_General.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/ProtocolStack/ErrorHandlingProtocolStack_CANopen.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/ProtocolStack/ErrorHandlingProtocolStack_EtherCAT.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/ProtocolStack/ErrorHandlingProtocolStack_InfoteamSerial.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/ProtocolStack/ErrorHandlingProtocolStack_MaxonSerialV1.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/ProtocolStack/ErrorHandlingProtocolStack_MaxonSerialV2.h>

#include <CommunicationModel/CommonLayer/ErrorHandling/ProtocolStack/ErrorHandlingProtocolStack.h>

CErrorHandlingProtocolStack::CErrorHandlingProtocolStack()
{
}

CErrorHandlingProtocolStack::~CErrorHandlingProtocolStack()
{
}

BOOL CErrorHandlingProtocolStack::GetErrorDescription(DWORD p_ulErrorCode, CStdString *p_pDescription)
{
    BOOL oResult(FALSE);

    if(CErrorHandlingProtocolStack_General::GetErrorDescription(p_ulErrorCode, p_pDescription)
        || CErrorHandlingProtocolStack_MaxonSerialV1::GetErrorDescription(p_ulErrorCode, p_pDescription)
        || CErrorHandlingProtocolStack_MaxonSerialV2::GetErrorDescription(p_ulErrorCode, p_pDescription)
        || CErrorHandlingProtocolStack_InfoteamSerial::GetErrorDescription(p_ulErrorCode, p_pDescription)
        || CErrorHandlingProtocolStack_CANopen::GetErrorDescription(p_ulErrorCode, p_pDescription)
        || CErrorHandlingProtocolStack_EtherCAT::GetErrorDescription(p_ulErrorCode, p_pDescription))
    {
        oResult = TRUE;
    }

    return oResult;
}
