#include "stdafx.h"

#include <MmcTypeDefinition.h>

#include <CommunicationModel/CommonLayer/ErrorHandling/ErrorCode_Definitions.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/ProtocolStack/ErrorHandlingProtocolStack_EtherCAT.h>

CErrorHandlingProtocolStack_EtherCAT::CErrorHandlingProtocolStack_EtherCAT()
{
}

CErrorHandlingProtocolStack_EtherCAT::~CErrorHandlingProtocolStack_EtherCAT()
{
}

BOOL CErrorHandlingProtocolStack_EtherCAT::GetErrorDescription(DWORD p_ulErrorCode, CStdString *p_pDescription)
{
    BOOL oResult(TRUE);

    switch(p_ulErrorCode)
    {
        case ERROR_ETHERCAT_SEND_FRAME:             *p_pDescription = _T("EtherCAT - Failed sent frame"); break;
        case ERROR_ETHERCAT_RECEIVE_FRAME:          *p_pDescription = _T("EtherCAT - Failed receive frame"); break;
        case ERROR_ETHERCAT_FRAME_NOT_RECEIVED:     *p_pDescription = _T("EtherCAT - Frame not received"); break;
        default: oResult = FALSE;
    }

    return oResult;
}
