#include "stdafx.h"

#include <MmcTypeDefinition.h>

#include <CommunicationModel/CommonLayer/ErrorHandling/ErrorCode_Definitions.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/ProtocolStack/ErrorHandlingProtocolStack_MaxonSerialV2.h>

CErrorHandlingProtocolStack_MaxonSerialV2::CErrorHandlingProtocolStack_MaxonSerialV2()
{
}

CErrorHandlingProtocolStack_MaxonSerialV2::~CErrorHandlingProtocolStack_MaxonSerialV2()
{
}

BOOL CErrorHandlingProtocolStack_MaxonSerialV2::GetErrorDescription(DWORD p_ulErrorCode, CStdString *p_pDescription)
{
    BOOL oResult(TRUE);

    switch(p_ulErrorCode)
    {
        case ERROR_MAXON_SERIAL_V2_STUFFING:                *p_pDescription = _T("Stuffing error"); break;
        case ERROR_MAXON_SERIAL_V2_DESTUFFING:              *p_pDescription = _T("Destuffing error"); break;
        case ERROR_MAXON_SERIAL_V2_BAD_CRC_RECEIVED:        *p_pDescription = _T("Bad CRC received"); break;
        case ERROR_MAXON_SERIAL_V2_BAD_DATA_SIZE_RECEIVED:  *p_pDescription = _T("Bad data size received"); break;
        case ERROR_MAXON_SERIAL_V2_BAD_DATA_SIZE_WRITTEN:   *p_pDescription = _T("Bad data size written"); break;
        case ERROR_MAXON_SERIAL_V2_SEND_FRAME:              *p_pDescription = _T("Serial data frame not written"); break;
        case ERROR_MAXON_SERIAL_V2_RECEIVE_FRAME:           *p_pDescription = _T("Serial data frame not received"); break;
        default: oResult = FALSE;
    }

    return oResult;
}
