#include "stdafx.h"

#include <MmcTypeDefinition.h>

#include <CommunicationModel/CommonLayer/ErrorHandling/ErrorCode_Definitions.h>
#include <CommunicationModel/CommonLayer/ErrorHandling/VirtualCommandSet/ErrorHandlingVirtualCommandSet_General.h>

CErrorHandlingVirtualCommandSet_General::CErrorHandlingVirtualCommandSet_General()
{
}

CErrorHandlingVirtualCommandSet_General::~CErrorHandlingVirtualCommandSet_General()
{
}

BOOL CErrorHandlingVirtualCommandSet_General::GetErrorDescription(DWORD p_ulErrorCode, CStdString *p_pDescription)
{
    BOOL oResult(TRUE);

    switch(p_ulErrorCode)
    {
        case ERROR_VIRTUAL_DEVICE_BAD_OBJECT_SIZE_EXPECTED:             *p_pDescription = _T("Bad data size received"); break;
        case ERROR_VIRTUAL_DEVICE_HOMING_ERROR:                         *p_pDescription = _T("Homing Error"); break;
        case ERROR_VIRTUAL_DEVICE_BAD_SII_CATEGORY:                     *p_pDescription = _T("Bad EtherCAT SII Category Type"); break;
        case ERROR_VIRTUAL_DEVICE_BAD_SII_STRING_TABLE:                 *p_pDescription = _T("Bad EtherCAT SII String Table"); break;
        case ERROR_VIRTUAL_DEVICE_STORE_FAILED:                         *p_pDescription = _T("Parameter Store Error"); break;
        case ERROR_VIRTUAL_DEVICE_RESTORE_FAILED:                       *p_pDescription = _T("Parameter Restore Error"); break;
        case ERROR_VIRTUAL_DEVICE_SENSOR_CONFIG_NOT_SUPPORTED:          *p_pDescription = _T("Sensor configuration not supported"); break;
        case ERROR_VIRTUAL_DEVICE_SENSOR_CONFIG_UNKNOWN:                *p_pDescription = _T("Sensor configuration unknown"); break;
        case ERROR_VIRTUAL_DEVICE_CONFIG_NOT_SUPPORTED:                 *p_pDescription = _T("Configuration not supported"); break;
        case ERROR_VIRTUAL_DEVICE_MASKING_DIGITAL_INPUT_NOT_SUPPORTED:  *p_pDescription = _T("Digital input mask not supported"); break;
        case ERROR_VIRTUAL_DEVICE_CONTROLLER_GAIN_NOT_SUPPORTED:        *p_pDescription = _T("Controller gain not supported"); break;
        default: oResult = FALSE;
    }

    return oResult;
}
