/////////////////////////////////////////////////////////////
//CommandGroupStandard_DCS_Epos4.cpp
//
//Project:CommunicationXLib
//Author:MMAGINA
//DateofCreation:28.05.2015
//
//Seeheaderfilefordescription.
//
//Copyright2015,maxonmotorag.
//Allrightsreserved.
///////////////////////////////////////////////////////////

#include "stdafx.h"

#include <CommunicationModel/DeviceCommandSet/Classes/CommandSets/Epos2/CommandSetObjectDictionary_DCS_Epos2.h>
#include <CommunicationModel/DeviceCommandSet/Classes/CommandSets/Epos2/CommandSetNetworkManagement_DCS_Epos2.h>
#include <CommunicationModel/DeviceCommandSet/Classes/CommandSets/Epos2/CommandSetGeneralGateway_DCS_Epos2.h>
#include <CommunicationModel/DeviceCommandSet/Classes/CommandSets/Epos2/CommandSetLayerSettingServices_DCS_Epos2.h>

#include <CommunicationModel/DeviceCommandSet/Classes/CommandGroups/Epos4/CommandGroupStandard_DCS_Epos4.h>

CCommandGroupStandard_DCS_Epos4::CCommandGroupStandard_DCS_Epos4()
{
    m_strCommandGroupName = COMMAND_GROUP_STANDARD;

    FillSetList();
}

CCommandGroupStandard_DCS_Epos4::~CCommandGroupStandard_DCS_Epos4()
{
    DeleteSetList();
}

void CCommandGroupStandard_DCS_Epos4::FillSetList()
{
    m_pCommandSetObjectDictionary = new CCommandSetObjectDictionary_DCS_Epos2();
    m_pCommandSetNetworkManagement = new CCommandSetNetworkManagement_DCS_Epos2();
    m_pCommandSetGeneralGateway = new CCommandSetGeneralGateway_DCS_Epos2();
    m_pCommandSetLayerSettingServices = new CCommandSetLayerSettingServices_DCS_Epos2();
}

void CCommandGroupStandard_DCS_Epos4::DeleteSetList()
{
    if(m_pCommandSetObjectDictionary)
    {
        delete m_pCommandSetObjectDictionary;
        m_pCommandSetObjectDictionary = NULL;
    }

    if(m_pCommandSetNetworkManagement)
    {
        delete m_pCommandSetNetworkManagement;
        m_pCommandSetNetworkManagement = NULL;
    }

    if(m_pCommandSetGeneralGateway)
    {
        delete m_pCommandSetGeneralGateway;
        m_pCommandSetGeneralGateway = NULL;
    }

    if(m_pCommandSetLayerSettingServices)
    {
        delete m_pCommandSetLayerSettingServices;
        m_pCommandSetLayerSettingServices = NULL;
    }
}

void CCommandGroupStandard_DCS_Epos4::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommandSetObjectDictionary) m_pCommandSetObjectDictionary->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetNetworkManagement) m_pCommandSetNetworkManagement->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetGeneralGateway) m_pCommandSetGeneralGateway->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetLayerSettingServices) m_pCommandSetLayerSettingServices->InitJournalManager(p_pJournalManager);
}

void CCommandGroupStandard_DCS_Epos4::ResetJournalManager()
{
    if(m_pCommandSetObjectDictionary) m_pCommandSetObjectDictionary->ResetJournalManager();
    if(m_pCommandSetNetworkManagement) m_pCommandSetNetworkManagement->ResetJournalManager();
    if(m_pCommandSetGeneralGateway) m_pCommandSetGeneralGateway->ResetJournalManager();
    if(m_pCommandSetLayerSettingServices) m_pCommandSetLayerSettingServices->ResetJournalManager();
}

BOOL CCommandGroupStandard_DCS_Epos4::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommandSetObjectDictionary && !m_pCommandSetObjectDictionary->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetNetworkManagement && !m_pCommandSetNetworkManagement->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetGeneralGateway && !m_pCommandSetGeneralGateway->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetLayerSettingServices && !m_pCommandSetLayerSettingServices->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}

CXXMLFile::CElementPart* CCommandGroupStandard_DCS_Epos4::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandGroup Elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandGroup");
        pElement->SetAt("Name", m_strCommandGroupName);

        //CommandSet Elements
        if(m_pCommandSetObjectDictionary && !m_pCommandSetObjectDictionary->StoreToXMLFile(p_pFile, pElement)) return pElement;
        if(m_pCommandSetNetworkManagement && !m_pCommandSetNetworkManagement->StoreToXMLFile(p_pFile, pElement)) return pElement;
        if(m_pCommandSetGeneralGateway && !m_pCommandSetGeneralGateway->StoreToXMLFile(p_pFile, pElement)) return pElement;
        if(m_pCommandSetLayerSettingServices && !m_pCommandSetLayerSettingServices->StoreToXMLFile(p_pFile, pElement)) return pElement;
    }

    return pElement;
}
