#include "stdafx.h"
#include "DeviceEpos2Factory.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

BOOL CDeviceEpos2Factory::GetAllIdentifiers(std::list<CStdString>& p_rTargets)
{
    BOOL oResult = FALSE;

    p_rTargets.clear();

    p_rTargets.push_back(PROTOCOL_MAXON_SERIAL_V1);
    p_rTargets.push_back(PROTOCOL_MAXON_SERIAL_V2);
    p_rTargets.push_back(PROTOCOL_CAN_OPEN);

    oResult = TRUE;

    return oResult;
}

BOOL CDeviceEpos2Factory::CreateInstance(CStdString p_Name, CGatewayDCStoPS*& p_rpNewInstance)
{
    BOOL oResult = FALSE;

    if(p_Name.CompareNoCase(PROTOCOL_MAXON_SERIAL_V1) == 0)
    {
        p_rpNewInstance = new CGatewayEpos2ToMaxonSerialV1();
        oResult = TRUE;
    }
    else if(p_Name.CompareNoCase(PROTOCOL_MAXON_SERIAL_V2) == 0)
    {
        p_rpNewInstance = new CGatewayEpos2ToMaxonSerialV2();
        oResult = TRUE;
    }
    else if(p_Name.CompareNoCase(PROTOCOL_CAN_OPEN) == 0)
    {
        p_rpNewInstance = new CGatewayEpos2ToCANopen();
        oResult = TRUE;
    }

    return oResult;
}
