#include "stdafx.h"
#include "DeviceInfoHandlingFactory.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

BOOL CDeviceInfoHandlingFactory::GetAllIdentifiers(std::list<CStdString>& p_rTargets)
{
    BOOL oResult = FALSE;

    p_rTargets.clear();

    p_rTargets.push_back(INTERFACE_RS232);
    p_rTargets.push_back(INTERFACE_USB);
    p_rTargets.push_back(INTERFACE_CAN);

    oResult = TRUE;

    return oResult;
}

BOOL CDeviceInfoHandlingFactory::CreateInstance(CStdString p_Name, CDeviceInfoHandlingBase*& p_rpNewInstance)
{
    BOOL oResult = FALSE;

    if(p_Name.CompareNoCase(INTERFACE_RS232) == 0)
    {
        p_rpNewInstance = new CRs232DeviceInfoHandling();
        oResult = TRUE;
    }
    else if(p_Name.CompareNoCase(INTERFACE_USB) == 0)
    {
        p_rpNewInstance = new CUsbDeviceInfoHandling();
        oResult = TRUE;
    }
    else if(p_Name.CompareNoCase(INTERFACE_CAN) == 0)
    {
        p_rpNewInstance = new CCANDeviceInfoHandling();
        oResult = TRUE;
    }

    return oResult;
}
