#include "stdafx.h"

#include <CommunicationModel/ProtocolStack/Classes/GatewayToInterface/CANopen/GatewayCANopenToCAN.h>

CGatewayCANopenToCAN::CGatewayCANopenToCAN()
{
    InitErrorHandling();
}

CGatewayCANopenToCAN::~CGatewayCANopenToCAN()
{
}

CGateway* CGatewayCANopenToCAN::Clone()
{
    CGatewayCANopenToCAN* pClonedGateway;

    pClonedGateway = new CGatewayCANopenToCAN();
    *pClonedGateway = *this;

    return pClonedGateway;
}

CGatewayCANopenToCAN& CGatewayCANopenToCAN::operator=(CGatewayCANopenToCAN& p_rOther)
{
    if(this != &p_rOther)
    {
        *((CGatewayCANopenToI*)this) = *((CGatewayCANopenToI*)&p_rOther);
    }

    return *this;
}

BOOL CGatewayCANopenToCAN::InitErrorHandling()
{
    BOOL oResult(FALSE);
    CErrorProducer errorProducer;
    CStdString className(_T("GatewayCANopenToCAN"));

    if(m_pErrorHandling)
    {
        //Init error producer
        errorProducer.Init(PROTOCOL_STACK_LAYER, className);
        oResult = m_pErrorHandling->InitErrorProducer(&errorProducer);
    }

    return oResult;
}
