#include "stdafx.h"
#include "ProtocolStackFactory.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

BOOL CProtocolStackFactory::GetAllIdentifiers(std::list<CStdString>& p_rTargets)
{
    BOOL oResult = FALSE;

    p_rTargets.clear();

    p_rTargets.push_back(PROTOCOL_MAXON_SERIAL_V1);
    p_rTargets.push_back(PROTOCOL_MAXON_SERIAL_V2);
    p_rTargets.push_back(PROTOCOL_CAN_OPEN);
    p_rTargets.push_back(PROTOCOL_INFOTEAM_SERIAL);

    oResult = TRUE;

    return oResult;
}

BOOL CProtocolStackFactory::CreateInstance(CStdString p_Name, CProtocolStackBase*& p_rpNewInstance)
{
    BOOL oResult = FALSE;

    if(p_Name.CompareNoCase(PROTOCOL_MAXON_SERIAL_V1) == 0)
    {
        p_rpNewInstance = new CProtocolStack_MaxonSerialV1();
        oResult = TRUE;
    }
    else if(p_Name.CompareNoCase(PROTOCOL_MAXON_SERIAL_V2) == 0)
    {
        p_rpNewInstance = new CProtocolStack_MaxonSerialV2();
        oResult = TRUE;
    }
    else if(p_Name.CompareNoCase(PROTOCOL_CAN_OPEN) == 0)
    {
        p_rpNewInstance = new CProtocolStack_CANopen();
        oResult = TRUE;
    }
    else if(p_Name.CompareNoCase(PROTOCOL_INFOTEAM_SERIAL) == 0)
    {
        p_rpNewInstance = new CProtocolStack_InfoteamSerial();
        oResult = TRUE;
    }

    return oResult;
}
