
#include "stdafx.h"

#include <CommunicationModel/VirtualCommandSet/Classes/CommandGroups/BaseClasses/CommandGroupBase_VCS.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/CanOpen/CommandSetGeneralGateway_VCS_CanOpen.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/CanOpen/CommandSetLayerSettingServices_VCS_CanOpen.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/CanOpen/CommandSetObjectDictionary_VCS_CanOpen.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetControllerGain_VCS_Configuration.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetRegulation_VCS_Configuration.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetMotor_VCS_Configuration.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetSafety_VCS_Configuration.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetSensors_VCS_Configuration.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Device/CommandSetInfos_VCS_Device.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/ErrorHandling/CommandSetErrorHistory_VCS_ErrorHandling.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/ErrorHandling/CommandSetReset_VCS_ErrorHandling.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/ErrorHandling/CommandSetSafety_VCS_ErrorHandling.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetAnalogInputs_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetAnalogOutputs_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetDigitalInputs_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetDigitalOutputs_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetPositionMarker_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Motion/CommandSetInfo_VCS_Motion.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetCurrentMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetHomingMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetInitialisation_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetPositionMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetProfilePositionMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetProfileVelocityMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetVelocityMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Scanning/CommandSetConfiguration_VCS_Scanning.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Scanning/CommandSetIdentification_VCS_Scanning.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/StateMachine/CommandSetCia402_VCS_StateMachine.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandGroups/Drive/CommandGroupStandard_VCS_Drive.h>

CCommandGroupStandard_VCS_Drive::CCommandGroupStandard_VCS_Drive()
{
    m_strCommandGroupName = COMMAND_GROUP_STANDARD;

    FillSetList();
}

CCommandGroupStandard_VCS_Drive::~CCommandGroupStandard_VCS_Drive()
{
    DeleteSetList();
}

void CCommandGroupStandard_VCS_Drive::FillSetList()
{
    m_pCommandSetCanOpenGeneralGateway = new CCommandSetGeneralGateway_VCS_CanOpen();
    m_pCommandSetCanOpenLayerSettingServices = new CCommandSetLayerSettingServices_VCS_CanOpen();
    m_pCommandSetCanOpenObjectDictionary = new CCommandSetObjectDictionary_VCS_CanOpen();
    m_pCommandSetConfigurationRegulation = new CCommandSetRegulation_VCS_Configuration();
    m_pCommandSetConfigurationMotor = new CCommandSetMotor_VCS_Configuration();
    m_pCommandSetConfigurationSafety = new CCommandSetSafety_VCS_Configuration();
    m_pCommandSetConfigurationSensors = new CCommandSetSensors_VCS_Configuration();
    m_pCommandSetDeviceInfos = new CCommandSetInfos_VCS_Device();
    m_pCommandSetErrorHandlingErrorHistory = new CCommandSetErrorHistory_VCS_ErrorHandling();
    m_pCommandSetErrorHandlingReset = new CCommandSetReset_VCS_ErrorHandling();
    m_pCommandSetErrorHandlingSafety = new CCommandSetSafety_VCS_ErrorHandling();
    m_pCommandSetInputsOutputsAnalogInputs = new CCommandSetAnalogInputs_VCS_InputsOutputs();
    m_pCommandSetInputsOutputsAnalogOutputs = new CCommandSetAnalogOutputs_VCS_InputsOutputs();
    m_pCommandSetInputsOutputsDigitalInputs = new CCommandSetDigitalInputs_VCS_InputsOutputs();
    m_pCommandSetInputsOutputsDigitalOutputs = new CCommandSetDigitalOutputs_VCS_InputsOutputs();
    m_pCommandSetInputsOutputsPositionMarker = new CCommandSetPositionMarker_VCS_InputsOutputs();
    m_pCommandSetMotionInfo = new CCommandSetInfo_VCS_Motion();
    m_pCommandSetOperationModeCurrentMode = new CCommandSetCurrentMode_VCS_OperationMode();
    m_pCommandSetOperationModeHomingMode = new CCommandSetHomingMode_VCS_OperationMode();
    m_pCommandSetOperationModeInitialisation = new CCommandSetInitialisation_VCS_OperationMode();
    m_pCommandSetOperationModePositionMode = new CCommandSetPositionMode_VCS_OperationMode();
    m_pCommandSetOperationModeVelocityMode = new CCommandSetVelocityMode_VCS_OperationMode();
    m_pCommandSetOperationModeProfilePositionMode = new CCommandSetProfilePositionMode_VCS_OperationMode();
    m_pCommandSetOperationModeProfileVelocityMode = new CCommandSetProfileVelocityMode_VCS_OperationMode();
    m_pCommandSetStateMachineCia402 = new CCommandSetCia402_VCS_StateMachine();
    m_pCommandSetScanningConfiguration = new CCommandSetConfiguration_VCS_Scanning();
    m_pCommandSetScanningIdentification = new CCommandSetIdentification_VCS_Scanning();
}

void CCommandGroupStandard_VCS_Drive::DeleteSetList()
{
    if(m_pCommandSetCanOpenGeneralGateway)
    {
        delete m_pCommandSetCanOpenGeneralGateway;
        m_pCommandSetCanOpenGeneralGateway = 0;
    }
    if(m_pCommandSetCanOpenLayerSettingServices)
    {
        delete m_pCommandSetCanOpenLayerSettingServices;
        m_pCommandSetCanOpenLayerSettingServices = 0;
    }
    if(m_pCommandSetCanOpenObjectDictionary)
    {
        delete m_pCommandSetCanOpenObjectDictionary;
        m_pCommandSetCanOpenObjectDictionary = 0;
    }
    if(m_pCommandSetConfigurationRegulation)
    {
        delete m_pCommandSetConfigurationRegulation;
        m_pCommandSetConfigurationRegulation = 0;
    }
    if(m_pCommandSetConfigurationMotor)
    {
        delete m_pCommandSetConfigurationMotor;
        m_pCommandSetConfigurationMotor = 0;
    }
    if(m_pCommandSetConfigurationSafety)
    {
        delete m_pCommandSetConfigurationSafety;
        m_pCommandSetConfigurationSafety = 0;
    }
    if(m_pCommandSetConfigurationSensors)
    {
        delete m_pCommandSetConfigurationSensors;
        m_pCommandSetConfigurationSensors = 0;
    }
    if(m_pCommandSetDeviceInfos)
    {
        delete m_pCommandSetDeviceInfos;
        m_pCommandSetDeviceInfos = 0;
    }
    if(m_pCommandSetErrorHandlingErrorHistory)
    {
        delete m_pCommandSetErrorHandlingErrorHistory;
        m_pCommandSetErrorHandlingErrorHistory = 0;
    }
    if(m_pCommandSetErrorHandlingReset)
    {
        delete m_pCommandSetErrorHandlingReset;
        m_pCommandSetErrorHandlingReset = 0;
    }
    if(m_pCommandSetErrorHandlingSafety)
    {
        delete m_pCommandSetErrorHandlingSafety;
        m_pCommandSetErrorHandlingSafety = 0;
    }
    if(m_pCommandSetInputsOutputsAnalogInputs)
    {
        delete m_pCommandSetInputsOutputsAnalogInputs;
        m_pCommandSetInputsOutputsAnalogInputs = 0;
    }
    if(m_pCommandSetInputsOutputsAnalogOutputs)
    {
        delete m_pCommandSetInputsOutputsAnalogOutputs;
        m_pCommandSetInputsOutputsAnalogOutputs = 0;
    }
    if(m_pCommandSetInputsOutputsDigitalInputs)
    {
        delete m_pCommandSetInputsOutputsDigitalInputs;
        m_pCommandSetInputsOutputsDigitalInputs = 0;
    }
    if(m_pCommandSetInputsOutputsDigitalOutputs)
    {
        delete m_pCommandSetInputsOutputsDigitalOutputs;
        m_pCommandSetInputsOutputsDigitalOutputs = 0;
    }
    if(m_pCommandSetInputsOutputsPositionMarker)
    {
        delete m_pCommandSetInputsOutputsPositionMarker;
        m_pCommandSetInputsOutputsPositionMarker = 0;
    }
    if(m_pCommandSetMotionInfo)
    {
        delete m_pCommandSetMotionInfo;
        m_pCommandSetMotionInfo = 0;
    }
    if(m_pCommandSetOperationModeCurrentMode)
    {
        delete m_pCommandSetOperationModeCurrentMode;
        m_pCommandSetOperationModeCurrentMode = 0;
    }
    if(m_pCommandSetOperationModeHomingMode)
    {
        delete m_pCommandSetOperationModeHomingMode;
        m_pCommandSetOperationModeHomingMode = 0;
    }
    if(m_pCommandSetOperationModeInitialisation)
    {
        delete m_pCommandSetOperationModeInitialisation;
        m_pCommandSetOperationModeInitialisation = 0;
    }
    if(m_pCommandSetOperationModePositionMode)
    {
        delete m_pCommandSetOperationModePositionMode;
        m_pCommandSetOperationModePositionMode = 0;
    }
    if(m_pCommandSetOperationModeVelocityMode)
    {
        delete m_pCommandSetOperationModeVelocityMode;
        m_pCommandSetOperationModeVelocityMode = 0;
    }
    if(m_pCommandSetOperationModeProfilePositionMode)
    {
        delete m_pCommandSetOperationModeProfilePositionMode;
        m_pCommandSetOperationModeProfilePositionMode = 0;
    }
    if(m_pCommandSetOperationModeProfileVelocityMode)
    {
        delete m_pCommandSetOperationModeProfileVelocityMode;
        m_pCommandSetOperationModeProfileVelocityMode = 0;
    }
    if(m_pCommandSetStateMachineCia402)
    {
        delete m_pCommandSetStateMachineCia402;
        m_pCommandSetStateMachineCia402 = 0;
    }
    if(m_pCommandSetScanningConfiguration)
    {
        delete m_pCommandSetScanningConfiguration;
        m_pCommandSetScanningConfiguration = 0;
    }
    if(m_pCommandSetScanningIdentification)
    {
        delete m_pCommandSetScanningIdentification;
        m_pCommandSetScanningIdentification = 0;
    }
}

CXXMLFile::CElementPart* CCommandGroupStandard_VCS_Drive::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    BOOL oInit = TRUE;
    CXXMLFile::CElement* pElement = 0;
    CXXMLFile::CElement* pElementSub = 0;

    if(p_pFile && p_pParentElement)
    {
        //CommandGroup Elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandGroup");
        pElement->SetAt("Name", m_strCommandGroupName);

        //CommandSet configuration elements
        pElementSub = (CXXMLFile::CElement*)p_pFile->AddElement(pElement);
        p_pFile->SetText(pElementSub, "CommandGroupSets");
        pElementSub->SetAt("Name", COMMAND_SET_CONFIGURATION);

        if(oInit && m_pCommandSetConfigurationSafety && !m_pCommandSetConfigurationSafety->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetConfigurationMotor && !m_pCommandSetConfigurationMotor->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetConfigurationSensors && !m_pCommandSetConfigurationSensors->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetConfigurationRegulation && !m_pCommandSetConfigurationRegulation->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        //CommandSet operation mode elements
        if(oInit && m_pCommandSetOperationModeProfilePositionMode && !m_pCommandSetOperationModeProfilePositionMode->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModeHomingMode && !m_pCommandSetOperationModeHomingMode->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModePositionMode && !m_pCommandSetOperationModePositionMode->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModeProfileVelocityMode && !m_pCommandSetOperationModeProfileVelocityMode->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModeVelocityMode && !m_pCommandSetOperationModeVelocityMode->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModeCurrentMode && !m_pCommandSetOperationModeCurrentMode->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        //CommandSet motion element
        if(oInit && m_pCommandSetMotionInfo && !m_pCommandSetMotionInfo->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        //CommandSet input/output elements
        pElementSub = (CXXMLFile::CElement*)p_pFile->AddElement(pElement);
        p_pFile->SetText(pElementSub, "CommandGroupSets");
        pElementSub->SetAt("Name", COMMAND_SET_INPUTS_OUTPUTS);
        if(oInit && m_pCommandSetInputsOutputsDigitalInputs && !m_pCommandSetInputsOutputsDigitalInputs->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetInputsOutputsDigitalOutputs && !m_pCommandSetInputsOutputsDigitalOutputs->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetInputsOutputsAnalogInputs && !m_pCommandSetInputsOutputsAnalogInputs->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetInputsOutputsAnalogOutputs && !m_pCommandSetInputsOutputsAnalogOutputs->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetInputsOutputsPositionMarker && !m_pCommandSetInputsOutputsPositionMarker->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        //CommandSet state machine element
        pElementSub = (CXXMLFile::CElement*)p_pFile->AddElement(pElement);
        p_pFile->SetText(pElementSub, "CommandGroupSets");
        pElementSub->SetAt("Name", COMMAND_SET_STATE_MACHINE);
        if(oInit && m_pCommandSetStateMachineCia402 && !m_pCommandSetStateMachineCia402->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModeInitialisation && !m_pCommandSetOperationModeInitialisation->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        //CommandSet CANopen element
        if(oInit && m_pCommandSetCanOpenGeneralGateway && !m_pCommandSetCanOpenGeneralGateway->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetCanOpenObjectDictionary && !m_pCommandSetCanOpenObjectDictionary->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        //CommandSet Error handling element
        pElementSub = (CXXMLFile::CElement*)p_pFile->AddElement(pElement);
        p_pFile->SetText(pElementSub, "CommandGroupSets");
        pElementSub->SetAt("Name", COMMAND_SET_ERROR_HANDLING);
        if(oInit && m_pCommandSetErrorHandlingReset && !m_pCommandSetErrorHandlingReset->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetErrorHandlingErrorHistory && !m_pCommandSetErrorHandlingErrorHistory->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        //CommandSet device element
        if(oInit && m_pCommandSetDeviceInfos && !m_pCommandSetDeviceInfos->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;

        if(!oInit)
        {
            pElement = 0;
        }
    }

    return pElement;
}

void CCommandGroupStandard_VCS_Drive::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommandSetCanOpenGeneralGateway) m_pCommandSetCanOpenGeneralGateway->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetCanOpenLayerSettingServices) m_pCommandSetCanOpenLayerSettingServices->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetCanOpenObjectDictionary) m_pCommandSetCanOpenObjectDictionary->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetConfigurationRegulation) m_pCommandSetConfigurationRegulation->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetConfigurationMotor) m_pCommandSetConfigurationMotor->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetConfigurationSafety) m_pCommandSetConfigurationSafety->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetConfigurationSensors) m_pCommandSetConfigurationSensors->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetDeviceInfos) m_pCommandSetDeviceInfos->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetErrorHandlingErrorHistory) m_pCommandSetErrorHandlingErrorHistory->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetErrorHandlingReset) m_pCommandSetErrorHandlingReset->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetErrorHandlingSafety) m_pCommandSetErrorHandlingSafety->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetInputsOutputsAnalogInputs) m_pCommandSetInputsOutputsAnalogInputs->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetInputsOutputsAnalogOutputs) m_pCommandSetInputsOutputsAnalogOutputs->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetInputsOutputsDigitalInputs) m_pCommandSetInputsOutputsDigitalInputs->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetInputsOutputsDigitalOutputs) m_pCommandSetInputsOutputsDigitalOutputs->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetInputsOutputsPositionMarker) m_pCommandSetInputsOutputsPositionMarker->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetMotionInfo) m_pCommandSetMotionInfo->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetOperationModeCurrentMode) m_pCommandSetOperationModeCurrentMode->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetOperationModeHomingMode) m_pCommandSetOperationModeHomingMode->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetOperationModeInitialisation) m_pCommandSetOperationModeInitialisation->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetOperationModePositionMode) m_pCommandSetOperationModePositionMode->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetOperationModeVelocityMode) m_pCommandSetOperationModeVelocityMode->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetOperationModeProfilePositionMode) m_pCommandSetOperationModeProfilePositionMode->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetOperationModeProfileVelocityMode) m_pCommandSetOperationModeProfileVelocityMode->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetStateMachineCia402) m_pCommandSetStateMachineCia402->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetScanningConfiguration) m_pCommandSetScanningConfiguration->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetScanningIdentification) m_pCommandSetScanningIdentification->InitJournalManager(p_pJournalManager);
}

void CCommandGroupStandard_VCS_Drive::ResetJournalManager()
{
    if(m_pCommandSetCanOpenGeneralGateway) m_pCommandSetCanOpenGeneralGateway->ResetJournalManager();
    if(m_pCommandSetCanOpenLayerSettingServices) m_pCommandSetCanOpenLayerSettingServices->ResetJournalManager();
    if(m_pCommandSetCanOpenObjectDictionary) m_pCommandSetCanOpenObjectDictionary->ResetJournalManager();
    if(m_pCommandSetConfigurationRegulation) m_pCommandSetConfigurationRegulation->ResetJournalManager();
    if(m_pCommandSetConfigurationMotor) m_pCommandSetConfigurationMotor->ResetJournalManager();
    if(m_pCommandSetConfigurationSafety) m_pCommandSetConfigurationSafety->ResetJournalManager();
    if(m_pCommandSetConfigurationSensors) m_pCommandSetConfigurationSensors->ResetJournalManager();
    if(m_pCommandSetDeviceInfos) m_pCommandSetDeviceInfos->ResetJournalManager();
    if(m_pCommandSetErrorHandlingErrorHistory) m_pCommandSetErrorHandlingErrorHistory->ResetJournalManager();
    if(m_pCommandSetErrorHandlingReset) m_pCommandSetErrorHandlingReset->ResetJournalManager();
    if(m_pCommandSetErrorHandlingSafety) m_pCommandSetErrorHandlingSafety->ResetJournalManager();
    if(m_pCommandSetInputsOutputsAnalogInputs) m_pCommandSetInputsOutputsAnalogInputs->ResetJournalManager();
    if(m_pCommandSetInputsOutputsAnalogOutputs) m_pCommandSetInputsOutputsAnalogOutputs->ResetJournalManager();
    if(m_pCommandSetInputsOutputsDigitalInputs) m_pCommandSetInputsOutputsDigitalInputs->ResetJournalManager();
    if(m_pCommandSetInputsOutputsDigitalOutputs) m_pCommandSetInputsOutputsDigitalOutputs->ResetJournalManager();
    if(m_pCommandSetInputsOutputsPositionMarker) m_pCommandSetInputsOutputsPositionMarker->ResetJournalManager();
    if(m_pCommandSetMotionInfo) m_pCommandSetMotionInfo->ResetJournalManager();
    if(m_pCommandSetOperationModeCurrentMode) m_pCommandSetOperationModeCurrentMode->ResetJournalManager();
    if(m_pCommandSetOperationModeHomingMode) m_pCommandSetOperationModeHomingMode->ResetJournalManager();
    if(m_pCommandSetOperationModeInitialisation) m_pCommandSetOperationModeInitialisation->ResetJournalManager();
    if(m_pCommandSetOperationModePositionMode) m_pCommandSetOperationModePositionMode->ResetJournalManager();
    if(m_pCommandSetOperationModeVelocityMode) m_pCommandSetOperationModeVelocityMode->ResetJournalManager();
    if(m_pCommandSetOperationModeProfilePositionMode) m_pCommandSetOperationModeProfilePositionMode->ResetJournalManager();
    if(m_pCommandSetOperationModeProfileVelocityMode) m_pCommandSetOperationModeProfileVelocityMode->ResetJournalManager();
    if(m_pCommandSetStateMachineCia402) m_pCommandSetStateMachineCia402->ResetJournalManager();
    if(m_pCommandSetScanningConfiguration) m_pCommandSetScanningConfiguration->ResetJournalManager();
    if(m_pCommandSetScanningIdentification) m_pCommandSetScanningIdentification->ResetJournalManager();
}

BOOL CCommandGroupStandard_VCS_Drive::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult = TRUE;

    if(oResult && m_pCommandSetCanOpenGeneralGateway && !m_pCommandSetCanOpenGeneralGateway->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetCanOpenLayerSettingServices && !m_pCommandSetCanOpenLayerSettingServices->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetCanOpenObjectDictionary && !m_pCommandSetCanOpenObjectDictionary->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetConfigurationRegulation && !m_pCommandSetConfigurationRegulation->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetConfigurationMotor && !m_pCommandSetConfigurationMotor->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetConfigurationSafety && !m_pCommandSetConfigurationSafety->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetConfigurationSensors && !m_pCommandSetConfigurationSensors->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetDeviceInfos && !m_pCommandSetDeviceInfos->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetErrorHandlingErrorHistory && !m_pCommandSetErrorHandlingErrorHistory->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetErrorHandlingReset && !m_pCommandSetErrorHandlingReset->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetErrorHandlingSafety && !m_pCommandSetErrorHandlingSafety->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetInputsOutputsAnalogInputs && !m_pCommandSetInputsOutputsAnalogInputs->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetInputsOutputsAnalogOutputs && !m_pCommandSetInputsOutputsAnalogOutputs->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetInputsOutputsDigitalInputs && !m_pCommandSetInputsOutputsDigitalInputs->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetInputsOutputsDigitalOutputs && !m_pCommandSetInputsOutputsDigitalOutputs->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetInputsOutputsPositionMarker && !m_pCommandSetInputsOutputsPositionMarker->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetMotionInfo && !m_pCommandSetMotionInfo->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetOperationModeCurrentMode && !m_pCommandSetOperationModeCurrentMode->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetOperationModeHomingMode && !m_pCommandSetOperationModeHomingMode->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetOperationModeInitialisation && !m_pCommandSetOperationModeInitialisation->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetOperationModePositionMode && !m_pCommandSetOperationModePositionMode->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetOperationModeVelocityMode && !m_pCommandSetOperationModeVelocityMode->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetOperationModeProfilePositionMode && !m_pCommandSetOperationModeProfilePositionMode->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetOperationModeProfileVelocityMode && !m_pCommandSetOperationModeProfileVelocityMode->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetStateMachineCia402 && !m_pCommandSetStateMachineCia402->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetScanningConfiguration && !m_pCommandSetScanningConfiguration->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetScanningIdentification && !m_pCommandSetScanningIdentification->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
