
#include "stdafx.h"

#include <CommunicationModel/VirtualCommandSet/Classes/CommandGroups/BaseClasses/CommandGroupBase_VCS.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/CanOpen/CommandSetGeneralGateway_VCS_CanOpen.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/CanOpen/CommandSetLayerSettingServices_VCS_CanOpen.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/CanOpen/CommandSetObjectDictionary_VCS_CanOpen.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetControllerGain_VCS_Configuration.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetRegulation_VCS_Configuration.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetMotor_VCS_Configuration.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetSafety_VCS_Configuration.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetSensors_VCS_Configuration.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetUnits_VCS_Configuration.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/DataRecorder/CommandSetDataRecording_VCS_DataRecorder.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Device/CommandSetInfos_VCS_Device.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/ErrorHandling/CommandSetErrorHistory_VCS_ErrorHandling.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/ErrorHandling/CommandSetReset_VCS_ErrorHandling.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/ErrorHandling/CommandSetSafety_VCS_ErrorHandling.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetAnalogInputs_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetAnalogOutputs_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetDigitalInputs_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetDigitalOutputs_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetPositionCompare_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetPositionMarker_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Motion/CommandSetInfo_VCS_Motion.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetCurrentMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetCurrentModeAnalog_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetHomingMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetInitialisation_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetInterpolatedPositionMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetMasterEncoderMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetPositionMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetPositionModeAnalog_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetProfilePositionMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetProfileVelocityMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetStepDirectionMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetVelocityMode_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetVelocityModeAnalog_VCS_OperationMode.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Parameter/CommandSetPersistence_VCS_Parameter.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/StateMachine/CommandSetCia402_VCS_StateMachine.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandGroups/Drive2/CommandGroupStandard_VCS_Drive2.h>

CCommandGroupStandard_VCS_Drive2::CCommandGroupStandard_VCS_Drive2()
{
    m_strCommandGroupName = COMMAND_GROUP_STANDARD;

    FillSetList();
}

CCommandGroupStandard_VCS_Drive2::~CCommandGroupStandard_VCS_Drive2()
{
    DeleteSetList();
}

void CCommandGroupStandard_VCS_Drive2::FillSetList()
{
    m_pCommandSetConfigurationUnits = new CCommandSetUnits_VCS_Configuration();
    m_pCommandSetDataRecorderDataRecording = new CCommandSetDataRecording_VCS_DataRecorder();
    m_pCommandSetInputsOutputsPositionCompare = new CCommandSetPositionCompare_VCS_InputsOutputs();
    m_pCommandSetOperationModeCurrentModeAnalog = new CCommandSetCurrentModeAnalog_VCS_OperationMode();
    m_pCommandSetOperationModeInterpolatedPositionMode = new CCommandSetInterpolatedPositionMode_VCS_OperationMode();
    m_pCommandSetOperationModeMasterEncoderMode = new CCommandSetMasterEncoderMode_VCS_OperationMode();
    m_pCommandSetOperationModePositionModeAnalog = new CCommandSetPositionModeAnalog_VCS_OperationMode();
    m_pCommandSetOperationModeStepDirectionMode = new CCommandSetStepDirectionMode_VCS_OperationMode();
    m_pCommandSetOperationModeVelocityModeAnalog = new CCommandSetVelocityModeAnalog_VCS_OperationMode();
    m_pCommandSetParameterPersistence = new CCommandSetPersistence_VCS_Parameter();
}

void CCommandGroupStandard_VCS_Drive2::DeleteSetList()
{
    if(m_pCommandSetConfigurationUnits)
    {
        delete m_pCommandSetConfigurationUnits;
        m_pCommandSetConfigurationUnits = 0;
    }
    if(m_pCommandSetDataRecorderDataRecording)
    {
        delete m_pCommandSetDataRecorderDataRecording;
        m_pCommandSetDataRecorderDataRecording = 0;
    }
    if(m_pCommandSetInputsOutputsPositionCompare)
    {
        delete m_pCommandSetInputsOutputsPositionCompare;
        m_pCommandSetInputsOutputsPositionCompare = 0;
    }
    if(m_pCommandSetOperationModeCurrentModeAnalog)
    {
        delete m_pCommandSetOperationModeCurrentModeAnalog;
        m_pCommandSetOperationModeCurrentModeAnalog = 0;
    }
    if(m_pCommandSetOperationModeInterpolatedPositionMode)
    {
        delete m_pCommandSetOperationModeInterpolatedPositionMode;
        m_pCommandSetOperationModeInterpolatedPositionMode = 0;
    }
    if(m_pCommandSetOperationModeMasterEncoderMode)
    {
        delete m_pCommandSetOperationModeMasterEncoderMode;
        m_pCommandSetOperationModeMasterEncoderMode = 0;
    }
    if(m_pCommandSetOperationModePositionModeAnalog)
    {
        delete m_pCommandSetOperationModePositionModeAnalog;
        m_pCommandSetOperationModePositionModeAnalog = 0;
    }
    if(m_pCommandSetOperationModeStepDirectionMode)
    {
        delete m_pCommandSetOperationModeStepDirectionMode;
        m_pCommandSetOperationModeStepDirectionMode = 0;
    }
    if(m_pCommandSetOperationModeVelocityModeAnalog)
    {
        delete m_pCommandSetOperationModeVelocityModeAnalog;
        m_pCommandSetOperationModeVelocityModeAnalog = 0;
    }
    if(m_pCommandSetParameterPersistence)
    {
        delete m_pCommandSetParameterPersistence;
        m_pCommandSetParameterPersistence = 0;
    }
}

CXXMLFile::CElementPart* CCommandGroupStandard_VCS_Drive2::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    BOOL oInit = TRUE;
    CXXMLFile::CElement* pElement = 0;
    CXXMLFile::CElement* pElementSub = 0;

    if(p_pFile && p_pParentElement)
    {
        //CommandGroup elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandGroup");
        pElement->SetAt("Name", m_strCommandGroupName);

        //CommandSet configuration elements
        pElementSub = (CXXMLFile::CElement*)p_pFile->AddElement(pElement);
        p_pFile->SetText(pElementSub, "CommandGroupSets");
        pElementSub->SetAt("Name", COMMAND_SET_CONFIGURATION);

        if(oInit && m_pCommandSetConfigurationUnits && !m_pCommandSetConfigurationUnits->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetConfigurationSafety && !m_pCommandSetConfigurationSafety->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetConfigurationMotor && !m_pCommandSetConfigurationMotor->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetConfigurationSensors && !m_pCommandSetConfigurationSensors->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetConfigurationRegulation && !m_pCommandSetConfigurationRegulation->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        //CommandSet operation mode elements
        if(oInit && m_pCommandSetOperationModeInitialisation && !m_pCommandSetOperationModeInitialisation->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModeProfilePositionMode && !m_pCommandSetOperationModeProfilePositionMode->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModeHomingMode && !m_pCommandSetOperationModeHomingMode->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModeInterpolatedPositionMode && !m_pCommandSetOperationModeInterpolatedPositionMode->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        //CommandSet position mode
        pElementSub = (CXXMLFile::CElement*)p_pFile->AddElement(pElement);
        p_pFile->SetText(pElementSub, "CommandGroupSets");
        pElementSub->SetAt("Name", COMMAND_SET_OPERATION_MODE_POSITION_MODE);
        if(oInit && m_pCommandSetOperationModePositionMode && !m_pCommandSetOperationModePositionMode->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModePositionModeAnalog && !m_pCommandSetOperationModePositionModeAnalog->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        //CommandSet operation mode elements
        if(oInit && m_pCommandSetOperationModeMasterEncoderMode && !m_pCommandSetOperationModeMasterEncoderMode->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModeStepDirectionMode && !m_pCommandSetOperationModeStepDirectionMode->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModeProfileVelocityMode && !m_pCommandSetOperationModeProfileVelocityMode->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        //CommandSet velocity mode
        pElementSub = (CXXMLFile::CElement*)p_pFile->AddElement(pElement);
        p_pFile->SetText(pElementSub, "CommandGroupSets");
        pElementSub->SetAt("Name", COMMAND_SET_OPERATION_MODE_VELOCITY_MODE);
        if(oInit && m_pCommandSetOperationModeVelocityMode && !m_pCommandSetOperationModeVelocityMode->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModeVelocityModeAnalog && !m_pCommandSetOperationModeVelocityModeAnalog->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        //CommandSet current mode
        pElementSub = (CXXMLFile::CElement*)p_pFile->AddElement(pElement);
        p_pFile->SetText(pElementSub, "CommandGroupSets");
        pElementSub->SetAt("Name", COMMAND_SET_OPERATION_MODE_CURRENT_MODE);
        if(oInit && m_pCommandSetOperationModeCurrentMode && !m_pCommandSetOperationModeCurrentMode->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetOperationModeCurrentModeAnalog && !m_pCommandSetOperationModeCurrentModeAnalog->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        //CommandSet motion element
        if(oInit && m_pCommandSetMotionInfo && !m_pCommandSetMotionInfo->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        //CommandSet input/output elements
        pElementSub = (CXXMLFile::CElement*)p_pFile->AddElement(pElement);
        p_pFile->SetText(pElementSub, "CommandGroupSets");
        pElementSub->SetAt("Name", COMMAND_SET_INPUTS_OUTPUTS);
        if(oInit && m_pCommandSetInputsOutputsDigitalInputs && !m_pCommandSetInputsOutputsDigitalInputs->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetInputsOutputsDigitalOutputs && !m_pCommandSetInputsOutputsDigitalOutputs->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetInputsOutputsAnalogInputs && !m_pCommandSetInputsOutputsAnalogInputs->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetInputsOutputsAnalogOutputs && !m_pCommandSetInputsOutputsAnalogOutputs->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetInputsOutputsPositionCompare && !m_pCommandSetInputsOutputsPositionCompare->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetInputsOutputsPositionMarker && !m_pCommandSetInputsOutputsPositionMarker->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        //CommandSet state machine element
        if(oInit && m_pCommandSetStateMachineCia402 && !m_pCommandSetStateMachineCia402->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        //CommandSet CANopen elements
        if(oInit && m_pCommandSetCanOpenGeneralGateway && !m_pCommandSetCanOpenGeneralGateway->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetCanOpenObjectDictionary && !m_pCommandSetCanOpenObjectDictionary->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        //CommandSet Error handling element
        pElementSub = (CXXMLFile::CElement*)p_pFile->AddElement(pElement);
        p_pFile->SetText(pElementSub, "CommandGroupSets");
        pElementSub->SetAt("Name", COMMAND_SET_ERROR_HANDLING);
        if(oInit && m_pCommandSetErrorHandlingReset && !m_pCommandSetErrorHandlingReset->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetErrorHandlingErrorHistory && !m_pCommandSetErrorHandlingErrorHistory->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        //CommandSet device element
        if(oInit && m_pCommandSetDeviceInfos && !m_pCommandSetDeviceInfos->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        //CommandSet data recording element
        if(oInit && m_pCommandSetDataRecorderDataRecording && !m_pCommandSetDataRecorderDataRecording->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;

        if(!oInit)
        {
            pElement = 0;
        }
    }

    return pElement;
}

void CCommandGroupStandard_VCS_Drive2::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    CCommandGroupStandard_VCS_Drive::InitJournalManager(p_pJournalManager);

    if(m_pCommandSetConfigurationUnits) m_pCommandSetConfigurationUnits->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetDataRecorderDataRecording) m_pCommandSetDataRecorderDataRecording->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetInputsOutputsPositionCompare) m_pCommandSetInputsOutputsPositionCompare->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetOperationModeCurrentModeAnalog) m_pCommandSetOperationModeCurrentModeAnalog->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetOperationModeInterpolatedPositionMode) m_pCommandSetOperationModeInterpolatedPositionMode->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetOperationModeMasterEncoderMode) m_pCommandSetOperationModeMasterEncoderMode->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetOperationModePositionModeAnalog) m_pCommandSetOperationModePositionModeAnalog->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetOperationModeStepDirectionMode) m_pCommandSetOperationModeStepDirectionMode->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetOperationModeVelocityModeAnalog) m_pCommandSetOperationModeVelocityModeAnalog->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetParameterPersistence) m_pCommandSetParameterPersistence->InitJournalManager(p_pJournalManager);
}

void CCommandGroupStandard_VCS_Drive2::ResetJournalManager()
{
    CCommandGroupStandard_VCS_Drive::ResetJournalManager();

    if(m_pCommandSetConfigurationUnits) m_pCommandSetConfigurationUnits->ResetJournalManager();
    if(m_pCommandSetDataRecorderDataRecording) m_pCommandSetDataRecorderDataRecording->ResetJournalManager();
    if(m_pCommandSetInputsOutputsPositionCompare) m_pCommandSetInputsOutputsPositionCompare->ResetJournalManager();
    if(m_pCommandSetOperationModeCurrentModeAnalog) m_pCommandSetOperationModeCurrentModeAnalog->ResetJournalManager();
    if(m_pCommandSetOperationModeInterpolatedPositionMode) m_pCommandSetOperationModeInterpolatedPositionMode->ResetJournalManager();
    if(m_pCommandSetOperationModeMasterEncoderMode) m_pCommandSetOperationModeMasterEncoderMode->ResetJournalManager();
    if(m_pCommandSetOperationModePositionModeAnalog) m_pCommandSetOperationModePositionModeAnalog->ResetJournalManager();
    if(m_pCommandSetOperationModeStepDirectionMode) m_pCommandSetOperationModeStepDirectionMode->ResetJournalManager();
    if(m_pCommandSetOperationModeVelocityModeAnalog) m_pCommandSetOperationModeVelocityModeAnalog->ResetJournalManager();
    if(m_pCommandSetParameterPersistence) m_pCommandSetParameterPersistence->ResetJournalManager();
}

BOOL CCommandGroupStandard_VCS_Drive2::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult = CCommandGroupStandard_VCS_Drive::InitGateway(p_pGateway);

    if(oResult && m_pCommandSetConfigurationUnits && !m_pCommandSetConfigurationUnits->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetDataRecorderDataRecording && !m_pCommandSetDataRecorderDataRecording->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetInputsOutputsPositionCompare && !m_pCommandSetInputsOutputsPositionCompare->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetOperationModeCurrentModeAnalog && !m_pCommandSetOperationModeCurrentModeAnalog->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetOperationModeInterpolatedPositionMode && !m_pCommandSetOperationModeInterpolatedPositionMode->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetOperationModeMasterEncoderMode && !m_pCommandSetOperationModeMasterEncoderMode->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetOperationModePositionModeAnalog && !m_pCommandSetOperationModePositionModeAnalog->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetOperationModeStepDirectionMode && !m_pCommandSetOperationModeStepDirectionMode->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetOperationModeVelocityModeAnalog && !m_pCommandSetOperationModeVelocityModeAnalog->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetParameterPersistence && !m_pCommandSetParameterPersistence->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}

