
#include "stdafx.h"

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/CanOpen/CommandSetGeneralGateway_VCS_CanOpen.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/CanOpen/CommandSetLayerSettingServices_VCS_CanOpen.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/CanOpen/CommandSetObjectDictionary_VCS_CanOpen.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Device/CommandSetInfos_VCS_Device.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/ErrorHandling/CommandSetErrorHistory_VCS_ErrorHandling.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/ErrorHandling/CommandSetReset_VCS_ErrorHandling.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/ErrorHandling/CommandSetSafety_VCS_ErrorHandling.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Scanning/CommandSetConfiguration_VCS_Scanning.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Scanning/CommandSetIdentification_VCS_Scanning.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandGroups/Plc/CommandGroupStandard_VCS_Plc.h>

CCommandGroupStandard_VCS_Plc::CCommandGroupStandard_VCS_Plc()
{
    m_strCommandGroupName = COMMAND_GROUP_STANDARD;

    FillSetList();
}

CCommandGroupStandard_VCS_Plc::~CCommandGroupStandard_VCS_Plc()
{
    DeleteSetList();
}

void CCommandGroupStandard_VCS_Plc::FillSetList()
{
    m_pCommandSetCanOpenGeneralGateway = new CCommandSetGeneralGateway_VCS_CanOpen();
    m_pCommandSetCanOpenLayerSettingServices = new CCommandSetLayerSettingServices_VCS_CanOpen();
    m_pCommandSetCanOpenObjectDictionary = new CCommandSetObjectDictionary_VCS_CanOpen();
    m_pCommandSetDeviceInfos = new CCommandSetInfos_VCS_Device();
    m_pCommandSetErrorHandlingErrorHistory = new CCommandSetErrorHistory_VCS_ErrorHandling();
    m_pCommandSetErrorHandlingReset = new CCommandSetReset_VCS_ErrorHandling();
    m_pCommandSetErrorHandlingSafety = new CCommandSetSafety_VCS_ErrorHandling();
    m_pCommandSetScanningConfiguration = new CCommandSetConfiguration_VCS_Scanning();
    m_pCommandSetScanningIdentification = new CCommandSetIdentification_VCS_Scanning();
}

void CCommandGroupStandard_VCS_Plc::DeleteSetList()
{
    if(m_pCommandSetCanOpenGeneralGateway)
    {
        delete m_pCommandSetCanOpenGeneralGateway;
        m_pCommandSetCanOpenGeneralGateway = 0;
    }
    if(m_pCommandSetCanOpenLayerSettingServices)
    {
        delete m_pCommandSetCanOpenLayerSettingServices;
        m_pCommandSetCanOpenLayerSettingServices = 0;
    }
    if(m_pCommandSetCanOpenObjectDictionary)
    {
        delete m_pCommandSetCanOpenObjectDictionary;
        m_pCommandSetCanOpenObjectDictionary = 0;
    }
    if(m_pCommandSetDeviceInfos)
    {
        delete m_pCommandSetDeviceInfos;
        m_pCommandSetDeviceInfos = 0;
    }
    if(m_pCommandSetErrorHandlingErrorHistory)
    {
        delete m_pCommandSetErrorHandlingErrorHistory;
        m_pCommandSetErrorHandlingErrorHistory = 0;
    }
    if(m_pCommandSetErrorHandlingReset)
    {
        delete m_pCommandSetErrorHandlingReset;
        m_pCommandSetErrorHandlingReset = 0;
    }
    if(m_pCommandSetErrorHandlingSafety)
    {
        delete m_pCommandSetErrorHandlingSafety;
        m_pCommandSetErrorHandlingSafety = 0;
    }
     if(m_pCommandSetScanningConfiguration)
    {
        delete m_pCommandSetScanningConfiguration;
        m_pCommandSetScanningConfiguration = 0;
    }
    if(m_pCommandSetScanningIdentification)
    {
        delete m_pCommandSetScanningIdentification;
        m_pCommandSetScanningIdentification = 0;
    }
}

CXXMLFile::CElementPart* CCommandGroupStandard_VCS_Plc::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    BOOL oInit = TRUE;
    CXXMLFile::CElement* pElement = 0;

    if(p_pFile && p_pParentElement)
    {
        //CommandGroup elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandGroup");
        pElement->SetAt("Name", m_strCommandGroupName);

        //CommandSet elements
        if(oInit && m_pCommandSetCanOpenGeneralGateway && !m_pCommandSetCanOpenGeneralGateway->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetCanOpenObjectDictionary && !m_pCommandSetCanOpenObjectDictionary->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetErrorHandlingErrorHistory && !m_pCommandSetErrorHandlingErrorHistory->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetErrorHandlingReset && !m_pCommandSetErrorHandlingReset->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetErrorHandlingSafety && !m_pCommandSetErrorHandlingSafety->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetDeviceInfos && !m_pCommandSetDeviceInfos->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;

        if(!oInit)
        {
            pElement = 0;
        }
    }

    return pElement;
}

void CCommandGroupStandard_VCS_Plc::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommandSetCanOpenGeneralGateway) m_pCommandSetCanOpenGeneralGateway->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetCanOpenLayerSettingServices) m_pCommandSetCanOpenLayerSettingServices->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetCanOpenObjectDictionary) m_pCommandSetCanOpenObjectDictionary->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetDeviceInfos) m_pCommandSetDeviceInfos->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetErrorHandlingErrorHistory) m_pCommandSetErrorHandlingErrorHistory->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetErrorHandlingReset) m_pCommandSetErrorHandlingReset->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetErrorHandlingSafety) m_pCommandSetErrorHandlingSafety->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetScanningConfiguration) m_pCommandSetScanningConfiguration->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetScanningIdentification) m_pCommandSetScanningIdentification->InitJournalManager(p_pJournalManager);
}

void CCommandGroupStandard_VCS_Plc::ResetJournalManager()
{
    if(m_pCommandSetCanOpenGeneralGateway) m_pCommandSetCanOpenGeneralGateway->ResetJournalManager();
    if(m_pCommandSetCanOpenLayerSettingServices) m_pCommandSetCanOpenLayerSettingServices->ResetJournalManager();
    if(m_pCommandSetCanOpenObjectDictionary) m_pCommandSetCanOpenObjectDictionary->ResetJournalManager();
    if(m_pCommandSetDeviceInfos) m_pCommandSetDeviceInfos->ResetJournalManager();
    if(m_pCommandSetErrorHandlingErrorHistory) m_pCommandSetErrorHandlingErrorHistory->ResetJournalManager();
    if(m_pCommandSetErrorHandlingReset) m_pCommandSetErrorHandlingReset->ResetJournalManager();
    if(m_pCommandSetErrorHandlingSafety) m_pCommandSetErrorHandlingSafety->ResetJournalManager();
    if(m_pCommandSetScanningConfiguration) m_pCommandSetScanningConfiguration->ResetJournalManager();
    if(m_pCommandSetScanningIdentification) m_pCommandSetScanningIdentification->ResetJournalManager();
}

BOOL CCommandGroupStandard_VCS_Plc::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult = TRUE;

    if(oResult && m_pCommandSetCanOpenGeneralGateway && !m_pCommandSetCanOpenGeneralGateway->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetCanOpenLayerSettingServices && !m_pCommandSetCanOpenLayerSettingServices->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetCanOpenObjectDictionary && !m_pCommandSetCanOpenObjectDictionary->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetDeviceInfos && !m_pCommandSetDeviceInfos->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetErrorHandlingErrorHistory && !m_pCommandSetErrorHandlingErrorHistory->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetErrorHandlingReset && !m_pCommandSetErrorHandlingReset->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetErrorHandlingSafety && !m_pCommandSetErrorHandlingSafety->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetScanningConfiguration && !m_pCommandSetScanningConfiguration->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetScanningIdentification && !m_pCommandSetScanningIdentification->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
