
#include "stdafx.h"

#include <CommunicationModel/VirtualCommandSet/Classes/CommandGroups/BaseClasses/CommandGroupBase_VCS.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/CanOpen/CommandSetGeneralGateway_VCS_CanOpen.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/CanOpen/CommandSetObjectDictionary_VCS_CanOpen.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Device/CommandSetInfos_VCS_Device.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/ErrorHandling/CommandSetErrorHistory_VCS_ErrorHandling.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/ErrorHandling/CommandSetReset_VCS_ErrorHandling.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Firmware/CommandSetDownload_VCS_Firmware.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetAnalogInputs_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetAnalogOutputs_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetDigitalInputs_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/InputsOutputs/CommandSetDigitalOutputs_VCS_InputsOutputs.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Parameter/CommandSetPersistence_VCS_Parameter.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Scada/CommandSetInitialisation_VCS_Scada.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Scada/CommandSetProcessImage_VCS_Scada.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Scada/CommandSetProcessInputOutput_VCS_Scada.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Scada/CommandSetProgramStatus_VCS_Scada.h>
#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Scada/CommandSetProgramVariable_VCS_Scada.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandGroups/Plc2/CommandGroupStandard_VCS_Plc2.h>

CCommandGroupStandard_VCS_Plc2::CCommandGroupStandard_VCS_Plc2()
{
    m_strCommandGroupName = COMMAND_GROUP_STANDARD;

    FillSetList();
}

CCommandGroupStandard_VCS_Plc2::~CCommandGroupStandard_VCS_Plc2()
{
    DeleteSetList();
}

void CCommandGroupStandard_VCS_Plc2::FillSetList()
{
    m_pCommandSetFirmwareDownload = new CCommandSetDownload_VCS_Firmware();
    m_pCommandSetInputsOutputsAnalogInputs = new CCommandSetAnalogInputs_VCS_InputsOutputs();
    m_pCommandSetInputsOutputsAnalogOutputs = new CCommandSetAnalogOutputs_VCS_InputsOutputs();
    m_pCommandSetInputsOutputsDigitalInputs = new CCommandSetDigitalInputs_VCS_InputsOutputs();
    m_pCommandSetInputsOutputsDigitalOutputs = new CCommandSetDigitalOutputs_VCS_InputsOutputs();
    m_pCommandSetParameterPersistence = new CCommandSetPersistence_VCS_Parameter();
    m_pCommandSetScadaInitialisation = new CCommandSetInitialisation_VCS_Scada();
    m_pCommandSetScadaProcessImage = new CCommandSetProcessImage_VCS_Scada();
    m_pCommandSetScadaProcessInputOutput = new CCommandSetProcessInputOutput_VCS_Scada();
    m_pCommandSetScadaProgramStatus = new CCommandSetProgramStatus_VCS_Scada();
    m_pCommandSetScadaProgramVariable = new CCommandSetProgramVariable_VCS_Scada();
}

void CCommandGroupStandard_VCS_Plc2::DeleteSetList()
{
    if(m_pCommandSetFirmwareDownload)
    {
        delete m_pCommandSetFirmwareDownload;
    m_pCommandSetFirmwareDownload = 0;
    }
    if(m_pCommandSetInputsOutputsAnalogInputs)
    {
        delete m_pCommandSetInputsOutputsAnalogInputs;
    m_pCommandSetInputsOutputsAnalogInputs = 0;
    }
    if(m_pCommandSetInputsOutputsAnalogOutputs)
    {
        delete m_pCommandSetInputsOutputsAnalogOutputs;
        m_pCommandSetInputsOutputsAnalogOutputs = 0;
    }
    if(m_pCommandSetInputsOutputsDigitalInputs)
    {
        delete m_pCommandSetInputsOutputsDigitalInputs;
        m_pCommandSetInputsOutputsDigitalInputs = 0;
    }
    if(m_pCommandSetInputsOutputsDigitalOutputs)
    {
        delete m_pCommandSetInputsOutputsDigitalOutputs;
        m_pCommandSetInputsOutputsDigitalOutputs = 0;
    }
    if(m_pCommandSetParameterPersistence)
    {
        delete m_pCommandSetParameterPersistence;
        m_pCommandSetParameterPersistence = 0;
    }
    if(m_pCommandSetScadaInitialisation)
    {
        delete m_pCommandSetScadaInitialisation;
        m_pCommandSetScadaInitialisation = 0;
    }
    if(m_pCommandSetScadaProcessImage)
    {
        delete m_pCommandSetScadaProcessImage;
        m_pCommandSetScadaProcessImage = 0;
    }
    if(m_pCommandSetScadaProcessInputOutput)
    {
        delete m_pCommandSetScadaProcessInputOutput;
        m_pCommandSetScadaProcessInputOutput = 0;
    }
    if(m_pCommandSetScadaProgramStatus)
    {
        delete m_pCommandSetScadaProgramStatus;
        m_pCommandSetScadaProgramStatus = 0;
    }
    if(m_pCommandSetScadaProgramVariable)
    {
        delete m_pCommandSetScadaProgramVariable;
        m_pCommandSetScadaProgramVariable = 0;
    }
}

CXXMLFile::CElementPart* CCommandGroupStandard_VCS_Plc2::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    BOOL oInit = TRUE;
    CXXMLFile::CElement* pElement = 0;
    CXXMLFile::CElement* pElementSub = 0;

    if(p_pFile && p_pParentElement)
    {
        //CommandGroup elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandGroup");
        pElement->SetAt("Name", m_strCommandGroupName);

        //CommandSet CANopen element
        if(oInit && m_pCommandSetCanOpenGeneralGateway && !m_pCommandSetCanOpenGeneralGateway->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        if(oInit && m_pCommandSetCanOpenObjectDictionary && !m_pCommandSetCanOpenObjectDictionary->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;
        //CommandSet Error handling element
        pElementSub = (CXXMLFile::CElement*)p_pFile->AddElement(pElement);
        p_pFile->SetText(pElementSub, "CommandGroupSets");
        pElementSub->SetAt("Name", COMMAND_SET_ERROR_HANDLING);
        if(oInit && m_pCommandSetErrorHandlingReset && !m_pCommandSetErrorHandlingReset->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        if(oInit && m_pCommandSetErrorHandlingErrorHistory && !m_pCommandSetErrorHandlingErrorHistory->StoreToXMLFile(p_pFile, pElementSub)) oInit = FALSE;
        //CommandSet device element
        if(oInit && m_pCommandSetDeviceInfos && !m_pCommandSetDeviceInfos->StoreToXMLFile(p_pFile, pElement)) oInit = FALSE;

        if(!oInit)
        {
            pElement = 0;
        }
    }

    return pElement;
}

void CCommandGroupStandard_VCS_Plc2::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    CCommandGroupStandard_VCS_Plc::InitJournalManager(p_pJournalManager);

    if(m_pCommandSetFirmwareDownload) m_pCommandSetFirmwareDownload->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetInputsOutputsAnalogInputs) m_pCommandSetInputsOutputsAnalogInputs->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetInputsOutputsAnalogOutputs) m_pCommandSetInputsOutputsAnalogOutputs->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetInputsOutputsDigitalInputs) m_pCommandSetInputsOutputsDigitalInputs->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetInputsOutputsDigitalOutputs) m_pCommandSetInputsOutputsDigitalOutputs->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetParameterPersistence) m_pCommandSetParameterPersistence->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetScadaInitialisation) m_pCommandSetScadaInitialisation->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetScadaProcessImage) m_pCommandSetScadaProcessImage->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetScadaProcessInputOutput) m_pCommandSetScadaProcessInputOutput->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetScadaProgramStatus) m_pCommandSetScadaProgramStatus->InitJournalManager(p_pJournalManager);
    if(m_pCommandSetScadaProgramVariable) m_pCommandSetScadaProgramVariable->InitJournalManager(p_pJournalManager);
}

void CCommandGroupStandard_VCS_Plc2::ResetJournalManager()
{
    CCommandGroupStandard_VCS_Plc::ResetJournalManager();

    if(m_pCommandSetFirmwareDownload) m_pCommandSetFirmwareDownload->ResetJournalManager();
    if(m_pCommandSetInputsOutputsAnalogInputs) m_pCommandSetInputsOutputsAnalogInputs->ResetJournalManager();
    if(m_pCommandSetInputsOutputsAnalogOutputs) m_pCommandSetInputsOutputsAnalogOutputs->ResetJournalManager();
    if(m_pCommandSetInputsOutputsDigitalInputs) m_pCommandSetInputsOutputsDigitalInputs->ResetJournalManager();
    if(m_pCommandSetInputsOutputsDigitalOutputs) m_pCommandSetInputsOutputsDigitalOutputs->ResetJournalManager();
    if(m_pCommandSetParameterPersistence) m_pCommandSetParameterPersistence->ResetJournalManager();
    if(m_pCommandSetScadaInitialisation) m_pCommandSetScadaInitialisation->ResetJournalManager();
    if(m_pCommandSetScadaProcessImage) m_pCommandSetScadaProcessImage->ResetJournalManager();
    if(m_pCommandSetScadaProcessInputOutput) m_pCommandSetScadaProcessInputOutput->ResetJournalManager();
    if(m_pCommandSetScadaProgramStatus) m_pCommandSetScadaProgramStatus->ResetJournalManager();
    if(m_pCommandSetScadaProgramVariable) m_pCommandSetScadaProgramVariable->ResetJournalManager();
}

BOOL CCommandGroupStandard_VCS_Plc2::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult = CCommandGroupStandard_VCS_Plc::InitGateway(p_pGateway);

    if(oResult && m_pCommandSetFirmwareDownload && !m_pCommandSetFirmwareDownload->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetInputsOutputsAnalogInputs && !m_pCommandSetInputsOutputsAnalogInputs->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetInputsOutputsAnalogOutputs && !m_pCommandSetInputsOutputsAnalogOutputs->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetInputsOutputsDigitalInputs && !m_pCommandSetInputsOutputsDigitalInputs->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetInputsOutputsDigitalOutputs && !m_pCommandSetInputsOutputsDigitalOutputs->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetParameterPersistence && !m_pCommandSetParameterPersistence->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetScadaInitialisation && !m_pCommandSetScadaInitialisation->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetScadaProcessImage && !m_pCommandSetScadaProcessImage->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetScadaProcessInputOutput && !m_pCommandSetScadaProcessInputOutput->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetScadaProgramStatus && !m_pCommandSetScadaProgramStatus->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommandSetScadaProgramVariable && !m_pCommandSetScadaProgramVariable->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
