
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_Configuration.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetRegulation_VCS_Configuration.h>

CCommandSetRegulation_VCS_Configuration::CCommandSetRegulation_VCS_Configuration()
{
    m_strCommandSetName = COMMAND_SET_CONFIGURATION_REGULATION;

    m_pCommand_GetControllerGain = 0;
    m_pCommand_GetCurrentRegulatorGain = 0;
    m_pCommand_GetPositionRegulatorGain = 0;
    m_pCommand_GetVelocityRegulatorGain = 0;
    m_pCommand_GetVelocityRegulatorFeedForward = NULL;
    m_pCommand_SetControllerGain = 0;
    m_pCommand_SetCurrentRegulatorGain = 0;
    m_pCommand_SetPositionRegulatorGain = 0;
    m_pCommand_SetVelocityRegulatorGain = 0;
    m_pCommand_SetVelocityRegulatorFeedForward = NULL;

    InitCommands();
}

CCommandSetRegulation_VCS_Configuration::~CCommandSetRegulation_VCS_Configuration()
{
    DeleteCommands();
}

BOOL CCommandSetRegulation_VCS_Configuration::VCS_GetCurrentRegulatorGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusP, WORD* p_pusI, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetCurrentRegulatorGain)
    {
        //Set parameter data
        m_pCommand_GetCurrentRegulatorGain->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetCurrentRegulatorGain->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetCurrentRegulatorGain->GetReturnParameterData(0, p_pusP, sizeof(*p_pusP));
        m_pCommand_GetCurrentRegulatorGain->GetReturnParameterData(1, p_pusI, sizeof(*p_pusI));

        //Get error code
        m_pCommand_GetCurrentRegulatorGain->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetRegulation_VCS_Configuration::VCS_GetPositionRegulatorGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusP, WORD* p_pusI, WORD* p_pusD, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetPositionRegulatorGain)
    {
        //Set parameter data
        m_pCommand_GetPositionRegulatorGain->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetPositionRegulatorGain->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetPositionRegulatorGain->GetReturnParameterData(0, p_pusP, sizeof(*p_pusP));
        m_pCommand_GetPositionRegulatorGain->GetReturnParameterData(1, p_pusI, sizeof(*p_pusI));
        m_pCommand_GetPositionRegulatorGain->GetReturnParameterData(2, p_pusD, sizeof(*p_pusD));

        //Get error code
        m_pCommand_GetPositionRegulatorGain->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetRegulation_VCS_Configuration::VCS_GetPositionRegulatorFeedForward(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD *p_pusVelocityFeedForward, WORD *p_pusAccelerationFeedForward, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetPositionRegulatorGain)
    {
        //Set parameter data
        m_pCommand_GetPositionRegulatorGain->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetPositionRegulatorGain->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetPositionRegulatorGain->GetReturnParameterData(0, p_pusVelocityFeedForward, sizeof(*p_pusVelocityFeedForward));
        m_pCommand_GetPositionRegulatorGain->GetReturnParameterData(1, p_pusAccelerationFeedForward, sizeof(*p_pusAccelerationFeedForward));

        //Get error code
        m_pCommand_GetPositionRegulatorGain->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetRegulation_VCS_Configuration::VCS_GetVelocityRegulatorGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusP, WORD* p_pusI, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetVelocityRegulatorGain)
    {
        //Set parameter data
        m_pCommand_GetVelocityRegulatorGain->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetVelocityRegulatorGain->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetVelocityRegulatorGain->GetReturnParameterData(0, p_pusP, sizeof(*p_pusP));
        m_pCommand_GetVelocityRegulatorGain->GetReturnParameterData(1, p_pusI, sizeof(*p_pusI));

        //Get error code
        m_pCommand_GetVelocityRegulatorGain->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetRegulation_VCS_Configuration::VCS_GetVelocityRegulatorFeedForward(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusVelocityFeedForward, WORD* p_pusAccelerationFeedForward, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetVelocityRegulatorFeedForward)
    {
        //Set parameter data
        m_pCommand_GetVelocityRegulatorFeedForward->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetVelocityRegulatorFeedForward->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetVelocityRegulatorFeedForward->GetReturnParameterData(0, p_pusVelocityFeedForward, sizeof(*p_pusVelocityFeedForward));
        m_pCommand_GetVelocityRegulatorFeedForward->GetReturnParameterData(1, p_pusAccelerationFeedForward, sizeof(*p_pusAccelerationFeedForward));

        //Get error code
        m_pCommand_GetVelocityRegulatorFeedForward->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetRegulation_VCS_Configuration::VCS_GetControllerGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usController, WORD p_usGain, __uint64* p_pullValue, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult(FALSE);

    if(m_pCommand_GetControllerGain)
    {
        //Set parameter data
        m_pCommand_GetControllerGain->ResetStatus();
        m_pCommand_SetControllerGain->SetParameterData(0, &p_usController, sizeof(p_usController));
        m_pCommand_SetControllerGain->SetParameterData(1, &p_usGain, sizeof(p_usGain));

        //Execute command
        oResult = m_pCommand_GetControllerGain->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetControllerGain->GetReturnParameterData(0, p_pullValue, sizeof(*p_pullValue));

        //Get error code
        m_pCommand_GetControllerGain->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetRegulation_VCS_Configuration::VCS_SetCurrentRegulatorGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usP, WORD p_usI, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetCurrentRegulatorGain)
    {
        //Set parameter data
        m_pCommand_SetCurrentRegulatorGain->ResetStatus();
        m_pCommand_SetCurrentRegulatorGain->SetParameterData(0, &p_usP, sizeof(p_usP));
        m_pCommand_SetCurrentRegulatorGain->SetParameterData(1, &p_usI, sizeof(p_usI));

        //Execute command
        oResult = m_pCommand_SetCurrentRegulatorGain->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetCurrentRegulatorGain->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetRegulation_VCS_Configuration::VCS_SetPositionRegulatorGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usP, WORD p_usI, WORD p_usD, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetPositionRegulatorGain)
    {
        //Set parameter data
        m_pCommand_SetPositionRegulatorGain->ResetStatus();
        m_pCommand_SetPositionRegulatorGain->SetParameterData(0, &p_usP, sizeof(p_usP));
        m_pCommand_SetPositionRegulatorGain->SetParameterData(1, &p_usI, sizeof(p_usI));
        m_pCommand_SetPositionRegulatorGain->SetParameterData(2, &p_usD, sizeof(p_usD));

        //Execute command
        oResult = m_pCommand_SetPositionRegulatorGain->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetPositionRegulatorGain->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetRegulation_VCS_Configuration::VCS_SetPositionRegulatorFeedForward(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usVelocityFeedForward, WORD p_usAccelerationFeedForward, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetPositionRegulatorGain)
    {
        //Set parameter data
        m_pCommand_SetPositionRegulatorGain->ResetStatus();
        m_pCommand_SetPositionRegulatorGain->SetParameterData(0, &p_usVelocityFeedForward, sizeof(p_usVelocityFeedForward));
        m_pCommand_SetPositionRegulatorGain->SetParameterData(1, &p_usAccelerationFeedForward, sizeof(p_usAccelerationFeedForward));

        //Execute command
        oResult = m_pCommand_SetPositionRegulatorGain->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetPositionRegulatorGain->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetRegulation_VCS_Configuration::VCS_SetVelocityRegulatorGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usP, WORD p_usI, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetVelocityRegulatorGain)
    {
        //Set parameter data
        m_pCommand_SetVelocityRegulatorGain->ResetStatus();
        m_pCommand_SetVelocityRegulatorGain->SetParameterData(0, &p_usP, sizeof(p_usP));
        m_pCommand_SetVelocityRegulatorGain->SetParameterData(1, &p_usI, sizeof(p_usI));

        //Execute command
        oResult = m_pCommand_SetVelocityRegulatorGain->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetVelocityRegulatorGain->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetRegulation_VCS_Configuration::VCS_SetVelocityRegulatorFeedForward(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usVelocityFeedForward, WORD p_usAccelerationFeedForward, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetVelocityRegulatorFeedForward)
    {
        //Set parameter data
        m_pCommand_SetVelocityRegulatorFeedForward->ResetStatus();
        m_pCommand_SetVelocityRegulatorFeedForward->SetParameterData(0, &p_usVelocityFeedForward, sizeof(p_usVelocityFeedForward));
        m_pCommand_SetVelocityRegulatorFeedForward->SetParameterData(1, &p_usAccelerationFeedForward, sizeof(p_usAccelerationFeedForward));

        //Execute command
        oResult = m_pCommand_SetVelocityRegulatorFeedForward->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetVelocityRegulatorFeedForward->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetRegulation_VCS_Configuration::VCS_SetControllerGain(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usController, WORD p_usGain, __uint64 p_ullValue, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetControllerGain)
    {
        //Set parameter data
        m_pCommand_SetControllerGain->ResetStatus();
        m_pCommand_SetControllerGain->SetParameterData(0, &p_usController, sizeof(p_usController));
        m_pCommand_SetControllerGain->SetParameterData(1, &p_usGain, sizeof(p_usGain));
        m_pCommand_SetControllerGain->SetParameterData(2, &p_ullValue, sizeof(p_ullValue));

        //Execute command
        oResult = m_pCommand_SetControllerGain->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetControllerGain->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetRegulation_VCS_Configuration::InitCommands()
{
    DeleteCommands();

    //Init GetCurrentRegulatorGain
    m_pCommand_GetCurrentRegulatorGain = new CCommand_VCS_Configuration();
    m_pCommand_GetCurrentRegulatorGain->InitCommand(CONF_GET_CURRENT_REGULATOR_GAIN);

    //Init GetPositionRegulatorGain
    m_pCommand_GetPositionRegulatorGain = new CCommand_VCS_Configuration();
    m_pCommand_GetPositionRegulatorGain->InitCommand(CONF_GET_POSITION_REGULATOR_GAIN);

    //Init GetVelocityRegulatorGain
    m_pCommand_GetVelocityRegulatorGain = new CCommand_VCS_Configuration();
    m_pCommand_GetVelocityRegulatorGain->InitCommand(CONF_GET_VELOCITY_REGULATOR_GAIN);
    
    //Init GetVelocityRegulatorFeedForward
    m_pCommand_GetVelocityRegulatorFeedForward = new CCommand_VCS_Configuration();
    m_pCommand_GetVelocityRegulatorFeedForward->InitCommand(CONF_GET_VELOCITY_REGULATOR_FEED_FORWARD);

    //Init GetControllerGain
    m_pCommand_GetControllerGain = new CCommand_VCS_Configuration();
    m_pCommand_GetControllerGain->InitCommand(CONF_GET_CONTROLLER_GAIN);

    //Init SetCurrentRegulatorGain
    m_pCommand_SetCurrentRegulatorGain = new CCommand_VCS_Configuration();
    m_pCommand_SetCurrentRegulatorGain->InitCommand(CONF_SET_CURRENT_REGULATOR_GAIN);

    //Init SetPositionRegulatorGain
    m_pCommand_SetPositionRegulatorGain = new CCommand_VCS_Configuration();
    m_pCommand_SetPositionRegulatorGain->InitCommand(CONF_SET_POSITION_REGULATOR_GAIN);

    //Init SetVelocityRegualtorGain
    m_pCommand_SetVelocityRegulatorGain = new CCommand_VCS_Configuration();
    m_pCommand_SetVelocityRegulatorGain->InitCommand(CONF_SET_VELOCITY_REGULATOR_GAIN);
    
    //Init SetVelocityRegulatorFeedForward
    m_pCommand_SetVelocityRegulatorFeedForward = new CCommand_VCS_Configuration();
    m_pCommand_SetVelocityRegulatorFeedForward->InitCommand(CONF_SET_VELOCITY_REGULATOR_FEED_FORWARD);

    //Init SetControllerGain
    m_pCommand_SetControllerGain = new CCommand_VCS_Configuration();
    m_pCommand_SetControllerGain->InitCommand(CONF_SET_CONTROLLER_GAIN);
}

void CCommandSetRegulation_VCS_Configuration::DeleteCommands()
{
    if(m_pCommand_GetCurrentRegulatorGain)
    {
        delete m_pCommand_GetCurrentRegulatorGain;
        m_pCommand_GetCurrentRegulatorGain = 0;
    }
    if(m_pCommand_GetPositionRegulatorGain)
    {
        delete m_pCommand_GetPositionRegulatorGain;
        m_pCommand_GetPositionRegulatorGain = 0;
    }
    if(m_pCommand_GetVelocityRegulatorGain)
    {
        delete m_pCommand_GetVelocityRegulatorGain;
        m_pCommand_GetVelocityRegulatorGain = 0;
    }
    if(m_pCommand_GetVelocityRegulatorFeedForward)
    {
        delete m_pCommand_GetVelocityRegulatorFeedForward;
        m_pCommand_GetVelocityRegulatorFeedForward = NULL;
    }
    if(m_pCommand_GetControllerGain)
    {
        delete m_pCommand_GetControllerGain;
        m_pCommand_GetControllerGain = 0;
    }
    if(m_pCommand_SetCurrentRegulatorGain)
    {
        delete m_pCommand_SetCurrentRegulatorGain;
        m_pCommand_SetCurrentRegulatorGain = 0;
    }
    if(m_pCommand_SetPositionRegulatorGain)
    {
        delete m_pCommand_SetPositionRegulatorGain;
        m_pCommand_SetPositionRegulatorGain = 0;
    }
    if(m_pCommand_SetVelocityRegulatorGain)
    {
        delete m_pCommand_SetVelocityRegulatorGain;
        m_pCommand_SetVelocityRegulatorGain = 0;
    }
    if(m_pCommand_SetVelocityRegulatorFeedForward)
    {
        delete m_pCommand_SetVelocityRegulatorFeedForward;
        m_pCommand_SetVelocityRegulatorFeedForward = NULL;
    }
    if(m_pCommand_SetControllerGain)
    {
        delete m_pCommand_SetControllerGain;
        m_pCommand_SetControllerGain = 0;
    }
}

CXXMLFile::CElementPart* CCommandSetRegulation_VCS_Configuration::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandSet");
        pElement->SetAt("Name", m_strCommandSetName);

        //Command elements
        if(m_pCommand_GetControllerGain) m_pCommand_GetControllerGain->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetControllerGain) m_pCommand_SetControllerGain->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetCurrentRegulatorGain) m_pCommand_GetCurrentRegulatorGain->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetPositionRegulatorGain) m_pCommand_GetPositionRegulatorGain->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetVelocityRegulatorGain) m_pCommand_GetVelocityRegulatorGain->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetVelocityRegulatorFeedForward) m_pCommand_GetVelocityRegulatorFeedForward->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetCurrentRegulatorGain) m_pCommand_SetCurrentRegulatorGain->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetPositionRegulatorGain) m_pCommand_SetPositionRegulatorGain->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetVelocityRegulatorGain) m_pCommand_SetVelocityRegulatorGain->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetVelocityRegulatorFeedForward) m_pCommand_SetVelocityRegulatorFeedForward->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetRegulation_VCS_Configuration::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_GetCurrentRegulatorGain) m_pCommand_GetCurrentRegulatorGain->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetPositionRegulatorGain) m_pCommand_GetPositionRegulatorGain->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetVelocityRegulatorGain) m_pCommand_GetVelocityRegulatorGain->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetVelocityRegulatorFeedForward) m_pCommand_GetVelocityRegulatorFeedForward->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetControllerGain) m_pCommand_GetControllerGain->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetCurrentRegulatorGain) m_pCommand_SetCurrentRegulatorGain->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetPositionRegulatorGain) m_pCommand_SetPositionRegulatorGain->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetVelocityRegulatorGain) m_pCommand_SetVelocityRegulatorGain->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetVelocityRegulatorFeedForward) m_pCommand_SetVelocityRegulatorFeedForward->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetControllerGain) m_pCommand_SetControllerGain->InitJournalManager(p_pJournalManager);
}

void CCommandSetRegulation_VCS_Configuration::ResetJournalManager()
{
    if(m_pCommand_GetCurrentRegulatorGain) m_pCommand_GetCurrentRegulatorGain->ResetJournalManager();
    if(m_pCommand_GetPositionRegulatorGain) m_pCommand_GetPositionRegulatorGain->ResetJournalManager();
    if(m_pCommand_GetVelocityRegulatorGain) m_pCommand_GetVelocityRegulatorGain->ResetJournalManager();
    if(m_pCommand_GetControllerGain) m_pCommand_GetControllerGain->ResetJournalManager();
    if(m_pCommand_GetVelocityRegulatorFeedForward) m_pCommand_GetVelocityRegulatorFeedForward->ResetJournalManager();
    if(m_pCommand_SetCurrentRegulatorGain) m_pCommand_SetCurrentRegulatorGain->ResetJournalManager();
    if(m_pCommand_SetPositionRegulatorGain) m_pCommand_SetPositionRegulatorGain->ResetJournalManager();
    if(m_pCommand_SetVelocityRegulatorGain) m_pCommand_SetVelocityRegulatorGain->ResetJournalManager();
    if(m_pCommand_SetVelocityRegulatorFeedForward) m_pCommand_SetVelocityRegulatorFeedForward->ResetJournalManager();
    if(m_pCommand_SetControllerGain) m_pCommand_SetControllerGain->ResetJournalManager();
}

BOOL CCommandSetRegulation_VCS_Configuration::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_GetCurrentRegulatorGain && !m_pCommand_GetCurrentRegulatorGain->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetPositionRegulatorGain && !m_pCommand_GetPositionRegulatorGain->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetVelocityRegulatorGain && !m_pCommand_GetVelocityRegulatorGain->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetVelocityRegulatorFeedForward && !m_pCommand_GetVelocityRegulatorFeedForward->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetControllerGain && !m_pCommand_GetControllerGain->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetCurrentRegulatorGain && !m_pCommand_SetCurrentRegulatorGain->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetPositionRegulatorGain && !m_pCommand_SetPositionRegulatorGain->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetVelocityRegulatorGain && !m_pCommand_SetVelocityRegulatorGain->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetVelocityRegulatorFeedForward && !m_pCommand_SetVelocityRegulatorFeedForward->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetControllerGain && !m_pCommand_SetControllerGain->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
