
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_Configuration.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetSafety_VCS_Configuration.h>

CCommandSetSafety_VCS_Configuration::CCommandSetSafety_VCS_Configuration()
{
    m_strCommandSetName = COMMAND_SET_CONFIGURATION_SAFETY;

    m_pCommand_GetMaxFollowingError = NULL;
    m_pCommand_SetMaxFollowingError = NULL;
    m_pCommand_GetMaxProfileVelocity = NULL;
    m_pCommand_SetMaxProfileVelocity = NULL;
    m_pCommand_GetMaxAcceleration = NULL;
    m_pCommand_SetMaxAcceleration = NULL;

    InitCommands();
}

CCommandSetSafety_VCS_Configuration::~CCommandSetSafety_VCS_Configuration()
{
    DeleteCommands();
}

BOOL CCommandSetSafety_VCS_Configuration::VCS_GetMaxFollowingError(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulMaxFollowingError, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetMaxFollowingError)
    {
        //Set parameter data
        m_pCommand_GetMaxFollowingError->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetMaxFollowingError->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetMaxFollowingError->GetReturnParameterData(0, p_pulMaxFollowingError, sizeof(*p_pulMaxFollowingError));

        //Get error code
        m_pCommand_GetMaxFollowingError->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSafety_VCS_Configuration::VCS_SetMaxFollowingError(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulMaxFollowingError, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetMaxFollowingError)
    {
        //Set parameter data
        m_pCommand_SetMaxFollowingError->ResetStatus();
        m_pCommand_SetMaxFollowingError->SetParameterData(0, &p_ulMaxFollowingError, sizeof(p_ulMaxFollowingError));

        //Execute command
        oResult = m_pCommand_SetMaxFollowingError->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetMaxFollowingError->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSafety_VCS_Configuration::VCS_GetMaxProfileVelocity(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulMaxProfileVelocity, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetMaxProfileVelocity)
    {
        //Set parameter data
        m_pCommand_GetMaxProfileVelocity->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetMaxProfileVelocity->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetMaxProfileVelocity->GetReturnParameterData(0, p_pulMaxProfileVelocity, sizeof(*p_pulMaxProfileVelocity));

        //Get error code
        m_pCommand_GetMaxProfileVelocity->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSafety_VCS_Configuration::VCS_SetMaxProfileVelocity(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulMaxProfileVelocity, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetMaxProfileVelocity)
    {
        //Set parameter data
        m_pCommand_SetMaxProfileVelocity->ResetStatus();
        m_pCommand_SetMaxProfileVelocity->SetParameterData(0, &p_ulMaxProfileVelocity, sizeof(p_ulMaxProfileVelocity));

        //Execute command
        oResult = m_pCommand_SetMaxProfileVelocity->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetMaxProfileVelocity->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSafety_VCS_Configuration::VCS_GetMaxAcceleration(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulMaxAcceleration, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetMaxAcceleration)
    {
        //Set parameter data
        m_pCommand_GetMaxAcceleration->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetMaxAcceleration->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetMaxAcceleration->GetReturnParameterData(0, p_pulMaxAcceleration, sizeof(*p_pulMaxAcceleration));

        //Get error code
        m_pCommand_GetMaxAcceleration->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSafety_VCS_Configuration::VCS_SetMaxAcceleration(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulMaxAcceleration, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetMaxAcceleration)
    {
        //Set parameter data
        m_pCommand_SetMaxAcceleration->ResetStatus();
        m_pCommand_SetMaxAcceleration->SetParameterData(0, &p_ulMaxAcceleration, sizeof(p_ulMaxAcceleration));

        //Execute command
        oResult = m_pCommand_SetMaxAcceleration->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetMaxAcceleration->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetSafety_VCS_Configuration::InitCommands()
{
    DeleteCommands();

    //Init GetMaxFollowingError
    m_pCommand_GetMaxFollowingError = new CCommand_VCS_Configuration();
    m_pCommand_GetMaxFollowingError->InitCommand(CONF_GET_MAX_FOLLOWING_ERROR);
    //Init SetMaxFollowingError
    m_pCommand_SetMaxFollowingError = new CCommand_VCS_Configuration();
    m_pCommand_SetMaxFollowingError->InitCommand(CONF_SET_MAX_FOLLOWING_ERROR);
    //Init GetMaxProfileVelocity
    m_pCommand_GetMaxProfileVelocity = new CCommand_VCS_Configuration();
    m_pCommand_GetMaxProfileVelocity->InitCommand(CONF_GET_MAX_PROFILE_VELOCITY);
    //Init SetMaxProfileVelocity
    m_pCommand_SetMaxProfileVelocity = new CCommand_VCS_Configuration();
    m_pCommand_SetMaxProfileVelocity->InitCommand(CONF_SET_MAX_PROFILE_VELOCITY);
    //Init GetMaxAcceleration
    m_pCommand_GetMaxAcceleration = new CCommand_VCS_Configuration();
    m_pCommand_GetMaxAcceleration->InitCommand(CONF_GET_MAX_ACCELERATION);
    //Init SetMaxAcceleration
    m_pCommand_SetMaxAcceleration = new CCommand_VCS_Configuration();
    m_pCommand_SetMaxAcceleration->InitCommand(CONF_SET_MAX_ACCELERATION);
}

void CCommandSetSafety_VCS_Configuration::DeleteCommands()
{
    if(m_pCommand_GetMaxFollowingError)
    {
        delete m_pCommand_GetMaxFollowingError;
        m_pCommand_GetMaxFollowingError = NULL;
    }
    if(m_pCommand_SetMaxFollowingError)
    {
        delete m_pCommand_SetMaxFollowingError;
        m_pCommand_SetMaxFollowingError = NULL;
    }
    if(m_pCommand_GetMaxProfileVelocity)
    {
        delete m_pCommand_GetMaxProfileVelocity;
        m_pCommand_GetMaxProfileVelocity = NULL;
    }
    if(m_pCommand_SetMaxProfileVelocity)
    {
        delete m_pCommand_SetMaxProfileVelocity;
        m_pCommand_SetMaxProfileVelocity = NULL;
    }
    if(m_pCommand_GetMaxAcceleration)
    {
        delete m_pCommand_GetMaxAcceleration;
        m_pCommand_GetMaxAcceleration = NULL;
    }
    if(m_pCommand_SetMaxAcceleration)
    {
        delete m_pCommand_SetMaxAcceleration;
        m_pCommand_SetMaxAcceleration = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetSafety_VCS_Configuration::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandSet");
        pElement->SetAt("Name", m_strCommandSetName);

        //Command elements
        if(m_pCommand_GetMaxFollowingError) m_pCommand_GetMaxFollowingError->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetMaxFollowingError) m_pCommand_SetMaxFollowingError->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetMaxProfileVelocity) m_pCommand_GetMaxProfileVelocity->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetMaxProfileVelocity) m_pCommand_SetMaxProfileVelocity->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetMaxAcceleration) m_pCommand_GetMaxAcceleration->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetMaxAcceleration) m_pCommand_SetMaxAcceleration->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetSafety_VCS_Configuration::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_GetMaxFollowingError) m_pCommand_GetMaxFollowingError->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetMaxFollowingError) m_pCommand_SetMaxFollowingError->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetMaxProfileVelocity) m_pCommand_GetMaxProfileVelocity->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetMaxProfileVelocity) m_pCommand_SetMaxProfileVelocity->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetMaxAcceleration) m_pCommand_GetMaxAcceleration->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetMaxAcceleration) m_pCommand_SetMaxAcceleration->InitJournalManager(p_pJournalManager);
}

void CCommandSetSafety_VCS_Configuration::ResetJournalManager()
{
    if(m_pCommand_GetMaxFollowingError) m_pCommand_GetMaxFollowingError->ResetJournalManager();
    if(m_pCommand_SetMaxFollowingError) m_pCommand_SetMaxFollowingError->ResetJournalManager();
    if(m_pCommand_GetMaxProfileVelocity) m_pCommand_GetMaxProfileVelocity->ResetJournalManager();
    if(m_pCommand_SetMaxProfileVelocity) m_pCommand_SetMaxProfileVelocity->ResetJournalManager();
    if(m_pCommand_GetMaxAcceleration) m_pCommand_GetMaxAcceleration->ResetJournalManager();
    if(m_pCommand_SetMaxAcceleration) m_pCommand_SetMaxAcceleration->ResetJournalManager();
}

BOOL CCommandSetSafety_VCS_Configuration::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_GetMaxFollowingError && !m_pCommand_GetMaxFollowingError->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetMaxFollowingError && !m_pCommand_SetMaxFollowingError->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetMaxProfileVelocity && !m_pCommand_GetMaxProfileVelocity->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetMaxProfileVelocity && !m_pCommand_SetMaxProfileVelocity->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetMaxAcceleration && !m_pCommand_GetMaxAcceleration->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetMaxAcceleration && !m_pCommand_SetMaxAcceleration->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
