
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_Configuration.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Configuration/CommandSetSensors_VCS_Configuration.h>

CCommandSetSensors_VCS_Configuration::CCommandSetSensors_VCS_Configuration()
{
    m_strCommandSetName = COMMAND_SET_CONFIGURATION_SENSOR;

    m_pCommand_GetEncoderParameter = NULL;
    m_pCommand_SetEncoderParameter = NULL;
    m_pCommand_GetSensorType = NULL;
    m_pCommand_SetSensorType = NULL;
    m_pCommand_GetIncEncoderParameter = NULL;
    m_pCommand_SetIncEncoderParameter = NULL;
    m_pCommand_GetHallSensorParameter = NULL;
    m_pCommand_SetHallSensorParameter = NULL;
    m_pCommand_GetSsiAbsEncoderParameter = NULL;
    m_pCommand_SetSsiAbsEncoderParameter = NULL;
    m_pCommand_GetSsiAbsEncoderParameterEx = NULL;
    m_pCommand_SetSsiAbsEncoderParameterEx = NULL;

    InitCommands();
}

CCommandSetSensors_VCS_Configuration::~CCommandSetSensors_VCS_Configuration()
{
    DeleteCommands();
}

BOOL CCommandSetSensors_VCS_Configuration::VCS_GetEncoderParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusCounts, WORD* p_pusPositionSensorType, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetEncoderParameter)
    {
        //Set parameter data
        m_pCommand_GetEncoderParameter->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetEncoderParameter->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetEncoderParameter->GetReturnParameterData(0, p_pusCounts, sizeof(*p_pusCounts));
        m_pCommand_GetEncoderParameter->GetReturnParameterData(1, p_pusPositionSensorType, sizeof(*p_pusPositionSensorType));

        //Get error code
        m_pCommand_GetEncoderParameter->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSensors_VCS_Configuration::VCS_GetSensorType(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusSensorType, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetSensorType)
    {
        //Set parameter data
        m_pCommand_GetSensorType->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetSensorType->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetSensorType->GetReturnParameterData(0, p_pusSensorType, sizeof(*p_pusSensorType));

        //Get error code
        m_pCommand_GetSensorType->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSensors_VCS_Configuration::VCS_GetIncEncoderParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulEncoderResolution, BOOL* p_poInvertedPolarity, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetIncEncoderParameter)
    {
        //Set parameter data
        m_pCommand_GetIncEncoderParameter->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetIncEncoderParameter->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetIncEncoderParameter->GetReturnParameterData(0, p_pulEncoderResolution, sizeof(*p_pulEncoderResolution));
        m_pCommand_GetIncEncoderParameter->GetReturnParameterData(1, p_poInvertedPolarity, sizeof(*p_poInvertedPolarity));

        //Get error code
        m_pCommand_GetIncEncoderParameter->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSensors_VCS_Configuration::VCS_GetHallSensorParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL* p_poInvertedPolarity, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetHallSensorParameter)
    {
        //Set parameter data
        m_pCommand_GetHallSensorParameter->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetHallSensorParameter->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetHallSensorParameter->GetReturnParameterData(0, p_poInvertedPolarity, sizeof(*p_poInvertedPolarity));

        //Get error code
        m_pCommand_GetHallSensorParameter->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSensors_VCS_Configuration::VCS_GetSsiAbsEncoderParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusDataRate, WORD* p_pusNbOfMultiTurnDataBits, WORD* p_pusNbOfSingleTurnDataBits, BOOL* p_poInvertedPolarity, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetSsiAbsEncoderParameter)
    {
        //Set parameter data
        m_pCommand_GetSsiAbsEncoderParameter->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetSsiAbsEncoderParameter->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetSsiAbsEncoderParameter->GetReturnParameterData(0, p_pusDataRate, sizeof(*p_pusDataRate));
        m_pCommand_GetSsiAbsEncoderParameter->GetReturnParameterData(1, p_pusNbOfMultiTurnDataBits, sizeof(*p_pusNbOfMultiTurnDataBits));
        m_pCommand_GetSsiAbsEncoderParameter->GetReturnParameterData(2, p_pusNbOfSingleTurnDataBits, sizeof(*p_pusNbOfSingleTurnDataBits));
        m_pCommand_GetSsiAbsEncoderParameter->GetReturnParameterData(3, p_poInvertedPolarity, sizeof(*p_poInvertedPolarity));

        //Get error code
        m_pCommand_GetSsiAbsEncoderParameter->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSensors_VCS_Configuration::VCS_GetSsiAbsEncoderParameterEx(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusDataRate, WORD* p_pusNbOfMultiTurnDataBits, WORD* p_pusNbOfSingleTurnDataBits, WORD* p_pusNbOfSpecialDataBits, BOOL* p_poInvertedPolarity, WORD* p_pusTimeout, WORD* p_pusPowerupTime, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if (m_pCommand_GetSsiAbsEncoderParameterEx)
    {
        //Set parameter data
        m_pCommand_GetSsiAbsEncoderParameterEx->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetSsiAbsEncoderParameterEx->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetSsiAbsEncoderParameterEx->GetReturnParameterData(0, p_pusDataRate, sizeof(*p_pusDataRate));
        m_pCommand_GetSsiAbsEncoderParameterEx->GetReturnParameterData(1, p_pusNbOfMultiTurnDataBits, sizeof(*p_pusNbOfMultiTurnDataBits));
        m_pCommand_GetSsiAbsEncoderParameterEx->GetReturnParameterData(2, p_pusNbOfSingleTurnDataBits, sizeof(*p_pusNbOfSingleTurnDataBits));
        m_pCommand_GetSsiAbsEncoderParameterEx->GetReturnParameterData(3, p_pusNbOfSpecialDataBits, sizeof(*p_pusNbOfSpecialDataBits));
        m_pCommand_GetSsiAbsEncoderParameterEx->GetReturnParameterData(4, p_poInvertedPolarity, sizeof(*p_poInvertedPolarity));
        m_pCommand_GetSsiAbsEncoderParameterEx->GetReturnParameterData(5, p_pusTimeout, sizeof(*p_pusTimeout));
        m_pCommand_GetSsiAbsEncoderParameterEx->GetReturnParameterData(6, p_pusPowerupTime, sizeof(*p_pusPowerupTime));

        //Get error code
        m_pCommand_GetSsiAbsEncoderParameterEx->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSensors_VCS_Configuration::VCS_SetEncoderParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usCounts, WORD p_usPositionSensorType, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetEncoderParameter)
    {
        //Set parameter data
        m_pCommand_SetEncoderParameter->ResetStatus();
        m_pCommand_SetEncoderParameter->SetParameterData(0, &p_usCounts, sizeof(p_usCounts));
        m_pCommand_SetEncoderParameter->SetParameterData(1, &p_usPositionSensorType, sizeof(p_usPositionSensorType));

        //Execute command
        oResult = m_pCommand_SetEncoderParameter->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetEncoderParameter->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSensors_VCS_Configuration::VCS_SetSensorType(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usSensorType, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetSensorType)
    {
        //Set parameter data
        m_pCommand_SetSensorType->ResetStatus();
        m_pCommand_SetSensorType->SetParameterData(0, &p_usSensorType, sizeof(p_usSensorType));

        //Execute command
        oResult = m_pCommand_SetSensorType->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetSensorType->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSensors_VCS_Configuration::VCS_SetIncEncoderParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulEncoderResolution, BOOL p_oInvertedPolarity, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetIncEncoderParameter)
    {
        //Set parameter data
        m_pCommand_SetIncEncoderParameter->ResetStatus();
        m_pCommand_SetIncEncoderParameter->SetParameterData(0, &p_ulEncoderResolution, sizeof(p_ulEncoderResolution));
        m_pCommand_SetIncEncoderParameter->SetParameterData(1, &p_oInvertedPolarity, sizeof(p_oInvertedPolarity));

        //Execute command
        oResult = m_pCommand_SetIncEncoderParameter->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetIncEncoderParameter->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSensors_VCS_Configuration::VCS_SetHallSensorParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL p_oInvertedPolarity, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetHallSensorParameter)
    {
        //Set parameter data
        m_pCommand_SetHallSensorParameter->ResetStatus();
        m_pCommand_SetHallSensorParameter->SetParameterData(0, &p_oInvertedPolarity, sizeof(p_oInvertedPolarity));

        //Execute command
        oResult = m_pCommand_SetHallSensorParameter->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetHallSensorParameter->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSensors_VCS_Configuration::VCS_SetSsiAbsEncoderParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usDataRate, WORD p_usNbOfMultiTurnDataBits, WORD p_usNbOfSingleTurnDataBits, BOOL p_oInvertedPolarity, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetSsiAbsEncoderParameter)
    {
        //Set parameter data
        m_pCommand_SetSsiAbsEncoderParameter->ResetStatus();
        m_pCommand_SetSsiAbsEncoderParameter->SetParameterData(0, &p_usDataRate, sizeof(p_usDataRate));
        m_pCommand_SetSsiAbsEncoderParameter->SetParameterData(1, &p_usNbOfMultiTurnDataBits, sizeof(p_usNbOfMultiTurnDataBits));
        m_pCommand_SetSsiAbsEncoderParameter->SetParameterData(2, &p_usNbOfSingleTurnDataBits, sizeof(p_usNbOfSingleTurnDataBits));
        m_pCommand_SetSsiAbsEncoderParameter->SetParameterData(3, &p_oInvertedPolarity, sizeof(p_oInvertedPolarity));

        //Execute command
        oResult = m_pCommand_SetSsiAbsEncoderParameter->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetSsiAbsEncoderParameter->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetSensors_VCS_Configuration::VCS_SetSsiAbsEncoderParameterEx(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usDataRate, WORD p_usNbOfMultiTurnDataBits, WORD p_usNbOfSingleTurnDataBits, WORD p_usNbOfSpecialDataBits, BOOL p_oInvertedPolarity, WORD p_usTimeout, WORD p_usPowertupTime, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if (m_pCommand_SetSsiAbsEncoderParameterEx)
    {
        //Set parameter data
        m_pCommand_SetSsiAbsEncoderParameterEx->ResetStatus();
        m_pCommand_SetSsiAbsEncoderParameterEx->SetParameterData(0, &p_usDataRate, sizeof(p_usDataRate));
        m_pCommand_SetSsiAbsEncoderParameterEx->SetParameterData(1, &p_usNbOfMultiTurnDataBits, sizeof(p_usNbOfMultiTurnDataBits));
        m_pCommand_SetSsiAbsEncoderParameterEx->SetParameterData(2, &p_usNbOfSingleTurnDataBits, sizeof(p_usNbOfSingleTurnDataBits));
        m_pCommand_SetSsiAbsEncoderParameterEx->SetParameterData(3, &p_usNbOfSpecialDataBits, sizeof(p_usNbOfSpecialDataBits));
        m_pCommand_SetSsiAbsEncoderParameterEx->SetParameterData(4, &p_oInvertedPolarity, sizeof(p_oInvertedPolarity));
        m_pCommand_SetSsiAbsEncoderParameterEx->SetParameterData(5, &p_usTimeout, sizeof(p_usTimeout));
        m_pCommand_SetSsiAbsEncoderParameterEx->SetParameterData(6, &p_usPowertupTime, sizeof(p_usPowertupTime));

        //Execute command
        oResult = m_pCommand_SetSsiAbsEncoderParameterEx->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetSsiAbsEncoderParameterEx->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetSensors_VCS_Configuration::InitCommands()
{
    DeleteCommands();

    //Init GetEncoderParameter
    m_pCommand_GetEncoderParameter = new CCommand_VCS_Configuration();
    m_pCommand_GetEncoderParameter->InitCommand(CONF_GET_ENCODER_PARAMETER);
    //Init SetEncoderParameter
    m_pCommand_SetEncoderParameter = new CCommand_VCS_Configuration();
    m_pCommand_SetEncoderParameter->InitCommand(CONF_SET_ENCODER_PARAMETER);
    //Init GetSensorType
    m_pCommand_GetSensorType = new CCommand_VCS_Configuration();
    m_pCommand_GetSensorType->InitCommand(CONF_GET_SENSOR_TYPE);
    //Init SetSensorType
    m_pCommand_SetSensorType = new CCommand_VCS_Configuration();
    m_pCommand_SetSensorType->InitCommand(CONF_SET_SENSOR_TYPE);
    //Init GetIncEncoderParameter
    m_pCommand_GetIncEncoderParameter = new CCommand_VCS_Configuration();
    m_pCommand_GetIncEncoderParameter->InitCommand(CONF_GET_INC_ENCODER_PARAMETER);
    //Init SetIncEncoderParameter
    m_pCommand_SetIncEncoderParameter = new CCommand_VCS_Configuration();
    m_pCommand_SetIncEncoderParameter->InitCommand(CONF_SET_INC_ENCODER_PARAMETER);
    //Init GetHallSensorParameter
    m_pCommand_GetHallSensorParameter = new CCommand_VCS_Configuration();
    m_pCommand_GetHallSensorParameter->InitCommand(CONF_GET_HALL_SENSOR_PARAMETER);
    //Init SetHallSensorParameter
    m_pCommand_SetHallSensorParameter = new CCommand_VCS_Configuration();
    m_pCommand_SetHallSensorParameter->InitCommand(CONF_SET_HALL_SENSOR_PARAMETER);
    //Init GetSsiAbsEncoderParameter
    m_pCommand_GetSsiAbsEncoderParameter = new CCommand_VCS_Configuration();
    m_pCommand_GetSsiAbsEncoderParameter->InitCommand(CONF_GET_SSI_ABS_ENCODER_PARAMETER);
    //Init SetSsiAbsEncoderParameter
    m_pCommand_SetSsiAbsEncoderParameter = new CCommand_VCS_Configuration();
    m_pCommand_SetSsiAbsEncoderParameter->InitCommand(CONF_SET_SSI_ABS_ENCODER_PARAMETER);
    //Init GetSsiAbsEncoderParameterEx
    m_pCommand_GetSsiAbsEncoderParameterEx = new CCommand_VCS_Configuration();
    m_pCommand_GetSsiAbsEncoderParameterEx->InitCommand(CONF_GET_SSI_ABS_ENCODER_PARAMETER_EX);
    //Init SetSsiAbsEncoderParameterEx
    m_pCommand_SetSsiAbsEncoderParameterEx = new CCommand_VCS_Configuration();
    m_pCommand_SetSsiAbsEncoderParameterEx->InitCommand(CONF_SET_SSI_ABS_ENCODER_PARAMETER_EX);
}

void CCommandSetSensors_VCS_Configuration::DeleteCommands()
{
    if(m_pCommand_GetEncoderParameter)
    {
        delete m_pCommand_GetEncoderParameter;
        m_pCommand_GetEncoderParameter = NULL;
    }
    if(m_pCommand_SetEncoderParameter)
    {
        delete m_pCommand_SetEncoderParameter;
        m_pCommand_SetEncoderParameter = NULL;
    }
    if(m_pCommand_GetSensorType)
    {
        delete m_pCommand_GetSensorType;
        m_pCommand_GetSensorType = NULL;
    }
    if(m_pCommand_SetSensorType)
    {
        delete m_pCommand_SetSensorType;
        m_pCommand_SetSensorType = NULL;
    }
    if(m_pCommand_GetIncEncoderParameter)
    {
        delete m_pCommand_GetIncEncoderParameter;
        m_pCommand_GetIncEncoderParameter = NULL;
    }
    if(m_pCommand_SetIncEncoderParameter)
    {
        delete m_pCommand_SetIncEncoderParameter;
        m_pCommand_SetIncEncoderParameter = NULL;
    }
    if(m_pCommand_GetHallSensorParameter)
    {
        delete m_pCommand_GetHallSensorParameter;
        m_pCommand_GetHallSensorParameter = NULL;
    }
    if(m_pCommand_SetHallSensorParameter)
    {
        delete m_pCommand_SetHallSensorParameter;
        m_pCommand_SetHallSensorParameter = NULL;
    }
    if(m_pCommand_GetSsiAbsEncoderParameter)
    {
        delete m_pCommand_GetSsiAbsEncoderParameter;
        m_pCommand_GetSsiAbsEncoderParameter = NULL;
    }
    if(m_pCommand_SetSsiAbsEncoderParameter)
    {
        delete m_pCommand_SetSsiAbsEncoderParameter;
        m_pCommand_SetSsiAbsEncoderParameter = NULL;
    }
    if (m_pCommand_GetSsiAbsEncoderParameterEx)
    {
        delete m_pCommand_GetSsiAbsEncoderParameterEx;
        m_pCommand_GetSsiAbsEncoderParameterEx = NULL;
    }
    if (m_pCommand_SetSsiAbsEncoderParameterEx)
    {
        delete m_pCommand_SetSsiAbsEncoderParameterEx;
        m_pCommand_SetSsiAbsEncoderParameterEx = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetSensors_VCS_Configuration::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandSet");
        pElement->SetAt("Name", m_strCommandSetName);

        //Command elements
        if(m_pCommand_GetEncoderParameter) m_pCommand_GetEncoderParameter->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetEncoderParameter) m_pCommand_SetEncoderParameter->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetSensorType) m_pCommand_GetSensorType->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetSensorType) m_pCommand_SetSensorType->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetIncEncoderParameter) m_pCommand_GetIncEncoderParameter->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetIncEncoderParameter) m_pCommand_SetIncEncoderParameter->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetHallSensorParameter) m_pCommand_GetHallSensorParameter->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetHallSensorParameter) m_pCommand_SetHallSensorParameter->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetSsiAbsEncoderParameter) m_pCommand_GetSsiAbsEncoderParameter->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetSsiAbsEncoderParameter) m_pCommand_SetSsiAbsEncoderParameter->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if (m_pCommand_GetSsiAbsEncoderParameterEx) m_pCommand_GetSsiAbsEncoderParameterEx->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if (m_pCommand_SetSsiAbsEncoderParameterEx) m_pCommand_SetSsiAbsEncoderParameterEx->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetSensors_VCS_Configuration::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_GetEncoderParameter) m_pCommand_GetEncoderParameter->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetEncoderParameter) m_pCommand_SetEncoderParameter->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetSensorType) m_pCommand_GetSensorType->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetSensorType) m_pCommand_SetSensorType->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetIncEncoderParameter) m_pCommand_GetIncEncoderParameter->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetIncEncoderParameter) m_pCommand_SetIncEncoderParameter->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetHallSensorParameter) m_pCommand_GetHallSensorParameter->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetHallSensorParameter) m_pCommand_SetHallSensorParameter->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetSsiAbsEncoderParameter) m_pCommand_GetSsiAbsEncoderParameter->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetSsiAbsEncoderParameter) m_pCommand_SetSsiAbsEncoderParameter->InitJournalManager(p_pJournalManager);
    if (m_pCommand_GetSsiAbsEncoderParameterEx) m_pCommand_GetSsiAbsEncoderParameterEx->InitJournalManager(p_pJournalManager);
    if (m_pCommand_SetSsiAbsEncoderParameterEx) m_pCommand_SetSsiAbsEncoderParameterEx->InitJournalManager(p_pJournalManager);
}

void CCommandSetSensors_VCS_Configuration::ResetJournalManager()
{
    if(m_pCommand_GetEncoderParameter) m_pCommand_GetEncoderParameter->ResetJournalManager();
    if(m_pCommand_SetEncoderParameter) m_pCommand_SetEncoderParameter->ResetJournalManager();
    if(m_pCommand_GetSensorType) m_pCommand_GetSensorType->ResetJournalManager();
    if(m_pCommand_SetSensorType) m_pCommand_SetSensorType->ResetJournalManager();
    if(m_pCommand_GetIncEncoderParameter) m_pCommand_GetIncEncoderParameter->ResetJournalManager();
    if(m_pCommand_SetIncEncoderParameter) m_pCommand_SetIncEncoderParameter->ResetJournalManager();
    if(m_pCommand_GetHallSensorParameter) m_pCommand_GetHallSensorParameter->ResetJournalManager();
    if(m_pCommand_SetHallSensorParameter) m_pCommand_SetHallSensorParameter->ResetJournalManager();
    if(m_pCommand_GetSsiAbsEncoderParameter) m_pCommand_GetSsiAbsEncoderParameter->ResetJournalManager();
    if(m_pCommand_SetSsiAbsEncoderParameter) m_pCommand_SetSsiAbsEncoderParameter->ResetJournalManager();
    if (m_pCommand_GetSsiAbsEncoderParameterEx) m_pCommand_GetSsiAbsEncoderParameterEx->ResetJournalManager();
    if (m_pCommand_SetSsiAbsEncoderParameterEx) m_pCommand_SetSsiAbsEncoderParameterEx->ResetJournalManager();
}

BOOL CCommandSetSensors_VCS_Configuration::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_GetEncoderParameter && !m_pCommand_GetEncoderParameter->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetEncoderParameter && !m_pCommand_SetEncoderParameter->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetSensorType && !m_pCommand_GetSensorType->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetSensorType && !m_pCommand_SetSensorType->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetIncEncoderParameter && !m_pCommand_GetIncEncoderParameter->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetIncEncoderParameter && !m_pCommand_SetIncEncoderParameter->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetHallSensorParameter && !m_pCommand_GetHallSensorParameter->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetHallSensorParameter && !m_pCommand_SetHallSensorParameter->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetSsiAbsEncoderParameter && !m_pCommand_GetSsiAbsEncoderParameter->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetSsiAbsEncoderParameter && !m_pCommand_SetSsiAbsEncoderParameter->InitGateway(p_pGateway)) oResult = FALSE;
    if (oResult && m_pCommand_GetSsiAbsEncoderParameterEx && !m_pCommand_GetSsiAbsEncoderParameterEx->InitGateway(p_pGateway)) oResult = FALSE;
    if (oResult && m_pCommand_SetSsiAbsEncoderParameterEx && !m_pCommand_SetSsiAbsEncoderParameterEx->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
