
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_Motion.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Motion/CommandSetInfo_VCS_Motion.h>

CCommandSetInfo_VCS_Motion::CCommandSetInfo_VCS_Motion()
{
    m_strCommandSetName = COMMAND_SET_MOTION_INFO;

    m_pCommand_GetMovementState = NULL;
    m_pCommand_GetPositionIs = NULL;
    m_pCommand_GetCurrentIs = NULL;
    m_pCommand_GetVelocityIs = NULL;
    m_pCommand_GetCurrentIsAveraged = NULL;
    m_pCommand_GetVelocityIsAveraged = NULL;

    InitCommands();
}

CCommandSetInfo_VCS_Motion::~CCommandSetInfo_VCS_Motion()
{
    DeleteCommands();
}

BOOL CCommandSetInfo_VCS_Motion::VCS_GetMovementState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL* p_poTargetReached, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetMovementState)
    {
        //Set parameter data
        m_pCommand_GetMovementState->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetMovementState->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetMovementState->GetReturnParameterData(0, p_poTargetReached, sizeof(*p_poTargetReached));

        //Get error code
        m_pCommand_GetMovementState->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetInfo_VCS_Motion::VCS_GetPositionIs(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int* p_plPositionIs, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetPositionIs)
    {
        //Set parameter data
        m_pCommand_GetPositionIs->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetPositionIs->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetPositionIs->GetReturnParameterData(0, p_plPositionIs, sizeof(*p_plPositionIs));

        //Get error code
        m_pCommand_GetPositionIs->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetInfo_VCS_Motion::VCS_GetCurrentIs(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, short* p_psCurrentIs, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetCurrentIs)
    {
        //Set parameter data
        m_pCommand_GetCurrentIs->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetCurrentIs->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetCurrentIs->GetReturnParameterData(0, p_psCurrentIs, sizeof(*p_psCurrentIs));

        //Get error code
        m_pCommand_GetCurrentIs->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetInfo_VCS_Motion::VCS_GetVelocityIs(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int* p_plVelocityIs, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetVelocityIs)
    {
        //Set parameter data
        m_pCommand_GetVelocityIs->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetVelocityIs->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetVelocityIs->GetReturnParameterData(0, p_plVelocityIs, sizeof(*p_plVelocityIs));

        //Get error code
        m_pCommand_GetVelocityIs->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetInfo_VCS_Motion::VCS_GetCurrentIsAveraged(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, short* p_psCurrentIs, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetCurrentIsAveraged)
    {
        //Set parameter data
        m_pCommand_GetCurrentIsAveraged->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetCurrentIsAveraged->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetCurrentIsAveraged->GetReturnParameterData(0, p_psCurrentIs, sizeof(*p_psCurrentIs));

        //Get error code
        m_pCommand_GetCurrentIsAveraged->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetInfo_VCS_Motion::VCS_GetVelocityIsAveraged(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int* p_plVelocityIs, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetVelocityIsAveraged)
    {
        //Set parameter data
        m_pCommand_GetVelocityIsAveraged->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetVelocityIsAveraged->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetVelocityIsAveraged->GetReturnParameterData(0, p_plVelocityIs, sizeof(*p_plVelocityIs));

        //Get error code
        m_pCommand_GetVelocityIsAveraged->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetInfo_VCS_Motion::InitCommands()
{
    DeleteCommands();

    //Init GetMovementState
    m_pCommand_GetMovementState = new CCommand_VCS_Motion();
    m_pCommand_GetMovementState->InitCommand(MOTION_GET_MOVEMENT_STATE);

    //Init GetPositionIs
    m_pCommand_GetPositionIs = new CCommand_VCS_Motion();
    m_pCommand_GetPositionIs->InitCommand(MOTION_GET_POSITION_IS);

    //Init GetCurrentIs
    m_pCommand_GetCurrentIs = new CCommand_VCS_Motion();
    m_pCommand_GetCurrentIs->InitCommand(MOTION_GET_CURRENT_IS);

    //Init GetVelocityIs
    m_pCommand_GetVelocityIs = new CCommand_VCS_Motion();
    m_pCommand_GetVelocityIs->InitCommand(MOTION_GET_VELOCITY_IS);

    //Init GetCurrentIsAveraged
    m_pCommand_GetCurrentIsAveraged = new CCommand_VCS_Motion();
    m_pCommand_GetCurrentIsAveraged->InitCommand(MOTION_GET_CURRENT_IS_AVERAGED);

    //Init GetVelocityIs
    m_pCommand_GetVelocityIsAveraged = new CCommand_VCS_Motion();
    m_pCommand_GetVelocityIsAveraged->InitCommand(MOTION_GET_VELOCITY_IS_AVERAGED);
}

void CCommandSetInfo_VCS_Motion::DeleteCommands()
{
    if(m_pCommand_GetMovementState)
    {
        delete m_pCommand_GetMovementState;
        m_pCommand_GetMovementState = NULL;
    }

    if(m_pCommand_GetPositionIs)
    {
        delete m_pCommand_GetPositionIs;
        m_pCommand_GetPositionIs = NULL;
    }

    if(m_pCommand_GetCurrentIs)
    {
        delete m_pCommand_GetCurrentIs;
        m_pCommand_GetCurrentIs = NULL;
    }

    if(m_pCommand_GetVelocityIs)
    {
        delete m_pCommand_GetVelocityIs;
        m_pCommand_GetVelocityIs = NULL;
    }

    if(m_pCommand_GetCurrentIsAveraged)
    {
        delete m_pCommand_GetCurrentIsAveraged;
        m_pCommand_GetCurrentIsAveraged = NULL;
    }

    if(m_pCommand_GetVelocityIsAveraged)
    {
        delete m_pCommand_GetVelocityIsAveraged;
        m_pCommand_GetVelocityIsAveraged = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetInfo_VCS_Motion::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement = NULL;

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandSet");
        pElement->SetAt("Name", m_strCommandSetName);

        //Command elements
        if(m_pCommand_GetMovementState) m_pCommand_GetMovementState->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetCurrentIs) m_pCommand_GetCurrentIs->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetCurrentIsAveraged) m_pCommand_GetCurrentIsAveraged->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetPositionIs) m_pCommand_GetPositionIs->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetVelocityIs) m_pCommand_GetVelocityIs->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetVelocityIsAveraged) m_pCommand_GetVelocityIsAveraged->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetInfo_VCS_Motion::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_GetMovementState) m_pCommand_GetMovementState->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetPositionIs) m_pCommand_GetPositionIs->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetCurrentIs) m_pCommand_GetCurrentIs->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetVelocityIs) m_pCommand_GetVelocityIs->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetCurrentIsAveraged) m_pCommand_GetCurrentIsAveraged->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetVelocityIsAveraged) m_pCommand_GetVelocityIsAveraged->InitJournalManager(p_pJournalManager);
}

void CCommandSetInfo_VCS_Motion::ResetJournalManager()
{
    if(m_pCommand_GetMovementState) m_pCommand_GetMovementState->ResetJournalManager();
    if(m_pCommand_GetPositionIs) m_pCommand_GetPositionIs->ResetJournalManager();
    if(m_pCommand_GetCurrentIs) m_pCommand_GetCurrentIs->ResetJournalManager();
    if(m_pCommand_GetVelocityIs) m_pCommand_GetVelocityIs->ResetJournalManager();
    if(m_pCommand_GetCurrentIsAveraged) m_pCommand_GetCurrentIsAveraged->ResetJournalManager();
    if(m_pCommand_GetVelocityIsAveraged) m_pCommand_GetVelocityIsAveraged->ResetJournalManager();
}

BOOL CCommandSetInfo_VCS_Motion::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_GetMovementState && !m_pCommand_GetMovementState->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetPositionIs && !m_pCommand_GetPositionIs->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetCurrentIs && !m_pCommand_GetCurrentIs->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetVelocityIs && !m_pCommand_GetVelocityIs->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetCurrentIsAveraged && !m_pCommand_GetCurrentIsAveraged->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetVelocityIsAveraged && !m_pCommand_GetVelocityIsAveraged->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
