
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_OperationMode.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetCurrentMode_VCS_OperationMode.h>

CCommandSetCurrentMode_VCS_OperationMode::CCommandSetCurrentMode_VCS_OperationMode()
{
    m_strCommandSetName = COMMAND_SET_OPERATION_MODE_CURRENT_MODE;

    m_pCommand_GetCurrentMust = NULL;
    m_pCommand_SetCurrentMust = NULL;

    InitCommands();
}

CCommandSetCurrentMode_VCS_OperationMode::~CCommandSetCurrentMode_VCS_OperationMode()
{
    DeleteCommands();
}

BOOL CCommandSetCurrentMode_VCS_OperationMode::VCS_GetCurrentMust(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, short* p_psCurrentMust, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetCurrentMust)
    {
        //Set parameter data
        m_pCommand_GetCurrentMust->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetCurrentMust->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetCurrentMust->GetReturnParameterData(0, p_psCurrentMust, sizeof(*p_psCurrentMust));

        //Get error code
        m_pCommand_GetCurrentMust->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetCurrentMode_VCS_OperationMode::VCS_SetCurrentMust(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, short p_sCurrentMust, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetCurrentMust)
    {
        //Set parameter data
        m_pCommand_SetCurrentMust->ResetStatus();
        m_pCommand_SetCurrentMust->SetParameterData(0, &p_sCurrentMust, sizeof(p_sCurrentMust));

        //Execute command
        oResult = m_pCommand_SetCurrentMust->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetCurrentMust->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetCurrentMode_VCS_OperationMode::InitCommands()
{
    DeleteCommands();

    //Init GetCurrentMust
    m_pCommand_GetCurrentMust = new CCommand_VCS_OperationMode();
    m_pCommand_GetCurrentMust->InitCommand(MODE_CUM_GET_CURRENT_MUST);
    //Init SetCurrentMust
    m_pCommand_SetCurrentMust = new CCommand_VCS_OperationMode();
    m_pCommand_SetCurrentMust->InitCommand(MODE_CUM_SET_CURRENT_MUST);
}

void CCommandSetCurrentMode_VCS_OperationMode::DeleteCommands()
{
    if(m_pCommand_GetCurrentMust)
    {
        delete m_pCommand_GetCurrentMust;
        m_pCommand_GetCurrentMust = NULL;
    }
    if(m_pCommand_SetCurrentMust)
    {
        delete m_pCommand_SetCurrentMust;
        m_pCommand_SetCurrentMust = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetCurrentMode_VCS_OperationMode::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pParentElement;

        //Command elements
        if(m_pCommand_GetCurrentMust) m_pCommand_GetCurrentMust->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetCurrentMust) m_pCommand_SetCurrentMust->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetCurrentMode_VCS_OperationMode::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_GetCurrentMust) m_pCommand_GetCurrentMust->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetCurrentMust) m_pCommand_SetCurrentMust->InitJournalManager(p_pJournalManager);
}

void CCommandSetCurrentMode_VCS_OperationMode::ResetJournalManager()
{
    if(m_pCommand_GetCurrentMust) m_pCommand_GetCurrentMust->ResetJournalManager();
    if(m_pCommand_SetCurrentMust) m_pCommand_SetCurrentMust->ResetJournalManager();
}

BOOL CCommandSetCurrentMode_VCS_OperationMode::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_GetCurrentMust && !m_pCommand_GetCurrentMust->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetCurrentMust && !m_pCommand_SetCurrentMust->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
