
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_OperationMode.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetCurrentPulseMode_VCS_OperationMode.h>

CCommandSetCurrentPulseMode_VCS_OperationMode::CCommandSetCurrentPulseMode_VCS_OperationMode()
{
    m_strCommandSetName = COMMAND_SET_OPERATION_MODE_CURRENT_PULSE_MODE;

    m_pCommand_DoCurrentPulse = NULL;

    InitCommands();
}

CCommandSetCurrentPulseMode_VCS_OperationMode::~CCommandSetCurrentPulseMode_VCS_OperationMode()
{
    DeleteCommands();
}

BOOL CCommandSetCurrentPulseMode_VCS_OperationMode::VCS_DoCurrentPulse(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_DoCurrentPulse)
    {
        //Set parameter data
        m_pCommand_DoCurrentPulse->ResetStatus();

        //Execute command
        oResult = m_pCommand_DoCurrentPulse->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_DoCurrentPulse->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetCurrentPulseMode_VCS_OperationMode::InitCommands()
{
    DeleteCommands();

    //Init GetCurrentMust
    m_pCommand_DoCurrentPulse = new CCommand_VCS_OperationMode();
    m_pCommand_DoCurrentPulse->InitCommand(MODE_CPM_DO_CURRENT_PULSE);
}

void CCommandSetCurrentPulseMode_VCS_OperationMode::DeleteCommands()
{
    if(m_pCommand_DoCurrentPulse)
    {
        delete m_pCommand_DoCurrentPulse;
        m_pCommand_DoCurrentPulse = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetCurrentPulseMode_VCS_OperationMode::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandSet");
        pElement->SetAt("Name", m_strCommandSetName);

        //Command elements
        if(m_pCommand_DoCurrentPulse) m_pCommand_DoCurrentPulse->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetCurrentPulseMode_VCS_OperationMode::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_DoCurrentPulse) m_pCommand_DoCurrentPulse->InitJournalManager(p_pJournalManager);
}

void CCommandSetCurrentPulseMode_VCS_OperationMode::ResetJournalManager()
{
    if(m_pCommand_DoCurrentPulse) m_pCommand_DoCurrentPulse->ResetJournalManager();
}

BOOL CCommandSetCurrentPulseMode_VCS_OperationMode::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_DoCurrentPulse && !m_pCommand_DoCurrentPulse->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
