
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_OperationMode.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetCyclicSyncTorqueMode_VCS_OperationMode.h>

CCommandSetCyclicSyncTorqueMode_VCS_OperationMode::CCommandSetCyclicSyncTorqueMode_VCS_OperationMode()
{
    m_strCommandSetName = COMMAND_SET_OPERATION_MODE_CYCLIC_SYNC_TORQUE_MODE;

    m_pCommand_InitCyclicSyncTorqueMode = 0;
    m_pCommand_GetTargetTorque = 0;
    m_pCommand_SetTargetTorque = 0;
    m_pCommand_GetTorqueIs = 0;

    InitCommands();
}

CCommandSetCyclicSyncTorqueMode_VCS_OperationMode::~CCommandSetCyclicSyncTorqueMode_VCS_OperationMode()
{
    DeleteCommands();
}

BOOL CCommandSetCyclicSyncTorqueMode_VCS_OperationMode::VCS_InitCyclicSyncTorqueMode(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usNominalCurrent, DWORD p_ulTorqueConstant, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult(FALSE);

    if(m_pCommand_InitCyclicSyncTorqueMode)
    {
        //Set parameter data
        m_pCommand_InitCyclicSyncTorqueMode->ResetStatus();
        m_pCommand_InitCyclicSyncTorqueMode->SetParameterData(0, &p_usNominalCurrent, sizeof(p_usNominalCurrent));
        m_pCommand_InitCyclicSyncTorqueMode->SetParameterData(1, &p_ulTorqueConstant, sizeof(p_ulTorqueConstant));

        //Execute command
        oResult = m_pCommand_InitCyclicSyncTorqueMode->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_InitCyclicSyncTorqueMode->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetCyclicSyncTorqueMode_VCS_OperationMode::VCS_SetTargetTorque(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usTargetCurrent, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult(FALSE);

    if(m_pCommand_SetTargetTorque)
    {
        //Set parameter data
        m_pCommand_SetTargetTorque->ResetStatus();
        m_pCommand_SetTargetTorque->SetParameterData(0, &p_usTargetCurrent, sizeof(p_usTargetCurrent));

        //Execute command
        oResult = m_pCommand_SetTargetTorque->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetTargetTorque->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetCyclicSyncTorqueMode_VCS_OperationMode::VCS_GetTargetTorque(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusTargetCurrent, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult(FALSE);

    if(m_pCommand_GetTargetTorque)
    {
        //Set parameter data
        m_pCommand_GetTargetTorque->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetTargetTorque->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetTargetTorque->GetReturnParameterData(0, p_pusTargetCurrent, sizeof(*p_pusTargetCurrent));

        //Get error code
        m_pCommand_GetTargetTorque->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetCyclicSyncTorqueMode_VCS_OperationMode::VCS_GetTorqueIs(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusCurrentIs, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult(FALSE);

    if(m_pCommand_GetTorqueIs)
    {
        //Set parameter data
        m_pCommand_GetTorqueIs->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetTorqueIs->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetTorqueIs->GetReturnParameterData(0, p_pusCurrentIs, sizeof(*p_pusCurrentIs));

        //Get error code
        m_pCommand_GetTorqueIs->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetCyclicSyncTorqueMode_VCS_OperationMode::InitCommands()
{
    DeleteCommands();

    m_pCommand_InitCyclicSyncTorqueMode = new CCommand_VCS_OperationMode();
    m_pCommand_InitCyclicSyncTorqueMode->InitCommand(MODE_CST_INIT_CYCLIC_SYNC_TORQUE_MODE);

    m_pCommand_GetTargetTorque = new CCommand_VCS_OperationMode();
    m_pCommand_GetTargetTorque->InitCommand(MODE_CST_GET_TARGET_TORQUE);

    m_pCommand_SetTargetTorque = new CCommand_VCS_OperationMode();
    m_pCommand_SetTargetTorque->InitCommand(MODE_CST_SET_TARGET_TORQUE);

    m_pCommand_GetTorqueIs = new CCommand_VCS_OperationMode();
    m_pCommand_GetTorqueIs->InitCommand(MODE_CST_GET_TORQUE_IS);
}

void CCommandSetCyclicSyncTorqueMode_VCS_OperationMode::DeleteCommands()
{
    if(m_pCommand_InitCyclicSyncTorqueMode)
    {
        delete m_pCommand_InitCyclicSyncTorqueMode;
        m_pCommand_InitCyclicSyncTorqueMode = NULL;
    }
    if(m_pCommand_GetTargetTorque)
    {
        delete m_pCommand_GetTargetTorque;
        m_pCommand_GetTargetTorque = NULL;
    }
    if(m_pCommand_SetTargetTorque)
    {
        delete m_pCommand_SetTargetTorque;
        m_pCommand_SetTargetTorque = NULL;
    }
    if(m_pCommand_GetTorqueIs)
    {
        delete m_pCommand_GetTorqueIs;
        m_pCommand_GetTorqueIs = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetCyclicSyncTorqueMode_VCS_OperationMode::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandSet");
        pElement->SetAt("Name", m_strCommandSetName);

        //Command elements
        if(m_pCommand_InitCyclicSyncTorqueMode) m_pCommand_InitCyclicSyncTorqueMode->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetTargetTorque) m_pCommand_GetTargetTorque->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetTargetTorque) m_pCommand_SetTargetTorque->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetTorqueIs) m_pCommand_GetTorqueIs->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetCyclicSyncTorqueMode_VCS_OperationMode::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_InitCyclicSyncTorqueMode) m_pCommand_InitCyclicSyncTorqueMode->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetTargetTorque) m_pCommand_GetTargetTorque->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetTargetTorque) m_pCommand_SetTargetTorque->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetTorqueIs) m_pCommand_GetTorqueIs->InitJournalManager(p_pJournalManager);
}

void CCommandSetCyclicSyncTorqueMode_VCS_OperationMode::ResetJournalManager()
{
    if(m_pCommand_InitCyclicSyncTorqueMode) m_pCommand_InitCyclicSyncTorqueMode->ResetJournalManager();
    if(m_pCommand_GetTargetTorque) m_pCommand_GetTargetTorque->ResetJournalManager();
    if(m_pCommand_SetTargetTorque) m_pCommand_SetTargetTorque->ResetJournalManager();
    if(m_pCommand_GetTorqueIs) m_pCommand_GetTorqueIs->ResetJournalManager();
}

BOOL CCommandSetCyclicSyncTorqueMode_VCS_OperationMode::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_InitCyclicSyncTorqueMode && !m_pCommand_InitCyclicSyncTorqueMode->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetTargetTorque && !m_pCommand_GetTargetTorque->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetTargetTorque && !m_pCommand_SetTargetTorque->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetTorqueIs && !m_pCommand_GetTorqueIs->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
