
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_OperationMode.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetPositionMode_VCS_OperationMode.h>

CCommandSetPositionMode_VCS_OperationMode::CCommandSetPositionMode_VCS_OperationMode()
{
    m_strCommandSetName = COMMAND_SET_OPERATION_MODE_POSITION_MODE;

    m_pCommand_GetPositionMust = NULL;
    m_pCommand_SetPositionMust = NULL;

    InitCommands();
}

CCommandSetPositionMode_VCS_OperationMode::~CCommandSetPositionMode_VCS_OperationMode()
{
    DeleteCommands();
}

BOOL CCommandSetPositionMode_VCS_OperationMode::VCS_GetPositionMust(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, short* p_psPositionMust, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetPositionMust)
    {
        //Set parameter data
        m_pCommand_GetPositionMust->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetPositionMust->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetPositionMust->GetReturnParameterData(0, p_psPositionMust, sizeof(p_psPositionMust));

        //Get error code
        m_pCommand_GetPositionMust->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetPositionMode_VCS_OperationMode::VCS_SetPositionMust(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, short p_sPositionMust, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetPositionMust)
    {
        //Set parameter data
        m_pCommand_SetPositionMust->ResetStatus();
        m_pCommand_SetPositionMust->SetParameterData(0, &p_sPositionMust, sizeof(p_sPositionMust));

        //Execute command
        oResult = m_pCommand_SetPositionMust->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetPositionMust->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetPositionMode_VCS_OperationMode::InitCommands()
{
    DeleteCommands();

    //Init GetPositionMust
    m_pCommand_GetPositionMust = new CCommand_VCS_OperationMode();
    m_pCommand_GetPositionMust->InitCommand(MODE_POM_GET_POSITION_MUST);
    //Init SetPostionMust
    m_pCommand_SetPositionMust = new CCommand_VCS_OperationMode();
    m_pCommand_SetPositionMust->InitCommand(MODE_POM_SET_POSITION_MUST);
}

void CCommandSetPositionMode_VCS_OperationMode::DeleteCommands()
{
    if(m_pCommand_GetPositionMust)
    {
        delete m_pCommand_GetPositionMust;
        m_pCommand_GetPositionMust = NULL;
    }
    if(m_pCommand_SetPositionMust)
    {
        delete m_pCommand_SetPositionMust;
        m_pCommand_SetPositionMust = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetPositionMode_VCS_OperationMode::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pParentElement;

        //Command elements
        if(m_pCommand_GetPositionMust) m_pCommand_GetPositionMust->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetPositionMust) m_pCommand_SetPositionMust->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetPositionMode_VCS_OperationMode::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_GetPositionMust) m_pCommand_GetPositionMust->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetPositionMust) m_pCommand_SetPositionMust->InitJournalManager(p_pJournalManager);
}

void CCommandSetPositionMode_VCS_OperationMode::ResetJournalManager()
{
    if(m_pCommand_GetPositionMust) m_pCommand_GetPositionMust->ResetJournalManager();
    if(m_pCommand_SetPositionMust) m_pCommand_SetPositionMust->ResetJournalManager();
}

BOOL CCommandSetPositionMode_VCS_OperationMode::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_GetPositionMust && !m_pCommand_GetPositionMust->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetPositionMust && !m_pCommand_SetPositionMust->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
