
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_OperationMode.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetProfileVelocityMode_VCS_OperationMode.h>

CCommandSetProfileVelocityMode_VCS_OperationMode::CCommandSetProfileVelocityMode_VCS_OperationMode()
{
    m_strCommandSetName = COMMAND_SET_OPERATION_MODE_PROFILE_VELOCITY_MODE;

    m_pCommand_GetTargetVelocity = NULL;
    m_pCommand_GetVelocityProfile = NULL;
    m_pCommand_HaltVelocityMovement = NULL;
    m_pCommand_MoveWithVelocity = NULL;
    m_pCommand_SetVelocityProfile = NULL;
    m_pCommand_EnableVelocityWindow = NULL;
    m_pCommand_DisableVelocityWindow = NULL;

    InitCommands();
}

CCommandSetProfileVelocityMode_VCS_OperationMode::~CCommandSetProfileVelocityMode_VCS_OperationMode()
{
    DeleteCommands();
}

BOOL CCommandSetProfileVelocityMode_VCS_OperationMode::VCS_GetTargetVelocity(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int* p_plTargetVelocity, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetTargetVelocity)
    {
        //Set parameter data
        m_pCommand_GetTargetVelocity->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetTargetVelocity->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetTargetVelocity->GetReturnParameterData(0, p_plTargetVelocity, sizeof(*p_plTargetVelocity));

        //Get error code
        m_pCommand_GetTargetVelocity->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetProfileVelocityMode_VCS_OperationMode::VCS_GetVelocityProfile(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pdProfileAcceleration, DWORD* p_pdProfileDeceleration, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetVelocityProfile)
    {
        //Set parameter data
        m_pCommand_GetVelocityProfile->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetVelocityProfile->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetVelocityProfile->GetReturnParameterData(0, p_pdProfileAcceleration, sizeof(*p_pdProfileAcceleration));
        m_pCommand_GetVelocityProfile->GetReturnParameterData(1, p_pdProfileDeceleration, sizeof(*p_pdProfileDeceleration));

        //Get error code
        m_pCommand_GetVelocityProfile->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetProfileVelocityMode_VCS_OperationMode::VCS_HaltVelocityMovement(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_HaltVelocityMovement)
    {
        //Set parameter data
        m_pCommand_HaltVelocityMovement->ResetStatus();

        //Execute command
        oResult = m_pCommand_HaltVelocityMovement->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_HaltVelocityMovement->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetProfileVelocityMode_VCS_OperationMode::VCS_MoveWithVelocity(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int p_lTargetVelocity, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_MoveWithVelocity)
    {
        //Set parameter data
        m_pCommand_MoveWithVelocity->ResetStatus();
        m_pCommand_MoveWithVelocity->SetParameterData(0, &p_lTargetVelocity, sizeof(p_lTargetVelocity));

        //Execute command
        oResult = m_pCommand_HaltVelocityMovement->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_MoveWithVelocity->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetProfileVelocityMode_VCS_OperationMode::VCS_SetVelocityProfile(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulProfileAcceleration, DWORD p_ulProfileDeceleration, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetVelocityProfile)
    {
        //Set parameter data
        m_pCommand_SetVelocityProfile->ResetStatus();
        m_pCommand_SetVelocityProfile->SetParameterData(0, &p_ulProfileAcceleration, sizeof(p_ulProfileAcceleration));
        m_pCommand_SetVelocityProfile->SetParameterData(1, &p_ulProfileDeceleration, sizeof(p_ulProfileDeceleration));

        //Execute command
        oResult = m_pCommand_HaltVelocityMovement->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetVelocityProfile->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetProfileVelocityMode_VCS_OperationMode::VCS_EnableVelocityWindow(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulVelocityWindow, WORD p_usVelocityWindowTime, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_EnableVelocityWindow)
    {
        //Set parameter data
        m_pCommand_EnableVelocityWindow->ResetStatus();
        m_pCommand_EnableVelocityWindow->SetParameterData(0, &p_ulVelocityWindow, sizeof(p_ulVelocityWindow));
        m_pCommand_EnableVelocityWindow->SetParameterData(1, &p_usVelocityWindowTime, sizeof(p_usVelocityWindowTime));

        //Execute command
        oResult = m_pCommand_EnableVelocityWindow->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_EnableVelocityWindow->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetProfileVelocityMode_VCS_OperationMode::VCS_DisableVelocityWindow(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_DisableVelocityWindow)
    {
        //Set parameter data
        m_pCommand_DisableVelocityWindow->ResetStatus();

        //Execute command
        oResult = m_pCommand_DisableVelocityWindow->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_DisableVelocityWindow->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetProfileVelocityMode_VCS_OperationMode::InitCommands()
{
    DeleteCommands();

    //Init GetTargetVelocity
    m_pCommand_GetTargetVelocity = new CCommand_VCS_OperationMode();
    m_pCommand_GetTargetVelocity->InitCommand(MODE_PVM_GET_TARGET_VELOCITY);
    //Init GetVelocityProfile
    m_pCommand_GetVelocityProfile = new CCommand_VCS_OperationMode();
    m_pCommand_GetVelocityProfile->InitCommand(MODE_PVM_GET_VELOCITY_PROFILE);
    //Init HaltVelocityMovement
    m_pCommand_HaltVelocityMovement = new CCommand_VCS_OperationMode();
    m_pCommand_HaltVelocityMovement->InitCommand(MODE_PVM_HALT_VELOCITY_MOVEMENT);
    //Init MoveWithVelocity
    m_pCommand_MoveWithVelocity = new CCommand_VCS_OperationMode();
    m_pCommand_MoveWithVelocity->InitCommand(MODE_PVM_MOVE_WITH_VELOCITY);
    //Init SetVelocityProfile
    m_pCommand_SetVelocityProfile = new CCommand_VCS_OperationMode();
    m_pCommand_SetVelocityProfile->InitCommand(MODE_PVM_SET_VELOCITY_PROFILE);
    //Init EnableVelocityWindow
    m_pCommand_EnableVelocityWindow = new CCommand_VCS_OperationMode();
    m_pCommand_EnableVelocityWindow->InitCommand(MODE_PVM_ENABLE_VELOCITY_WINDOW);
    //Init DisableVelocityWindow
    m_pCommand_DisableVelocityWindow = new CCommand_VCS_OperationMode();
    m_pCommand_DisableVelocityWindow->InitCommand(MODE_PVM_DISABLE_VELOCITY_WINDOW);
}

void CCommandSetProfileVelocityMode_VCS_OperationMode::DeleteCommands()
{
    if(m_pCommand_GetTargetVelocity)
    {
        delete m_pCommand_GetTargetVelocity;
        m_pCommand_GetTargetVelocity = NULL;
    }
    if(m_pCommand_GetVelocityProfile)
    {
        delete m_pCommand_GetVelocityProfile;
        m_pCommand_GetVelocityProfile = NULL;
    }
    if(m_pCommand_HaltVelocityMovement)
    {
        delete m_pCommand_HaltVelocityMovement;
        m_pCommand_HaltVelocityMovement = NULL;
    }
    if(m_pCommand_MoveWithVelocity)
    {
        delete m_pCommand_MoveWithVelocity;
        m_pCommand_MoveWithVelocity = NULL;
    }
    if(m_pCommand_SetVelocityProfile)
    {
        delete m_pCommand_SetVelocityProfile;
        m_pCommand_SetVelocityProfile = NULL;
    }

    if(m_pCommand_EnableVelocityWindow)
    {
        delete m_pCommand_EnableVelocityWindow;
        m_pCommand_EnableVelocityWindow = NULL;
    }

    if(m_pCommand_DisableVelocityWindow)
    {
        delete m_pCommand_DisableVelocityWindow;
        m_pCommand_DisableVelocityWindow = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetProfileVelocityMode_VCS_OperationMode::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandSet");
        pElement->SetAt("Name", m_strCommandSetName);

        //Command elements
        if(m_pCommand_GetVelocityProfile) m_pCommand_GetVelocityProfile->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetVelocityProfile) m_pCommand_SetVelocityProfile->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetTargetVelocity) m_pCommand_GetTargetVelocity->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_MoveWithVelocity) m_pCommand_MoveWithVelocity->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_HaltVelocityMovement) m_pCommand_HaltVelocityMovement->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_EnableVelocityWindow) m_pCommand_EnableVelocityWindow->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_DisableVelocityWindow) m_pCommand_DisableVelocityWindow->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetProfileVelocityMode_VCS_OperationMode::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_GetTargetVelocity) m_pCommand_GetTargetVelocity->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetVelocityProfile) m_pCommand_GetVelocityProfile->InitJournalManager(p_pJournalManager);
    if(m_pCommand_HaltVelocityMovement) m_pCommand_HaltVelocityMovement->InitJournalManager(p_pJournalManager);
    if(m_pCommand_MoveWithVelocity) m_pCommand_MoveWithVelocity->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetVelocityProfile) m_pCommand_SetVelocityProfile->InitJournalManager(p_pJournalManager);
    if(m_pCommand_EnableVelocityWindow) m_pCommand_EnableVelocityWindow->InitJournalManager(p_pJournalManager);
    if(m_pCommand_DisableVelocityWindow) m_pCommand_DisableVelocityWindow->InitJournalManager(p_pJournalManager);
}

void CCommandSetProfileVelocityMode_VCS_OperationMode::ResetJournalManager()
{
    if(m_pCommand_GetTargetVelocity) m_pCommand_GetTargetVelocity->ResetJournalManager();
    if(m_pCommand_GetVelocityProfile) m_pCommand_GetVelocityProfile->ResetJournalManager();
    if(m_pCommand_HaltVelocityMovement) m_pCommand_HaltVelocityMovement->ResetJournalManager();
    if(m_pCommand_MoveWithVelocity) m_pCommand_MoveWithVelocity->ResetJournalManager();
    if(m_pCommand_SetVelocityProfile) m_pCommand_SetVelocityProfile->ResetJournalManager();
    if(m_pCommand_EnableVelocityWindow) m_pCommand_EnableVelocityWindow->ResetJournalManager();
    if(m_pCommand_DisableVelocityWindow) m_pCommand_DisableVelocityWindow->ResetJournalManager();
}

BOOL CCommandSetProfileVelocityMode_VCS_OperationMode::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_GetTargetVelocity && !m_pCommand_GetTargetVelocity->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetVelocityProfile && !m_pCommand_GetVelocityProfile->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_HaltVelocityMovement && !m_pCommand_HaltVelocityMovement->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_MoveWithVelocity && !m_pCommand_MoveWithVelocity->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetVelocityProfile && !m_pCommand_SetVelocityProfile->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_EnableVelocityWindow && !m_pCommand_EnableVelocityWindow->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_DisableVelocityWindow && !m_pCommand_DisableVelocityWindow->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
