
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_OperationMode.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetStepDirectionMode_VCS_OperationMode.h>

CCommandSetStepDirectionMode_VCS_OperationMode::CCommandSetStepDirectionMode_VCS_OperationMode()
{
    m_strCommandSetName = COMMAND_SET_OPERATION_MODE_STEP_DIRECTION_MODE;

    m_pCommand_GetStepDirectionParameter = NULL;
    m_pCommand_SetStepDirectionParameter = NULL;

    InitCommands();
}

CCommandSetStepDirectionMode_VCS_OperationMode::~CCommandSetStepDirectionMode_VCS_OperationMode()
{
    DeleteCommands();
}

BOOL CCommandSetStepDirectionMode_VCS_OperationMode::VCS_GetStepDirectionParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusScalingNumerator, WORD* p_pusScalingDenominator, BYTE* p_pubPolarity, DWORD* p_pulMaxVelocity, DWORD* p_pulMaxAcceleration, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetStepDirectionParameter)
    {
        //Set parameter data
        m_pCommand_GetStepDirectionParameter->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetStepDirectionParameter->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetStepDirectionParameter->GetReturnParameterData(0, p_pusScalingNumerator, sizeof(*p_pusScalingNumerator));
        m_pCommand_GetStepDirectionParameter->GetReturnParameterData(1, p_pusScalingDenominator, sizeof(*p_pusScalingDenominator));
        m_pCommand_GetStepDirectionParameter->GetReturnParameterData(2, p_pubPolarity, sizeof(*p_pubPolarity));
        m_pCommand_GetStepDirectionParameter->GetReturnParameterData(3, p_pulMaxVelocity, sizeof(*p_pulMaxVelocity));
        m_pCommand_GetStepDirectionParameter->GetReturnParameterData(4, p_pulMaxAcceleration, sizeof(*p_pulMaxAcceleration));

        //Get error code
        m_pCommand_GetStepDirectionParameter->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetStepDirectionMode_VCS_OperationMode::VCS_SetStepDirectionParameter(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usScalingNumerator, WORD p_usScalingDenominator, BYTE p_ubPolarity, DWORD p_ulMaxVelocity, DWORD p_ulMaxAcceleration, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetStepDirectionParameter)
    {
        //Set parameter data
        m_pCommand_SetStepDirectionParameter->ResetStatus();
        m_pCommand_SetStepDirectionParameter->SetParameterData(0, &p_usScalingNumerator, sizeof(p_usScalingNumerator));
        m_pCommand_SetStepDirectionParameter->SetParameterData(1, &p_usScalingDenominator, sizeof(p_usScalingDenominator));
        m_pCommand_SetStepDirectionParameter->SetParameterData(2, &p_ubPolarity, sizeof(p_ubPolarity));
        m_pCommand_SetStepDirectionParameter->SetParameterData(3, &p_ulMaxVelocity, sizeof(p_ulMaxVelocity));
        m_pCommand_SetStepDirectionParameter->SetParameterData(4, &p_ulMaxAcceleration, sizeof(p_ulMaxAcceleration));

        //Execute command
        oResult = m_pCommand_GetStepDirectionParameter->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetStepDirectionParameter->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetStepDirectionMode_VCS_OperationMode::InitCommands()
{
    DeleteCommands();

    //Init GetStepDirectionParameter
    m_pCommand_GetStepDirectionParameter = new CCommand_VCS_OperationMode();
    m_pCommand_GetStepDirectionParameter->InitCommand(MODE_STM_GET_STEP_DIRECTION_PARAMETER);

    //Init SetStepDirectionParameter
    m_pCommand_SetStepDirectionParameter = new CCommand_VCS_OperationMode;
    m_pCommand_SetStepDirectionParameter->InitCommand(MODE_STM_SET_STEP_DIRECTION_PARAMETER);
}

void CCommandSetStepDirectionMode_VCS_OperationMode::DeleteCommands()
{
    if(m_pCommand_GetStepDirectionParameter)
    {
        delete m_pCommand_GetStepDirectionParameter;
        m_pCommand_GetStepDirectionParameter = NULL;
    }
    if(m_pCommand_SetStepDirectionParameter)
    {
        delete m_pCommand_SetStepDirectionParameter;
        m_pCommand_SetStepDirectionParameter = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetStepDirectionMode_VCS_OperationMode::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandSet");
        pElement->SetAt("Name", m_strCommandSetName);

        //Command elements
        if(m_pCommand_GetStepDirectionParameter) m_pCommand_GetStepDirectionParameter->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetStepDirectionParameter) m_pCommand_SetStepDirectionParameter->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetStepDirectionMode_VCS_OperationMode::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_GetStepDirectionParameter) m_pCommand_GetStepDirectionParameter->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetStepDirectionParameter) m_pCommand_SetStepDirectionParameter->InitJournalManager(p_pJournalManager);
}

void CCommandSetStepDirectionMode_VCS_OperationMode::ResetJournalManager()
{
    if(m_pCommand_GetStepDirectionParameter) m_pCommand_GetStepDirectionParameter->ResetJournalManager();
    if(m_pCommand_SetStepDirectionParameter) m_pCommand_SetStepDirectionParameter->ResetJournalManager();
}

BOOL CCommandSetStepDirectionMode_VCS_OperationMode::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_GetStepDirectionParameter && !m_pCommand_GetStepDirectionParameter->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetStepDirectionParameter && !m_pCommand_SetStepDirectionParameter->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
