
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_OperationMode.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetTuningMode_VCS_OperationMode.h>

CCommandSetTuningMode_VCS_OperationMode::CCommandSetTuningMode_VCS_OperationMode()
{
    m_strCommandSetName = COMMAND_SET_OPERATION_MODE_TUNING_MODE;

    m_pCommand_DoTuning = 0;

    InitCommands();
}

CCommandSetTuningMode_VCS_OperationMode::~CCommandSetTuningMode_VCS_OperationMode()
{
    DeleteCommands();
}

BOOL CCommandSetTuningMode_VCS_OperationMode::VCS_DoTuning(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult(FALSE);

    if(m_pCommand_DoTuning)
    {
        //Set parameter data
        m_pCommand_DoTuning->ResetStatus();

        //Execute command
        oResult = m_pCommand_DoTuning->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_DoTuning->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetTuningMode_VCS_OperationMode::InitCommands()
{
    DeleteCommands();

    m_pCommand_DoTuning = new CCommand_VCS_OperationMode();
    m_pCommand_DoTuning->InitCommand(MODE_TUNING_DO_TUNING);
}

void CCommandSetTuningMode_VCS_OperationMode::DeleteCommands()
{
    if(m_pCommand_DoTuning)
    {
        delete m_pCommand_DoTuning;
        m_pCommand_DoTuning = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetTuningMode_VCS_OperationMode::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandSet");
        pElement->SetAt("Name", m_strCommandSetName);

        //Command elements
        if(m_pCommand_DoTuning) m_pCommand_DoTuning->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetTuningMode_VCS_OperationMode::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_DoTuning) m_pCommand_DoTuning->InitJournalManager(p_pJournalManager);
}

void CCommandSetTuningMode_VCS_OperationMode::ResetJournalManager()
{
    if(m_pCommand_DoTuning) m_pCommand_DoTuning->ResetJournalManager();
}

BOOL CCommandSetTuningMode_VCS_OperationMode::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_DoTuning && !m_pCommand_DoTuning->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
