
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_OperationMode.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/OperationMode/CommandSetVelocityMode_VCS_OperationMode.h>

CCommandSetVelocityMode_VCS_OperationMode::CCommandSetVelocityMode_VCS_OperationMode()
{
    m_strCommandSetName = COMMAND_SET_OPERATION_MODE_VELOCITY_MODE;

    m_pCommand_GetVelocityMust = NULL;
    m_pCommand_SetVelocityMust = NULL;

    InitCommands();
}

CCommandSetVelocityMode_VCS_OperationMode::~CCommandSetVelocityMode_VCS_OperationMode()
{
    DeleteCommands();
}

BOOL CCommandSetVelocityMode_VCS_OperationMode::VCS_GetVelocityMust(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int* p_plVelocityMust, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetVelocityMust)
    {
        //Set parameter data
        m_pCommand_GetVelocityMust->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetVelocityMust->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetVelocityMust->GetReturnParameterData(0, p_plVelocityMust, sizeof(*p_plVelocityMust));

        //Get error code
        m_pCommand_GetVelocityMust->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetVelocityMode_VCS_OperationMode::VCS_SetVelocityMust(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, int p_lVelocityMust, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetVelocityMust)
    {
        //Set parameter data
        m_pCommand_SetVelocityMust->ResetStatus();
        m_pCommand_SetVelocityMust->SetParameterData(0, &p_lVelocityMust, sizeof(p_lVelocityMust));

        //Execute command
        oResult = m_pCommand_GetVelocityMust->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data

        //Get error code
        m_pCommand_SetVelocityMust->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetVelocityMode_VCS_OperationMode::InitCommands()
{
    DeleteCommands();

    //Init GetVelocityMust
    m_pCommand_GetVelocityMust = new CCommand_VCS_OperationMode();
    m_pCommand_GetVelocityMust->InitCommand(MODE_VEM_GET_VELOCITY_MUST);

    //Init SetVelocityMust
    m_pCommand_SetVelocityMust = new CCommand_VCS_OperationMode;
    m_pCommand_SetVelocityMust->InitCommand(MODE_VEM_SET_VELOCITY_MUST);
}

void CCommandSetVelocityMode_VCS_OperationMode::DeleteCommands()
{
    if(m_pCommand_GetVelocityMust)
    {
        delete m_pCommand_GetVelocityMust;
        m_pCommand_GetVelocityMust = NULL;
    }
    if(m_pCommand_SetVelocityMust)
    {
        delete m_pCommand_SetVelocityMust;
        m_pCommand_SetVelocityMust = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetVelocityMode_VCS_OperationMode::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pParentElement;

        //Command elements
        if(m_pCommand_GetVelocityMust) m_pCommand_GetVelocityMust->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetVelocityMust) m_pCommand_SetVelocityMust->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetVelocityMode_VCS_OperationMode::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_GetVelocityMust) m_pCommand_GetVelocityMust->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetVelocityMust) m_pCommand_GetVelocityMust->InitJournalManager(p_pJournalManager);
}

void CCommandSetVelocityMode_VCS_OperationMode::ResetJournalManager()
{
    if(m_pCommand_GetVelocityMust) m_pCommand_GetVelocityMust->ResetJournalManager();
    if(m_pCommand_SetVelocityMust) m_pCommand_SetVelocityMust->ResetJournalManager();
}

BOOL CCommandSetVelocityMode_VCS_OperationMode::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_GetVelocityMust && !m_pCommand_GetVelocityMust->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetVelocityMust && !m_pCommand_SetVelocityMust->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
