#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_Scanning.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Scanning/CommandSetConfiguration_VCS_Scanning.h>

CCommandSetConfiguration_VCS_Scanning::CCommandSetConfiguration_VCS_Scanning()
{
    m_strCommandSetName = COMMAND_SET_SCANNING_CONFIGURATION;

    m_pCommand_ReadNodeId = 0;
    m_pCommand_WriteNodeId = 0;
    m_pCommand_ReadStationId = 0;
    m_pCommand_WriteStationId = 0;
    m_pCommand_ReadTransferRate = 0;
    m_pCommand_WriteTransferRate = 0;
    m_pCommand_Store = 0;
    m_pCommand_Reset = 0;
    m_pCommand_WaitForReboot = 0;

    InitCommands();
}

CCommandSetConfiguration_VCS_Scanning::~CCommandSetConfiguration_VCS_Scanning()
{
    DeleteCommands();
}

BOOL CCommandSetConfiguration_VCS_Scanning::VCS_ReadNodeId(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulNodeId, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_ReadNodeId)
    {
        //Set parameter data
        m_pCommand_ReadNodeId->ResetStatus();

        //Execute command
        oResult = m_pCommand_ReadNodeId->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_ReadNodeId->GetReturnParameterData(0, p_pulNodeId, sizeof(*p_pulNodeId));

        //Get error code
        m_pCommand_ReadNodeId->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetConfiguration_VCS_Scanning::VCS_WriteNodeId(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulNodeId, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_WriteNodeId)
    {
        //Set parameter data
        m_pCommand_WriteNodeId->ResetStatus();
        m_pCommand_WriteNodeId->SetParameterData(0, &p_ulNodeId, sizeof(p_ulNodeId));

        //Execute command
        oResult = m_pCommand_WriteNodeId->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_WriteNodeId->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetConfiguration_VCS_Scanning::VCS_ReadStationId(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD* p_pusStationId, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_ReadStationId)
    {
        //Set parameter data
        m_pCommand_ReadStationId->ResetStatus();

        //Execute command
        oResult = m_pCommand_ReadStationId->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_ReadStationId->GetReturnParameterData(0, p_pusStationId, sizeof(*p_pusStationId));

        //Get error code
        m_pCommand_ReadStationId->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetConfiguration_VCS_Scanning::VCS_WriteStationId(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, WORD p_usStationId, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_WriteStationId)
    {
        //Set parameter data
        m_pCommand_WriteStationId->ResetStatus();
        m_pCommand_WriteStationId->SetParameterData(0, &p_usStationId, sizeof(p_usStationId));

        //Execute command
        oResult = m_pCommand_WriteStationId->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_WriteStationId->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetConfiguration_VCS_Scanning::VCS_ReadTransferRate(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulTransferRate, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_ReadTransferRate)
    {
        //Set parameter data
        m_pCommand_ReadTransferRate->ResetStatus();

        //Execute command
        oResult = m_pCommand_ReadTransferRate->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_ReadTransferRate->GetReturnParameterData(0, p_pulTransferRate, sizeof(*p_pulTransferRate));

        //Get error code
        m_pCommand_ReadTransferRate->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetConfiguration_VCS_Scanning::VCS_WriteTransferRate(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD p_ulTransferRate, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_WriteTransferRate)
    {
        //Set parameter data
        m_pCommand_WriteTransferRate->ResetStatus();
        m_pCommand_WriteTransferRate->SetParameterData(0, &p_ulTransferRate, sizeof(p_ulTransferRate));

        //Execute command
        oResult = m_pCommand_WriteTransferRate->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_WriteTransferRate->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetConfiguration_VCS_Scanning::VCS_Store(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_Store)
    {
        //Set parameter data
        m_pCommand_Store->ResetStatus();

        //Execute command
        oResult = m_pCommand_Store->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_Store->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetConfiguration_VCS_Scanning::VCS_ResetDevice(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL p_oBroadcast, BOOL p_oWaitForReboot, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_Reset)
    {
        //Set parameter data
        m_pCommand_Reset->ResetStatus();

        //Execute command
        oResult = m_pCommand_Reset->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_Reset->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetConfiguration_VCS_Scanning::VCS_WaitForReboot(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_WaitForReboot)
    {
        //Set parameter data
        m_pCommand_WaitForReboot->ResetStatus();

        //Execute command
        oResult = m_pCommand_WaitForReboot->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_WaitForReboot->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetConfiguration_VCS_Scanning::InitCommands()
{
    DeleteCommands();

    m_pCommand_ReadNodeId = new CCommand_VCS_Scanning();
    m_pCommand_ReadNodeId->InitCommand(SCAN_READ_VENDOR_ID);
    m_pCommand_WriteNodeId = new CCommand_VCS_Scanning();
    m_pCommand_WriteNodeId->InitCommand(SCAN_WRITE_NODE_ID);
    m_pCommand_ReadStationId = new CCommand_VCS_Scanning();
    m_pCommand_ReadStationId->InitCommand(SCAN_READ_STATION_ID);
    m_pCommand_WriteStationId = new CCommand_VCS_Scanning();
    m_pCommand_WriteStationId->InitCommand(SCAN_WRITE_STATION_ID);
    m_pCommand_ReadTransferRate = new CCommand_VCS_Scanning();
    m_pCommand_ReadTransferRate->InitCommand(SCAN_READ_TRANSFER_RATE);
    m_pCommand_WriteTransferRate = new CCommand_VCS_Scanning();
    m_pCommand_WriteTransferRate->InitCommand(SCAN_WRITE_TRANSFER_RATE);
    m_pCommand_Store = new CCommand_VCS_Scanning();
    m_pCommand_Store->InitCommand(SCAN_STORE);
    m_pCommand_Reset = new CCommand_VCS_Scanning();
    m_pCommand_Reset->InitCommand(SCAN_RESET_DEVICE);
    m_pCommand_WaitForReboot = new CCommand_VCS_Scanning();
    m_pCommand_WaitForReboot->InitCommand(SCAN_WAIT_FOR_REBOOT);
}

void CCommandSetConfiguration_VCS_Scanning::DeleteCommands()
{
    if(m_pCommand_ReadNodeId)
    {
        delete m_pCommand_ReadNodeId;
        m_pCommand_ReadNodeId = NULL;
    }
    if(m_pCommand_WriteNodeId)
    {
        delete m_pCommand_WriteNodeId;
        m_pCommand_WriteNodeId = NULL;
    }
    if(m_pCommand_ReadStationId)
    {
        delete m_pCommand_ReadStationId;
        m_pCommand_ReadStationId = NULL;
    }
    if(m_pCommand_WriteStationId)
    {
        delete m_pCommand_WriteStationId;
        m_pCommand_WriteStationId = NULL;
    }
    if(m_pCommand_ReadTransferRate)
    {
        delete m_pCommand_ReadTransferRate;
        m_pCommand_ReadTransferRate = NULL;
    }
    if(m_pCommand_WriteTransferRate)
    {
        delete m_pCommand_WriteTransferRate;
        m_pCommand_WriteTransferRate = NULL;
    }
    if(m_pCommand_Store)
    {
        delete m_pCommand_Store;
        m_pCommand_Store = NULL;
    }
    if(m_pCommand_Reset)
    {
        delete m_pCommand_Reset;
        m_pCommand_Reset = NULL;
    }
    if(m_pCommand_WaitForReboot)
    {
        delete m_pCommand_WaitForReboot;
        m_pCommand_WaitForReboot = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetConfiguration_VCS_Scanning::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandSet");
        pElement->SetAt("Name", m_strCommandSetName);

        //Command elements
        if(m_pCommand_ReadNodeId) m_pCommand_ReadNodeId->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_WriteNodeId) m_pCommand_WriteNodeId->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_ReadStationId) m_pCommand_ReadStationId->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_WriteStationId) m_pCommand_WriteStationId->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_ReadTransferRate) m_pCommand_ReadTransferRate->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_WriteTransferRate) m_pCommand_WriteTransferRate->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_Store) m_pCommand_Store->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_Reset) m_pCommand_Reset->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_WaitForReboot) m_pCommand_WaitForReboot->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetConfiguration_VCS_Scanning::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_ReadNodeId) m_pCommand_ReadNodeId->InitJournalManager(p_pJournalManager);
    if(m_pCommand_WriteNodeId) m_pCommand_WriteNodeId->InitJournalManager(p_pJournalManager);
    if(m_pCommand_ReadStationId) m_pCommand_ReadStationId->InitJournalManager(p_pJournalManager);
    if(m_pCommand_WriteStationId) m_pCommand_WriteStationId->InitJournalManager(p_pJournalManager);
    if(m_pCommand_ReadTransferRate) m_pCommand_ReadTransferRate->InitJournalManager(p_pJournalManager);
    if(m_pCommand_WriteTransferRate) m_pCommand_WriteTransferRate->InitJournalManager(p_pJournalManager);
    if(m_pCommand_Store) m_pCommand_Store->InitJournalManager(p_pJournalManager);
    if(m_pCommand_Reset) m_pCommand_Reset->InitJournalManager(p_pJournalManager);
    if(m_pCommand_WaitForReboot) m_pCommand_WaitForReboot->InitJournalManager(p_pJournalManager);
}

void CCommandSetConfiguration_VCS_Scanning::ResetJournalManager()
{
    if(m_pCommand_ReadNodeId) m_pCommand_ReadNodeId->ResetJournalManager();
    if(m_pCommand_WriteNodeId) m_pCommand_WriteNodeId->ResetJournalManager();
    if(m_pCommand_ReadStationId) m_pCommand_ReadStationId->ResetJournalManager();
    if(m_pCommand_WriteStationId) m_pCommand_WriteStationId->ResetJournalManager();
    if(m_pCommand_ReadTransferRate) m_pCommand_ReadTransferRate->ResetJournalManager();
    if(m_pCommand_WriteTransferRate) m_pCommand_WriteTransferRate->ResetJournalManager();
    if(m_pCommand_Store) m_pCommand_Store->ResetJournalManager();
    if(m_pCommand_Reset) m_pCommand_Reset->ResetJournalManager();
    if(m_pCommand_WaitForReboot) m_pCommand_WaitForReboot->ResetJournalManager();
}

BOOL CCommandSetConfiguration_VCS_Scanning::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_ReadNodeId && !m_pCommand_ReadNodeId->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_WriteNodeId && !m_pCommand_WriteNodeId->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_ReadStationId && !m_pCommand_ReadStationId->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_WriteStationId && !m_pCommand_WriteStationId->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_ReadTransferRate && !m_pCommand_ReadTransferRate->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_WriteTransferRate && !m_pCommand_WriteTransferRate->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_Store && !m_pCommand_Store->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_Reset && !m_pCommand_Reset->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_WaitForReboot && !m_pCommand_WaitForReboot->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
