
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_Scanning.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/Scanning/CommandSetIdentification_VCS_Scanning.h>

CCommandSetIdentification_VCS_Scanning::CCommandSetIdentification_VCS_Scanning()
{
    m_strCommandSetName = COMMAND_SET_SCANNING_IDENTIFICATION;

    m_pCommand_ReadVendorId = 0;
    m_pCommand_ReadDeviceType = 0;
    m_pCommand_ReadDeviceName = 0;
    m_pCommand_ReadProductCode = 0;
    m_pCommand_ReadRevisionNumber = 0;
    m_pCommand_ReadSerialNumber = 0;
    m_pCommand_IsIdentifySupported = 0;
    m_pCommand_StartIdentify = 0;
    m_pCommand_StopIdentify = 0;

    InitCommands();
}

CCommandSetIdentification_VCS_Scanning::~CCommandSetIdentification_VCS_Scanning()
{
    DeleteCommands();
}

BOOL CCommandSetIdentification_VCS_Scanning::VCS_ReadVendorId(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulVendorId, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult(FALSE);

    if(m_pCommand_ReadVendorId)
    {
        //Set parameter data
        m_pCommand_ReadVendorId->ResetStatus();

        //Execute command
        oResult = m_pCommand_ReadVendorId->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_ReadVendorId->GetReturnParameterData(0, p_pulVendorId, sizeof(*p_pulVendorId));

        //Get error code
        m_pCommand_ReadVendorId->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetIdentification_VCS_Scanning::VCS_ReadDeviceType(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulDeviceType, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult(FALSE);

    if(m_pCommand_ReadDeviceType)
    {
        //Set parameter data
        m_pCommand_ReadDeviceType->ResetStatus();

        //Execute command
        oResult = m_pCommand_ReadDeviceType->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_ReadDeviceType->GetReturnParameterData(0, p_pulDeviceType, sizeof(*p_pulDeviceType));

        //Get error code
        m_pCommand_ReadDeviceType->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetIdentification_VCS_Scanning::VCS_ReadDeviceName(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CStdString& p_rulDeviceName, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult(FALSE);
    DWORD ulLength(0);

    if(m_pCommand_ReadDeviceName)
    {
        //Set parameter data
        m_pCommand_ReadDeviceName->ResetStatus();

        //Execute command
        oResult = m_pCommand_ReadDeviceName->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_ReadDeviceName->GetReturnParameterData(0, (void*)&p_rulDeviceName, ulLength);

        //Get error code
        m_pCommand_ReadDeviceName->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetIdentification_VCS_Scanning::VCS_ReadProductCode(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulProductCode, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult(FALSE);

    if(m_pCommand_ReadProductCode)
    {
        //Set parameter data
        m_pCommand_ReadProductCode->ResetStatus();

        //Execute command
        oResult = m_pCommand_ReadProductCode->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_ReadProductCode->GetReturnParameterData(0, p_pulProductCode, sizeof(*p_pulProductCode));

        //Get error code
        m_pCommand_ReadProductCode->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetIdentification_VCS_Scanning::VCS_ReadRevisionNumber(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulRevisionNumber, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult(FALSE);

    if(m_pCommand_ReadRevisionNumber)
    {
        //Set parameter data
        m_pCommand_ReadRevisionNumber->ResetStatus();

        //Execute command
        oResult = m_pCommand_ReadRevisionNumber->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_ReadRevisionNumber->GetReturnParameterData(0, p_pulRevisionNumber, sizeof(*p_pulRevisionNumber));

        //Get error code
        m_pCommand_ReadRevisionNumber->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetIdentification_VCS_Scanning::VCS_ReadSerialNumber(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulSerialNumber, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult(FALSE);

    if(m_pCommand_ReadSerialNumber)
    {
        //Set parameter data
        m_pCommand_ReadSerialNumber->ResetStatus();

        //Execute command
        oResult = m_pCommand_ReadSerialNumber->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_ReadSerialNumber->GetReturnParameterData(0, p_pulSerialNumber, sizeof(*p_pulSerialNumber));

        //Get error code
        m_pCommand_ReadSerialNumber->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetIdentification_VCS_Scanning::VCS_IsIdentifySupported(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulRevisionNumber, BYTE* p_rubIdentifySupported, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if (m_pCommand_IsIdentifySupported)
    {
        //Set parameter data
        m_pCommand_IsIdentifySupported->ResetStatus();
        m_pCommand_IsIdentifySupported->SetParameterData(0, &p_pulRevisionNumber, sizeof(p_pulRevisionNumber));

        //Execute command
        oResult = m_pCommand_IsIdentifySupported->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_IsIdentifySupported->SetReturnParameterData(0, &p_rubIdentifySupported, sizeof(p_rubIdentifySupported));

        //Get error code
        m_pCommand_StartIdentify->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetIdentification_VCS_Scanning::VCS_StartIdentify(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, DWORD* p_pulVendorId, DWORD* p_pulProductCode, DWORD* p_pulRevisionNumber, DWORD* p_pulSerialNumber, WORD* p_pusTimeout, BYTE* p_pubNodeId, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if (m_pCommand_StartIdentify)
    {
        //Set parameter data
        m_pCommand_StartIdentify->ResetStatus();
        m_pCommand_StartIdentify->SetParameterData(0, &p_pulVendorId, sizeof(p_pulVendorId));
        m_pCommand_StartIdentify->SetParameterData(1, &p_pulProductCode, sizeof(p_pulProductCode));
        m_pCommand_StartIdentify->SetParameterData(2, &p_pulRevisionNumber, sizeof(p_pulRevisionNumber));
        m_pCommand_StartIdentify->SetParameterData(3, &p_pulSerialNumber, sizeof(p_pulSerialNumber));
        m_pCommand_StartIdentify->SetParameterData(4, &p_pusTimeout, sizeof(p_pusTimeout));
        m_pCommand_StartIdentify->SetParameterData(5, &p_pubNodeId, sizeof(p_pubNodeId));

        //Execute command
        oResult = m_pCommand_StartIdentify->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_StartIdentify->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetIdentification_VCS_Scanning::VCS_StopIdentify(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BYTE* p_pubMode, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if (m_pCommand_StopIdentify)
    {
        //Set parameter data
        m_pCommand_StopIdentify->ResetStatus();
        m_pCommand_StopIdentify->SetParameterData(0, &p_pubMode, sizeof(p_pubMode));

        //Execute command
        oResult = m_pCommand_StopIdentify->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_StopIdentify->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}


void CCommandSetIdentification_VCS_Scanning::InitCommands()
{
    DeleteCommands();

    m_pCommand_ReadVendorId = new CCommand_VCS_Scanning();
    m_pCommand_ReadVendorId->InitCommand(SCAN_READ_VENDOR_ID);
    m_pCommand_ReadDeviceType = new CCommand_VCS_Scanning();
    m_pCommand_ReadDeviceType->InitCommand(SCAN_READ_DEVICE_TYPE);
    m_pCommand_ReadDeviceName = new CCommand_VCS_Scanning();
    m_pCommand_ReadDeviceName->InitCommand(SCAN_READ_DEVICE_NAME);
    m_pCommand_ReadProductCode = new CCommand_VCS_Scanning();
    m_pCommand_ReadProductCode->InitCommand(SCAN_READ_PRODUCT_CODE);
    m_pCommand_ReadRevisionNumber = new CCommand_VCS_Scanning();
    m_pCommand_ReadRevisionNumber->InitCommand(SCAN_READ_REVISION_NUMBER);
    m_pCommand_ReadSerialNumber = new CCommand_VCS_Scanning();
    m_pCommand_ReadSerialNumber->InitCommand(SCAN_READ_SERIAL_NUMBER);
    m_pCommand_StartIdentify = new CCommand_VCS_Scanning();
    m_pCommand_StartIdentify->InitCommand(SCAN_START_IDENTIFY);
    m_pCommand_StopIdentify = new CCommand_VCS_Scanning();
    m_pCommand_StopIdentify->InitCommand(SCAN_STOP_IDENTIFY);
}

void CCommandSetIdentification_VCS_Scanning::DeleteCommands()
{
    if(m_pCommand_ReadVendorId)
    {
        delete m_pCommand_ReadVendorId;
        m_pCommand_ReadVendorId = NULL;
    }
    if(m_pCommand_ReadDeviceType)
    {
        delete m_pCommand_ReadDeviceType;
        m_pCommand_ReadDeviceType = NULL;
    }
    if(m_pCommand_ReadDeviceName)
    {
        delete m_pCommand_ReadDeviceName;
        m_pCommand_ReadDeviceName = NULL;
    }
    if(m_pCommand_ReadProductCode)
    {
        delete m_pCommand_ReadProductCode;
        m_pCommand_ReadProductCode = NULL;
    }
    if(m_pCommand_ReadRevisionNumber)
    {
        delete m_pCommand_ReadRevisionNumber;
        m_pCommand_ReadRevisionNumber = NULL;
    }
    if(m_pCommand_ReadSerialNumber)
    {
        delete m_pCommand_ReadSerialNumber;
        m_pCommand_ReadSerialNumber = NULL;
    }
    if (m_pCommand_StartIdentify)
    {
        delete m_pCommand_StartIdentify;
        m_pCommand_StartIdentify = NULL;
    }
    if (m_pCommand_StopIdentify)
    {
        delete m_pCommand_StopIdentify;
        m_pCommand_StopIdentify = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetIdentification_VCS_Scanning::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandSet");
        pElement->SetAt("Name", m_strCommandSetName);

        //Command elements
        if(m_pCommand_ReadVendorId) m_pCommand_ReadVendorId->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_ReadDeviceType) m_pCommand_ReadDeviceType->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_ReadDeviceName) m_pCommand_ReadDeviceName->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_ReadProductCode) m_pCommand_ReadProductCode->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_ReadRevisionNumber) m_pCommand_ReadRevisionNumber->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_ReadSerialNumber) m_pCommand_ReadSerialNumber->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_StartIdentify) m_pCommand_StartIdentify->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_StopIdentify) m_pCommand_StopIdentify->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetIdentification_VCS_Scanning::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_ReadVendorId) m_pCommand_ReadVendorId->InitJournalManager(p_pJournalManager);
    if(m_pCommand_ReadDeviceType) m_pCommand_ReadDeviceType->InitJournalManager(p_pJournalManager);
    if(m_pCommand_ReadDeviceName) m_pCommand_ReadDeviceName->InitJournalManager(p_pJournalManager);
    if(m_pCommand_ReadProductCode) m_pCommand_ReadProductCode->InitJournalManager(p_pJournalManager);
    if(m_pCommand_ReadRevisionNumber) m_pCommand_ReadRevisionNumber->InitJournalManager(p_pJournalManager);
    if(m_pCommand_ReadSerialNumber) m_pCommand_ReadSerialNumber->InitJournalManager(p_pJournalManager);
    if(m_pCommand_StartIdentify) m_pCommand_StartIdentify->InitJournalManager(p_pJournalManager);
    if(m_pCommand_StopIdentify) m_pCommand_StopIdentify->InitJournalManager(p_pJournalManager);
}

void CCommandSetIdentification_VCS_Scanning::ResetJournalManager()
{
    if(m_pCommand_ReadVendorId) m_pCommand_ReadVendorId->ResetJournalManager();
    if(m_pCommand_ReadDeviceType) m_pCommand_ReadDeviceType->ResetJournalManager();
    if(m_pCommand_ReadDeviceName) m_pCommand_ReadDeviceName->ResetJournalManager();
    if(m_pCommand_ReadProductCode) m_pCommand_ReadProductCode->ResetJournalManager();
    if(m_pCommand_ReadRevisionNumber) m_pCommand_ReadRevisionNumber->ResetJournalManager();
    if(m_pCommand_ReadSerialNumber) m_pCommand_ReadSerialNumber->ResetJournalManager();
    if(m_pCommand_StartIdentify) m_pCommand_StartIdentify->ResetJournalManager();
    if(m_pCommand_StopIdentify) m_pCommand_StopIdentify->ResetJournalManager();
}

BOOL CCommandSetIdentification_VCS_Scanning::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_ReadVendorId && !m_pCommand_ReadVendorId->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_ReadDeviceType && !m_pCommand_ReadDeviceType->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_ReadDeviceName && !m_pCommand_ReadDeviceName->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_ReadProductCode && !m_pCommand_ReadProductCode->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_ReadRevisionNumber && !m_pCommand_ReadRevisionNumber->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_ReadSerialNumber && !m_pCommand_ReadSerialNumber->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_StartIdentify && !m_pCommand_StartIdentify->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_StopIdentify && !m_pCommand_StopIdentify->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
