
#include "stdafx.h"

#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_StateMachine.h>

#include <CommunicationModel/VirtualCommandSet/Classes/CommandSets/StateMachine/CommandSetCia402_VCS_StateMachine.h>

CCommandSetCia402_VCS_StateMachine::CCommandSetCia402_VCS_StateMachine()
{
    m_strCommandSetName = COMMAND_SET_STATE_MACHINE_CIA402;

    m_pCommand_ClearFault = NULL;
    m_pCommand_GetDisableState = NULL;
    m_pCommand_GetEnableState = NULL;
    m_pCommand_GetFaultState = NULL;
    m_pCommand_GetQuickStopState = NULL;
    m_pCommand_SetDisableState = NULL;
    m_pCommand_SetEnableState = NULL;
    m_pCommand_SetQuickStopState = NULL;

    InitCommands();
}

CCommandSetCia402_VCS_StateMachine::~CCommandSetCia402_VCS_StateMachine()
{
    DeleteCommands();
}

BOOL CCommandSetCia402_VCS_StateMachine::VCS_ClearFault(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_ClearFault)
    {
        //Set parameter data
        m_pCommand_ClearFault->ResetStatus();

        //Execute command
        oResult = m_pCommand_ClearFault->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_ClearFault->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetCia402_VCS_StateMachine::VCS_GetDisableState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL* p_poIsDisabled, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetDisableState)
    {
        //Set parameter data
        m_pCommand_GetDisableState->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetDisableState->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetDisableState->GetReturnParameterData(0, p_poIsDisabled, sizeof(*p_poIsDisabled));

        //Get error code
        m_pCommand_GetDisableState->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetCia402_VCS_StateMachine::VCS_GetEnableState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL* p_poIsEnabled, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetEnableState)
    {
        //Set parameter data
        m_pCommand_GetEnableState->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetEnableState->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetEnableState->GetReturnParameterData(0, p_poIsEnabled, sizeof(*p_poIsEnabled));

        //Get error code
        m_pCommand_GetEnableState->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetCia402_VCS_StateMachine::VCS_GetFaultState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL* p_poIsInFault, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetFaultState)
    {
        //Set parameter data
        m_pCommand_GetFaultState->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetFaultState->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetFaultState->GetReturnParameterData(0, p_poIsInFault, sizeof(*p_poIsInFault));

        //Get error code
        m_pCommand_GetFaultState->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetCia402_VCS_StateMachine::VCS_GetQuickStopState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, BOOL* p_poQuickStopActive, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_GetQuickStopState)
    {
        //Set parameter data
        m_pCommand_GetQuickStopState->ResetStatus();

        //Execute command
        oResult = m_pCommand_GetQuickStopState->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get return parameter data
        m_pCommand_GetQuickStopState->GetReturnParameterData(0, p_poQuickStopActive, sizeof(*p_poQuickStopActive));

        //Get error code
        m_pCommand_GetQuickStopState->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetCia402_VCS_StateMachine::VCS_SetDisableState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetDisableState)
    {
        //Set parameter data
        m_pCommand_SetDisableState->ResetStatus();

        //Execute command
        oResult = m_pCommand_SetDisableState->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetDisableState->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetCia402_VCS_StateMachine::VCS_SetEnableState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetEnableState)
    {
        //Set parameter data
        m_pCommand_SetEnableState->ResetStatus();

        //Execute command
        oResult = m_pCommand_SetEnableState->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetEnableState->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

BOOL CCommandSetCia402_VCS_StateMachine::VCS_SetQuickStopState(CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle, CErrorInfo* p_pErrorInfo)
{
    BOOL oResult = FALSE;

    if(m_pCommand_SetQuickStopState)
    {
        //Set parameter data
        m_pCommand_SetQuickStopState->ResetStatus();

        //Execute command
        oResult = m_pCommand_SetQuickStopState->Execute(p_pManager, p_hHandle, p_hTransactionHandle);

        //Get error code
        m_pCommand_SetQuickStopState->GetErrorInfo(p_pErrorInfo);
    }

    return oResult;
}

void CCommandSetCia402_VCS_StateMachine::InitCommands()
{
    DeleteCommands();

    //Init ClearFault
    m_pCommand_ClearFault = new CCommand_VCS_StateMachine();
    m_pCommand_ClearFault->InitCommand(STATE_CLEAR_FAULT);
    //Init GetDisableState
    m_pCommand_GetDisableState = new CCommand_VCS_StateMachine();
    m_pCommand_GetDisableState->InitCommand(STATE_GET_DISABLE_STATE);
    //Init GetEnableState
    m_pCommand_GetEnableState = new CCommand_VCS_StateMachine();
    m_pCommand_GetEnableState->InitCommand(STATE_GET_ENABLE_STATE);
    //Init GetFaultState
    m_pCommand_GetFaultState = new CCommand_VCS_StateMachine();
    m_pCommand_GetFaultState->InitCommand(STATE_GET_FAULT_STATE);
    //Init GetQuickStopState
    m_pCommand_GetQuickStopState = new CCommand_VCS_StateMachine();
    m_pCommand_GetQuickStopState->InitCommand(STATE_GET_QUICK_STOP_STATE);
    //Init SetDisableState
    m_pCommand_SetDisableState = new CCommand_VCS_StateMachine();
    m_pCommand_SetDisableState->InitCommand(STATE_SET_DISABLE_STATE);
    //Init SetEnableState
    m_pCommand_SetEnableState = new CCommand_VCS_StateMachine();
    m_pCommand_SetEnableState->InitCommand(STATE_SET_ENABLE_STATE);
    //Init SetQuickStopState
    m_pCommand_SetQuickStopState = new CCommand_VCS_StateMachine();
    m_pCommand_SetQuickStopState->InitCommand(STATE_SET_QUICK_STOP_STATE);
}

void CCommandSetCia402_VCS_StateMachine::DeleteCommands()
{
    if(m_pCommand_ClearFault)
    {
        delete m_pCommand_ClearFault;
        m_pCommand_ClearFault = NULL;
    }
    if(m_pCommand_GetDisableState)
    {
        delete m_pCommand_GetDisableState;
        m_pCommand_GetDisableState = NULL;
    }
    if(m_pCommand_GetEnableState)
    {
        delete m_pCommand_GetEnableState;
        m_pCommand_GetEnableState = NULL;
    }
    if(m_pCommand_GetFaultState)
    {
        delete m_pCommand_GetFaultState;
        m_pCommand_GetFaultState = NULL;
    }
    if(m_pCommand_GetQuickStopState)
    {
        delete m_pCommand_GetQuickStopState;
        m_pCommand_GetQuickStopState = NULL;
    }
    if(m_pCommand_SetDisableState)
    {
        delete m_pCommand_SetDisableState;
        m_pCommand_SetDisableState = NULL;
    }
    if(m_pCommand_SetEnableState)
    {
        delete m_pCommand_SetEnableState;
        m_pCommand_SetEnableState = NULL;
    }
    if(m_pCommand_SetQuickStopState)
    {
        delete m_pCommand_SetQuickStopState;
        m_pCommand_SetQuickStopState = NULL;
    }
}

CXXMLFile::CElementPart* CCommandSetCia402_VCS_StateMachine::StoreToXMLFile(CXXMLFile* p_pFile, CXXMLFile::CElementPart* p_pParentElement)
{
    CXXMLFile::CElement* pElement(0);

    if(p_pFile && p_pParentElement)
    {
        //CommandSet elements
        pElement = (CXXMLFile::CElement*)p_pFile->AddElement(p_pParentElement);
        p_pFile->SetText(pElement, "CommandSet");
        pElement->SetAt("Name", m_strCommandSetName);

        //Command elements
        if(m_pCommand_GetFaultState) m_pCommand_GetFaultState->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_ClearFault) m_pCommand_ClearFault->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetEnableState) m_pCommand_GetEnableState->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetEnableState) m_pCommand_SetEnableState->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetDisableState) m_pCommand_GetDisableState->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetDisableState) m_pCommand_SetDisableState->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_GetQuickStopState) m_pCommand_GetQuickStopState->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
        if(m_pCommand_SetQuickStopState) m_pCommand_SetQuickStopState->StoreToXMLFile(p_pFile, pElement, CHECK_NOT_VISIBILITY, CHECK_GATEWAY_SUPPORT);
    }

    return pElement;
}

void CCommandSetCia402_VCS_StateMachine::InitJournalManager(CJournalManagerBase* p_pJournalManager)
{
    if(m_pCommand_ClearFault) m_pCommand_ClearFault->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetDisableState) m_pCommand_GetDisableState->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetEnableState) m_pCommand_GetEnableState->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetFaultState) m_pCommand_GetFaultState->InitJournalManager(p_pJournalManager);
    if(m_pCommand_GetQuickStopState) m_pCommand_GetQuickStopState->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetDisableState) m_pCommand_SetDisableState->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetEnableState) m_pCommand_SetEnableState->InitJournalManager(p_pJournalManager);
    if(m_pCommand_SetQuickStopState) m_pCommand_SetQuickStopState->InitJournalManager(p_pJournalManager);
}

void CCommandSetCia402_VCS_StateMachine::ResetJournalManager()
{
    if(m_pCommand_ClearFault) m_pCommand_ClearFault->ResetJournalManager();
    if(m_pCommand_GetDisableState) m_pCommand_GetDisableState->ResetJournalManager();
    if(m_pCommand_GetEnableState) m_pCommand_GetEnableState->ResetJournalManager();
    if(m_pCommand_GetFaultState) m_pCommand_GetFaultState->ResetJournalManager();
    if(m_pCommand_GetQuickStopState) m_pCommand_GetQuickStopState->ResetJournalManager();
    if(m_pCommand_SetDisableState) m_pCommand_SetDisableState->ResetJournalManager();
    if(m_pCommand_SetEnableState) m_pCommand_SetEnableState->ResetJournalManager();
    if(m_pCommand_SetQuickStopState) m_pCommand_SetQuickStopState->ResetJournalManager();
}

BOOL CCommandSetCia402_VCS_StateMachine::InitGateway(CGateway* p_pGateway)
{
    BOOL oResult(TRUE);

    if(oResult && m_pCommand_ClearFault && !m_pCommand_ClearFault->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetDisableState && !m_pCommand_GetDisableState->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetEnableState && !m_pCommand_GetEnableState->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetFaultState && !m_pCommand_GetFaultState->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_GetQuickStopState && !m_pCommand_GetQuickStopState->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetDisableState && !m_pCommand_SetDisableState->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetEnableState && !m_pCommand_SetEnableState->InitGateway(p_pGateway)) oResult = FALSE;
    if(oResult && m_pCommand_SetQuickStopState && !m_pCommand_SetQuickStopState->InitGateway(p_pGateway)) oResult = FALSE;

    return oResult;
}
