#include "stdafx.h"

#include <Log/MmcLog/MmcLog.h>
#include <CommunicationModel/CommonLayer/Classes/Commands/DeviceCommandSet/DcsCanOpenCommunicationDef.h>
#include <CommunicationModel/CommonLayer/Classes/Commands/DeviceCommandSet/DcsCanOpenDriveDef.h>
#include <CommunicationModel/CommonLayer/Classes/Commands/DeviceCommandSet/DcsEpos4Def.h>
#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_OperationMode.h>
#include <CommunicationModel/CommonLayer/Classes/Commands/VirtualCommandSet/Command_VCS_InputsOutputs.h>
#include <CommunicationModel/DeviceCommandSet/BaseClasses/DeviceCommandSetManagerBase.h>

#include <CommunicationModel/VirtualCommandSet/Classes/Gateway/Drive2/GatewayDrive2ToEpos4.h>

CGatewayDrive2ToEpos4::CGatewayDrive2ToEpos4()
{
    InitErrorHandling();
}

CGatewayDrive2ToEpos4::~CGatewayDrive2ToEpos4()
{
}

CGateway *CGatewayDrive2ToEpos4::Clone()
{
    CGatewayDrive2ToEpos4 *pClonedGateway;

    pClonedGateway = new CGatewayDrive2ToEpos4();
    *pClonedGateway = *this;

    return (CGatewayVCStoDCS*)pClonedGateway;
}

CGatewayDrive2ToEpos4& CGatewayDrive2ToEpos4::operator=(CGatewayDrive2ToEpos4& p_rOther)
{
    if(this != &p_rOther)
    {
        *((CGatewayVCStoEpos4*)this) = *((CGatewayVCStoEpos4*)&p_rOther);
    }

    return *this;
}

BOOL CGatewayDrive2ToEpos4::ProcessCommand(CCommandRoot* p_pCommand, CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle)
{
    BOOL oResult(FALSE);

    if(CheckLayers(p_pCommand, p_pManager))
    {
        BOOL oLogMessageActive = p_pCommand->IsLogMessageActive();

        LogCmdMessageIn(p_pCommand, oLogMessageActive, _T("CGatewayDrive2ToEpos4"));

        oResult = ProcessDrive2Command(p_pCommand, p_pManager, p_hHandle, p_hTransactionHandle);

        if(p_pCommand->IsIdle())
        {
            oResult = CGatewayDriveToEpos4::ProcessCommand(p_pCommand, p_pManager, p_hHandle, p_hTransactionHandle);
        }

        LogCmdMessageOut(p_pCommand, oLogMessageActive, _T("CGatewayDrive2ToEpos4"));
    }

    return oResult;
}

BOOL CGatewayDrive2ToEpos4::ProcessDrive2Command(CCommandRoot* p_pCommand, CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle)
{
    BOOL oResult = FALSE;

    return oResult;
}

BOOL CGatewayDrive2ToEpos4::InitErrorHandling()
{
    BOOL oResult = FALSE;
    CErrorProducer errorProducer;
    CStdString className = _T("GatewayDrive2ToEpos4");

    if(m_pErrorHandling)
    {
        //Init error producer
        errorProducer.Init(VIRTUAL_COMMAND_SET_LAYER, className);
        oResult = m_pErrorHandling->InitErrorProducer(&errorProducer);
    }

    return oResult;
}
