
#include "stdafx.h"

#include <CommunicationModel/VirtualCommandSet/Classes/Gateway/Plc2/GatewayPlc2ToEsam2.h>

CGatewayPlc2ToEsam2::CGatewayPlc2ToEsam2()
{
    InitErrorHandling();
}

CGatewayPlc2ToEsam2::~CGatewayPlc2ToEsam2()
{
}

CGateway* CGatewayPlc2ToEsam2::Clone()
{
    CGatewayPlc2ToEsam2* pClonedGateway;

    pClonedGateway = new CGatewayPlc2ToEsam2();
    *pClonedGateway = *this;

    return (CGatewayVCStoDCS*)pClonedGateway;
}

CGatewayPlc2ToEsam2& CGatewayPlc2ToEsam2::operator=(CGatewayPlc2ToEsam2& p_rOther)
{
    if(this != &p_rOther)
    {
        *((CGatewayVCStoEsam2*)this) = *((CGatewayVCStoEsam2*)&p_rOther);
    }

    return *this;
}

BOOL CGatewayPlc2ToEsam2::ProcessCommand(CCommandRoot* p_pCommand, CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle)
{
    BOOL oResult(FALSE);

    if(CheckLayers(p_pCommand, p_pManager))
    {
        BOOL oLogMessageActive = p_pCommand->IsLogMessageActive();

        LogCmdMessageIn(p_pCommand, oLogMessageActive, _T("CGatewayPlc2ToEsam2"));

        oResult = ProcessPlc2Command(p_pCommand, p_pManager, p_hHandle, p_hTransactionHandle);

        if(p_pCommand->IsIdle())
        {
            oResult = CGatewayPlcToEsam2::ProcessCommand(p_pCommand, p_pManager, p_hHandle, p_hTransactionHandle);
        }

        LogCmdMessageOut(p_pCommand, oLogMessageActive, _T("CGatewayPlc2ToEsam2"));
    }

    return oResult;
}

BOOL CGatewayPlc2ToEsam2::ProcessPlc2Command(CCommandRoot* p_pCommand, CLayerManagerBase* p_pManager, HANDLE p_hHandle, HANDLE p_hTransactionHandle)
{
    BOOL oResult(FALSE);

    return oResult;
}

BOOL CGatewayPlc2ToEsam2::InitErrorHandling()
{
    BOOL oResult(FALSE);
    CErrorProducer errorProducer;
    CStdString className(_T("GatewayPlc2ToEsam2"));

    if(m_pErrorHandling)
    {
        //Init error producer
        errorProducer.Init(VIRTUAL_COMMAND_SET_LAYER, className);
        oResult = m_pErrorHandling->InitErrorProducer(&errorProducer);
    }

    return oResult;
}
