#pragma once

#include <MmcTypeDefinition.h>

#include "../BaseClasses/UsbDeviceInfo.h"

class CFtd2xxDeviceInfo: public CUsbDeviceInfo
{
public:
    CFtd2xxDeviceInfo(void);
    virtual ~CFtd2xxDeviceInfo(void);
    CFtd2xxDeviceInfo& operator=(CFtd2xxDeviceInfo& other);
    virtual CUsbDeviceInfo* Clone();

    //Class Infos
    virtual void InitClassInfo() { m_strClassType = _T("-CFtd2xxDeviceInfo") + m_strClassType;}

    //Initialisation
    BOOL Init(CUsbDeviceInfo& p_rDeviceInfo);
    BOOL Init(CStdString p_PortChain, CStdString p_DevicePath, WORD p_usVendorId, WORD p_usProductId, CStdString p_SerialNumber, DWORD p_ulLocId, DWORD p_ulFlags);
    BOOL InitDrvPortInfo(DWORD p_ulLocationId);

    //Update
    BOOL Update(CUsbDeviceInfo& p_rDeviceInfo);

    //Identifiers
    BOOL SetLocationId(DWORD p_ulLocationId);
    BOOL SetDrvFlags(DWORD p_ulFlags);
    DWORD GetLocationId();
    DWORD GetDrvFlags();

    //Log Infos
    BOOL GetLogInfos(CStdString& p_rInfos, ELogInfoType p_eType);

    //Storage
    BOOL WriteTo(CMmcUserSettings* p_pUserSettings);
    BOOL ReadFrom(CMmcUserSettings* p_pUserSettings);

private:
    //Identifiers
    DWORD m_ulLocationId;
    DWORD m_ulDrvFlags;
};

