#pragma once

#include <StdString.h>
#include <Drv/Ftd2xx/Ftd2xxDeviceInfo.h>
#include "../MmcErrorHndl.h"

// USB FTDI baudrate
const unsigned int USB_FTDI_BAUDRATE_1M = 1000000;
const unsigned int USB_FTDI_BAUDRATE_CHIP_FREQUENCY_OPTIMIZED = 1041700;
const unsigned int USB_FTDI_BAUDRATE_TI_FIRMWARE_UPDATE = 38400;

class CMmcFtd2xxHndlDef : public CMmcErrorHndl
{
public:
    virtual ~CMmcFtd2xxHndlDef() {}

public:
    virtual CStdString GetDeviceClassType() = 0;
    virtual bool GetDeviceInfos(tUsbDeviceInfoList& p_rDeviceInfoList, unsigned short p_vendorId, unsigned short p_productId, BOOL p_oIsFtdDevice) = 0;
    virtual bool OpenPort(CFtd2xxDeviceInfo& p_rInfo) = 0;
    virtual bool ClosePort() = 0;
    virtual bool Reload() = 0;
    virtual bool Configure() = 0;
    virtual bool SetTimeouts(unsigned int dReadTimeout, unsigned int dWriteTimeout) = 0;
    virtual bool SetBaudrate(unsigned int ulBaudrate) = 0;
    virtual bool GetStatus(unsigned int *pAmountInRxQueue, unsigned int *pAmountInTxQueue, unsigned int *pEventStatus) = 0;
    virtual bool ReadByte( unsigned char *pData, unsigned int *pDataRead) = 0;
    virtual bool Read(void *pDataBuffer, unsigned int dNumberOfBytesToRead, unsigned int *pdNumberOfBytesRead) = 0;
    virtual bool Write(void *pDataBuffer, unsigned int dNumberOfBytesToWrite, unsigned int *pdNumberOfBytesWritten) = 0;

    virtual bool EE_Program(    unsigned short p_usVendorId,
                                unsigned short p_usProductId,
                                TCHAR* p_pManufacturer,
                                unsigned int p_ulManufacturerLength,
                                TCHAR* p_pDescription,
                                unsigned int p_ulDescriptionLength,
                                TCHAR* p_pSerialNumber,
                                unsigned int p_ulSerialNumberLength,
                                bool p_oUseVcpDriver) = 0;

    virtual bool EE_Read(   unsigned short& p_rusVendorId,
                            unsigned short& p_rusProductId,
                            TCHAR*& p_rpManufacturer,
                            unsigned int& p_rulManufacturerLength,
                            TCHAR*& p_rpDescription,
                            unsigned int& p_rulDescriptionLength,
                            TCHAR*& p_rpSerialNumber,
                            unsigned int& p_rulSerialNumberLength,
                            bool& p_roUseVcpDriver) = 0;
    virtual bool Rescan() = 0;
    virtual bool Reload(unsigned short usVendorId, unsigned short usProductId) = 0;
    virtual bool GetQueueStatus(unsigned int *pdAmountRxQueue) = 0;
    virtual CStdString GetFtStatusDescription(unsigned long status) = 0;
};
