#pragma once

#include "MmcFtd2xxHndlDef.h"

class CMmcFtd2xxHndlBase : public CMmcFtd2xxHndlDef
{
public:
    CMmcFtd2xxHndlBase();
    virtual ~CMmcFtd2xxHndlBase();

public:
    CStdString GetDeviceClassType();
    bool GetDeviceInfos(tUsbDeviceInfoList& p_rDeviceInfoList, unsigned short p_vendorId, unsigned short p_productId, BOOL p_oIsFtdDevice);
    bool OpenPort(CFtd2xxDeviceInfo& p_rInfo);
    bool ClosePort();
    bool Reload();
    bool Configure();
    bool SetTimeouts(unsigned int dReadTimeout, unsigned int dWriteTimeout);
    bool SetBaudrate(unsigned int ulBaudrate);
    bool GetStatus(unsigned int *pAmountInRxQueue, unsigned int *pAmountInTxQueue, unsigned int *pEventStatus);
    bool ReadByte( unsigned char *pData, unsigned int *pDataRead);
    bool Read(void *pDataBuffer, unsigned int dNumberOfBytesToRead, unsigned int *pdNumberOfBytesRead);
    bool Write(void *pDataBuffer, unsigned int dNumberOfBytesToWrite, unsigned int *pdNumberOfBytesWritten);

    bool EE_Program(    unsigned short p_usVendorId,
                        unsigned short p_usProductId,
                        TCHAR* p_pManufacturer,
                        unsigned int p_ulManufacturerLength,
                        TCHAR* p_pDescription,
                        unsigned int p_ulDescriptionLength,
                        TCHAR* p_pSerialNumber,
                        unsigned int p_ulSerialNumberLength,
                        bool p_oUseVcpDriver);

    bool EE_Read(   unsigned short& p_rusVendorId,
                    unsigned short& p_rusProductId,
                    TCHAR*& p_rpManufacturer,
                    unsigned int& p_rulManufacturerLength,
                    TCHAR*& p_rpDescription,
                    unsigned int& p_rulDescriptionLength,
                    TCHAR*& p_rpSerialNumber,
                    unsigned int& p_rulSerialNumberLength,
                    bool& p_roUseVcpDriver);
    bool Rescan();
    bool Reload(unsigned short usVendorId, unsigned short usProductId);
    bool GetQueueStatus(unsigned int *pdAmountRxQueue);
    CStdString GetFtStatusDescription(unsigned long status);

private:
    bool AreLibraryFunctionsLoaded() { return true; }

    bool CreateDeviceInfoList(unsigned int *pdNbOfDevices);
    bool GetDeviceInfoDetail(unsigned int dDeviceIndex, unsigned int *pFlags, unsigned int *pType, unsigned int *pID, unsigned int *pLocId, char* strSerialNumberBuffer, char* strDescriptionBuffer);

    bool GetDeviceInfosFromFtdi(tUsbDeviceInfoList& p_rDeviceInfoList, unsigned short p_vendorId, unsigned short p_productId);
    bool DeleteDeviceInfoList(tUsbDeviceInfoList& p_rDeviceInfoList);
    bool GetDeviceInfosFromUsbTree(tUsbDeviceInfoList& p_rDeviceInfoList, unsigned short p_vendorId, unsigned short p_productId);
    bool MergeDeviceInfos(tUsbDeviceInfoList& p_rTargetDeviceInfoList, tUsbDeviceInfoList& p_rUsbTreeDeviceInfoList, tUsbDeviceInfoList& p_rFtdiDeviceInfoList);
    bool FindDeviceInfo(tUsbDeviceInfoList& p_rDeviceInfoList, CStdString p_vendorId, CStdString p_productId, CStdString p_serialNumber, CFtd2xxDeviceInfo*& p_rpDeviceInfo);

private:
    PVOID m_Handle;
};
