#ifndef COMMON_INCLUDE_DRV_HELPER_USBAPI_USBAPILINUX_H_
#define COMMON_INCLUDE_DRV_HELPER_USBAPI_USBAPILINUX_H_

#include <list>
#include <wchar.h>
#include "../../../../../Linux/include/Drv/Ftd2xx/ftd2xx.h"
#include <iconv.h>

#include <Drv/Helper/UsbApi/UsbDeviceDescription.h>

extern libusb_context *UsbContext;

int  UsbInit(void);
int  UsbExit(void);
bool UsbEnumerate(unsigned short vendor_id, unsigned short product_id, std::list<CUsbDeviceDescription*>& p_rDeviceInfoList);
void UsbFreeEnumeration(std::list<CUsbDeviceDescription*>& p_rDeviceInfoList);

wchar_t *GetUsbString(libusb_device_handle *dev, uint8_t idx);
char *MakePath(libusb_device *dev, int interface_number);
uint16_t GetFirstLanguage(libusb_device_handle *dev);
int IsLanguageSupported(libusb_device_handle *dev, uint16_t lang);
uint16_t GetUsbCodeForCurrentLocale();

#endif /* COMMON_INCLUDE_DRV_HELPER_USBAPI_USBAPILINUX_H_ */
