#pragma once

#include "UsbDeviceBase.h"

class CUsbDevice: public CUsbDeviceBase
{
public:
    CUsbDevice();
    virtual ~CUsbDevice();
    virtual CUsbDeviceBase* Clone();
    CUsbDevice& operator=(CUsbDevice& p_rOther);

    void Init(CStdString p_driverKeyName, CStdString p_deviceId);
    void Init(DWORD p_ulPortIndex, CStdString p_devicePath, WORD p_usVendorId, WORD p_usProductId, WORD p_usSerialNumberId, CStdString p_serialNumber);
    
    CStdString GetDriverKeyName();
    CStdString GetDeviceId();
    WORD GetVendorId();
    WORD GetProductId();
    virtual BOOL GetInfos(CStdString& p_rDevicePath,WORD& p_rusVendorId, WORD& p_rusProductId, CStdString& p_rSerialNumber);
  
private:
    CStdString m_DriverKeyName;
    CStdString m_DeviceId;

    WORD m_usVendorId;
    WORD m_usProductId;
    WORD m_usSerialNumberId;
    CStdString m_SerialNumber;
};

