#pragma once

#include <MmcTypeDefinition.h>

class CUsbDevices;
class CUsbDevice;

class CUsbDeviceBase
{
public:
    CUsbDeviceBase();
    virtual ~CUsbDeviceBase();
    virtual CUsbDeviceBase* Clone();
    CUsbDeviceBase& operator=(CUsbDeviceBase& p_rOther);

    void InitParent(CUsbDeviceBase* p_pParent);
    void InitIndex(DWORD p_ulIndex);
    void InitDevicePath(CStdString p_devicePath);
    virtual void AddChild(CUsbDeviceBase* p_pDeviceBase);

    DWORD GetIndex();
    CStdString GetDevicePath();
    CStdString GetPortChain();
    CUsbDeviceBase* GetParent();
    std::list<CUsbDeviceBase*>* GetChildren();

    BOOL GetPortChain(CStdString p_devicePath, CStdString& p_rPortChain);
    BOOL GetPortChain(WORD p_usVendorId, WORD p_usProductId, CStdString p_serialNumber, CStdString& p_rPortChain);
    BOOL GetPortChains(WORD p_usVendorId, WORD p_usProductId, CStdStringArray& p_rPortChains);

    BOOL GetInfos(CStdString p_portChain, CStdString& p_rDevicePath, WORD& p_rusVendorId, WORD& p_rusProductId, CStdString& p_rSerialNumber);

protected:
    void InitPortChains();
    virtual CStdString BuildPortChain();
    virtual BOOL GetInfos(CStdString& p_rDevicePath, WORD& p_rusVendorId, WORD& p_rusProductId, CStdString& p_rSerialNumber);
      
    CStdString GetParentDevicePath();
    CStdString GetChildDevicePath(int p_lIndex);

private:
    void DeleteChildDevices();
    
private:
    DWORD m_ulIndex;
    CStdString m_DevicePath;
    CStdString m_PortChain;

    CUsbDeviceBase* m_pParent;
    std::list<CUsbDeviceBase*> m_ChildDevices;   
};

