#pragma once

#include <MmcTypeDefinition.h>

class CUsbDevice;

class CUsbDevices
{
public:
    CUsbDevices();
    virtual ~CUsbDevices(void);

    BOOL Load();
    BOOL Reset();

    BOOL GetPortChains(WORD p_usVendorId, WORD p_usProductId, CStdStringArray& p_rPortChains);
    BOOL GetInfos(CStdString p_portChain, CStdString& p_rDevicePath, WORD& p_rusVendorId, WORD& p_rusProductId, CStdString& p_rSerialNumber);
    BOOL GetUsbDeviceByDriverKeyName(CStdString p_driverKeyName, CUsbDevice*& p_rpUsbDevice);

    std::list<CUsbDevice*> GetDeviceList();

private:
    BOOL LoadUsbDevices();
    void DeleteUsbDevices();

private:
    std::list<CUsbDevice*> m_UsbDevices;
};

