#pragma once

#include <MmcTypeDefinition.h>
#include <Thread/MmcCriticalSectionEx.h>

class CUsbHostController;
class CUsbDevices;
class CUsbDevice;
class CUsbApi;

class CUsbTree
{
public:
    CUsbTree(void);
    virtual ~CUsbTree(void);
    static CUsbTree* GetInstance();

    BOOL Load();
    BOOL Reset();

    BOOL GetPortChain(CStdString p_devicePath, CStdString& p_rPortChain);
    BOOL GetPortChain(WORD p_usVendorId, WORD p_usProductId, CStdString p_serialNumber, CStdString& p_rPortChain);
    BOOL GetPortChains(WORD p_usVendorId, WORD p_usProductId, CStdStringArray& p_rPortChains);

    BOOL GetInfos(CStdString p_portChain, CStdString& p_rDevicePath, WORD& p_rusVendorId, WORD& p_rusProductId, CStdString& p_rSerialNumber);

private:
    BOOL LoadHostControllers();
    void DeleteHostControllers();

    void InitInhibitTime();
    void ResetInhibitTime();
    BOOL IsInhibitTimeElapsed();

    void Lock();
    void Unlock();

private:
    static CUsbTree m_Singleton;
    CMmcCriticalSectionEx m_CriticalSection;

    std::list<CUsbHostController*> m_UsbHostControllers;
    DWORD m_ulInhibitStartCount;
};

