#pragma once

#include "UsbTreeFactoryDef.h"

class CUsbHostController;
class CUsbDevice;
class CUsbDevices;
class CLinuxRootHub;
class CLinuxUsbHub;
class CUsbDeviceBase;
class CLinuxUsbDevice;

class CUsbTreeFactoryBase : public CUsbTreeFactoryDef
{
public:
    CUsbTreeFactoryBase();
    virtual ~CUsbTreeFactoryBase();

    BOOL LoadHostControllers(std::list<CUsbHostController*>& p_rHostControllers);
    BOOL LoadUsbDevices(std::list<CUsbDevice*>& p_rUsbDevices);

private:
    BOOL EnumerateHostControllers(std::list<CUsbHostController*>& p_rHostControllers);
    BOOL EnumerateDevices(std::list<CUsbDevice*>& p_rUsbDevices);
    BOOL EnumerateRootHubs(CUsbHostController* p_pHostController);
    BOOL LoadRootHub(CUsbHostController* p_pHostController, CLinuxRootHub* p_pRootHub, CLinuxUsbHub*& p_pUsbHub);
    BOOL LoadChildDevices(CUsbDeviceBase* p_pParent, CLinuxUsbDevice* p_pUsbDevice);
};
