#pragma once

#include <StdString.h>
#include <Drv/Hid/HidDeviceInfo.h>

// USB HID baudrate
const unsigned int USB_HID_BAUDRATE_1M = 1000000;
const unsigned int USB_HID_BAUDRATE_CHIP_FREQUENCY_OPTIMIZED = 1041700;

class CMmcHidHndlDef
{
    virtual bool Init() = 0;
    virtual CStdString GetDeviceClassType() = 0;
    virtual bool GetDeviceInfos(tUsbDeviceInfoList& p_rDeviceInfoList, unsigned short p_usVendorId, unsigned short p_usProductId, BOOL p_oIsHidDevice) = 0;
    virtual bool OpenPort(CHidDeviceInfo& p_rInfo) = 0;
    virtual bool ClosePort() = 0;
    virtual bool IsValid() = 0;
    virtual bool IsOpened() = 0;
    virtual bool PurgeBuffer() = 0;
    virtual bool WaitForOutReportData(unsigned long p_ulTimeout) = 0;
    virtual unsigned long WaitForOverlapped(unsigned long p_ulTimeout) = 0;
    virtual bool UpdateOutReport() = 0;
    virtual bool ReadFile(void* p_pBuffer, DWORD p_ulNumberOfBytesToRead, DWORD* p_pulpNumberOfBytesRead) = 0;
    virtual bool WriteFile(void* p_pBuffer, DWORD p_ulNumberOfBytesToWrite, DWORD* p_pulNumberOfBytesWritten) = 0;
    virtual bool CancelIo() = 0;
    virtual CStdString GetLastError() = 0;
    virtual bool ResetOutReport() = 0;
    virtual int GetInputReportByteLength() = 0;
    virtual int GetOutputReportByteLength() = 0;
    virtual bool GetOverlappedResult(DWORD* p_pulNumberOfBytesTransferred, BOOL p_oWait) = 0;
    virtual bool SetBaudrate(DWORD p_ulBaudrate) = 0;
};
