#pragma once

#include "MmcHidHndlDef.h"

class CHidDevice;

class CMmcHidHndlBase : public CMmcHidHndlDef
{
public:
    CMmcHidHndlBase();
    virtual ~CMmcHidHndlBase();

public:
    bool Init();
    CStdString GetDeviceClassType();
    bool GetDeviceInfos(tUsbDeviceInfoList& p_rDeviceInfoList, unsigned short p_vendorId, unsigned short p_productId, BOOL p_oIsHidDevice);
    bool OpenPort(CHidDeviceInfo& p_rInfo);
    bool ClosePort();
    bool IsValid();
    bool IsOpened();
    bool PurgeBuffer();
    bool WaitForOutReportData(unsigned long p_ulTimeout);
    unsigned long WaitForOverlapped(unsigned long p_ulTimeout);
    bool UpdateOutReport();
    bool ReadFile(void* lpBuffer, DWORD nNumberOfBytesToRead, DWORD* lpNumberOfBytesRead);
    bool WriteFile(void* lpBuffer, DWORD nNumberOfBytesToWrite, DWORD *lpNumberOfBytesWritten);
    CStdString GetLastError();
    bool ResetOutReport();
    bool CancelIo();
    int GetInputReportByteLength();
    int GetOutputReportByteLength();
    bool GetOverlappedResult(DWORD* p_pulNumberOfBytesTransferred, BOOL p_oWait);
    bool SetBaudrate(DWORD p_ulBaudrate);

private:
    CHidDevice *m_hDeviceObject;
    CMmcCriticalSection m_CriticalSection;
    CStdString m_Path;
};
