#pragma once

#include <Drv/Hid/HidDeviceDescription.h>
#include <wchar.h>
#include "hid.h"
#include <list>

struct hid_device_;
typedef struct hid_device_ hid_device;

int   hid_init(void);

int   hid_exit(void);

bool hid_enumerate(unsigned short vendor_id, unsigned short product_id, std::list<CHidDeviceDescription*>& p_rDeviceInfoList);

void hid_free_enumeration(std::list<CHidDeviceDescription*>& p_rDeviceInfoList);

hid_device * hid_open(unsigned short vendor_id, unsigned short product_id, const wchar_t *serial_number);

hid_device * hid_open_path(const char *path);

int  hid_write(hid_device *device, const unsigned char *data, size_t length);

int  hid_read_timeout(hid_device *dev, unsigned char *data, size_t length, int milliseconds);

int  hid_read(hid_device *device, unsigned char *data, size_t length);

int  hid_set_nonblocking(hid_device *device, int nonblock);

int  hid_send_feature_report(hid_device *device, const unsigned char *data, size_t length);

int  hid_get_feature_report(hid_device *device, unsigned char *data, size_t length);

void hid_close(hid_device *device);

int  hid_get_manufacturer_string(hid_device *device, wchar_t *string, size_t maxlen);

int  hid_get_product_string(hid_device *device, wchar_t *string, size_t maxlen);

int  hid_get_serial_number_string(hid_device *device, wchar_t *string, size_t maxlen);

int  hid_get_indexed_string(hid_device *device, int string_index, wchar_t *string, size_t maxlen);
