#pragma once

#include <StdString.h>
#include "../MmcErrorHndl.h"
#include <MmcTypeDefinition.h>
#include <Drv/SocketCAN/SocketCANDeviceInfo.h>

class CMmcSocketCANHndlDef : public CMmcErrorHndl
{
public:
	virtual ~CMmcSocketCANHndlDef() {}

    virtual bool GetDeviceInfos(tSocketCANDeviceInfoList& p_rDeviceInfoList) = 0;
    virtual bool OpenInterface(CSocketCANDeviceInfo& p_rInfo) = 0;
    virtual bool CloseInterface() = 0;
    virtual bool OpenPort(CStdString p_portName) = 0;
    virtual bool ClosePort() = 0;
    virtual bool GetPortSettings(DWORD* p_pulBaudrate, DWORD* p_pulTimeout) = 0;
    virtual bool SetPortSettings(DWORD p_ulBaudrate, DWORD p_ulTimeout) = 0;
    virtual bool CheckStatusAndReset() = 0;
    virtual bool ResetPort() = 0;

    virtual bool ReceiveFilteredCanFrame(DWORD p_ulCobIdFilter, int p_lRtrFilter, DWORD p_ulTimeout, DWORD* p_pulCobId, int* p_plRtr, unsigned char* p_pubDlc, void** p_ppDataBuffer, DWORD* p_pulDataBufferLength) = 0;
    virtual bool ReceiveCanFrame(DWORD p_ulTimeout, DWORD* p_pulCobId, int* p_plRtr, unsigned char* p_pubDlc, void** p_ppDataBuffer, DWORD* p_pulDataBufferLength) = 0;
    virtual bool TransmitCanFrame(DWORD p_ulCobId, int p_lRtr, unsigned char p_ubDlc, void* p_pDataBuffer, DWORD p_ulDataBufferLength) = 0;

    virtual CStdString GetInterfaceName() = 0;
};
