#pragma once


#include <Drv/SocketCAN/MmcSocketCANHndlDef.h>
#include <StdString.h>

class CMmcSocketCANHndlBase : public CMmcSocketCANHndlDef
{
public:
    CMmcSocketCANHndlBase();
    virtual ~CMmcSocketCANHndlBase();

    CMmcSocketCANHndlBase& operator=(CMmcSocketCANHndlBase& p_rOther);

public:
    bool GetDeviceInfos(tSocketCANDeviceInfoList& p_rDeviceInfoList);
    bool OpenInterface(CSocketCANDeviceInfo& p_rInfo);
    bool CloseInterface();
    bool OpenPort(CStdString p_portName);
    bool ClosePort();
    bool ResetPort();
    bool GetPortSettings(unsigned long* p_pulBaudrate, unsigned long* p_pulTimeout);
    bool SetPortSettings(unsigned long p_ulBaudrate, unsigned long p_ulTimeout);

    bool TransmitCanFrame(unsigned long p_ulCobId, int p_lRtr, unsigned char p_ubDlc, void* p_pDataBuffer, unsigned long p_ulDataBufferLength);
    bool ReceiveCanFrame(unsigned long p_ulTimeout, unsigned long* p_pulCobId, int* p_plRtr, unsigned char* p_pubDlc, void** p_ppDataBuffer, unsigned long* p_pulDataBufferLength);
    bool ReceiveFilteredCanFrame(unsigned long p_ulCobIdFilter, int p_lRtrFilter, unsigned long p_ulTimeout, unsigned long* p_pulCobId, int* p_plRtr, unsigned char* p_pubDlc, void** p_ppDataBuffer, unsigned long* p_pulDataBufferLength);

    bool CheckStatusAndReset();
	CStdString GetInterfaceName();
};
