#pragma once

#include <MmcTypeDefinition.h>
#include <Storage/MmcUserSettings.h>

class CSocketCANDeviceInfo;

typedef std::list<CSocketCANDeviceInfo*> tSocketCANDeviceInfoList;
typedef std::pair<CStdString, CStdString> tStdStringPair;
typedef std::list<tStdStringPair> tStdStringPairList;

class CSocketCANDeviceInfo
{
public:
    CSocketCANDeviceInfo(void);
    virtual ~CSocketCANDeviceInfo(void);

    CSocketCANDeviceInfo& operator=(CSocketCANDeviceInfo& p_rOther);
    virtual CSocketCANDeviceInfo* Clone();

    //Class infos
    virtual void InitClassInfo() { m_classType = _T("-CSocketCANDeviceInfo") + m_classType; }
    BOOL IsKindOf(CStdString p_classType);
    CStdString GetClassType();

    //Initialisation
    BOOL SetInterfaceName(CStdString p_InterfaceName);
    BOOL SetDeviceName(CStdString p_DeviceName);
    BOOL SetDriverName(CStdString p_DriverName);
    BOOL SetDeviceAddress(CStdString p_DeviceAddress);
    BOOL SetInterfaceIndex(int p_lIndex);
    BOOL AddPort(CStdString p_PhysicalPortName);

    //Identifiers
    CStdString GetInterfaceName();
    CStdString GetDeviceName();
    CStdString GetDriverName();
    CStdString GetDeviceAddress();
    CStdStringArray GetPortNames();
    CStdStringArray GetPhysicalPortNames();
    CStdString GetPhysicalPortName(CStdString p_VirtualPortName);
    CStdString GetVirtualPortName(CStdString p_PhysicalPortName);
    int GetPortCount();
    int GetInterfaceIndex();

private:
    CStdString GetVirtualPortName();

protected:
    //Class infos
    CStdString m_classType;

    //Infos
    CStdString m_InterfaceName;
    CStdString m_DeviceName;
    CStdString m_DriverName;
    CStdString m_DeviceAddress;
    tStdStringPairList m_PortList;
    int m_lInterfaceIndex;
};
