#pragma once

#include <list>
#include <Thread/MmcCriticalSectionEx.h>

class CIEventsBase;

class CEventsSourceBase
{
public:
    CEventsSourceBase();
    virtual ~CEventsSourceBase(void);

    //Events
    virtual BOOL RegisterEvents(CIEventsBase* p_pIEvents);
    virtual BOOL UnregisterEvents(CIEventsBase* p_pIEvents);

private:
    //Events
    BOOL IsEventsExisting(CIEventsBase* p_pIEvents);
    BOOL DoUnregistration();

protected:
    //Events
    std::list<CIEventsBase*> m_EventsList;
    CMmcCriticalSectionEx m_mutex;
};
