#pragma once

#include <list>
#include <StdString.h>
#include "../Message/LogMessageType.h"

class CLogMessageLevel;

extern const unsigned int ALL_PIDS;
extern const unsigned int ALL_TIDS;

class CLogFilter
{
public:
    CLogFilter();
    virtual ~CLogFilter();

    bool IsMatching();
    bool IsMatching(ELogMessageType p_eType);
    bool IsMatching(CLogMessageLevel* p_pMessageLevel);
    bool IsMatching(ELogMessageType p_eType, CLogMessageLevel* p_pMessageLevel);

protected:
    void AddType(ELogMessageType p_eType);
    void RemoveType(ELogMessageType p_eType);
    int  GetTypesCount();
    void AddMessageLevel(CLogMessageLevel* p_pMessageLevel);
    void RemoveMessageLevel(CStdString p_Level);
    void AddTid(unsigned int p_lTid);
    void AddPid(unsigned int p_lPid);
    bool IsMatchingProcess();
    bool IsMatchingThread();
    void DeleteLevelList(std::list<CLogMessageLevel*>& p_rLevelList);
    void DeleteLevelLists();
    bool IsTypeInList(std::list<ELogMessageType>& p_TypeList, ELogMessageType p_eType);
    bool IsLevelInPositiveList(CLogMessageLevel* p_pMessageLevel);
    bool IsLevelInNegativeList(CStdString p_LevelUniqueId);

private:
    std::list<ELogMessageType> m_PositiveTypeList;
    std::list<ELogMessageType> m_NegativeTypeList;
    std::list<CLogMessageLevel*> m_PositiveLevelList;
    std::list<CStdString> m_NegativeLevelList;
    std::list<unsigned int> m_TidList;
    std::list<unsigned int> m_PidList;
};
