#pragma once

#include <Time/MmcHiResTimer.h>
#include <list>
#include <Thread/MmcCriticalSection.h>
#include "TimespanEntry.h"
#include "LogFormatMaskType.h"

typedef std::list<CTimespanEntry*> tTimespanEntryList;

class CTimespanLogFormatMaskType : public CLogFormatMaskType
{
public:
    CTimespanLogFormatMaskType();
    virtual ~CTimespanLogFormatMaskType();

    virtual CStdString ToString();

    static void Cleanup();

private:
    void AddLeadingZeros(CStdString& p_Msg);
    bool FindTimespanEntry(unsigned long p_ulThreadId, CTimespanEntry*& p_rpTimestampEntry);

private:
    static tTimespanEntryList* m_pThreadTimespanEntries;
    static CMmcCriticalSection* m_pLockObject;
};
