#pragma once

#include <StdString.h>
#include <list>

#include <Log/MmcLog/Log/Message/LogMessageType.h>

class CLogFormat;
class CLogMessageLevel;

class CLogMessage
{
public:
    CLogMessage();
    virtual ~CLogMessage();

    void AddFormat(CLogFormat* p_pLogFormat);

    void SetLevel(CLogMessageLevel* p_LogMessageLevel);
    void SetType(ELogMessageType p_eType);

    void ResetLevel();
    void ResetType();

    CLogMessageLevel* GetLevel();
    ELogMessageType GetType();
    CStdString GetMessage();

    virtual void CreateFormatList() = 0;

    CStdString Format(CStdString p_Msg);
    CStdString Format(CStdString p_Msg, double p_Timestamp);

private:
    void DeleteLogFormatList();

private:
    std::list<CLogFormat*> m_LogFormatList;
    CLogMessageLevel* m_pLogMessageLevel;
    ELogMessageType m_eType;
    CStdString m_Message;
};
