#pragma once

#include <StdString.h>
#include "Factory/MmcLogFactory.h"
#include "Thread/MmcCriticalSection.h"
#include "Thread/MmcSingleLock.h"
#include "Message/CommunicationMessageLevel.h"
#include "Log/Message/AllMessageLevel.h"
#include "Log/Message/UserDefinedMessageLevel.h"
#include <memory>

class CMmcLog
{
public:
    static bool Log(CStdString p_msg);
    static bool Log(ELogMessageType p_eMessageType, CStdString p_msg);
    static bool Log(CLogMessageLevel p_rMsgLevel, CStdString p_msg);
    static bool Log(ELogMessageType p_eMessageType, CLogMessageLevel p_rMsgLevel, CStdString p_msg);

    static bool IsActive(ELogMessageType p_eMessageType);
    static bool IsActive(CLogMessageLevel p_rMsgLevel);
    static bool IsActive(ELogMessageType p_eMessageType, CLogMessageLevel p_rMsgLevel);

protected:
    static void Cleanup();

private:
    static void InitLog();
    static void Lock(CMmcSingleLock& p_rSingleLock);
    static void Unlock(CMmcSingleLock& p_rSingleLock);

private:
    static bool m_oLogInitialized;
    static std::auto_ptr<CMmcCriticalSection> m_LockObject;
    static std::auto_ptr<CLog> m_Log;
};
