#ifndef ___TYPE_DEFINITIONS_
#define ___TYPE_DEFINITIONS_

#include <Thread/MmcCriticalSection.h>
#include <StdString.h>
#include <vector>
#include <list>

#ifdef _UNICODE
    typedef std::wiostream tMmcIoStream;
#else
    typedef std::iostream tMmcIoStream;
#endif

#ifndef WINVER

#define _NO_WINDOWS
#define USE_CURRENT_STL_IMPL

#include <string>
#include <Thread/MmcThread.h>
#include <limits.h>
#include <unistd.h>

#define MB_OK               0x00000000L
#define MB_ICONINFORMATION  0x00000040L
#define _I64_MAX            LLONG_MAX
#define _I64_MIN            LLONG_MIN
#define _UI64_MAX           ULLONG_MAX
#define _UI32_MAX           ULONG_MAX
#define _I8_MAX             CHAR_MAX
#define _I8_MIN             CHAR_MIN

#ifndef _T
#define _T(x) x
#endif

#ifndef CObject
class CObject {};
#endif

#ifndef WINAPI
#define WINAPI
#endif

#ifndef __stdcall
#define __stdcall
#endif

#ifndef LONG_MAX
#define LONG_MAX 2147483647
#endif

#ifndef ULONG_MAX
#define ULONG_MAX -1
#endif

#ifndef USHRT_MAX
#define USHRT_MAX (unsigned short)(-1)
#endif

#ifndef UINT_MAX
#define UINT_MAX (unsigned int)(-1)
#endif

#ifndef LOWORD
#define LOWORD(l)           ((WORD)(((DWORD_PTR)(l)) & 0xffff))
#endif

#ifndef HIWORD
#define HIWORD(l)           ((WORD)((((DWORD_PTR)(l)) >> 16) & 0xffff))
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef _tcslen
#define _tcslen strlen
#endif //_tcslen

#ifndef _stprintf
#define _stprintf sprintf
#endif //_stprintf

#ifndef _tcstoul
#define _tcstoul strtoul
#endif //_tcstoul

#ifndef _tcstol
#define _tcstol strtol
#endif //_tcstol

#ifndef _tstof
#define _tstof atof
#endif //_tstof

#ifndef _tcstok
#define _tcstok strtok
#endif //_tcstok

#ifndef BOOL
typedef int            BOOL;
#endif

#ifndef HANDLE
typedef void *HANDLE;
#endif

#ifndef HKEY
typedef void *HKEY;
#endif

#ifndef NULL
#define NULL 0
#endif

#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef WORD
typedef unsigned short WORD;
#endif

#ifndef DWORD
typedef unsigned int DWORD;
#endif

#ifndef DWORD_PTR
typedef DWORD DWORD_PTR;
#endif

#ifndef IJournal
#define IJournal void*
#endif

#ifndef T_JournalCallback
#define T_JournalCallback void*
#endif

#ifndef CArchive
class CArchive {};
#endif

#ifndef CStdStringArray
typedef std::vector<std::string> CStdStringArray;
#endif

#ifndef CStdDWordArray
typedef std::vector<DWORD> CStdDWordArray;
#endif

#ifndef CStdByteArray
typedef std::vector<unsigned char> CStdByteArray;
#endif

#ifndef PVOID
typedef void *PVOID;
#endif

#ifndef LPVOID
typedef PVOID LPVOID;
#endif

#ifndef __int8
typedef signed char __int8;
#endif

#ifndef __uint8
typedef unsigned char __uint8;
#endif

#ifndef __int16
typedef short __int16;
#endif

#ifndef __uint16
typedef unsigned short __uint16;
#endif

#ifndef __int32
typedef int __int32;
#endif

#ifndef __uint32
typedef unsigned int __uint32;
#endif

#ifndef __int64
typedef long long __int64;
#endif

#ifndef __uint64
typedef unsigned long long __uint64;
#endif

#ifndef LONG
typedef unsigned int LONG;
#endif

#ifndef LONGLONG
typedef long long LONGLONG;
#endif

#if __cplusplus < 201103L
    #ifndef char16_t
        typedef short char16_t;
    #endif
#endif

#else
    //WINDOWS
    #ifndef CStdStringArray
        typedef std::vector<CStdString> CStdStringArray;
    #endif

    #ifndef CStdWordArray
        typedef std::vector<unsigned short> CStdWordArray;
    #endif

    #ifndef CStdWordArray
        typedef std::vector<unsigned long> CStdDWordArray;
    #endif

    #ifndef CStdByteArray
        typedef std::vector<unsigned char> CStdByteArray;
    #endif

    #ifndef __uint64
        typedef unsigned __int64 __uint64;
    #endif

    #ifndef __uint8
        typedef unsigned __int8 __uint8;
    #endif

    #ifndef __uint16
        typedef unsigned short __uint16;
    #endif

    #ifndef __uint32
        typedef unsigned int __uint32;
    #endif
#endif //_WIN32

#endif //___TYPE_DEFINITIONS_
