#pragma once

#include <afxmt.h>

#include "MmcCriticalSection.h"
#include "MmcThreadBase.h"

class CMmcThreadWin : public CMmcThreadBase
{
public:
    CMmcThreadWin();
    virtual ~CMmcThreadWin();

    //Start Stop
    BOOL Start();
    BOOL Stop();

    //Thread Function
    virtual DWORD WINAPI ThreadFunc();

protected:
    BOOL SetHighPriority();
    BOOL IsStillActive();    
    BOOL WaitWithMessageLoop(HANDLE p_hEvent, DWORD p_ulTimeout);

    virtual void SetThreadState(EThreadBaseState p_eState);

private:
    void ResetThreadVariables();
    void WaitForStop();

    DWORD TraceStart();
    void TraceStop(DWORD p_ulTimestamp);

    static unsigned __stdcall BaseThreadFunc(LPVOID pParam);

private:
    HANDLE m_thread;
    unsigned int m_ThreadID;
    CMmcCriticalSection m_StartStopSync;
};
