#include "stdafx.h"

#include <Drv/Helper/UsbTree/UsbDevice.h>

CUsbDevice::CUsbDevice()
    : CUsbDeviceBase()
    , m_DriverKeyName(_T(""))
    , m_DeviceId(_T(""))
    , m_usVendorId(0)
    , m_usProductId(0)
    , m_usSerialNumberId(0)
    , m_SerialNumber(_T(""))
{
}

CUsbDevice::~CUsbDevice()
{
}

CUsbDeviceBase* CUsbDevice::Clone()
{
    CUsbDevice* pClonedUsbDevice = new CUsbDevice();
    *pClonedUsbDevice = *this;

    return pClonedUsbDevice;
}

CUsbDevice& CUsbDevice::operator=(CUsbDevice& p_rOther)
{
    if(this != &p_rOther)
    {
        *((CUsbDeviceBase*)this) = *((CUsbDeviceBase*)&p_rOther);
        m_DriverKeyName = p_rOther.m_DriverKeyName;
        m_DeviceId = p_rOther.m_DeviceId;
        m_usVendorId = p_rOther.m_usVendorId;
        m_usProductId = p_rOther.m_usProductId;
        m_usSerialNumberId = p_rOther.m_usSerialNumberId;
        m_SerialNumber = p_rOther.m_SerialNumber;
    }

    return *this;
}

void CUsbDevice::Init(CStdString p_driverKeyName, CStdString p_deviceId)
{
    m_DriverKeyName = p_driverKeyName;
    m_DeviceId = p_deviceId;
}

void CUsbDevice::Init(DWORD p_ulIndex, CStdString p_devicePath, WORD p_usVendorId, WORD p_usProductId, WORD p_usSerialNumberId, CStdString p_serialNumber)
{
    InitIndex(p_ulIndex);
    InitDevicePath(p_devicePath);

    m_usVendorId = p_usVendorId;
    m_usProductId = p_usProductId;
    m_usSerialNumberId = p_usSerialNumberId;
    m_SerialNumber = p_serialNumber;
}

CStdString CUsbDevice::GetDriverKeyName()
{
    return m_DriverKeyName;
}

CStdString CUsbDevice::GetDeviceId()
{
    return m_DeviceId;
}

WORD CUsbDevice::GetVendorId()
{
    return m_usVendorId;
}

WORD CUsbDevice::GetProductId()
{
    return m_usProductId;
}

BOOL CUsbDevice::GetInfos(CStdString& p_rDevicePath, WORD& p_rusVendorId, WORD& p_rusProductId, CStdString& p_rSerialNumber)
{
    CStdString devicePath(_T(""));

    devicePath = GetChildDevicePath(0);
    if(devicePath.IsEmpty())
    {
        devicePath = GetDevicePath();
    }
    
    p_rDevicePath = devicePath;
    p_rusVendorId = m_usVendorId;
    p_rusProductId = m_usProductId;
    p_rSerialNumber = m_SerialNumber;

    return TRUE;
}
