#include "stdafx.h"

#include <Drv/Helper/UsbTree/UsbHub.h>

CUsbHub::CUsbHub(BOOL p_oRootHub)
    : CUsbDeviceBase()
    , m_oIsRootHub(p_oRootHub)
    , m_ulPortCount(0)
{
}

CUsbHub::~CUsbHub(void)
{
}

CUsbDeviceBase* CUsbHub::Clone()
{
    CUsbHub* pClonedHub = new CUsbHub(m_oIsRootHub);
    *pClonedHub = *this;

    return pClonedHub;
}

CUsbHub& CUsbHub::operator=(CUsbHub& p_rOther)
{
    if(this != &p_rOther)
    {
        *((CUsbDeviceBase*)this) = *((CUsbDeviceBase*)&p_rOther);
        m_ulPortCount = p_rOther.m_ulPortCount;
        m_oIsRootHub = p_rOther.m_oIsRootHub;
    }

    return *this;
}

void CUsbHub::Init(DWORD p_ulIndex, CStdString p_devicePath, DWORD p_ulPortCount)
{
    InitIndex(p_ulIndex);
    InitDevicePath(p_devicePath);

    m_ulPortCount = p_ulPortCount;
}

DWORD CUsbHub::GetPortCount()
{
    return m_ulPortCount;
}

CStdString CUsbHub::BuildPortChain()
{
    CStdString portChain(_T(""));
    CUsbDeviceBase* pParent = GetParent();

    if(m_oIsRootHub)
    {
        if(pParent != 0)
        {
            portChain = pParent->GetPortChain();
        }
    }
    else
    {
        portChain = CUsbDeviceBase::BuildPortChain();
    }

    return portChain;
}

BOOL CUsbHub::IsUsbHub()
{
    return TRUE;
}
