#include "stdafx.h"
#include <Drv/Hid/HidDeviceInfo.h>
#include <MmcTypeDefinition.h>

CHidDeviceInfo::CHidDeviceInfo(void)
{
    InitClassInfo();
}

CHidDeviceInfo::~CHidDeviceInfo(void)
{
}

CUsbDeviceInfo* CHidDeviceInfo::Clone()
{
    CHidDeviceInfo* pDeviceInfo(0);

    pDeviceInfo = new CHidDeviceInfo();
    *pDeviceInfo = *this;

    return pDeviceInfo;
}

CHidDeviceInfo& CHidDeviceInfo::operator=(CHidDeviceInfo& p_rOther)
{
    if(this != &p_rOther)
    {
        *((CUsbDeviceInfo*)(this)) = *((CUsbDeviceInfo*)&p_rOther);
    }

    return *this;
}

BOOL CHidDeviceInfo::GetLogInfos(CStdString& p_rInfos, CUsbDeviceInfo::ELogInfoType p_eType)
{
    BOOL oResult(FALSE);

    switch(p_eType)
    {
        case LIT_IDENTIFIER: p_rInfos.Format(_T("%s PortChain *%s* DevicePath %s; "), m_PortName, m_PortChain, GetDevicePath()); oResult = TRUE; break;
        case LIT_STATE: p_rInfos.Format(_T("%s PortChain *%s* DevicePath %s PluggedIn %i OpenedByProcess %i OpenedByInstance %i OpenedBy %s; "), m_PortName, m_PortChain, GetDevicePath(), IsPluggedIn(), GetOpenedByProcess(), GetOpenedByInstance(), GetOpenedBy()); oResult = TRUE; break;
    }

    return oResult;
}

BOOL CHidDeviceInfo::Init(CUsbDeviceInfo& p_rDeviceInfo)
{
    BOOL oResult(FALSE);

    oResult = CUsbDeviceInfo::Init(p_rDeviceInfo);
    if(p_rDeviceInfo.IsKindOf(_T("CHidDeviceInfo")))
    {
        oResult = TRUE;
    }

    return oResult;
}

BOOL CHidDeviceInfo::Init(CStdString p_PortChain, CStdString p_DevicePath, WORD p_usVendorId, WORD p_usProductId, CStdString p_SerialNumber)
{
    BOOL oResult(FALSE);

    if(CUsbDeviceInfo::Init(p_PortChain, p_DevicePath, p_usVendorId, p_usProductId, p_SerialNumber))
    {
        oResult = TRUE;
    }

    return oResult;
}

BOOL CHidDeviceInfo::Update(CUsbDeviceInfo& p_rDeviceInfo)
{
    BOOL oResult(FALSE);

    if(p_rDeviceInfo.IsKindOf(_T("CHidDeviceInfo")))
    {
        CUsbDeviceInfo::Update(p_rDeviceInfo);
        oResult = TRUE;
    }

    return oResult;
}
