#include "stdafx.h"
#include <Drv/Rs232/Rs232DeviceInfo.h>
#include <MmcTypeDefinition.h>

CRs232DeviceInfo::CRs232DeviceInfo(void):
    m_strClassType(_T("-"))
    , m_PortName(_T(""))
{
    InitClassInfo();
}

CRs232DeviceInfo::~CRs232DeviceInfo(void)
{
}

BOOL CRs232DeviceInfo::IsKindOf(CStdString strClassType)
{
    BOOL oResult(FALSE);

    //Init
    strClassType = _T("-") + strClassType + _T("-");

    //Check ClassType
    if(m_strClassType.Find(strClassType) != -1)
    {
        oResult = TRUE;
    }

    return oResult;
}

CStdString CRs232DeviceInfo::GetClassType()
{
    int lIndex = 1;
    CStdString classType(_T(""));

    if(!m_strClassType.IsEmpty())
    {
        lIndex = m_strClassType.Find(_T("-"), lIndex);
        if(lIndex != -1)
        {
            classType = m_strClassType.substr(0, lIndex);
            classType = classType.TrimLeft(_T("-"));
            classType = classType.TrimRight(_T("-"));
        }
    }

    return classType;
}

CRs232DeviceInfo& CRs232DeviceInfo::operator=(CRs232DeviceInfo& p_rOther)
{
    if(this != &p_rOther)
    {
        m_PortName = p_rOther.m_PortName;
    }

    return *this;
}

CRs232DeviceInfo* CRs232DeviceInfo::Clone()
{
    CRs232DeviceInfo* pDeviceInfo = 0;

    pDeviceInfo = new CRs232DeviceInfo();
    *pDeviceInfo = *this;

    return pDeviceInfo;
}

BOOL CRs232DeviceInfo::Init(CStdString p_PortName)
{
    BOOL oResult(TRUE);

    m_PortName = p_PortName;

    return oResult;
}

CStdString CRs232DeviceInfo::GetPortName()
{
    return m_PortName;
}
