
#include "stdafx.h"
#include <Events/EventsSourceBase.h>
#include <Events/IEventsBase.h>

CIEventsBase::CIEventsBase(void)
{
}

CIEventsBase::~CIEventsBase(void)
{
    DoUnregistration();
}

BOOL CIEventsBase::RegisterEventsSource(CEventsSourceBase* p_pEventsSource)
{
    BOOL oResult(FALSE);

    if(!IsEventsSourceExisting(p_pEventsSource))
    {
        //Register
        m_EventsSourceList.push_back(p_pEventsSource);
        oResult = TRUE;
    }
    else
    {
        //Already registered
        oResult = TRUE;
    }

    return oResult;
}

BOOL CIEventsBase::UnregisterEventsSource(CEventsSourceBase* p_pEventsSource)
{
    BOOL oResult(FALSE);

    if(IsEventsSourceExisting(p_pEventsSource))
    {
        //Unregister
        m_EventsSourceList.remove(p_pEventsSource);
        oResult = TRUE;
    }
    else
    {
        //Not registered
        oResult = TRUE;
    }

    return oResult;
}

BOOL CIEventsBase::IsEventsSourceExisting(CEventsSourceBase* p_pEventsSource)
{
    BOOL oResult(FALSE);

    for(std::list<CEventsSourceBase*>::iterator it = m_EventsSourceList.begin(); it != m_EventsSourceList.end(); it++)
    {
        if(p_pEventsSource == *(it))
        {
            oResult = TRUE;
            break;
        }
    }

    return oResult;
}

BOOL CIEventsBase::DoUnregistration()
{
    BOOL oResult(TRUE);

    for(std::list<CEventsSourceBase*>::iterator it = m_EventsSourceList.begin(); it != m_EventsSourceList.end(); it++)
    {
        CEventsSourceBase* pEventsSource = *(it);

        if(!pEventsSource->UnregisterEvents(this)) oResult = FALSE;
    }

    return oResult;
}

