#include "stdafx.h"
#include <Log/MmcLog/Log/Message/Format/LogFormatMask.h>
#include <Log/MmcLog/Log/Message/Format/LogFormatMaskType.h>

using namespace std;

CLogFormatMask::CLogFormatMask()
    : m_Separator(_T(" "))
{
}

CLogFormatMask::~CLogFormatMask()
{
    DeleteMaskTypeList();
}

void CLogFormatMask::SetSeparator(CStdString p_Separator)
{
    m_Separator = p_Separator;
}

CStdString CLogFormatMask::GetLogMessage()
{
    CStdString result;

    if(m_FormatMaskTypeList.size() > 0)
    {
        list<CLogFormatMaskType*>::iterator lastit = m_FormatMaskTypeList.end();

        lastit--;

        for(list<CLogFormatMaskType*>::iterator it = m_FormatMaskTypeList.begin(); it != m_FormatMaskTypeList.end(); it++)
        {
            CLogFormatMaskType* pFormatMaskType = (*it);
            CStdString msg = pFormatMaskType->ToString();

            if(msg.GetLength() > 0)
            {
                result += msg;

                if(it != lastit)
                {
                    result += m_Separator;
                }
            }
        }
    }

    return result;
}

void CLogFormatMask::DeleteMaskTypeList()
{
    list<CLogFormatMaskType*>::iterator it = m_FormatMaskTypeList.begin();

    while(it != m_FormatMaskTypeList.end())
    {
        CLogFormatMaskType* pMaskType = (*it);

        m_FormatMaskTypeList.erase(it);

        delete pMaskType;

        it = m_FormatMaskTypeList.begin();
    }
}

void CLogFormatMask::AddMaskType(CLogFormatMaskType* p_pMaskType)
{
    m_FormatMaskTypeList.push_back(p_pMaskType);
}
