#include "stdafx.h"
#include <Log/MmcLog/Log/Message/Format/LogFormatMaskType.h>

CLogFormatMaskType::CLogFormatMaskType()
{
    m_eType = FMT_UNDEFINED;
}

CLogFormatMaskType::CLogFormatMaskType(ELogFormatMaskType p_eMaskType)
{
    m_eType = p_eMaskType;
}

CLogFormatMaskType::~CLogFormatMaskType()
{
}

void CLogFormatMaskType::SetMaskType(ELogFormatMaskType p_eMaskType)
{
    m_eType = p_eMaskType;
}

ELogFormatMaskType CLogFormatMaskType::GetMaskType()
{
    return m_eType;
}

bool CLogFormatMaskType::FromString(CStdString p_MaskType)
{
    bool oResult = true;
    int lBeginIndex = p_MaskType.Find(_T("$("));
    int lEndIndex = p_MaskType.ReverseFind(_T(")"));

    if(lBeginIndex != -1 && lEndIndex != -1)
    {
        CStdString type = p_MaskType.Mid(lBeginIndex, lEndIndex - lBeginIndex);

        if(type.CompareNoCase(_T("*")) == 0) 
        {
            m_eType = FMT_UNDEFINED;
        }
        else if(type.CompareNoCase(_T("Type")) == 0) 
        {
            m_eType = FMT_TYPE;
        }
        else if(type.CompareNoCase(_T("Level")) == 0) 
        {
            m_eType = FMT_LEVEL;
        }
        else if(type.CompareNoCase(_T("Message")) == 0) 
        {
            m_eType = FMT_MESSAGE;
        }
        else if(type.CompareNoCase(_T("Tid")) == 0) 
        {
            m_eType = FMT_TID;
        }
        else if(type.CompareNoCase(_T("Pid")) == 0) 
        {
            m_eType = FMT_PID;
        }
        else if(type.CompareNoCase(_T("Time")) == 0) 
        {
            m_eType = FMT_TIME;
        }
        else if(type.CompareNoCase(_T("Timestamp")) == 0) 
        {
            m_eType = FMT_TIMESTAMP;
        }
        else if(type.CompareNoCase(_T("Timespan")) == 0) 
        {
            m_eType = FMT_TIMESPAN;
        }
        else
        {
            oResult = false;
        }
    }
    else
    {
        oResult = false;
    }

    return oResult;
}

CStdString CLogFormatMaskType::ToString()
{
    CStdString result;
    CStdString type;

    switch(m_eType)
    {
        case FMT_UNDEFINED:
        {
            type = _T("*");
            break;
        }
        case FMT_LOG_IDENTIFICATION:
        {
            type = _T("LogIdentification");
            break;
        }
        case FMT_TYPE:
        {
            type = _T("Type");
            break;
        }
        case FMT_LEVEL:
        {
            type = _T("Level");
            break;
        }
        case FMT_MESSAGE:
        {
            type = _T("Message");
            break;
        }
        case FMT_TID:
        {
            type = _T("Tid");
            break;
        }
        case FMT_PID:
        {
            type = _T("Pid");
            break;
        }
        case FMT_TIME:
        {
            type = _T("Time");
            break;
        }
        case FMT_TIMESTAMP:
        {
            type = _T("Timestamp");
            break;
        }
        case FMT_TIMESPAN:
        {
            type = _T("Timespan");
            break;
        }
    }

    result.Format(_T("$(%s)"), type);

    return result;
}
