#include "stdafx.h"

#include <Process/MmcProcess.h>
#include <Time/MmcHiResTimer.h>

#include <Log/MmcLog/Log/Message/Format/TimespanEntry.h>

CTimespanEntry::CTimespanEntry()
{
    m_pTimer = new CMmcHiResTimer();
    m_dElapsedTime = 0;
    m_ulThreadId = MmcGetCurrentThreadId();
}

CTimespanEntry::~CTimespanEntry()
{
    delete m_pTimer;
}

void CTimespanEntry::Start()
{
    if(m_pTimer)
    {
        m_pTimer->start();
    }

    m_dElapsedTime = 0;
}

double CTimespanEntry::GetTimespan()
{
    double dResult = 0;

    if(m_pTimer)
    {
        dResult = m_pTimer->getElapsedTimeInMilliSec() - m_dElapsedTime;
    }

    return dResult;
}

unsigned long CTimespanEntry::GetThreadId()
{
    return m_ulThreadId;
}

void CTimespanEntry::Reset()
{
    if(m_pTimer)
    {
        m_dElapsedTime = m_pTimer->getElapsedTimeInMilliSec();
    }
}
