#include "stdafx.h"
#include <Log/MmcLog/Message/CommunicationMessageLevel.h>


CCommunicationMessageLevel::CCommunicationMessageLevel()
{
    m_eLevel = CML_UNDEFINED;
}

CCommunicationMessageLevel::CCommunicationMessageLevel(ECommunicationMessageLevel p_eLevel)
{
    m_eLevel = p_eLevel;

    SetUniqueId(ConvertToUniqueId(p_eLevel));
}

CCommunicationMessageLevel::~CCommunicationMessageLevel()
{
}

bool CCommunicationMessageLevel::IsMatching(CStdString p_uniqueId, ECommunicationMessageLevel& p_reMessageLevel)
{
    bool oResult = false;
    CCommunicationMessageLevel level;

    if(p_uniqueId == level.ConvertToUniqueId(CML_VCS).Trim())
    {
        p_reMessageLevel = CML_VCS;
        oResult = true;
    }
    else if(p_uniqueId == level.ConvertToUniqueId(CML_DCS).Trim())
    {
        p_reMessageLevel = CML_DCS;
        oResult = true;
    }
    else if(p_uniqueId == level.ConvertToUniqueId(CML_PS).Trim())
    {
        p_reMessageLevel = CML_PS;
        oResult = true;
    }
    else if(p_uniqueId == level.ConvertToUniqueId(CML_I).Trim())
    {
        p_reMessageLevel = CML_I;
        oResult = true;
    }

    return oResult;
}

CStdString CCommunicationMessageLevel::ConvertToUniqueId(ECommunicationMessageLevel p_eLevel)
{
    CStdString result;

    switch(p_eLevel)
    {
        case CML_VCS:
        {
            result = "VCS";
            break;
        }
        case CML_DCS:
        {
            result = "DCS";
            break;
        }
        case CML_PS:
        {
            result = "PS-";
            break;
        }
        case CML_I:
        {
            result = "-I-";
            break;
        }
        default:
        {
            result = "-?-";
            break;
        }
    }

    result.Replace(_T("-"), _T(" "));

    return result;
}

CStdString CCommunicationMessageLevel::ToString()
{
    CStdString result;

    switch(m_eLevel)
    {
        case CML_VCS:
        {
            result = "[VCS]";
            break;
        }
        case CML_DCS:
        {
            result = "[DCS]";
            break;
        }
        case CML_PS:
        {
            result = "[PS]";
            break;
        }
        case CML_I:
        {
            result = "[I]";
            break;
        }
        default:
        {
            result = "[?]";
             break;
        }
    }

    return result;
}
