#include "stdafx.h"
#include <Thread/Events/IThreadBaseEvents.h>
#include <Thread/MmcThreadBase.h>
#include <Thread/Events/ThreadBaseEventsSource.h>

using namespace std;

CThreadBaseEventsSource::CThreadBaseEventsSource()
    : m_pThreadBase(0)
    , m_OldState(TBS_STOPPED)
    , m_lOldPriority(0)
{
    m_lOldPriority = -1;
}

CThreadBaseEventsSource::~CThreadBaseEventsSource()
{
}

void CThreadBaseEventsSource::InitThreadBase(CMmcThreadBase* p_pThreadBase)
{
    m_pThreadBase = p_pThreadBase;
}

BOOL CThreadBaseEventsSource::SendEventStateChanged(CMmcThreadBase* p_pEventSource, EThreadBaseState p_NewState)
{
    BOOL oResult = TRUE;
    CIEventsBase* pEvents = 0;
    CIThreadBaseEvents* pThreadBaseEvents = 0;

    if(m_mutex.Lock(0))
    {
        for(list<CIEventsBase*>::iterator it = m_EventsList.begin(); it != m_EventsList.end(); it++)
        {
            pEvents = *(it);
            pThreadBaseEvents = dynamic_cast<CIThreadBaseEvents*>(pEvents);

            if(pThreadBaseEvents)
            {
                pThreadBaseEvents->OnThreadBaseStateChanged(m_pThreadBase, m_OldState, p_NewState);
            }
        }

        m_OldState = p_NewState;

        m_mutex.Unlock();
    }

    return oResult;
}

BOOL CThreadBaseEventsSource::SendEventPriorityChanged(CMmcThreadBase* p_pEventSource, int p_lNewState)
{
    BOOL oResult = TRUE;
    CIEventsBase* pEvents = 0;
    CIThreadBaseEvents* pThreadBaseEvents = 0;

    if (m_mutex.Lock(0))
    {
        for (list<CIEventsBase*>::iterator it = m_EventsList.begin(); it != m_EventsList.end(); it++)
        {
            pEvents = *(it);
            pThreadBaseEvents = dynamic_cast<CIThreadBaseEvents*>(pEvents);

            if (pThreadBaseEvents)
            {
                pThreadBaseEvents->OnThreadBasePriorityChanged(m_pThreadBase, m_lOldPriority, p_lNewState);
            }
        }

        m_lOldPriority = p_lNewState;

        m_mutex.Unlock();
    }

    return oResult;
}