#ifndef CLINUXUSBTREE_H
#define CLINUXUSBTREE_H

#include <list>
#include <dirent.h>
#include "StdString.h"
#include "LinuxUsbDirectory.h"

class CLinuxRootHub;
class CUsbDeviceDescription;

class CLinuxUsbTree
{
public:
    CLinuxUsbTree();
    ~CLinuxUsbTree();
    
    bool GetRootHubs(std::list<CLinuxRootHub*>& p_rRootHubs);
    bool DeviceExists(int p_lBusNum, int p_lPortNum, CStdString p_DevicePath, int p_lIdProduct, int p_lIdVendor);

private:
    int EnumerateDirectoryTree(CStdString p_DirectoryRoot);
    void DeleteDirectories();
    bool EnumerateDevices();
    void DeleteRootHubEnumeration();
    bool EnumerateRootHubs();

    void EnumerateDirectory(const char *name);
    void AddDirectory(const char *p_pName, dirent *p_pEntry);	
    void AddLinkedDirectory(const char *p_pName, dirent *p_pEntry);
    
    static bool DirectorySort(CLinuxUsbDirectory* p_pLeft, CLinuxUsbDirectory* p_pRight);
	static int AddDirectory(const char *p_pFilePath, const struct stat *p_pStatInfo, const int p_lTypeFlag, struct FTW *p_pPathInfo);

    std::list<CUsbDeviceDescription*> m_DeviceInfoList;
    std::list<CLinuxRootHub*> m_RootHubs;

    static CMmcCriticalSection m_Sync;
    static std::list<CLinuxUsbDirectory*> m_Directories;
};

#endif // CLINUXUSBTREE_H
