#pragma once

#include <map>
#include <StdString.h>
#include <Thread/MmcCriticalSection.h>

class CMmcSingleLock;

class CMmcCriticalSectionExLinux
{
public:
	CMmcCriticalSectionExLinux();
	virtual ~CMmcCriticalSectionExLinux();

    void Init(CStdString name);
    bool Lock(unsigned int dTimeout, CStdString strTrace="");
    bool Unlock(CStdString strTrace="");
    bool AbortLock(bool oActive);
    bool IsLocked(CStdString strTrace="");

    typedef std::map<pthread_t, CMmcSingleLock*> ThreadToSingleLockMap;
   	typedef std::pair<pthread_t, CMmcSingleLock*> ThreadToSinglePair;

private:
    CMmcSingleLock* FindSingleLock();
    void DeleteThreadIdToSingleLockMap();

private:
    CStdString m_Name;
    bool m_oAbortLock;

    CMmcCriticalSection m_CriticalSection;
    ThreadToSingleLockMap m_MapThreadIdToSingleLock;
};
