#pragma once

#include <StdString.h>
#include <semaphore.h>
#include "../../include/Thread/MmcSyncObjectLinux.h"

class CMmcSemaphoreLinux : public CMmcSyncObjectLinux
{
public:
	CMmcSemaphoreLinux(int lInitialCount = 1,int lMaxCount = 1, CStdString strName = "");
    virtual ~CMmcSemaphoreLinux();

    bool InitialLock();
	bool Lock(unsigned int p_lTimeout = 0);
	bool Unlock();

private:
    void CreateSemaphore();
    void DestroySemaphore();
    bool FastLock();
    bool TimedLock(unsigned int p_lTimeout);

private:
    sem_t* m_pSemaphore;
    CStdString m_Name;
    int m_lInitialCount;
};
