#include <stdio.h>
#include <memory.h>
#include <fcntl.h>
#include <unistd.h>
#include <algorithm>
#include <dirent.h>
#include <stddef.h>
#include <Drv/SocketCAN/SocketCANDevice.h>

#include <Drv/SocketCAN/SocketCANPort.h>


CSocketCANPort::CSocketCANPort()
	: m_pDevice(0)
{
}

CSocketCANPort::CSocketCANPort(CStdString p_Name)
	: m_pDevice(0)
{
	m_Name = p_Name;
}

CSocketCANPort::~CSocketCANPort()
{
	DeleteDeviceInfo();
}

void CSocketCANPort::DeleteDeviceInfo()
{
	if(m_pDevice)
	{
		delete m_pDevice;
		m_pDevice = 0;
	}
}

bool CSocketCANPort::Init()
{
	bool oResult = false;

	oResult = ReadCanPortOperState();

	if(oResult)
	{
		oResult = ReadCanDeviceInfo();
	}

	return oResult;
}

CStdString CSocketCANPort::GetName()
{
	return m_Name;
}

CStdString CSocketCANPort::GetOperstate()
{
	return m_Operstate;
}

CSocketCANDevice* CSocketCANPort::GetDevice()
{
	return m_pDevice;
}

bool CSocketCANPort::ReadCanDeviceInfo()
{
	bool oResult = false;

	DeleteDeviceInfo();

	m_pDevice = new CSocketCANDevice();

	if(m_pDevice)
	{
		oResult = m_pDevice->Init(m_Name);
	}

	return oResult;
}

bool CSocketCANPort::ReadCanPortOperState()
{
	bool oResult = false;
	CStdString filename;
	int lFileSize = 0;
	FILE* pFile = 0;
	char* pBuffer = 0;

	filename.Format("/sys/class/net/%s/operstate", m_Name);

	pFile = fopen(filename, "r");

	if(pFile)
	{
		if(fseek(pFile, 0, SEEK_END) == 0)
		{
			lFileSize = ftell(pFile);

			if(lFileSize > 0)
			{
				pBuffer = new char[lFileSize + 1];

				memset(pBuffer, 0, lFileSize + 1);

				rewind(pFile);

				if(fread(pBuffer, sizeof(char), (::size_t)lFileSize, pFile) >= 0)
				{
					oResult = true;
				}

				m_Operstate = pBuffer;

				if(m_Operstate.GetAt(m_Operstate.GetLength()-1) == '\n')
				{
					m_Operstate.GetBufferSetLength(m_Operstate.GetLength()-1);
				}
			}
		}

		fclose(pFile);
	}

	return oResult;
}
