#include "stdafx.h"
#include <Process/MmcProcess.h>
#include <cstdlib>
#include <unistd.h>
#include <Log/MmcLog/Log/Message/AllMessageLevel.h>
#include <Log/MmcLog/Log/Message/UserDefinedMessageLevel.h>
#include <Log/MmcLog/Message/CommunicationMessageLevel.h>

#include "../../../../include/Log/MmcLog/Filter/FileExistsLogFilter.h"

using namespace std;

CFileExistsLogFilter::CFileExistsLogFilter()
{
	Init();
}

CFileExistsLogFilter::~CFileExistsLogFilter()
{
}

bool CFileExistsLogFilter::LogFileExists()
{
	bool oResult = false;
	CStdString fileName;
	FILE *pFile = 0;
	char *homeDir = getenv(_T("HOME"));

	fileName.Format(_T("%s/.maxon_motor_ag/logall"), homeDir);

	if ((pFile = fopen(fileName.c_str(), "r")))
	{
		fclose(pFile);
		oResult = true;
	}

	return oResult;
}

void CFileExistsLogFilter::ActivateAll()
{
	AddPid(ALL_PIDS);
	AddTid(ALL_TIDS);

	AddType(LMT_INFO);
	AddType(LMT_ERROR);
	AddType(LMT_WARNING);
	AddType(LMT_DEBUG);
	AddType(LMT_EXCEPTION);

	CLogMessageLevel* pLogMessageLevel = new CAllMessageLevel();

	AddMessageLevel(pLogMessageLevel);
}

void CFileExistsLogFilter::Init()
{
	if(LogFileExists())
	{
		ActivateAll();
	}
}
