#include <stdafx.h>
#include <Log/MmcLog/Log/Message/Format/TypeLogFormatMaskType.h>
#include <Log/MmcLog/Log/Message/Format/LevelLogFormatMaskType.h>
#include <Log/MmcLog/Log/Message/Format/MessageLogFormatMaskType.h>
#include <Log/MmcLog/Log/Message/Format/ProcessIdLogFormatMaskType.h>
#include <Log/MmcLog/Log/Message/Format/IdentLogFormatMaskType.h>
#include <Log/MmcLog/Log/Message/Format/ThreadIdLogFormatMaskType.h>
#include <Log/MmcLog/Log/Message/Format/TimespanLogFormatMaskType.h>
#include <Log/MmcLog/Log/Message/Format/TimeLogFormatMaskType.h>

#include "../../../../../include/Log/MmcLog/Message/Format/ConsoleLogFormatMask.h"

CConsoleLogFormatMask::CConsoleLogFormatMask(CLogMessage* p_pLogMessage)
    : m_pLogMessage(p_pLogMessage)
{
    Init();
}

CConsoleLogFormatMask::~CConsoleLogFormatMask()
{
}

void CConsoleLogFormatMask::Init()
{
    SetSeparator(_T(","));

    AddMaskType(new CTimeLogFormatMaskType());

    AddMaskType(new CTimespanLogFormatMaskType());

    AddMaskType(new CTypeLogFormatMaskType(m_pLogMessage));

    AddMaskType(new CProcessIdLogFormatMaskType());

    AddMaskType(new CThreadIdLogFormatMaskType());

    AddMaskType(new CLevelLogFormatMaskType(m_pLogMessage));

    AddMaskType(new CMessageLogFormatMaskType(m_pLogMessage));
}
