/*
 * MmcProcess.cpp
 *
 *  Created on: Oct 20, 2010
 *      Author: dawid
 */
#include <Process/MmcProcess.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/times.h>
#include <sys/time.h>

unsigned long MmcGetLastError()
{
	return 0;
}

bool	MmcIsProcessAvailable(unsigned long p_ulProcessId)
{
	CStdString	fileName;
	bool		active = false;

	fileName.Format("/proc/%ld", p_ulProcessId);

	FILE* file = fopen(fileName, "r");

	if( file != 0 )
	{
		active = true;
		fclose(file);
	}

	return active;
}

unsigned long MmcGetTickCount()
{
	struct timeval tv;
	if(gettimeofday(&tv, NULL) != 0)
			return 0;

	return (tv.tv_sec * 1000) + (tv.tv_usec / 1000);
}

void MmcSleep(unsigned int milliseconds)
{
	struct timespec ts;
	const int MILISEC_TO_SEC_FACTOR = 1000;
	const int NANOSEC_TO_SEC_FACTOR = MILISEC_TO_SEC_FACTOR*MILISEC_TO_SEC_FACTOR;

	ts.tv_sec = milliseconds / MILISEC_TO_SEC_FACTOR;
	ts.tv_nsec = (milliseconds % MILISEC_TO_SEC_FACTOR) * NANOSEC_TO_SEC_FACTOR;

	nanosleep(&ts, NULL);
}

unsigned long MmcGetCurrentProcessId()
{
	return getpid();
}

unsigned long MmcGetCurrentThreadId()
{
	return pthread_self();
}

CStdString MmcGetModuleName()
{
	return "MmcSysLib";
}

CStdString MmcGetApplicationName()
{
	return "";
}

CStdString MmcGetApplicationVersion()
{
	return "";
}

CStdString MmcGetApplicationFileVersion()
{
	return "";
}
